!c A.Vef, 8.8.94 : Modifikationen im ganzen Modul:                      
!c es waren einige Abfragen der Form "if (undefinierte variable)...     
!c vorhanden. Diese wurden rauskommentiert und mit >> markiert.         
!c Wenn sonst mal ein Betriebssystem lokale Variablen nicht initialisier
!c geht alles schief...                                                 
!c                                                                      
      subroutine axscl
      use comalp
 
      implicit none 
!     plottet Achsen-Beschriftung und Textzeile                         
!                                                                       
!     M. Alflen 15.12.89                                                
!                                                                       
!	erweitert um variablen offset zwischen Rahmen und Plot                
!                                                                       
!     Modifiziert: A.Vef, 12.11.90                                      
!       geaenderte Erkennung symmetrischer x-Skala (Moessbauer-Spektrum)
!       Grund: vorher falsche Skalierung bei ESCA-Daten                 
                                                                        
      character*1   CTEXT,CXTEXT,CYTEXT 
      COMMON /TXT/  CTEXT(132),CXTEXT(80),CYTEXT(80) 
                                                                        
      logical       l_semi,l_xtext,l_xtextl,l_xtextr,                   &
     &              l_xscal,l_xscall,l_xscalr,                          &
     &              l_xtck,l_xtckl,l_xtckr,                             &
     &              l_yscal,                                            &
     &              l_ytext,                                            &
     &              l_ytck,                                             &
     &              l_yxscalr,l_ask                                     
                                                                        
      logical       b_exist,l_xscalt,l_xtckt,l_xtextb,l_xtextt,         &
     &              l_yscall,l_ytckl,l_ytckr,l_yscalr,l_ytextl,         &
     &              l_ytextr,l_xscalb,l_xtckb                           
      common/blog/  b_exist,l_xscalt,l_xtckt,l_xtextb,l_xtextt,         &
     &              l_yscall,l_ytckl,l_ytckr,l_yscalr,l_ytextl,         &
     &              l_ytextr,l_xscalb,l_xtckb                           
                                                                        
      character     cxanf(24),cxend(24),cxstep(24),                     &
     &              cyanf(24),cyend(24),cystep(24),cnum(24)             
      character*132 querytype(2),chcom,chstr(2),wrb*1 
!     &              canf*10,cend*10,cstep*10,cf*1                      
      real          out 
      dimension     out(32) 
                                                                        
      integer       ixscal,iyscal,ixtck,iytck,i,naxfor,                 &
     &              nxanf,nxend,nxstep,ixmod,                           &
     &              nyanf,nyend,nystep,iymod,iymode,                    &
     &              iout,nxx,nnum,it,nny,j,jj,ii                        
      real          G1,G2,G3,G4,G5,G6,old,h,wi1,wi2,wi,                 &
     &              absx,xscal,xoffset,xbck,hhx,x,xp,xxww,xwi,xpos,     &
     &              absy,yscal,yoffset,ybck,hhy,y,yp,yyww,zh,hlog10     
                                                                        
      integer       IX,IY,ixt,iyt,nx,ny,ixscp10,iyscp10,ixmode 
      real          xtop,ytop,xbot,ybot,xanfsc,xendsc,xstep,            &
     &              xanflg,xendlg,xanflgsc,xendlgsc,xlgstep,            &
     &              yanfsc,yendsc,ystep,zxtext,zytext,                  &
     &              yanflg,yendlg,yanflgsc,yendlgsc,ylgstep             
       common/top/  xtop,ytop,xbot,ybot,xanfsc,xendsc,xstep,            &
     &              xanflg,xendlg,xanflgsc,xendlgsc,xlgstep,            &
     &              yanfsc,yendsc,ystep,zxtext,zytext,                  &
     &              yanflg,yendlg,yanflgsc,yendlgsc,ylgstep,            &
     &              IX,IY,ixt,iyt,nx,ny,ixscp10,iyscp10,ixmode          
                                                                        
                                                                        
                                                                        
      hlog10=1.  !alog(10.0) 
                                                                        
      if(l_logx)then 
       xanflg=exp(xanf*hlog10) 
       xendlg=exp(xend*hlog10) 
       call scaling(xanflg,xendlg,1,xanflgsc,xendlgsc,xlgstep,i) 
       IX=ifix(abs(xanflgsc-xendlgsc)/xlgstep+.5)+1 
       nx=NAXFOR(xanflgsc,xendlgsc,xlgstep) 
       if(ixscp10.ne.0.and.nx.eq.0)then 
        h=10**ixscp10 
        do I=1,IX 
         XP=xendlgsc-I*xlgstep 
         j=XP/h 
         if(j*h+0.001.lt.Xp)nx=2 
        end do 
       end if 
      else 
       if(abs((xanf-xanfsc)/xstep).gt.0.95)xanfsc=xanfsc-xstep 
       ABSX= ABS((XENDSC-XANFSC)/XSTEP) 
       IX = IFIX(ABSX+.5) + 1 
       XOFFSET=XEND-XENDSC 
      end if 
                                                                        
      if(l_logy)then 
       yanflg=exp(yanf*hlog10) 
       yendlg=exp(yend*hlog10) 
       call scaling(yanflg,yendlg,1,yanflgsc,yendlgsc,ylgstep,i) 
       IY=ifix(abs(yanflgsc-yendlgsc)/ylgstep+.5)+1 
       ny=NAXFOR(yanflgsc,yendlgsc,ylgstep) 
       if(iyscp10.ne.0.and.ny.eq.0)then 
        h=10**iyscp10 
        do I=1,IY 
         YP=yendlgsc-I*ylgstep 
         j=YP/h 
         if(j*h+0.001.lt.Yp)ny=2 
        end do 
       end if 
      else 
       if(abs((yanf-yanfsc)/ystep).gt.0.95)yanfsc=yanfsc-ystep 
       ABSY= ABS((YENDSC-YANFSC)/YSTEP) 
       IY = IFIX(ABSY+.5) + 1 
       YOFFSET=YEND-YENDSC 
      end if 
                                                                        
                                                                        
!     l_new = true  : neuer Datensatz                                   
!     l_scal = true : neue Skalierung                                   
!     l_xaxb = true  : untere x-Achse gemalt ( in frame )               
!     l_xaxt = true  : obere x-Achse gemalt ( in frame )                
!     l_yaxl = true  : linke y-Achse gemalt ( in frame )                
!     l_yaxr = true  : rechte y-Achse gemalt ( in frame )               
!                                                                       
      l_ask= .not. (l_inter .and. l_def) 
      if (.not.l_inter.and.l_ask)wrb='r' 
      if (l_inter.and.l_ask)wrb='w' 
      if (l_inter.and..not.l_ask)wrb='d' 
                                                                        
                                    ! Faktor fuer Text                  
       zxtext=1. 
       zytext=1. 
       l_xtext=.true. 
       l_ytext=.true. 
                                    ! Skalierung an                     
       ixscal=1 
       iyscal=1 
       l_xscal=.true. 
       l_yscal=.true. 
                                    ! Achsen-Ticks an                   
       ixtck=1 
       iytck=1 
       l_xtck=.true. 
       l_ytck=.true. 
       if (l_xaxb .and. l_xaxt) then 
                                     ! normale x-Achsen-Skalierung      
        ixmode=0 
        l_xtextb=.true. 
        l_xtextt=.false. 
        l_xscalb=.true. 
        l_xscalt=.false. 
        l_xtckb=.true. 
        l_xtckt=.true. 
       else if (l_xaxb) then 
                                      ! untere x-Achsen-Skalierung      
        ixmode=-1 
        l_xtextb=.true. 
        l_xtextt=.false. 
        l_xscalb=.true. 
        l_xscalt=.false. 
        l_xtckb=.true. 
        l_xtckt=.false. 
       else if (l_xaxt) then 
                                      ! obere x-Achsen-Skalierung       
        ixmode=-2 
        l_xtextb=.false. 
        l_xtextt=.true. 
        l_xscalb=.false. 
        l_xscalt=.true. 
        l_xtckb=.false. 
        l_xtckt=.true. 
!cccc  else if (.not. l_xaxr .and. .not. l_xaxl) then                   
!cccc  >> l_xaxr und l_xaxl sind undefiniert                            
       else 
                                      ! keine x-Achsen-Skalierung       
        l_xtextl=.false. 
        l_xtextr=.false. 
        l_xscall=.false. 
        l_xscalr=.false. 
        l_xtckl=.false. 
        l_xtckr=.false. 
       end if 
       if (l_yaxl .and. l_yaxr) then 
                                     ! normale y-Achsen-Skalierung      
        iymode=0 
        l_ytextl=.true. 
        l_ytextr=.false. 
        l_yscall=.true. 
        l_yscalr=.false. 
        l_ytckl=.true. 
        l_ytckr=.true. 
       else if (l_yaxl) then 
                                      ! linke y-Achsen-Skalierung       
        iymode=-1 
        l_ytextl=.true. 
        l_ytextr=.false. 
        l_yscall=.true. 
        l_yscalr=.false. 
        l_ytckl=.true. 
        l_ytckr=.false. 
       else if (l_yaxr) then 
                                      ! rechte y-Achsen-Skalierung      
        iymode=-2 
        l_ytextl=.false. 
        l_ytextr=.true. 
        l_yscall=.false. 
        l_yscalr=.true. 
        l_ytckl=.false. 
        l_ytckr=.true. 
       else if (.not. l_yaxr .and. .not. l_yaxl) then 
                                      ! keine y-Achsen-Skalierung       
        l_ytextl=.false. 
        l_ytextr=.false. 
        l_yscall=.false. 
        l_yscalr=.false. 
        l_ytckl=.false. 
        l_ytckr=.false. 
       end if 
!                                                                       
                                                   !  no inscription on 
       if (.not. l_xaxb .and. .not. l_xaxt) then 
        zxtext=0. 
        l_xtext=.false. 
        ixscal=0 
        l_xscal=.false. 
        ixtck=0 
        l_xtck=.false. 
        l_word=.false. 
       end if 
!                                                                       
                                                   !  no inscription on 
       if (.not. l_yaxr .and. .not. l_yaxl) then 
        zytext=0. 
        l_ytext=.false. 
        iyscal=0 
        l_yscal=.false. 
        iytck=0 
        l_ytck=.false. 
       end if 
!***********************input section***********************************
                                                                        
                                                                        
!********************input of x-axis inscription************************
                                                                        
!      x-axis text size*          [1.0]   values, scale  (y,n) [y,y]    
                                                                        
       querytype(1)='x-axis text size*           [' 
       querytype(2)='     values, scale (y,n) [' 
       chstr(1)='1.0' 
       chstr(2)='y,y' 
       chcom='text size,values, scale' 
       call ask2strings(querytype,chstr,chcom,NPL,NRD,NWR,NBA,wrb) 
       call trlch(10,chstr(1),iout,out) 
       zxtext=out(1) 
       if (zxtext .lt. 0.01 ) then 
        l_xtext=.false. 
        zxtext=0. 
       else 
        l_xtext=.true. 
       end if 
                                                                        
       if(chstr(2)(1:1).eq.'y') then 
         l_xscal=.true. 
         ixscal=1 
       else 
         ixscal=0 
         l_xscal=.false. 
       end if 
                                                                        
       if(chstr(2)(3:3).eq.'y') then 
        l_xtck=.true. 
        ixtck=1 
       else 
        ixtck=0 
        l_xtck=.false. 
       end if 
                                                                        
!*********************input of x-inscription mode***********************
                                                                        
!      inscription           (normal,top,bottom,inverted)  [n]          
                                                                        
        if ( .not. l_xaxb) ixmode=-2 
        if ( .not. l_xaxt) ixmode=-1 
       chstr(1)='n' 
       if(ixmod.eq.-2) chstr(1)='t' 
       if(ixmod.eq.-1) chstr(1)='b' 
                                                                        
        querytype(1)=                                                   &
     & '    inscription               (normal,top,bottom,inverted) ['   
        chcom='inscription' 
       call ask1string(querytype(1),chstr(1),chcom,NPL,NRD,NWR,NBA,wrb) 
       if(chstr(1)(1:1).eq.'t') then 
                          ! top x-axis only                             
        ixmode=-2 
        l_xtextb=.false. 
        l_xtextt=.true. 
        l_xscalb=.false. 
        l_xscalt=.true. 
        l_xtckb=.false. 
        l_xtckt=.true. 
       else if(chstr(1)(1:1).eq.'b') then 
                           ! bottom x-axis only                         
        ixmode= -1 
        l_xtextb=.true. 
        l_xtextt=.false. 
        l_xscalb=.true. 
        l_xscalt=.false. 
        l_xtckb=.true. 
        l_xtckt=.false. 
       else if(chstr(1)(1:1).eq.'n') then 
                            ! normal x-axis                             
        ixmode=0 
        l_xtextb=.true. 
        l_xtextt=.false. 
        l_xscalb=.true. 
        l_xscalt=.false. 
        l_xtckb=.true. 
        l_xtckt=.true. 
       else if(chstr(1)(1:1).eq.'i') then 
                      ! inverse x-axis                                  
        ixmode= 1 
        l_xtextb=.false. 
        l_xtextt=.true. 
        l_xscalb=.false. 
        l_xscalt=.true. 
        l_xtckb=.true. 
        l_xtckt=.true. 
       end if 
                                                                        
!***********************************************************************
                                                                        
      l_xtextb = l_xtext .and. l_xtextb .and. l_xaxb 
      l_xtextt = l_xtext .and. l_xtextt .and. l_xaxt 
      l_xscalb = l_xscal .and. l_xscalb .and. l_xaxb 
      l_xscalt = l_xscal .and. l_xscalt .and. l_xaxt 
      l_xtckb  = l_xtck  .and. l_xtckb .and. l_xaxb 
      l_xtckt  = l_xtck  .and. l_xtckt .and. l_xaxt 
                                                                        
!      write(6,'(2(a,l3))')'l_xtextb=',l_xtextb,'  l_xtextt=',l_xtextt  
!      write(6,'(2(a,l3))')'l_xscalb=',l_xscalb,'  l_xscalt=',l_xscalt  
!      write(6,'(2(a,l3))')'l_xtckb =',l_xtckb,'  l_xtckt =',l_xtckt    
!**********************input section y-axis*****************************
                                                                        
!*******************input of y-axis inscription*************************
                                                                        
!      y-axis text size*          [1.0]   values, scale  (y,n) [y,y]    
                                                                        
       querytype(1)='y-axis text size*           [' 
       querytype(2)='     values, scale (y,n) [' 
       chstr(1)='1.0' 
       chstr(2)='y,y' 
       chcom='text size,values, scale' 
       call ask2strings(querytype,chstr,chcom,NPL,NRD,NWR,NBA,wrb) 
       call trlch(10,chstr(1),iout,out) 
       zytext=out(1) 
       if (zytext .lt. 0.01 ) then 
        l_ytext=.false. 
        zytext=0. 
       else 
        l_ytext=.true. 
       end if 
                                                                        
       if(chstr(2)(1:1).eq.'y') then 
         l_yscal=.true. 
         iyscal=1 
       else 
         iyscal=0 
         l_yscal=.false. 
       end if 
                                                                        
       if(chstr(2)(3:3).eq.'y') then 
        l_ytck=.true. 
        iytck=1 
       else 
        iytck=0 
        l_ytck=.false. 
       end if 
                                                                        
!***********************input of y-inscription mode*********************
                                                                        
!      inscription            (normal,left,right,inverted) [n]          
        if (.not. l_yaxl) iymode=-2 
        if (.not. l_yaxr) iymode=-1 
       chstr(1)='n' 
       if(iymod.eq.-2) chstr(1)='r' 
       if(iymod.eq.-1) chstr(1)='l' 
                                                                        
        querytype(1)=                                                   &
     & '    inscription               (normal,left,right,inverted) ['   
        chcom='inscription' 
       call ask1string(querytype(1),chstr(1),chcom,NPL,NRD,NWR,NBA,wrb) 
                                                                        
                                     ! right y-axis only                
       if(chstr(1)(1:1).eq.'r') then 
       iymode=-2 
       l_ytextl=.false. 
       l_ytextr=.true. 
       l_yscall=.false. 
       l_yscalr=.true. 
       l_ytckl=.false. 
       l_ytckr=.true. 
                                         ! left y-axis only             
      else if(chstr(1)(1:1).eq.'l')then 
       iymode= -1 
       l_ytextl=.true. 
       l_ytextr=.false. 
       l_yscall=.true. 
       l_yxscalr=.false. 
       l_ytckl=.true. 
       l_ytckr=.false. 
                                        ! normal y-axis                 
      else if(chstr(1)(1:1).eq.'n')then 
       iymode= 0 
       l_ytextl=.true. 
       l_ytextr=.false. 
       l_yscall=.true. 
       l_yscalr=.false. 
       l_ytckl=.true. 
       l_ytckr=.true. 
                                        ! inverse y-axis                
      else if(chstr(1)(1:1).eq.'i')then 
       iymode= 1 
       l_ytextl=.false. 
       l_ytextr=.true. 
       l_yscall=.false. 
       l_yscalr=.true. 
       l_ytckl=.true. 
       l_ytckr=.true. 
      end if 
                                                                        
!***********************************************************************
      l_ytextl = l_ytext .and. l_ytextl .and. l_yaxl 
      l_ytextr = l_ytext .and. l_ytextr .and. l_yaxr 
      l_yscall = l_yscal .and. l_yscall .and. l_yaxl 
      l_yscalr = l_yscal .and. l_yscalr .and. l_yaxr 
      l_ytckl  = l_ytck  .and. l_ytckl  .and. l_yaxl 
      l_ytckr  = l_ytck  .and. l_ytckr  .and. l_yaxr 
                                                                        
!***********************************************************************
                                                                        
!************************* size of plotarea*****************************
      call plotfrm1(xbot,ybot,xtop,ytop) 
      xbot=xbot-hx/2. 
      xtop=xtop+hx/2. 
      ytop=ytop+hy/2. 
      ybot=ybot-hy/2. 
                                                                        
      xscal=gx/(xend-xanf) 
      yscal=gy/(yend-yanf) 
                                                                        
      OLD=0. 
      XBCK=0. 
      YBCK=0. 
!************************plot inscription of bottom x-axis**************
      IF (l_xscalb) then 
       Y=YRAND 
       OLD=0. 
                                                                        
       DO  I=IX,1,-1 
        if(l_logx)then 
         XP=xendlgsc-(I-1)*xlgstep 
         X=XRAND+xoff_r+XSCAL*(alog(xendlg)/hlog10                      &
     &                -alog(XP)/hlog10)                                 
        else 
         X=XRAND+xoff_r+XSCAL*((I-1)*XSTEP+XOFFSET) 
         XP=XENDSC-(I-1)*XSTEP 
         G1=abs(XP/(XENDSC-XANFSC)) 
         if(G1.lt.1.E-4) XP=0.0 
        end if 
                                                                        
        if(G1.lt.1.E-4) XP=0.0 
         if ( xp .eq. 0. ) then 
         nxx=0 
        else 
         nxx=nx 
        end if 
        call numero(xp,nxx,cnum,nnum,1,ixscp10) 
                                                                        
        CALL TXTPLO (0.,0.,-1,cnum,nnum,hx,hy,0.,-1.,ybck,xwi,zh) 
        xwi=abs(xwi) 
        xpos=X+xwi/2. 
                                                     ! plot x-name      
        if (OLD.ge.xpos+xwi.or.I.eq.IX) then 
        CALL TXTPLO(y-2.*hy,xpos,-1,cnum,nnum,hx,hy,0.,-1.,ybck,xwi,zh) 
         if (ybck-(hx+hy)/4. .lt. ybot) ybot=ybck-(hx+hy)/4. 
         OLD=XPOS-HX 
        end if 
       END DO 
      END IF 
                                                                        
!*********************plot inscription of top x-axis********************
                                                                        
      IF (l_xscalt .or. l_xtckt) then 
       Y=YRAND+yoff_b+yoff_t+gy 
       OLD=0. 
                                                                        
       DO  I=IX,1,-1 
        if(l_logx)then 
         XP=xendlgsc-(I-1)*xlgstep 
         X=XRAND+xoff_r+XSCAL*(alog(xendlg)/hlog10                      &
     &                -alog(XP)/hlog10)                                 
        else 
         X=XRAND+xoff_r+XSCAL*((I-1)*XSTEP+XOFFSET) 
         XP=XENDSC-(I-1)*XSTEP 
         G1=abs(XP/(XENDSC-XANFSC)) 
         if(G1.lt.1.E-4) XP=0.0 
        end if 
        if ( XP .eq. 0. ) then 
         nxx=0 
        else 
         nxx=nx 
        end if 
        call numero(xp,nxx,cnum,nnum,1,ixscp10) 
                                                                        
        CALL TXTPLO (0.,0.,-1,cnum,nnum,hx,hy,0.,-1.,ybck,xwi,zh) 
        xwi=abs(xwi) 
        xpos=x+xwi/2. 
        IF (OLD.ge.xpos+xwi.or.I.eq.IX) then 
        CALL TXTPLO(y+.5*hy,xpos,-1,cnum,nnum,hx,hy,0.,-1.,ybck,xwi,zh) 
         OLD=XPOS 
         if (ybck+zh+(hx+hy)/2. .gt. ytop) ytop=ybck+zh+(hx+hy)/2. 
        end if 
       END DO 
      END IF 
                                                                        
!***********************plot name of x-axis*****************************
                                                                        
      IF (l_xtextb .or. l_xtextt ) then 
       hhx=hx*zxtext 
       hhy=hy*zxtext 
       if (l_xtextb) then 
        if (l_xscalb ) then 
         G1=YRAND-3.8*hhy 
         if(l_logx)G1=G1-0.3*hhy 
        else 
         G1=yrand-1.5*hhy 
        end if 
       end if 
       if (l_xtextt) then 
        if (l_xscalt) then 
         G1=YRAND+GY+yoff_t+yoff_b+2.2*hhy 
         if(l_logx)G1=G1+0.3*hhy 
        else 
         G1=yrand+gy+yoff_t+yoff_b+.2*hhy 
        end if 
       end if 
       it=80 
       do while ( it.gt.0 .and. CXTEXT(it).eq.' ' ) 
        it=it-1 
       end do 
       if ( it.gt.0 ) then 
        if(CXTEXT(it).eq.';') then 
         CXTEXT(it)=' ' 
         l_semi=.true. 
        else 
         l_semi=.false. 
        end if 
        G2=XRAND+xoff_l+FLOAT(it)*hhx 
        G3=0. 
        G4=-1. 
        CALL TXTPLO (G1,G2,-1,CXTEXT,it,hhx,hhy,G3,G4,G5,G6,zh) 
        g1=g1+zh 
        G5=G5-(hhx+hhy)/4. 
        if (g1.gt. ytop) ytop=g1 
        if (G5 .lt. ybot) ybot=G5 
                                                                        
        if (.not. l_semi) G2=XRAND+xoff_l+(G2-G6) 
        CALL TXTPLO (G1,G2,-1,CXTEXT,it,hhx,hhy,G3,G4,G5,G6,zh) 
        g1=g1+zh+(hhx+hhy)/2. 
        G5=G5-(hhx+hhy)/2. 
        if (g1.gt. ytop) ytop=g1 
        if (G5 .lt. ybot) ybot=G5 
       end if 
      end if 
                                                                        
!*********************plot inscription of left y-axis*******************
      IF (l_yscall .or. l_ytckl) then 
       X=XRAND+xoff_l+xoff_r+GX 
       OLD=0. 
       DO  I=1,IY
        if(l_logy)then 
         YP=yendlgsc-(I-1)*ylgstep 
         Y=YRAND+yoff_b+GY-YSCAL*(alog(yendlgsc+YOFFSET)/hlog10-alog(YP)/hlog10)
        else 
         Y=YRAND+yoff_b+GY-YSCAL*((I-1)*YSTEP+YOFFSET) 
         YP=YENDSC-(I-1)*YSTEP 
         G1=abs(YP/(YENDSC-YANFSC)) 
         if(G1.lt.1.E-4) YP=0.0 
        end if 
                                                                        
        if ( Yp .eq. 0. ) then 
         nny=0 
        else 
         nny=ny 
        end if 
        call numero(yp,nny,cnum,nnum,1,iyscp10)  ! normal yaxis 
        IF( l_yscall ) then 
         CALL TXTPLO (0.,0.,-1,cnum,nnum,hx,hy,0.,-1.,ybck,xwi,zh)
         xwi=abs(xwi)+hx 

         if(nny .lt. 0) xwi=xwi-.5*hx 
         if( I.EQ.1 .or. OLD.ge.Y+1.5*HY) then 
          CALL txtplo(Y-HY/2.,X+xwi,-1,cnum,nnum,HX,HY,0.,-1.,YBCK,XBCK,zh)     
          OLD=Y 
          if(xtop.lt.XBCK+xwi) xtop=XBCK+xwi 
         end if 
        END IF 

       END DO 
      END IF 
                                                                        
!*********************plot inscription of right y-axis******************
                                                                        
      IF (l_yscalr.or.l_ytckr ) then 
       X=XRAND 
       OLD=0. 
                                                                        
                                                                        
                            !  values at right y-axis                   
       IF ( l_yscalr ) then 
        DO  I=1,IY 
         if(l_logy)then 
          YP=yendlgsc-(I-1)*ylgstep 
          Y=YRAND+yoff_b+GY-YSCAL*(alog(yendlgsc+YOFFSET)/hlog10        &
     &                -alog(YP)/hlog10)                                 
         else 
          Y=YRAND+yoff_b+GY-YSCAL*((I-1)*YSTEP+YOFFSET) 
          YP=YENDSC-(I-1)*YSTEP 
          G1=abs(YP/(YENDSC-YANFSC)) 
          if(G1.lt.1.E-4) YP=0.0 
         end if 
                                                                        
         if ( Yp .eq. 0. ) then 
          nny=0 
         else 
          nny=ny 
         end if 
         call numero(yp,nny,cnum,nnum,1,iyscp10) 
                                                                        
         if( I.EQ.1 .or. OLD.ge.Y-1.5*HY) then 
          CALL txtplo(Y-HY/2.,X-hx,-1,cnum,nnum,HX,HY,0.,-1.,           &
     &                                                 YBCK,XBCK,zh)    
          if(xbot.gt.XBCK-nnum*hx-zh)xbot=XBCK-nnum*hx-zh 
          OLD=Y 
         end if 
                                                                        
        END DO 
       END IF 
      END IF 
!***********************plot name of y-axis*****************************
                                                                        
      if ( l_ytextl .or. l_ytextr ) then 
       hhx=hx*zytext 
       hhy=hy*zytext 
       if (l_yscalr .or. l_yscall) then 
        call numero(yanfsc,ny,cnum,nnum,1,iyscp10) 
        CALL txtplo(0.,0.,-1,cnum,nnum,HX,HY,0.,-1.,YBCK,wi1,zh) 
        wi1=abs(wi1) 
        call numero(yendsc,ny,cnum,nnum,1,iyscp10) 
        CALL txtplo(0.,0.,-1,cnum,nnum,HX,HY,0.,-1.,YBCK,wi2,zh) 
        wi2=abs(wi2) 
        wi=amax1(wi1,wi2) 
       else 
        wi=0. 
       end if 
                                                                        
       it=80 
       do while (it.gt.0 .and. CYTEXT(it).eq.' ' ) 
        it=it-1 
       end do 
       if ( it .gt. 0) then 
        if (CYTEXT(it).eq.';') then 
         CYTEXT(it)=' ' 
         l_semi=.true. 
        else 
         l_semi=.false. 
        end if 
        if (l_ytextl) then 
         G1=YRAND+GY+yoff_b-FLOAT(it)*hhx 
         G2=XRAND+GX+xoff_l+xoff_r+1.5*HX+.5*HHY+WI 
         if(l_logy)G2=G2+1.5**HX 
         G3=1. 
         G4=0. 
        else if (l_ytextr) then 
         G1=YRAND+GY+yoff_b-FLOAT(it)*hhx 
         G2=XRAND-HX-1.5*HHY-WI 
         G3=1. 
         G4=0. 
        end if 
!       write(6,'(a,80a1)')'a CYTEXT=',CYTEXT                           
                                                                        
        CALL TXTPLO (0.,0.,-1,CYTEXT,it,hhx,hhy,G3,G4,yyww,xxww,zh) 
        if (.not. l_semi) g1=yrand+gy+yoff_b-yyww 
                                                                        
!        write(6,'(a,5f10.3)')'axscl ,G2,..=',G2,XRAND                  
        CALL TXTPLO (G1,G2,-1,CYTEXT,it,hhx,hhy,G3,G4,G5,G6,zh) 
        G2=G2+(hhx+hhy)/2.+zh 
        G6=G6-(hhx+hhy)/2. 
        if (xbot .gt. G6) xbot=G6 
                                                                        
        if (G2 .gt. xtop) xtop=G2 
       end if 
      end if 
                                                                        
!************************ plot wordcard*********************************
                                                                        
      if (l_word) then 
       hhx=hx*zxtext 
       hhy=hy*zxtext 
                                                                        
       g2= xrand+gx+xoff_r 
       if (ixmode.eq.-2.or.ixmode.eq. 0)  g1=yrand-2.*hy 
       if (ixmode.eq.-1.or.ixmode.eq.1)  g1=yrand+GY+yoff_b+yoff_t+2.*hy 
       if (l_xtextb) then 
        if (l_xscalb ) then 
         G1=YRAND-3.5*hhy-3.*hy 
        else 
         G1=yrand-1.5*hhy-3.*hy 
        end if 
       else 
        if (l_xscalb ) g1=g1-2.*hy 
       end if 
       if (l_xtextt) then 
        if (l_xscalt) then 
         G1=YRAND+GY+yoff_b+yoff_t+2.2*hhy+3.*hy 
        else 
         G1=yrand+gy+yoff_b+yoff_t+.2*hhy+3.*hy 
        end if 
       else 
        if (l_xscalt) g1=g1+2.*hy 
       end if 
       it=132 
       do while (it.gt.0 .and. CTEXT(it).eq.' ' ) 
        it=it-1 
       end do 
       g3=0 
       g4=-1. 
       CALL TXTPLO (G1,G2,-1,CTEXT,it,hy,hx,G3,G4,G5,G6,zh) 
       G5=G5-zh-(hx+hy)/2. 
       G1=G1+zh+(hx+hy)/2. 
       if (G5 .lt. ybot) ybot=G5 
       if (G1 .gt. ytop) ytop=G1 
      end if 
!     write(6,'(a,2f10.3)')'3  axscl ybot,ytop=',ybot,ytop              
                                                                        
      return 
      END                                           
                                                                        
                                                                        
      subroutine dothebenplot
      use comalp 
      implicit none 
!     plottet Achsen-Beschriftung und Textzeile                         
!                                                                       
!     M. Alflen 15.12.89                                                
!                                                                       
!	erweitert um variablen offset zwischen Rahmen und Plot                
!                                                                       
!     Modifiziert: A.Vef, 12.11.90                                      
!       geaenderte Erkennung symmetrischer x-Skala (Moessbauer-Spektrum)
!       Grund: vorher falsche Skalierung bei ESCA-Daten                 
                                                                        
      character*1   CTEXT,CXTEXT,CYTEXT 
      COMMON /TXT/  CTEXT(132),CXTEXT(80),CYTEXT(80) 
                                                                        
      logical       b_exist,l_xscalt,l_xtckt,l_xtextb,l_xtextt,         &
     &              l_yscall,l_ytckl,l_ytckr,l_yscalr,l_ytextl,         &
     &              l_ytextr,l_xscalb,l_xtckb                           
      common/blog/  b_exist,l_xscalt,l_xtckt,l_xtextb,l_xtextt,         &
     &              l_yscall,l_ytckl,l_ytckr,l_yscalr,l_ytextl,         &
     &              l_ytextr,l_xscalb,l_xtckb                           
                                                                        
      integer       IX,IY,ixt,iyt,nx,ny,ixscp10,iyscp10,ixmode 
      real          xtop,ytop,xbot,ybot,xanfsc,xendsc,xstep,            &
     &              xanflg,xendlg,xanflgsc,xendlgsc,xlgstep,            &
     &              yanfsc,yendsc,ystep,zxtext,zytext,                  &
     &              yanflg,yendlg,yanflgsc,yendlgsc,ylgstep             
       common/top/  xtop,ytop,xbot,ybot,xanfsc,xendsc,xstep,            &
     &              xanflg,xendlg,xanflgsc,xendlgsc,xlgstep,            &
     &              yanfsc,yendsc,ystep,zxtext,zytext,                  &
     &              yanflg,yendlg,yanflgsc,yendlgsc,ylgstep,            &
     &              IX,IY,ixt,iyt,nx,ny,ixscp10,iyscp10,ixmode          
                                                                        
      real          xtick,ytick,                                        &
     &              dy,aynn,xscal,yscal,OLD,XBCK,YBCK,xoffset,yoffset,  &
     &              h,hhx,hhy,X,XP,Y,YP,g1,g2,g3,g4,g5,g6,              &
     &              yyww,xxww,zh,xpos,xwi,ywi,                          &
     &              wi,wi1,wi2,ABSX,ABSY,hlog10                         
      integer       i,ii,i0,j,jj,nn,it,nnum,nxx,nny,nold_pen 
                                                                        
      logical       l_semi 
      character     ende*4,cnum*1,bsl*1 
      dimension     xtick(20),ytick(20),cnum(24) 
                                                                        
      i0=ichar('0') 
      bsl=char(92) 
      hlog10=1.  !alog(10.0) 
                                                                        
      XOFFSET=XEND-XENDSC 
      YOFFSET=YEND-YENDSC 
                                                                        
!*************************** plot of background area********************
!       plot of background area                                         
       if(nbackgr.ne.1) then 
!       write(6,'(a,2i4)')'axscl  nbackgr,npen=',nbackgr,npen           
        call PFUMA(nbackgr) 
        call traa(ybot,xbot,0) 
        call traa(ybot,xtop,1) 
        call traa(ytop,xtop,1) 
        call traa(ytop,xbot,1) 
        nold_pen=nbackgr 
        call pluma(nold_pen) 
       end if 
!***************************                                            
                                                                        
      call plotframe 
      l_more=nplotsub.gt.1 
      if(l_more) then 
       nplotsub=nplotsub-1 
       l_more=nplotsub.gt.1 
       inquire (file='common.dat',exist=b_exist) 
       if(b_exist) then 
   10   read(11,'(2i6,l3)')NCOUNT,MAXN,l_error 
        do i=1,NCOUNT 
         read(11,'(4f15.5,i6)')XX(1,i),XX(2,i),YY(1,i),YY(2,i),NSYM(i) 
        end do 
        call plotthedata 
        read(11,'(a)')ende 
        backspace(11) 
        if(ende.ne.'ende') goto 10 
       else 
        call plotthedata 
       end if 
      else 
        call plotthedata 
      end if 
                                                                        
        nold_pen=-1 
        call pluma(nold_pen) 
!********************************************************************** 
      xscal=gx/(xend-xanf) 
      yscal=gy/(yend-yanf) 
      XBCK=0. 
      YBCK=0. 
!*****************plot inscription of bottom x-axis*********************
      IF (l_xscalb .or. l_xtckb) then 
       Y=YRAND 
       OLD=0. 
!---                                                                    
       if(ixscp10.gt.0.and.l_xtextb)then 
         jj=ixscp10 
         i=jj/10 
         ii=jj-10*i 
         bsl=char(92) 
         j=80 
         do while(CXTEXT(j).eq.' ') 
          j=j-1 
         end do 
         j=j+2 
                                                                        
          CXTEXT(j)='[' 
          CXTEXT(j+1)=bsl 
          CXTEXT(j+2)=',' 
          CXTEXT(j+3)='1' 
          CXTEXT(j+4)='0' 
          CXTEXT(j+5)='$' 
          CXTEXT(j+6)='^' 
         if(i.eq.0) then 
          CXTEXT(j+7)=char(jj+i0) 
          j=j+7 
         else 
          CXTEXT(j+7)=char(i+i0) 
          CXTEXT(j+8)=char(ii+i0) 
          j=j+8 
         end if 
          CXTEXT(j+1)='$' 
          CXTEXT(j+2)=' ' 
          CXTEXT(j+3)=bsl 
          CXTEXT(j+4)=',' 
          CXTEXT(j+5)=']' 
       end if 
!---                                                                    
       DO  I=IX,1,-1 
        if(l_logx)then 
         XP=xendlgsc-(I-1)*xlgstep 
         X=XRAND+xoff_r+XSCAL*(alog(xendlg)/hlog10-alog(XP)/hlog10)
         XP=xendlgsc-I*xlgstep 
         do j=1,IXT-1 
          h=float(j)/IXT*xlgstep 
          xtick(j)=XRAND+xoff_r+XSCAL*(alog(xendlg)/hlog10-alog(XP+h)/hlog10)
         end do 
        else 
         X=XRAND+xoff_r+XSCAL*((I-1)*XSTEP+XOFFSET) 
        end if 
                                                                        
        CALL TRAA (Y,X,0) 
        IF (l_xtckb) CALL TRAA (Y+HY/2.,X,1) 
                                                                        
                              ! values at bottom x-axis                 
        IF ( l_xscalb ) THEN 
         if(l_logx)then 
          XP=xendlgsc-(I-1)*xlgstep 
         else 
          XP=XENDSC-(I-1)*XSTEP 
          G1=abs(XP/(XENDSC-XANFSC)) 
          if(G1.lt.1.E-4) XP=0.0 
         end if 
         if ( xp .eq. 0. ) then 
          nxx=0 
         else 
          nxx=nx 
         end if 
         call numero(xp,nxx,cnum,nnum,1,ixscp10) 
                                                                        
         CALL TXTPLO (0.,0.,-1,cnum,nnum,hx,hy,0.,-1.,ybck,xwi,zh) 
         xwi=abs(xwi) 
         xpos=X+xwi/2. 
                                                      ! plot x-name     
         if (OLD.ge.xpos+xwi.or.I.eq.IX) then 
          CALL TXTPLO(y-2.*hy,xpos,1,cnum,nnum,hx,hy,0.,-1.,ybck,xwi,zh) 
          OLD=XPOS 
         end if 
        END IF 
!                                                                       
        IF (I.ne.IX.and. l_xtckb) then 
         DO  J=1,IXT-1 
          X=X+XSTEP*XSCAL/IXT 
          if(l_logx)X=xtick(J) 
          CALL TRAA (Y,X,0) 
          CALL TRAA (Y+HY/4.,X,1) 
         END DO 
        END IF 
!                                                                       
       END DO 
      END IF 
!                                                                       
!***********************************************************************
!                                                                       
!     plot inscription of top x-axis                                    
!                                                                       
!***********************************************************************
!                                                                       
      IF (l_xscalt .or. l_xtckt) then 
       Y=YRAND+yoff_b+yoff_t+gy 
       OLD=0. 
!---                                                                    
       if(ixscp10.gt.0.and.l_xtextt)then 
        jj=ixscp10 
        i=jj/10 
        ii=jj-10*i 
        bsl=char(92) 
        j=80 
        do while(CXTEXT(j).eq.' ') 
         j=j-1 
        end do 
        j=j+2 
                                                                        
        CXTEXT(j)='[' 
        CXTEXT(j+1)=bsl 
        CXTEXT(j+2)=',' 
        CXTEXT(j+3)='1' 
        CXTEXT(j+4)='0' 
        CXTEXT(j+5)='$' 
        CXTEXT(j+6)='^' 
        if(i.eq.0) then 
         CXTEXT(j+7)=char(jj+i0) 
         j=j+7 
        else 
         CXTEXT(j+7)=char(i+i0) 
         CXTEXT(j+8)=char(ii+i0) 
         j=j+8 
        end if 
        CXTEXT(j+1)='$' 
        CXTEXT(j+2)=' ' 
        CXTEXT(j+3)=bsl 
        CXTEXT(j+4)=',' 
        CXTEXT(j+5)=']' 
       end if 
                                                                        
!---                                                                    
       DO  I=IX,1,-1 
        if(l_logx)then 
         XP=xendlgsc-(I-1)*xlgstep 
         X=XRAND+xoff_r+XSCAL*(alog(xendlg)/hlog10-alog(XP)/hlog10) 
         XP=xendlgsc-I*xlgstep 
         do j=1,IXT-1 
          h=float(j)/IXT*xlgstep 
          xtick(j)=XRAND+xoff_r+XSCAL*(alog(xendlg)/hlog10-alog(XP+h)/hlog10)
         end do 
        else 
         X=XRAND+xoff_r+XSCAL*((I-1)*XSTEP+XOFFSET) 
        end if 
                                                                        
        CALL TRAA (Y,X,0) 
        IF (l_xtckt) CALL TRAA (Y-HY/2.,X,1) 
                                                                        
                              ! values at top x-axis                    
        IF ( l_xscalt ) THEN 
         if(l_logx)then 
          XP=xendlgsc-(I-1)*xlgstep 
         else 
          XP=XENDSC-(I-1)*XSTEP 
          G1=abs(XP/(XENDSC-XANFSC)) 
          if(G1.lt.1.E-4) XP=0.0 
         end if 
         if ( xp .eq. 0. ) then 
          nxx=0 
         else 
          nxx=nx 
         end if 
         call numero(xp,nxx,cnum,nnum,1,ixscp10) 
                                                                        
         CALL TXTPLO (0.,0.,-1,cnum,nnum,hx,hy,0.,-1.,ybck,xwi,zh) 
         xwi=abs(xwi) 
         xpos=x+xwi/2. 
                                                                        
                                                     ! plot x-name      
         if(OLD.ge.xpos+xwi.or.I.eq.IX) then 
          CALL TXTPLO(y+.5*hy,xpos,1,cnum,nnum,hx,hy,0.,-1.,ybck,xwi,zh) 
          OLD=XPOS 
         end if 
        END IF 
                                                                        
        IF (I.ne.IX .and. l_xtckt) then 
         DO  J=1,IXT-1 
          X=X+XSTEP*XSCAL/IXT 
          if(l_logx)X=xtick(J) 
          CALL TRAA (Y,X,0) 
          CALL TRAA (Y-HY/4.,X,1) 
         END DO 
        END IF 
       END DO 
      END IF 
!                                                                       
!***********************************************************************
!                                                                       
!     plot name of x-axis                                               
!                                                                       
!***********************************************************************
!                                                                       
      IF (l_xtextb .or. l_xtextt ) then 
       hhx=hx*zxtext 
       hhy=hy*zxtext 
       if (l_xtextb) then 
        if (l_xscalb ) then 
         G1=YRAND-3.8*hhy 
         if(l_logx)G1=G1-0.3*hhy 
        else 
         G1=yrand-1.5*hhy 
        end if 
       end if 
       if (l_xtextt) then 
        if (l_xscalt) then 
         G1=YRAND+GY+yoff_t+yoff_b+2.2*hhy 
         if(l_logx)G1=G1+0.3*hhy 
        else 
         G1=YRAND+GY+yoff_t+yoff_b+.2*hhy 
        end if 
       end if 
       it=80 
       do while ( it.gt.0 .and. CXTEXT(it).eq.' ' ) 
        it=it-1 
       end do 
       if ( it.gt.0 ) then 
        if(CXTEXT(it).eq.';') then 
         CXTEXT(it)=' ' 
         l_semi=.true. 
        else 
         l_semi=.false. 
        end if 
        G2=XRAND+xoff_l+FLOAT(it)*hhx 
        G3=0. 
        G4=-1. 
        CALL TXTPLO (G1,G2,-1,CXTEXT,it,hhx,hhy,G3,G4,G5,G6,zh) 
        if (.not. l_semi) G2=XRAND+xoff_l+(G2-G6) 
        CALL TXTPLO (G1,G2,0,CXTEXT,it,hhx,hhy,G3,G4,G5,G6,zh) 
       end if 
!                                                                       
      end if 
!                                                                       
!***********************************************************************
!                                                                       
!     plot inscription of left y-axis                                   
!                                                                       
!***********************************************************************
      IF (l_yscall .or. l_ytckl) then 
       X=XRAND+xoff_l+xoff_r+GX 
       OLD=0. 
!---                                                                    
       if(iyscp10.gt.0.and.l_ytextl)then 
         jj=iyscp10 
         i=jj/10 
         ii=jj-10*i 
         bsl=char(92) 
         j=80 
         do while((CYTEXT(j).eq.' '.or.CYTEXT(j).eq.'$').and.j.gt.1) 
          j=j-1 
         end do 
         j=j+2 
         if(CYTEXT(1).ne.'*') then
          CYTEXT(j)='[' 
          CYTEXT(j+1)=bsl 
          CYTEXT(j+2)=',' 
          CYTEXT(j+3)='1' 
          CYTEXT(j+4)='0' 
          CYTEXT(j+5)='$' 
          CYTEXT(j+6)='^' 
         if(i.eq.0) then 
          CYTEXT(j+7)=char(jj+i0) 
          j=j+7 
         else 
          CYTEXT(j+7)=char(i+i0) 
          CYTEXT(j+8)=char(ii+i0) 
          j=j+8 
         end if 
          CYTEXT(j+1)='$' 
          CYTEXT(j+2)=' ' 
          CYTEXT(j+3)=bsl 
          CYTEXT(j+4)=',' 
          CYTEXT(j+5)=']'
        else
          CYTEXT(1)=' '
        end if  
       end if 
!---                                                                    
       DO  I=1,IY 
        if(l_logy)then 
         YP=yendlgsc-(I-1)*ylgstep 
         Y=YRAND+yoff_b+GY-YSCAL*(alog(yendlg)/hlog10-alog(YP)/hlog10) 
         YP=yendlgsc-I*ylgstep 
         do j=1,IYT-1 
          h=float(j)/IYT*ylgstep 
          ytick(j)=YRAND+yoff_b+GY-YSCAL*(alog(yendlg)/hlog10-alog(YP+h)/hlog10)
         end do 
        else 
         Y=YRAND+yoff_b+GY-YSCAL*((I-1)*YSTEP+YOFFSET) 
        end if 
                                                                        
        CALL TRAA (Y,X,0) 
        IF(l_ytckl) CALL TRAA (Y,X-HX/2.,1) 
                                                                        
        if(l_logy)then 
         YP=yendlgsc-(I-1)*ylgstep 
        else 
         YP=YENDSC-(I-1)*YSTEP 
         G1=abs(YP/(YENDSC-YANFSC)) 
         if(G1.lt.1.E-4) YP=0.0 
        end if 
        if ( Yp .eq. 0. ) then 
         nny=0 
        else 
         nny=ny 
        end if 
        call numero(yp,nny,cnum,nnum,1,iyscp10) 

        if ( l_yscall ) then  ! normal yaxis  
         CALL TXTPLO (0.,0.,-1,cnum,nnum,hx,hy,0.,-1.,ybck,ywi,zh) 
         ywi=abs(ywi)+hx 
         if (nny .lt. 0) ywi=ywi-.5*hx    ! e-Format korrigieren  
         IF ( I.EQ.1 .or. OLD.ge.Y+1.5*HY) then 
          CALL txtplo(Y-HY/2.,X+ywi,1,cnum,nnum,HX,HY,0.,-1.,YBCK,XBCK,zh)     
          OLD=Y 
         end if 
        END IF 
!                                                                       
        IF (I.ne.IY .and. l_ytckl ) then 
         DO  J=1,IYT-1 
          if(l_logy)then 
            Y=ytick(J) 
          else 
           Y=Y-YSTEP*YSCAL/IYT 
          end if 
          call traa(y,x,0) 
          CALL TRAA (Y,X-HX/4.,1) 
         END DO 
        END IF 
!                                                                       
       END DO 
!                                                                       
      END IF 
!                                                                       
!***********************************************************************
!                                                                       
!     plot inscription of right y-axis                                  
!                                                                       
!***********************************************************************
      IF (l_ytckr ) then 
        X=XRAND 
        OLD=0. 
!---                                                                    
       if(iyscp10.gt.0.and.l_ytextr)then 
         jj=iyscp10 
         i=jj/10 
         ii=jj-10*i 
         bsl=char(92) 
         j=80 
         do while(CYTEXT(j).eq.' '.and.j.gt.1) 
          j=j-1 
         end do 
         j=j+2 
                                                                        
          CYTEXT(j)='[' 
          CYTEXT(j+1)=bsl 
          CYTEXT(j+2)=',' 
          CYTEXT(j+3)='1' 
          CYTEXT(j+4)='0' 
          CYTEXT(j+5)='$' 
          CYTEXT(j+6)='^' 
         if(i.eq.0) then 
          CYTEXT(j+7)=char(jj+i0) 
          j=j+7 
         else 
          CYTEXT(j+7)=char(i+i0) 
          CYTEXT(j+8)=char(ii+i0) 
          j=j+8 
         end if 
          CYTEXT(j+1)='$' 
          CYTEXT(j+2)=' ' 
          CYTEXT(j+3)=bsl 
          CYTEXT(j+4)=',' 
          CYTEXT(j+5)=']' 
       end if 
!---                                                                    
       DO  I=1,IY 
        if(l_logy)then 
         YP=yendlgsc-(I-1)*ylgstep 
         Y=YRAND+yoff_b+GY-YSCAL*(alog(yendlg)/hlog10                   &
     &                -alog(YP)/hlog10)                                 
         YP=yendlgsc-I*ylgstep 
         do j=1,IYT-1 
          h=float(j)/IYT*ylgstep 
          ytick(j)=YRAND+yoff_b+GY-YSCAL*(alog(yendlg)/hlog10           &
     &                -alog(YP+h)/hlog10)                               
         end do 
        else 
         Y=YRAND+yoff_b+GY-YSCAL*((I-1)*YSTEP+YOFFSET) 
        end if 
                                                                        
        CALL TRAA (Y,X,0) 
        IF(l_ytckr) CALL TRAA (Y,X+HX/2.,1) 
                                                                        
        if(l_logy)then 
         YP=yendlgsc-(I-1)*ylgstep 
        else 
         YP=YENDSC-(I-1)*YSTEP 
         G1=abs(YP/(YENDSC-YANFSC)) 
         if(G1.lt.1.E-4) YP=0.0 
        end if 
        if ( Yp .eq. 0. ) then 
         nny=0 
        else 
         nny=ny 
        end if 
        call numero(yp,nny,cnum,nnum,1,iyscp10) 
                                                                        
                             !  values at right y-axis                  
        IF ( l_yscalr ) then 
                                                                        
         IF ( I.EQ.1 .or. OLD.ge.Y+1.5*HY) then 
          CALL txtplo(Y-HY/2.,X-hx,1,cnum,nnum,HX,HY,0.,-1.,            &
     &                                                 YBCK,XBCK,zh)    
          OLD=Y 
         end if 
        END IF 
!                                                                       
        IF (I.ne.IY .and. l_ytckr ) then 
         DO J=1,IYT-1 
          if(l_logy)then 
            Y=ytick(J) 
          else 
           Y=Y-YSTEP*YSCAL/IYT 
          end if 
          call traa(y,x,0) 
          CALL TRAA (Y,X+HX/4.,1) 
         END DO 
        END IF 
       END DO 
      END IF 
!                                                                       
!***********************************************************************
!                                                                       
!     plot name of y-axis                                               
!                                                                       
!***********************************************************************
!                                                                       
      if ( l_ytextl .or. l_ytextr ) then 
       hhx=hx*zytext 
       hhy=hy*zytext 
       if (l_yscalr .or. l_yscall) then 
        call numero(yanfsc,ny,cnum,nnum,1,iyscp10) 
        CALL txtplo(0.,0.,-1,cnum,nnum,HX,HY,0.,-1.,YBCK,wi1,zh) 
        wi1=abs(wi1) 
        call numero(yendsc,ny,cnum,nnum,1,iyscp10) 
        CALL txtplo(0.,0.,-1,cnum,nnum,HX,HY,0.,-1.,YBCK,wi2,zh) 
        wi2=abs(wi2) 
        wi=amax1(wi1,wi2) 
       else 
        wi=0. 
       end if 
                                                                        
       it=80 
       do while (it.gt.0 .and. CYTEXT(it).eq.' ' ) 
        it=it-1 
       end do 
       if ( it .gt. 0) then 
        if (CYTEXT(it).eq.';') then 
         CYTEXT(it)=' ' 
         l_semi=.true. 
        else 
         l_semi=.false. 
        end if 
        if (l_ytextl) then 
         G1=YRAND+GY+yoff_b-FLOAT(it)*hhx 
         G2=XRAND+GX+xoff_l+xoff_r+1.5*HX+.5*HHY+WI 
         if(l_logy)G2=G2+1.5**HX 
         G3=1. 
         G4=0. 
        else if (l_ytextr) then 
         G1=YRAND+GY+yoff_b-FLOAT(it)*hhx 
         G2=XRAND-HX-1.5*HHY-WI 
         if(l_logy)G2=G2-2*HX 
         G3=1. 
         G4=0. 
        end if 
!                                                                       
        CALL TXTPLO (0.,0.,-1,CYTEXT,it,hhx,hhy,G3,G4,yyww,xxww,zh) 
                                                        ! correct for st
        if (.not. l_semi) g1=yrand+gy+yoff_b-yyww 
        CALL TXTPLO (G1,G2,1,CYTEXT,it,hhx,hhy,G3,G4,G5,G6,zh) 
       end if 
!                                                                       
      end if 
!                                                                       
!***********************************************************************
!                                                                       
!     plot wordcard                                                     
!                                                                       
!***********************************************************************
!                                                                       
      if (l_word) then 
       hhx=hx*zxtext 
       hhy=hy*zxtext 
                                                                        
       nold_pen=0 
       call pluma(nold_pen) 
       g2= xrand+gx+xoff_r 
       if (ixmode.eq.-2.or.ixmode.eq. 0) g1=yrand-2.*hy 
       if (ixmode.eq.-1.or.ixmode.eq.1)  g1=yrand+GY+yoff_b+yoff_t+2.*hy 
       if (l_xtextb) then 
        if (l_xscalb ) then 
         G1=YRAND-3.5*hhy-3.*hy 
        else 
         G1=yrand-1.5*hhy-3.*hy 
        end if 
       else 
        if (l_xscalb ) g1=g1-2.*hy 
       end if 
       if (l_xtextt) then 
        if (l_xscalt) then 
         G1=YRAND+GY+yoff_b+yoff_t+2.2*hhy+3.*hy 
        else 
         G1=yrand+gy+yoff_b+yoff_t+.2*hhy+3.*hy 
        end if 
       else 
        if (l_xscalt) g1=g1+2.*hy 
       end if 
       it=132 
       do while (it.gt.0 .and. CTEXT(it).eq.' ' ) 
        it=it-1 
       end do 
       g3=0 
       g4=-1. 
       CALL TXTPLO (G1,G2,1,CTEXT,it,hy,hx,G3,G4,G5,G6,zh) 
      end if 
                                                                        
      return 
      END                                           
                                                                        
      subroutine numexp(X,inum,nnum) 
      real X 
      integer in,i10,i1,nnum,k 
      character*1 inum(24) 
      i0=ichar('0') 
      do i=1,24 
       inum(i)=' ' 
      end do 
      in=X 
                                                                        
      inum(1)='1' 
      if(in.eq.0) then 
        nnum=1 
        return 
      end if 
      inum(2)='0' 
      inum(3)='$' 
      inum(4)='^' 
      k=4 
      if(in.lt.0)then 
       in=-in 
       inum(k+1)='-' 
       k=k+1 
      end if 
      i10=in/10 
      if(i10.gt.0)then 
       i1=in-i10*10 
       if(i10.ge.10)i10=ichar('x')-i0 
       inum(k+1)=char(i10+i0) 
       inum(k+2)=char(i1+i0) 
       nnum=k+2 
      else 
       inum(k+1)=char(in+i0) 
       nnum=k+1 
      end if 
      if(in.eq.0)nnum=1 
      return 
      END                                           
