/*									    */
/* Include file from VUIT						    */
/*	1. VUIT global routine declarations				    */
/*	2. Global variables						    */
/*	3. Literals from UIL code					    */

#ifndef __X_INPLIB_LOADED__
#define __X_INPLIB_LOADED__ 1
#include <stdio.h>                      /* For printf and so on. */
#include <stdlib.h>                      /* For printf and so on. */
#include <Xm/Text.h>
#include <Mrm/MrmAppl.h>                /* Motif Toolkit and MRM */
#include <X11/X.h>
#include <X11/Intrinsic.h>

#define MAX_WIDGETS 100

#define WIDGET_Message_Label  0
#define WIDGET_Main_Menu      1
#define WIDGET_Entscheidung_3 2
#define WIDGET_Message_Box    3

extern Widget widget_array[MAX_WIDGETS];
extern int MOTIF_raise_main;


/* Motif Global variables */
XtAppContext    app_context;		/* application context */
Widget		toplevel_widget;	/* Root widget ID of application */
MrmHierarchy	s_MrmHierarchy;		/* MRM database hierarchy ID */

/* Literals from the UIL code */

Display  *MOTIF_get_main_display();	        /* Display variable */
int MOTIF_xtoolkit_init(char *db_filename, int argc, char **argv);

void MOTIF_Lower_Widget(Widget w);
void MOTIF_Raise_Widget(Widget w);

void VUIT_Manage(char *widget_name);
void VUIT_Unmanage(char *widget_name);

void MOTIF_the_message(char mess[]);
void MOTIF_get_the_filename(char filnam[], char frage[], char wildcard[]);
int MOTIF_the_entscheidung_a(char txt[],int def, int anz);

void MOTIF_main();

#endif
