      subroutine frame(tabcolor,i_run)
      use comalp 
      implicit none 
      character*24 tabcolor(64) 
!     plottet Rahmen fuer ALLPLO                                        
!     legt Zeichenhoehe etc. fest                                       
!     bestimmt Ursprung                                                 
!                                                                       
!     M. Alflen 12.9.89                                                 
!                                                                       
!     erweitert fuer durchbrochene Achsen  ( ab Version 1.1 )           
!     M. Alflen 14.12.89                                                
                                                                        
                                                                        
      logical     l_x_br_bo_l,l_x_br_bo_r,l_x_br_to_l,l_x_br_to_r,      &
     &            l_y_br_le_b,l_y_br_le_t,l_y_br_ri_b,l_y_br_ri_t       
      real        pos_x,pos_y,wid_x,xd,b_wid,b_x,yd,b_y,b_off,heig_y 
      common/plfr/l_x_br_bo_l,l_x_br_bo_r,l_x_br_to_l,l_x_br_to_r,      &
     &            l_y_br_le_b,l_y_br_le_t,l_y_br_ri_b,l_y_br_ri_t,      &
     &            pos_x,pos_y,wid_x,xd,b_wid,b_x,yd,b_y,b_off,heig_y    
                                                                        
      logical       l_ask 
      real          a_version 
      common /ver/  a_version 
                                                                        
      integer       iout,nbloc,ix_br_bo,ix_br_to,                       &
     &              iy_br_le,iy_br_ri,i,j,i_run                         
      real          out,xorgp,yorgp 
                                                                        
      dimension out(32) 
      character*132 chstr(2),querytype(2),chcom,wrb*1 
                                                                        
      save 
!     input :                                                           
!     l_scal = .true. : neuen Rahmen malen                              
!     l_def  = .true. : default-Werte uebernehmen                       
!                                                                       
!     output :                                                          
!     l_xaxb  = .true. : untere x-Achse gezeichnet                      
!     l_xaxt  = .true. : obere x-Achse gezeichnet                       
!     l_xaxl  = .true. : linke y-Achse gezeichnet                       
!     l_xaxr  = .true. : rechte y-Achse gezeichnet                      
!                                                                       
      l_ask= .not. (l_def .and. l_inter) 
      if (i_run.le.1) then 
                                ! origin                                
       xorg=0. 
       yorg=0. 
       xorgp=0. 
       yorgp=0. 
       nbloc=0. 
       call PNUMA(yorg,xorg,nbloc,0.,0.)
 
                                                  
       npen=0              ! pen number       
       gx=15.              ! frame size       
       gy=10.                                 
       hx=0.4              ! character size   
       hy=0.4                                 
       xd=hx                                  
       yd=hy                                  
       sw=0.15             ! symbol size     
       sh=0.15                                
       pen=0.05            ! pen size         
       xoff_l=xd           ! offsets ( distance between  plot and axes  
       xoff_r=xd 
       yoff_b=yd 
       yoff_t=yd 
       l_xaxb=.true. 
       l_xaxt=.true. 
       l_yaxl=.true. 
       l_yaxr=.true. 

       l_x_br_bo_l=.false.  ! no break of axes 
       l_x_br_bo_r=.false. 
       l_x_br_to_l=.false. 
       l_x_br_to_r=.false. 
       l_y_br_le_b=.false. 
       l_y_br_le_t=.false. 
       l_y_br_ri_b=.false. 
       l_y_br_ri_t=.false. 
       ix_br_bo=0 
       ix_br_to=0 
       iy_br_le=0 
       iy_br_ri=0 
      end if 
                                                                        
      IF (l_scal) THEN          ! new frame        
                                                                       
      if (.not.l_inter.and.l_ask)wrb='r' 
      if (l_inter.and.l_ask)wrb='w' 
      if (l_inter.and..not.l_ask)wrb='d' 
                                                                        
!origin  x,y                [15.00,12.00]    width xw,yw [15.00,0.00]   
       querytype(1)='origin  x,y                 [' 
       querytype(2)='       width xw,yw   [' 
        chstr(1)='0.0,0.0' 
       chstr(2)='15.0,10.0' 
       chcom='origin,width' 
       call ask2strings(querytype,chstr,chcom,NPL,NRD,NWR,NBA,wrb) 
       call trlch(20,chstr(1),iout,out) 
       xorg=-out(1) 
       if (iout.gt.1)yorg=out(2) 
       call trlch(20,chstr(2),iout,out) 
       if ( out(1) .gt. 0.) gx=out(1) 
       if ( out(2) .gt. 0.) gy=out(2)
       
       call PNUMA(yorg+yorgp,xorg+xorgp,nbloc,0.,0.) 
       xorgp=-xorg 
       yorgp=-yorg 
                                                                        
!    borderwidth bx,by      [0.40,0.40]  character cw,ch        [0.40,0.
       querytype(1)='    borderwidth bx,by       [' 
       querytype(2)=' character cw,ch   [' 
       chstr(1)='0.40,0.40' 
       chstr(2)='0.40,0.40' 
       chcom='border/character' 
!       read(5,'(a)')                                                   
       call ask2strings(querytype,chstr,                                &
     &                             chcom,NPL,NRD,NWR,NBA,wrb)           
!       read(5,'(a)')                                                   
       call trlch(20,chstr(1),iout,out) 
       if ( out(1) .gt. 0.) xd=out(1) 
       if ( out(2) .gt. 0.) yd=out(2) 
       call trlch(20,chstr(2),iout,out) 
       if ( out(1) .gt. 0.) hx=out(1) 
       if ( out(2) .gt. 0.) hy=out(2) 
                                                                        
                                                                        
!    pen number (0..9)      [0]                                         
       querytype(1)='      color frame           [' 
       querytype(2)='     color background  [' 
       chstr(1)='black' 
       chstr(2)='white' 
       chcom='color/frame' 
       call ask2strings(querytype,chstr,chcom,NPL,NRD,NWR,NBA,wrb) 
       npen=0 
       i=1 
       do while(i.lt.64) 
        j=index(tabcolor(i),char(0)) 
        if(chstr(1)(1:j-1).eq.tabcolor(i)(1:j-1))then 
         npen=i-1 
         i=64 
        end if 
        i=i+1 
       end do 
       nbackgr=1 
       i=1 
       do while(i.lt.64) 
          j=index(tabcolor(i),char(0))
        if(chstr(2)(1:j-1).eq.tabcolor(i)(1:j-1))then 
         nbackgr=i-1 
         i=64 
        end if 
        i=i+1 
       end do 
                                                                        
        if(npen.eq.nbackgr)then 
         npen=nbackgr+1 
         if(nbackgr.eq.1)npen=0 
!         write(6,'(i5,a,2i4)')i,' datplo nbackgr,npen=',nbackgr,npen   
        end if 
                                                                        
                                                                        
!       write(6,'(a,2i4)')'nbackgr,npen=',nbackgr,npen                  
       xrand=xd+7.*hx+3*hy 
       yrand=yd+7.*hy 
                                                                        
       a_xanf=-xorg+xrand+xd 
       a_xend=-xorg+xrand+xd+gx 
       a_yanf= yorg+yrand+yd 
       a_yend= yorg+yrand+yd+gy 
       benf  = 2*xrand+2*xd+gx 
                                                                        
!       a_xanf=0                                                        
!       a_xend=0                                                        
!       a_yanf=0                                                        
!       a_yend=0                                                        
!       benf  =0                                                        
                                                                        
!x-axis (none,Both,bottom,top)                         [b]              
! none         l_xaxb=.false. l_xaxt=.false.                            
! Both         l_xaxb=.true.  l_xaxt=.true.                             
! bottom       l_xaxb=.true.  l_xaxt=.false.                            
! top          l_xaxb=.false. l_xaxt=.true.                             
       querytype(1)=                                                    &
     & 'x-axis                              (none,Both,bottom,top) ['   
       chstr(1)='B' 
       chcom='x-axis (none,Both,bottom,top)' 
       call ask1string(querytype(1),chstr(1),                           &
     &                              chcom,NPL,NRD,NWR,NBA,wrb)          
       if(chstr(1)(1:1).eq.'n') then 
        l_xaxb=.false. 
        l_xaxt=.false. 
       else if(chstr(1)(1:1 ).eq.'B') then 
        l_xaxb=.true. 
        l_xaxt=.true. 
       else if(chstr(1)(1:1).eq.'b') then 
        l_xaxb=.true. 
        l_xaxt=.false. 
       else if(chstr(1)(1:1).eq.'t') then 
        l_xaxb=.false. 
        l_xaxt=.true. 
       end if 
                                                                        
                                                    ! break of x-axes   
       if ( l_inter .or. a_version .gt. 1.0 ) then 
                                                                        
!    break(none,bottom,top) [b]             (left,right) [l]            
! none    xoff_l=xd                                                     
!         xoff_r=xd                                                     
!         l_x_br_bo_l=.false.                                           
!         l_x_br_bo_r=.false.                                           
!         l_x_br_to_l=.false.                                           
!         l_x_br_to_r=.false.                                           
                                                                        
! bottom left                                                           
!          xoff_l=2.*xd	   	                                            
!          xoff_r=xd                                                    
!          l_x_br_bo_l=.true.                                           
!          l_x_br_bo_r=.false.                                          
! bottom right                                                          
!          xoff_l=xd	   	                                               
!          xoff_r=2.*xd                                                 
!          l_x_br_bo_l=.false.                                          
!          l_x_br_bo_r=.true.                                           
! top left                                                              
!          xoff_l=2.*xd	                                                
!          xoff_r=xd   	                                                
!          l_x_br_to_l=.true.                                           
!          l_x_br_to_r=.false.                                          
! top right                                                             
!          xoff_l=xd	   	                                               
!          xoff_r=2.*xd                                                 
!          l_x_br_to_l=.false.                                          
!          l_x_br_to_r=.true.                                           
         querytype(1)='    break(none,bottom,top)  [' 
         querytype(2)='            (left,right)   [' 
         chstr(1)='n' 
         chstr(2)='l' 
         chcom='break x-axis' 
         call ask2strings(querytype,chstr,chcom,NPL,NRD,NWR,NBA,wrb) 
         if(chstr(1)(1:1).eq.'n') then 
          xoff_l=xd 
          xoff_r=xd 
          l_x_br_bo_l=.false. 
          l_x_br_bo_r=.false. 
          l_x_br_to_l=.false. 
          l_x_br_to_r=.false. 
         else if(chstr(1)(1:1).eq.'b') then 
          if(chstr(2)(1:1).eq.'l')then 
           xoff_l=2.*xd 
           xoff_r=xd 
           l_x_br_bo_l=.true. 
            l_x_br_bo_r=.false. 
          else if(chstr(2)(1:1).eq.'r')then 
           xoff_l=xd 
           xoff_r=2.*xd 
           l_x_br_bo_l=.false. 
           l_x_br_bo_r=.true. 
          end if 
         else if(chstr(1)(1:1).eq.'t') then 
          if(chstr(2)(1:1).eq.'l')then 
           xoff_l=2.*xd 
           xoff_r=xd 
           l_x_br_to_l=.true. 
           l_x_br_to_r=.false. 
          else if(chstr(2)(1:1).eq.'r')then 
           xoff_l=xd 
           xoff_r=2.*xd 
           l_x_br_to_l=.false. 
           l_x_br_to_r=.true. 
          end if 
         end if 
       end if 
                                                                        
!y-axis (none,Both,left,right)                         [B]              
       querytype(1)=                                                    &
     & 'y-axis                              (none,Both,left,right) ['   
       chstr(1)='B' 
       chcom='y-axis (none,Both,left,right)' 
       call ask1string(querytype(1),chstr(1),                           &
     &                              chcom,NPL,NRD,NWR,NBA,wrb)          
       if(chstr(1)(1:1).eq.'n') then 
        l_yaxl=.false. 
        l_yaxr=.false. 
       else if(chstr(1)(1:1).eq.'B'.or.chstr(1)(1:1).eq.'b') then 
        l_yaxl=.true. 
        l_yaxr=.true. 
       else if(chstr(1)(1:1).eq.'l') then 
        l_yaxl=.true. 
        l_yaxr=.false. 
       else if(chstr(1)(1:1).eq.'r') then 
        l_yaxl=.false. 
        l_yaxr=.true. 
       end if 
                                                                        
!                                                                       
                                                    ! break of y-axes   
       if ( l_inter .or. a_version .gt. 1.0 ) then 
!    break(none,left,right) [b]             (bottom,top) [n]            
         querytype(1)='    break(none,left,right)  [' 
         querytype(2)='            (bottom,top)   [' 
         chstr(1)='n' 
         chstr(2)='b' 
         chcom='break y-axis' 
         call ask2strings(querytype,chstr,chcom,NPL,NRD,NWR,NBA,wrb) 
         if(chstr(1)(1:1).eq.'n') then 
          yoff_t=yd 
          yoff_b=yd 
          l_y_br_le_b=.false. 
          l_y_br_le_t=.false. 
          l_y_br_ri_b=.false. 
          l_y_br_ri_t=.false. 
         else if(chstr(1)(1:1).eq.'l') then 
          if(chstr(2)(1:1).eq.'b') then 
           yoff_t=yd 
           yoff_b=2.*yd 
           l_y_br_le_b=.true. 
           l_y_br_le_t=.false. 
          else if(chstr(2)(1:1).eq.'t') then 
           yoff_t=2.*yd 
           yoff_b=yd 
           l_y_br_le_b=.false. 
           l_y_br_le_t=.true. 
          end if 
         else if(chstr(1)(1:1).eq.'r') then 
          if(chstr(2)(1:1).eq.'b') then 
          yoff_t=yd 
          yoff_b=2.*yd 
          l_y_br_ri_b=.true. 
          l_y_br_ri_t=.false. 
          else if(chstr(2)(1:1).eq.'t') then 
           yoff_t=2.*yd 
           yoff_b=yd 
           l_y_br_ri_b=.false. 
           l_y_br_ri_t=.true. 
          end if 
         end if 
       end if 
!                                                                       
      END IF 
!                                                                       
!     start plot                                                        
!      call plotframe                                                   
      return 
!                                                                       
 5000 format(80a1) 
 5001 format(1h ,80a1) 
 5050 format(1a80) 
!                                                                       
      END                                           
