      subroutine instruction 
      use comalp
      implicit none 
!     M. Alflen 12.9.89                                                 
!                                                                       
!     modifiziert fuer variablen Offset zwischen Rahmen und Plot        
!                                                                       
!	M. Alflen 15.12.89                                                    
      integer       IX,IY,ixt,iyt,nx,ny,ixscp10,iyscp10,ixmode 
      real          xtop,ytop,xbot,ybot,xanfsc,xendsc,xstep,            &
     &              xanflg,xendlg,xanflgsc,xendlgsc,xlgstep,            &
     &              yanfsc,yendsc,ystep,zxtext,zytext,                  &
     &              yanflg,yendlg,yanflgsc,yendlgsc,ylgstep             
       common/top/  xtop,ytop,xbot,ybot,xanfsc,xendsc,xstep,            &
     &              xanflg,xendlg,xanflgsc,xendlgsc,xlgstep,            &
     &              yanfsc,yendsc,ystep,zxtext,zytext,                  &
     &              yanflg,yendlg,yanflgsc,yendlgsc,ylgstep,            &
     &              IX,IY,ixt,iyt,nx,ny,ixscp10,iyscp10,ixmode          
                                                                        
      character     cxanf(24),cxend(24),cxstep(24),                     &
     &              cyanf(24),cyend(24),cystep(24)                      
      integer       NAXFOR,nform,nxanf,nxend,nxstep,nyanf,nyend,nystep 
                                                                        
      logical       l_ask 
      character*132 querytype(2),chcom,chstr(2),wrb*1,                  &
     &              canf*10,cend*10,cstep*10,cf*1,                      &
     &              form*7,chr*24,chl*24,chkblk*48                      
      integer       idum,nn,im,le,i,j,jj,ii,ls,iout 
      real          dum,dif,h,out 
      dimension     out(32) 
                                                                        
      chkblk=' ' 
      chkblk(1:1)=')' 
!      write(6,'(a,10L3)')                                              
!     & '##### subroutine datplo ',l_inter,l_def,l_scal                 
!     l_new = true  :  neuer Datensatz                                  
!     l_scal = true :  neu Skalieren                                    
!     l_def = true   : default-Werte uebernehmen                        
!      write(6,'(a,i6)')' datplo ncount=',ncount                        
                                                                        
      l_ask = .not. ( l_def .and. l_inter) 
      if (.not.l_inter.and.l_ask)wrb='r' 
      if (l_inter.and.l_ask)wrb='w' 
      if (l_inter.and..not.l_ask)wrb='d' 
                                                                        
!***********************************************************************
!                                                                       
                              !  input                                  
      if (l_scal ) then 
                                                                        
!***********************************************************************
!    x-range (-3.82,3.81)  [-4.00,4.00]           scale(lin,log) [li]   
       chstr(1)=' ' 
       querytype(1)=                                                    &
     & 'x-data                        (x ,log(x),10**x:  /lgx/pwx) ['   
       chcom='log/power10' 
       call ask1string(querytype,chstr,chcom,NPL,NRD,NWR,NBA,wrb) 
       l_logxd=.false. 
       l_10pxd=.false. 
       if(chstr(1)(1:3).eq.'lgx')then 
        l_logxd=.true. 
        l_logx=.true. 
        if(xmin.lt.0.)then 
         write(NWR,'(a,g12.4)')                                         &
     &  ' Log(x-data) not possible: 0>X_min=',xmin                      
         l_logxd=.false. 
         l_logx=.false. 
        end if 
       else if(chstr(1)(1:3).eq.'pwx')then 
        l_10pxd=.true. 
        if(xmax.gt.32.)then 
         write(NWR,'(a,g12.4)')                                         &
     &   ' 10**(x-data) not possible: 32<X_max=',xmax                   
         l_10pxd=.false. 
        end if 
       end if 
                                                                        
       if(l_logxd)then 
        xmin=log10(xmin) 
        xmax=log10(xmax) 
       else if(l_10pxd) then 
        xmin=10**xmin 
        xmax=10**xmax 
       end if 
                                                     ! x-plot Bereich   
       call scaling(xmin,xmax,0,xanf,xend,dum,idum) 
       if(abs((xend-xmax)/dum).gt.0.5)xend=xmax+0.1*dum 
                                                                        
       querytype(1)='    x-range(' 
       form='f12.2' 
       h=abs(xmin) 
       if(h.lt.0.01.and.h.ne.0..or.h.gt.1.e4)form='e12.2' 
       call trlnu(form,xmin,chr,nn,chl,im) 
       querytype(1)(13:)=chl(1:im)//',' 
!       le=44-im                                                        
       le=13-im 
       j=14+im 
       form='f12.2' 
       if(abs(xmax).lt.0.01.or.abs(xmax).gt.1.e4)form='e12.2' 
       call trlnu(form,xmax,chr,nn,chl,im) 
       querytype(1)(j:)=chl(1:im)//chkblk(:le-im)//'  [' 
       le=j+le+1 
!       write(6,'(a,i4)')' le=',le                                      
       form='f12.2' 
       h=abs(xanf) 
       if(h.lt.0.01.and.h.ne.0..or.h.gt.1.e4)form='e12.2' 
       call trlnu(form,xanf,chr,nn,chl,im) 
       chstr(1)(1:)=chl(1:im)//',' 
       j=2+im 
       form='f12.2' 
       if(abs(xend).lt.0.01.or.abs(xend).gt.1.e4)form='e12.3' 
       call trlnu(form,xend,chr,nn,chl,im) 
       chstr(1)(j:)=chl(1:im) 
       j=j+im 
       le=62-(le+j+20) 
!       write(6,'(a,3i4)')' j,im,le=',j,im,le                           
                                                                        
       call stringlength(chstr(1),ls) 
                                                                        
       querytype(2)=chkblk(2:le)//'(log scale y/n) [' 
       chstr(2)='n' 
       chcom='log/scale' 
!    x-range(0.00,1.08)    [0.00,1.20]             (log,ln;d,s,B) []    
       call ask2strings(querytype,chstr,chcom,NPL,NRD,NWR,NBA,wrb) 
       call trlch(20,chstr(1),iout,out) 
       if(iout.ge.1) xanf=out(1) 
       if(iout.eq.2) xend=out(2) 
       l_logx=.false. 
       if(chstr(2)(1:1).eq.'y')l_logx=.true. 
                                                                        
                                                                        
       if (xanf .eq. xend) then 
        xanf=xmin 
        xend=xmax 
       end if 
                                                                        
!                                                                       
!**********************input of x-scaling range*************************
!        scale (l,r,stepw,tick)  [0         20        2         5]      
                                                          ! x-Skala     
       call scaling(xanf,xend,1,xanfsc,xendsc,xstep,ixt) 
       NX=NAXFOR(XANFSC,XENDSC,XSTEP) 
       call numero(xanfsc,nx,cxanf,nxanf,0,0) 
       call numero(xendsc,nx,cxend,nxend,0,0) 
       call numero(xstep,nx,cxstep,nxstep,0,0) 
                                                                        
         do i=1,10 
          canf(i:i)=cxanf(i) 
          cend(i:i)=cxend(i) 
          cstep(i:i)=cxstep(i) 
         end do 
         cf=char(ixt+ichar('0')) 
         chstr(1)=canf//cend//cstep//cf//' 0' 
         querytype(1)='    scale(l,r,step,tick,pw)[' 
         chcom='l,r,step,tick,pw' 
         call ask1string(querytype(1),chstr(1),chcom,                   &
     &                                NPL,NRD,NWR,NBA,wrb)              
         nx=nform(chstr(1)) 
         call trlch(80,chstr(1),nn,out) 
                                                                        
                                                                        
         ixscp10=0 
         if(nn.eq.5) ixscp10=out(5) 
         if ( nn .ge. 3 ) then 
          dif =abs(out(1)-out(2))*1.0001 
          if (dif .gt. 0. .and. dif .ge. abs(out(3))                    &
     &        .and.out(1) .ge. xanf .and.out(2) .le. xend               &
     &    ) then                                                        
           xanfsc=out(1) 
           xendsc=out(2) 
           if ( xanfsc .lt. xendsc ) then 
            xstep=abs(out(3)) 
           else 
            xstep=-abs(out(3)) 
           end if 
           call numero(xanfsc,nx,cxanf,nxanf,0,ixscp10) 
           call numero(xendsc,nx,cxend,nxend,0,ixscp10) 
           call numero(xstep,nx,cxstep,nxstep,0,ixscp10) 
          end if 
         end if 
         if ( nn .ge. 4 .and. out(4) .ge. 0.) ixt=out(4) 
!*******************************************************************    
!    y-range (-3.82,3.81)                                [-4.00,4.00]   
       chstr(1)=' ' 
       querytype(1)=                                                    &
     & 'y-data                        (y ,log(y),10**y:  /lgy/pwy) ['   
       chcom='log/power10' 
       call ask1string(querytype,chstr,chcom,NPL,NRD,NWR,NBA,wrb) 
       l_logyd=.false. 
       l_10pyd=.false. 
       if(chstr(1)(1:3).eq.'lgy')then 
        l_logyd=.true. 
        if(ymin.le.0.)then 
         write(NWR,'(a,g12.4)')                                         &
     &  ' Log(y-data) not possible: 0>Y_min=',ymin                      
         l_logyd=.false. 
        end if 
       else if(chstr(1)(1:3).eq.'pwx')then 
        l_10pyd=.true. 
        if(ymax.gt.32.)then 
         write(NWR,'(a,g12.4)')                                         &
     &   ' 10**(y-data) not possible: 32<Y_max=',ymax                   
         l_10pyd=.false. 
        end if 
       end if 
                                                                        
       if(l_logyd)then 
        ymin=log10(ymin) 
        ymax=log10(ymax) 
       else if(l_10pyd) then 
        ymin=10**ymin 
        ymax=10**ymax 
       end if 
                                                     ! y-plot Bereich   
       call scaling(ymin,ymax,0,yanf,yend,dum,idum) 
       if(abs((yend-ymax)/dum).gt.0.5)yend=ymax+0.1*dum 
       if(abs((yanf-ymin)/dum).gt.0.5)yanf=ymin-0.1*dum 
                                                                        
       querytype(1)='    y-range(' 
       form='f12.2' 
       h=abs(ymin) 
       if(h.lt.0.01.and.h.ne.0..or.h.gt.1.e4)form='e12.2' 
       call trlnu(form,ymin,chr,nn,chl,im) 
       querytype(1)(13:)=chl(1:im)//',' 
       le=13-im 
       j=14+im 
       form='f12.2' 
       if(abs(ymax).lt.0.01.or.abs(ymax).gt.1.e4)form='e12.2' 
       call trlnu(form,ymax,chr,nn,chl,im) 
       querytype(1)(j:)=chl(1:im)//chkblk(:le-im)//'  [' 
       le=j+le+1 
       form='f12.2' 
       h=abs(yanf) 
       if(h.lt.0.01.and.h.ne.0..or.h.gt.1.e4)form='e12.2' 
       call trlnu(form,yanf,chr,nn,chl,im) 
       chstr(1)(1:)=chl(1:im)//',' 
       j=2+im 
       form='f12.2' 
       if(abs(yend).lt.0.01.or.abs(yend).gt.1.e4)form='e12.2' 
       call trlnu(form,yend,chr,nn,chl,im) 
       chstr(1)(j:)=chl(1:im) 
       j=j+im 
       le=62-(le+j+20) 
!       write(6,'(a,3i4)')' j,im,le=',j,im,le                           
                                                                        
       call stringlength(chstr(1),ls) 
                                                                        
       querytype(2)=chkblk(2:le)//'(log scale y/n) [' 
       chstr(2)='n' 
       if(l_logyd) chstr(2)='y' 
       chcom='log/scale' 
       call ask2strings(querytype(1),chstr(1),chcom,NPL,NRD,NWR,NBA,wrb) 
       call trlch(20,chstr(1),iout,out) 
       if(iout.ge.1) yanf=out(1) 
       if(iout.eq.2) yend=out(2) 
       l_logy=.false. 
       if(chstr(2)(1:1).eq.'y')l_logy=.true. 
                                                                        
!**********************input of y-scaling range************************ 
!        scale (l,r,step,tick) [-4,4,1,5]                               
                                                            ! y-Skala   
         call scaling(yanf,yend,1,yanfsc,yendsc,ystep,iyt) 
         ny=NAXFOR(yanfsc,yendsc,ystep) 
         call numero(yanfsc,ny,cyanf,nyanf,0,0) 
         call numero(yendsc,ny,cyend,nyend,0,0) 
         call numero(ystep,ny,cystep,nystep,0,0) 
                                                                        
         do i=1,10 
          canf(i:i)=cyanf(i) 
          cend(i:i)=cyend(i) 
          cstep(i:i)=cystep(i) 
         end do 
         cf=char(iyt+ichar('0')) 
         chstr(1)=canf//cend//cstep//cf//' 0' 
         querytype(1)='    scale(l,r,step,tick,pw)[' 
         chcom='l,r,step,tick,pw' 
         call ask1string(querytype(1),chstr(1),chcom,                   &
     &                                NPL,NRD,NWR,NBA,wrb)              
         ny=nform(chstr(1)) 
                                                                        
         call trlch(80,chstr(1),nn,out) 
         iyscp10=0 
         if(nn.eq.5) iyscp10=out(5) 

         if ( nn .ge. 3 ) then 
          dif =abs(out(1)-out(2))*1.0001 
          if (dif .gt. 0. .and. dif .ge. abs(out(3)) .and.              &
     &        out(1) .ge. yanf  .and.                                   &
     &        out(2) .le. yend                  ) then                  
           yanfsc=out(1) 
           yendsc=out(2) 
           if ( yanfsc .lt. yendsc ) then 
            ystep=abs(out(3)) 
           else 
            ystep=-abs(out(3)) 
           end if 
           call numero(yanfsc,ny,cyanf,nyanf,0,iyscp10) 
           call numero(yendsc,ny,cyend,nyend,0,iyscp10) 
           call numero(ystep,ny,cystep,nystep,0,iyscp10) 
          end if 
         end if 
         if ( nn .ge. 4 .and. out(4) .ge. 0.) iyt=out(4) 
!***********************************************************************
!                                                                       
                   !  end of input section                              
      END IF 
                                                                        
      return                                                            
      END                                           
                                                                        
      subroutine plotthedata 
      use comalp
      implicit none 
!     plottet Datenpunkte fuer ALLPLO                                   
!                                                                       
!     M. Alflen 12.9.89                                                 
!                                                                       
!     modifiziert fuer variablen Offset zwischen Rahmen und Plot        
!                                                                       
!	M. Alflen 15.12.89                                                    
      logical       l_ini,l_remove,l_fill 
                                                                        
      integer       k,i,isym,iloop,nold_pen,ipen,infra 
      real          genau,G1,G2,G3,G4,G5,G6,gg1,gg2,gg3,gg4,            &
     &              xscal,xl,xu,xlow,xup,yscal,yl,yu,ylow,yup           
                                                                        
                                   ! accuracy for real comparison       
      genau=1.e-4 
!      do i=1,NCOUNT                                                    
!        write(6,'(i4,2f10.2)')NSYM(i),XX(1,i),YY(1,i)                  
!      end do                                                           
      g1=xrand+gx+xoff_r 
      g3=yrand+yoff_b              
                                   
      call traa(g3,g1,0)           ! go to start                        
      xscal=gx/(xend-xanf)         ! x-scaling                          
      yscal=gy/(yend-yanf)         ! y-scaling                          
      xl=amin1(xanf,xend)           ! x-plot range ( user coo's )       
      xu=amax1(xanf,xend)          
      yl=amin1(yanf,yend)           ! y-plot range ( user coo's )       
      yu=amax1(yanf,yend)          
                                                                        
      xlow=gx+xrand+xoff_r+genau       ! x-plot range ( plot coo's )    
      xup=xrand+xoff_r-genau       
      ylow=gy+yrand+yoff_b+genau       ! y-plot range ( plot coo's )    
      yup=yrand+yoff_b-genau 

      nold_pen=-1 
      call pluma(nold_pen)         ! ask for old pen 
!     write(6,'(a,i4)')' datplo nold_pen=',nold_pen                    
!     write(6,'(20i5)')(NSYM(i),i=1,NCOUNT) 
      l_ini=.true.         ! initialize 
      infra=0 
      i=0 
      do while (i .lt. ncount ) 
        i=i+1 
        if(l_remove) then 
         if(xx(2,i).lt.0. .or.yy(2,i).lt.0.)goto 1000 
        end if 
        if(nsym(i).gt.900) then 
          isym=nsym(i)/1000
          isym=nsym(i)-1000*isym
          if(isym.eq.0)nsym(i)=-nsym(i)
!         fnsym(i)-100000
!          nsym(i)=nsym(i)-100000
          l_fill=.true.
        else
          l_fill=.false.         
        end if 
!        if(i.lt.4)write(6,'(i5,a,i6)')i,' nsym(i)=',nsym(i)                      
        if(nsym(i).le.0) then 
         ipen=1 
         isym=-nsym(i) 
        else 
         ipen=0 
         isym=nsym(i) 
        end if 
        npen=isym/1000 
        isym=isym-npen*1000 
!        if(i.lt.4)write(6,'(i5,a,2i6)')i,'    isym,npen=',isym,npen  
        if(isym.gt.0)ipen=0 
                                                                        
        iloop= isym/100 
        isym=isym-iloop*100 
        if (iloop.gt. 0) then                    ! =0 no filled symbol  
          g1=amin1(sw,sh) 
         iloop=ifix(g1/pen)+1                    ! plot iloop times  
        else 
         iloop=1 
        end if 
                                                                        
        if(npen.eq.nbackgr)then 
         npen=nbackgr+1 
         if(nbackgr.eq.1)npen=0         !  npen different from nbackgr  
        end if 
                                                                        
!       if(i.lt.4)write(6,'(i5,a,5i4)')i,' ipen,isym,npen,iloop=',ipen,isym,npen,iloop 
                                                                        
!        if(l_fill.or.(isym.eq.34.and.iloop.gt.1)) then 
        if(isym.eq.34.and.iloop.gt.1) then 
          call PFUMA(npen)  ! choose pen=fillcol
        else 
         call pluma(npen)    ! choose pen=color 
        end if 
                                                                        
         if(l_logyd) then 
         gg3=log10(YY(1,i)) 
         gg3=alog(YY(1,i)) 
        else if(l_10pyd) then 
         gg3=10**YY(1,i) 
        else 
         gg3=YY(1,i) 
        end if 
        if(l_logxd) then 
         gg1=log10(XX(1,i)) 
         gg1=alog(XX(1,i)) 
        else if(l_10pxd) then 
         gg1=10**XX(1,i) 
        else 
         gg1=XX(1,i) 
        end if 
                                                                        
                                                 ! plot error bars      
        if ( l_error ) then 
         if(l_logxd) then 
          gg2=XX(2,i)/XX(1,i) 
         else if(l_10pxd) then 
          gg2=gg1*(10**XX(2,i)-1.) 
         else 
          gg2=XX(2,i) 
         end if 
         g1=gg1+abs(gg2) 
         g2=gg1-abs(gg2) 
                                                                        
         if(l_logyd) then 
         gg4=YY(2,i)/YY(1,i) 
        else if(l_10pyd) then 
         gg4=gg3*(10**YY(2,i)-1.) 
        else 
         gg4=YY(2,i) 
        end if 
         g3=gg3+abs(gg4) 
         g4=gg3-abs(gg4) 
        else 
         g1=gg1 
         g2=g1 
         g3=gg3 
         g4=g3 
        end if 
!                                                                       
                                                             ! no clippi
        if ( ( .not. l_clip ) .or.                                      &
     &      ( ( g1 .le. xu .and. g2 .ge. xl ) .and.                     &
     &        ( g3 .le. yu .and. g4 .ge. yl )      )) then              
                                                            ! point in f
                                                                        
!         infra=infra+1                                                 
                                                     ! plot coordinate  
         gg1= xlow - ( gg1-xanf ) * xscal 
         gg3= yup + ( gg3-yanf) * yscal 
          if ( l_error ) then 
                                                     ! plot coordinate  
          g1= xlow - ( g1-xanf ) * xscal 
          g2= xlow - ( g2-xanf ) * xscal 
          g3= yup + ( g3-yanf ) * yscal 
          g4= yup + ( g4-yanf ) * yscal 
         end if 
!                                                                       
         if ( l_ini ) then 
                                          ! go to start point           
           call traa(gg3,gg1,0) 
            l_ini=.false. 
         end if 
                                                                        
         if ( isym .eq. 33 ) then 
          call traa(gg3,gg1,ipen) 
         end if 
!                                                                       
         if(isym.eq.0)then 
          call TRAA(gg3,gg1,ipen) 
         else 
                                          ! fill up symbol              
          do k=1,iloop 
           g5=sw-(k-1)*pen 
           if ( g5 .gt. 0 ) then 
            g6=sh-(k-1)*pen 
            if ( g6 .gt. 0 ) then 
             if ( isym .ne. 33 ) then 
              call becena (gg3,gg1,ipen,isym,g5,g6,0.,-1.)    ! plot sym
             else 
              g5=(g5+g6)/4. 
              CALL BCERCA (gg3,gg1,IPEN,G5,90.,360.)         ! plot circ
             end if 
            end if 
           end if 
          end do 
         end if 
                                                                        
         if ( isym .eq. 33 ) then 
          call traa(gg3,gg1,0) 
         end if 
!                                                                       
                                            ! plot error bars           
         if ( l_error )     then 
                                            ! plot x-error              
          if ( g1 .ne. g2 ) then 
           call traa(gg3,g1,0) 
           call traa(gg3,g2,1) 
           call traa(gg3,gg1,0) 
          end if 
                                            ! plot y-error              
          if ( g3 .ne. g4 ) then 
           call traa(g3,gg1,0) 
           call traa(g4,gg1,1) 
           call traa(gg3,gg1,0) 
          end if 
         end if 
!                                                                       
                                            ! point out of frame        
        else 
                                            ! break line                
         l_ini=.true. 
                                            ! end of point within frame 
        end if 
 1000  continue 
                                           ! end of plot                
      end do 
!      write(6,'(a,3i6)')' datplo i,ncount=',i,ncount,infra             
                                                                        
      isym=0 
                                           ! choose old pen             
      call pluma(nold_pen) 
                                                                        
      return 
      END                                           
                                                                        
                                                                        
      subroutine scaling(xanf0,xend0,ityp,xfirst,xlast,delta,itck) 
!                                                                       
!     scale berechnet Werte fuer Plotbereich und Achsenbeschriftung     
!                                                                       
!                                                                       
!     M. Alflen   8.9.89                                                
!                                                                       
!     ityp = 0 : Plotbereich ( d.h. xfirst<xanf , xlast>xend )          
!            1 : Achsen      ( d.h. xfirst>xanf , xlast<xend )          
!                                                                       
!     xanf , xend  : Eingabewerte Bereich                               
!     xfirst,xlast : geglaettete Ausgabewerte                           
!     delta        : Achsen-Unterteilung                                
!     itck         : Anzahl der Ticks zwischen zwei Unterteilungen      
!                                                                       
      real xmant (4) 
      DATA xmant /1.,2.,5.,10./ 
!                                                                       
      if(ityp.eq.1)then 
       xanf=xanf0*0.999999 
       xend=xend0*1.000001 
      else 
       xanf=xanf0 
       xend=xend0 
      end if 
      XFIRST = AMIN1(xanf,xend) 
      XLAST = AMAX1(xanf,xend) 
      xf=xfirst 
      xl=xlast 
      IF(XLAST-XFIRST .LT. 0.001) GOTO 999 
!                                                                       
      DELTA = (XLAST-XFIRST)/10. 
      TENPOW = 10. ** (INT(ALOG10(DELTA)+1000.)-1000) 
      DELTA = DELTA/TENPOW - 0.01 
!                                                                       
!     NOW DELTA CONTAINS MANTISSA, TENPOW THE TENPOWER OF DELTA         
!                                                                       
      DO 301 I=1,4 
       IS = I 
       IF(XMANT(I).GE.DELTA) GOTO 302 
  301 END DO 
!                                                                       
!     SMOOTH MANTISSA                                                   
!                                                                       
  302 CONTINUE 
      DELTA = XMANT(IS)*TENPOW 
!                                                                       
!     SMOOTH XFIRST,XLAST                                               
!                                                                       
      ROUND = 0.001 
      IF(XFIRST.LT.0.) ROUND = ROUND - 1. 
      XFIRST = DELTA * AINT(XFIRST/DELTA + ROUND) 
      XLAST = AINT((XLAST-XFIRST)/DELTA + 0.99999)*DELTA + XFIRST 
!                                                                       
      if ( ityp .eq. 1) then 
       if ( abs(xfirst) .lt. abs(xf)*(1.-1.e-4) )                       &
     &     xfirst=xfirst+delta                                          
       if ( abs(xlast) .gt. abs(xl)*(1.+1.e-4) )                        &
     &     xlast=xlast-delta                                            
      end if 
      if ( xanf .gt. xend ) then 
       xd=xfirst 
       xfirst=xlast 
       xlast=xd 
       delta=-delta 
      end if 
!                                                                       
      itck=min(ifix(xmant(is)),5) 
      return       ! keine sinnvolle Skalierung moeglich 

  999 continue 
      if (xanf .eq. xend) then 
       xanf=0 
       xend=1 
       delta=1 
      else 
       xfirst=xanf 
       xlast=xend 
       delta=xend-xanf 
      end if 
      itck=1 
      RETURN 
      END                                           
                                                                        
      function nform(in) 
                                                                        
!     nform analysiert Eingabestring (ASCII) und                        
!     bestimmt Skalierungs-Format fuer BATPLO                           
!     Im Eingabestring stehen mindestens 3 Zahlen.                      
!     Die 3. Zahl ( d.h. step ) bestimmt das Format.                    
!                                                                       
!     nform <0 : e-Format                                               
!           =0 : i-Format                                               
!           >0 : f-Format ( nform Nachkommastellen )                    
!                                                                       
!     in        : Integer -String ( A1 beschrieben )                    
!                                                                       
!                                                                       
!     M. Alflen   15.9.89                                               
!                                                                       
!                                                                       
      implicit none 
!                                                                       
      character*1 in(81),nbl,nko,npk,nE,nle 
      integer     izahl,i,k,nform 
      data nbl/' '/,nko/','/,npk/'.'/,nE/'E'/,nle/'e'/ 
!                                                                       
      izahl=0 
      i=1 
                                 ! vorspulen                            
      do while ( izahl .lt. 2 ) 
!                                                                       
                                                         ! Zahlenanfang 
       do while ( in(i) .eq. nbl  .and. i .lt. 80 ) 
        i=i+1 
       end do 
       if (in(i) .eq. nko ) then 
       i=i+1 
        do while (i .lt. 80 .and. in(i) .eq. nbl ) 
         i=i+1 
        end do 
       end if 
       i=i+1 
!                                                                       
       do while ( i .lt. 80 .and.in(i) .ne. nbl .and. in(i) .ne. nko )
                                                         ! Zahl ueberspr
        i=i+1 
       end do 
!                                                                       
                                                         ! Zahl gefunden
       izahl=izahl+1 
!                                                                       
      end do 
!                                                                       
      if (in(i) .eq. nko) i=i+1 
      do while (i .lt. 80 .and. ( in(i) .eq. nbl .or. in(i) .eq. nko ) ) 
       i=i+1 
      end do 
!                                                                       
      do while (i .lt. 80 .and.                                         &
     &          in(i) .ne. npk .and.                                    &
     &          in(i) .ne. nE  .and. in(i) .ne. nle .and.               &
     &          in(i) .ne. nbl .and. in(i) .ne. nko )                   
                                                           ! Punkt suche
                                                           ! e suchen   
                                                           ! Ende suchen
       i=i+1 
      end do 
!                                                                       
                                                           ! Ende gefund
      if (in(i) .eq. nbl .or. in(i) .eq. nko ) then 
                                                           ! i-Format   
       nform=0 
                                                           ! e gefunden 
      else if ( in(i) .eq. nE .or. in(i) .eq. nle ) then 
                                                           ! e-Format   
       nform=-1 
                                                           ! Punkt gefun
      else if ( in(i) .eq. npk ) then 
       k=0 
       do while ( i .lt. 80 .and.                                       &
     &           k .le. 5 .and.                                         &
     &           in(i) .ne. nE  .and. in(i) .ne. nle .and.              &
     &           in(i) .ne. nbl .and. in(i) .ne. nko )                  
                                                           ! max. 5 Stel
                                                           ! e suchen   
                                                           ! Ende suchen
        i=i+1 
        k=k+1 
       end do 
       k=k-1 
                                                           ! e gefunden 
       if (in(i) .eq. nE .or. in(i) .eq. nle ) then 
        if (k.gt.1) then 
                                                            ! e-Format 0
         nform=-k 
        else 
         nform=-1 
        end if 
       else 
        nform=k 
       end if 
!                                                                       
      end if 
!                                                                       
      return 
!                                                                       
      END                                           
