#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <netdb.h>
#include <time.h>
#include <errno.h> 
#include <sys/types.h>
#include <netinet/in.h> 
#include <arpa/inet.h>
#include <sys/socket.h>

#define printwd printwd_
#define printdf printdf_
#define copyhistory copyhistory_
#define sendmessage sendmessage_
#define viewdvi viewdvi_
#define exportenv exportenv_ 
#define viewpdf viewpdf_
#define openeditor openeditor_
#define systemcmd systemcmd_
#define ps2pdfroutinetree ps2pdfroutinetree_
#define envname envname_

#define BUFL  512
#define FALSE 0
#define TRUE 1 
#define STRL 80

char  recs[BUFL];
static int read_file(char filename[]){
  /* Read all 132-Byte-Records from the OMD-File into "feld" */
   FILE *dfile;
   dfile = fopen(filename,"rb");
   if (dfile==0){
      return FALSE;
   }
   fread(recs,1,sizeof(recs),dfile);
   fclose(dfile);
   if(recs[0]=='\0') {return FALSE;}
   else {return TRUE;}
}

void copyhistory(){
 char ma[80];
 strcpy(ma,"cp history.lst  history.err");
 system(ma);
}
void sendmessage(){
 char ma[80];
 strcpy(ma,"mail -s effi spiering@mail.uni-mainz.de < history.lst");
 system(ma);
}

void printwd(){
 char ma[80];
 strcpy(ma,"pwd > storage.am");
 system(ma);
}
void printdf(){
 char ma[80];
 strcpy(ma,"df -l -xcifs -k > storage.am");
 system(ma);
}
void ps2pdfroutinetree(){
 char ma[80];
 strcpy(ma,"ps2pdf routine_tree.ps");
 system(ma);
 strcpy(ma,"rm routine_tree.ps");
 system(ma);
 strcpy(ma,"xpdf routine_tree.pdf");
 system(ma);
}
void exportenv(char *variable){
    char ma[128];
     strcpy(ma,"export ");strcat(ma,variable);
     printf(" %s\n",ma);
 system(ma);
 strcpy(ma,"echo $VIEWER ");     printf(" %s\n",ma);
 system(ma);
}
void viewpdf(char *viewer ,char *pdffile){
    char ma[256];
     strcpy(ma,viewer);strcat(ma,pdffile);
     printf(" %s\n",ma);
 system(ma);
}


void viewdvi(char *dvifile){
    char ma[256];
     strcpy(ma,"xdvi ");strcat(ma,dvifile);
     /*printf(" %s\n",ma);*/
 system(ma);
}
void openeditor(int *k, char *posz){
    char *datum;
    char ma[132];
    int i;
    if (*k > 30){
     if((datum=getenv("EDITOR"))!=NULL){
	 i=0;do{ma[i]=datum[i];i++;} while(datum[i] != '\0'); ma[i]='\0';
         } else {*k=*k-20;};
    } else if(*k > 20 && *k < 30 ){
     strcpy(ma,"emacs ");strcat(ma,posz);
     if((datum=getenv("EMACSFONT"))!=NULL){
     strcat(ma," -fn '");strcat(ma,datum);strcat(ma,"'");}
    }
    switch(*k){
	case 11:strcpy(ma,"joe -overwrite -nonotice editor.pa"); 
	    break;
	case 12:strcpy(ma,"joe -overwrite -nonotice editor.co"); 
	    break;
	case 13:strcpy(ma,"joe -overwrite -nonotice editor.pa editor.co");
	    break;

	case 21:strcat(ma," editor.pa"); 		    
	    break;				    
	case 22:strcat(ma," editor.co"); 		    
	    break;				    
	case 23:strcat(ma," editor.pa editor.co");
	    break;

	case 31:strcat(ma," editor.pa");	    
	    break;				    
	case 32:strcat(ma," editor.co");	    
	    break;				    
	case 33:strcat(ma," editor.pa editor.co");
	    break;
    }; 
/* printf(" ma= %s NULL=%s\n",ma,NULL);*/
 system(ma);
}

void systemcmd(char *ma){
 system(ma);
}








