     subroutine th_sphere(isubthe,icase,iput,iget,info) 
      use glbconst, only: icstrf,ivstrf
      use comthe, only: real_fr,array_fr,theoryname
      implicit none 

      integer,intent(in) :: icase,iput,iget 
      integer,intent(out):: info 
      integer,intent(inout)::isubthe 

     real acn,apoints,stepwidth,dumac   
     common/acstrf/ acn,apoints,stepwidth,dumac(icstrf-3) 

     real avn,offset,factor,dumav        
     common/avstrf/ avn,offset,factor,dumav(ivstrf-3) 

      real           avm,ai,dumvm 
      common/avmaps/ avm,ai(32),dumvm(ivstrf-33)                                   
      logical        b_vm,b_dumvm 
      common/bvmaps/ b_vm,b_dumvm(ivstrf-1) 
      real           c1,pdegree,dumcm 
      common/acmaps/ c1,pdegree,dumcm(icstrf-2) 

      integer        i,i1,k,npoints,idegree
      real           x
      complex        hc
      
      npoints=apoints
      idegree=pdegree
      info=0
      if(isubthe.lt.0) then 
       theoryname='th_sphere           v=001' 
       c1=npoints 
       return 
      end if 
      if(iget.eq.0) print'(a)','iget not defined'      

      if(b_vm) then
       i1=iput
       do i=1,npoints
          hc=0
           x=stepwidth*float(2*i-1)
          do k=1,idegree
            hc=hc+ai(k)*cmplx(stepwidth,x)**k
          end do
          array_fr(i1+i)=hc
       end do
      else 
       isubthe=-abs(isubthe) 
      end if 

      return 
      END                                           
                                                                        
