     subroutine  texture_plot(cmch)  
     use glbconst, only: maxn,max8,maxsub,MDBPLFT,icstrf,infplot
     use comdat, only: ichanks,mxpt,mypt,mfpt,mgrpt,mdfpt,name_data,       &
                       formdata,b_data,file_data,name_theory,b_theory
     use comthe, only: real_fr      
     implicit none 
     character(len=4),intent(in):: cmch 
!     integer :: info 

     real           acn,apoints,scale_factor,dumac   
     common/acstrf/ acn,apoints,scale_factor,dumac(icstrf-3)
     
     integer      n_subspectra,logx,logy,logf,                  &
                  int3d,npnt3d,ifeder,ltext,npntplot,nchanplot,ncolor  
     real         parray,xyzdz,vtxt,vtxtp 


     character(len=132):: plotstrdef,plotstrpu,title
     character(len=24) :: axesname,abscissa,ordinata,bgcolor,fgcolor,   &  
                         datacolor,thcolor,rescolor,auxcolor1,          & 
                         auxcolor2,auxcolor3
     character(len=80) :: datfile
     character(len=16) :: axisformat
     character(len=8)  :: kform
     character(len=4)  :: namechan,ch4d,ch4de,ch4a,txtu
                 
     real              :: datx,errx,sym,subspectrum,daty,erry
     integer,parameter :: max8subn=maxsub*max8,max4=4*maxn,max16=maxn*16,&
                          maxn0=4*maxn+2,maxnh=4*maxn/2,max112=maxn*112, &
                 jdumpl=8*(max4+2)+4*(max4/2)+max4,                    &
                 idumpl=4*maxn-8*39-5*infplot-maxsub-201-14*33+jdumpl, &
                 kdumpl=5*max4+max4*maxsub,                            &
                 ldumpl=MDBPLFT*2-180*maxn-jdumpl-kdumpl  
     common/plot/parray(max112),xyzdz(8),vtxt(2,max16),vtxtp(8,32), &
                 int3d(max16),npnt3d(16),ifeder(max16),ltext(32),   &
                 npntplot(infplot),nchanplot(infplot),ncolor(maxsub),  &
                 n_subspectra,logx,logy,logf,                          &
                 namechan(infplot),kform(infplot),axisformat(3),       &
                 axesname(3),title,plotstrdef,plotstrpu,               &
                 bgcolor,fgcolor,datacolor,thcolor,rescolor,           &
                 auxcolor1,auxcolor2,auxcolor3,datfile,txtu,ch4a(461),     &
                 ch4d(idumpl),datx(max4),errx(max4),sym(max4),         &
                 subspectrum(max4,maxsub),daty(max4),erry(max4),ch4de(ldumpl)

     real            x_exp,x_the 
     common/dastr3d/ x_exp(maxn),x_the(maxn) 
     integer   i,i0,ii,j,jj,k,ISTEU,j6th,j9th,ny,isd,ipk,          &
               i_angle,i_angp1,  &
               nn,im,ntxt                  
     real      h,Xl,Yl,Zl,BREITE,HOEHE,alpha,rad,                   &
               thmax,damax,damin,scmin,                                &
               xend,yend,xbeg,ybeg,vxend,vyend,vxbeg,vybeg,hct,hzt     
                                                                       
     real,dimension(0:8):: OP
                                                                       
     character(len=80):: TEXT
     character(len=24):: chl,chr
     character(len=7) :: form
     character(len=4) :: ch4
     character(len=2) :: dbsl
     character(len=1) :: bsl
     integer         nformx,nformy 


!     Print*,  ichanks(2),'cmch====',cmch,Trim(file_data)

     if(cmch.eq.'dstr') then 
!      format  reading data                                             
       formdata(1)='z dz x y ' 
       formdata(2)=' '
       return
     end if
     if(cmch.eq.'dmod')return

      i0=ichar('0') 
      j6th=max8*6 
      j9th=max8*9
      ipk=4       ! package width
      do k=1,infplot 
       nchanplot(k)=0 
    end do
    
      txtu='yyy'//char(0)                                                                  
      nformx=1 
      nformy=1 
       plotstrdef='(xd,yd,zd,dz) (xt,yt,zt)'//char(0) 
        
      ii=index(file_data,'.') 
      if(ii.eq.0) then 
       datfile='Ptheory_nodata.ps'//char(0) 
      else 
       datfile='P'//file_data(1:ii)//'ps'//char(0) 
      end if                                                                       

      auxcolor3='magenta'//char(0)   
      bgcolor='Ivory'//char(0) 
      fgcolor='black'//char(0) 
      datacolor=fgcolor 
      thcolor=fgcolor 
      rescolor='blue'//char(0) 

      rad=0.0174533 
      do i=1,16 
       ltext(i)=0 
      end do 
!      n_theta,theta_beg,dtheta,n_omega,omega_beg,domega                

      hct=8; hzt=4     
      hct=hct*scale_factor
      hzt=hzt*scale_factor
         xyzdz(1)=0.0
         xyzdz(2)=hct
         xyzdz(3)=0. 
        xyzdz(4)=xyzdz(2) 
                                                                        
       i_angle=0 
       i_angp1=0 
       j=0
       b_theory=.true.
        i_angle=i_angle+1 
        i_angp1=i_angp1+1 
        j=ipk*(i_angp1-1)+j6th 
        parray(j+1)=0.
        parray(j+2)=hct
        parray(j+3)=0.
        i_angle=i_angle+1 
        i_angp1=i_angp1+1 
        j=ipk*(i_angp1-1)+j6th 
        parray(j+1)=hct*2
        parray(j+2)=hct
        parray(j+3)=0.        
        i_angle=i_angle+1 
        i_angp1=i_angp1+1 
        j=ipk*(i_angp1-1)+j6th 
        parray(j+1)=hct
        parray(j+2)=hct
        parray(j+3)=0.
        
        i_angle=i_angle+1 
        i_angp1=i_angp1+1 
        j=ipk*(i_angp1-1)+j6th 
        parray(j+1)=hct
        parray(j+2)=0
        parray(j+3)=0.
        i_angle=i_angle+1 
        i_angp1=i_angp1+1 
        j=ipk*(i_angp1-1)+j6th 
        parray(j+1)=hct
        parray(j+2)=hct*2
        parray(j+3)=0.

       i_angp1=i_angp1+1 
       j=ipk*(i_angp1-1)+j6th 
       parray(j+1)=i_angle 
       parray(j+2)=0 
       parray(j+3)=-1.
!      ------ end of caculation of the specular angles (red line)-------
                                                             
      do k=2,ichanks(0),2 
       do jj=ichanks(k-1),ichanks(k)
        i_angle=i_angle+1 
        i_angp1=i_angp1+1 
        j=ipk*(i_angp1-1)+j6th 
        parray(j+1)=hct 
        parray(j+2)=hct 
        parray(j+3)=hzt
        parray(j+4)=real_fr(mdfpt+jj)
        i_angle=i_angle+1 
        i_angp1=i_angp1+1 
        j=ipk*(i_angp1-1)+j6th 
        parray(j+1)=real_fr(mxpt+jj)*scale_factor*hzt+hct
        parray(j+2)=real_fr(mypt+jj)*scale_factor*hzt+hct 
        parray(j+3)=(real_fr(mfpt+jj)*scale_factor+1)*hzt
        parray(j+4)=real_fr(mdfpt+jj)

        i_angle=i_angle+1 
        i_angp1=i_angp1+1 
        j=ipk*(i_angp1-1)+j6th 
        parray(j+1)=hct 
        parray(j+2)=hct 
        parray(j+3)=hzt
        parray(j+4)=real_fr(mdfpt+jj)
      end do
     end do
        i_angp1=i_angp1+1 
        j=ipk*(i_angp1-1)+j6th 
        parray(j+1)=i_angle 
        parray(j+2)=0 
        parray(j+3)=-1. 
        
       i_angp1=i_angp1+1 
       j=ipk*(i_angp1-1)+j6th 
       parray(j+1)=-1. 
       parray(j+2)=-1. 
       parray(j+3)=-1. 
                                                                        
                                                                        
 !      decission for points or line                                     
       npnt3d(1)=1 
 !                                                                       
       abscissa='omega [mrad]' 
       axisformat(1)='%5.1f ' 
       ordinata='counts' 
       axisformat(2)='%12.2f ' 
                                                                        
      xyzdz(5)=1.e10 
      scmin=1.e10 
      xyzdz(6)=0. 
                                                                        
       j=j6th 
       thmax=0. 
       do k=1,i_angp1
!        write(6,'(i8,2f12.2)')j,parray(j+3)                
        if(parray(j+3).gt.thmax)thmax=parray(j+3) 
        j=j+ipk 
       end do 
       nchanplot(6)=i_angp1 
       if(thmax.gt.xyzdz(6))xyzdz(6)=thmax 
       j=j6th 
       do k=1,i_angp1 
        if(parray(j+3).lt.thmax)thmax=parray(j+3) 
        j=j+ipk 
       end do 
       if(thmax.lt.xyzdz(5))xyzdz(5)=thmax 
       scmin=thmax 
!       write(6,'(a,f12.5)') ' th_min=',scmin

       b_data=.false.  
      if(b_data)then 
        j=j9th 
        ny=0 
        do k=2,ichanks(0),2 
         do jj=ichanks(k-1),ichanks(k),isd 
         ny=ny+1 
         parray(j+1)=real_fr(mxpt+jj) 
         parray(j+2)=real_fr(mypt+jj) 
         parray(j+3)=real_fr(mfpt+jj) 
         parray(j+4)=real_fr(mdfpt+jj)
         parray(j+5)=0.01 
         j=j+5 
         end do 
       end do

                                                                         
       j=j9th 
       damax=0. 
       do k=1,ny 
!       write(6,'(i8,2f12.2)')j,parray(j+3),parray(j+4)                
        if(parray(j+3)+parray(j+4).gt.damax)                            &
                 damax=parray(j+3)+parray(j+4)                         
        j=j+5 
       end do 
       j=j9th 
       damin=damax 
       do k=1,ny 
        if(parray(j+3)-parray(j+4).lt.damin)                            &
     &            damin=parray(j+3)-parray(j+4)                         
        j=j+5 
       end do 
       if(damax.gt.xyzdz(6)) xyzdz(6)=damax 
       if(damin.lt.xyzdz(5)) xyzdz(5)=damin 
       nchanplot(1)=ny 
                                                                        
       j=j9th 
       do k=1,ny 
        if(parray(j+3).lt.scmin) scmin=parray(j+3) 
         j=j+5 
       end do 
      end if    ! b_data  
                                                                        
                                                                        
       i_angp1=i_angp1+1 
       j=3*(i_angp1-1)+j6th 
       parray(j+1)=-1. 
       parray(j+2)=-1. 
       parray(j+3)=-1. 

       abscissa='x' 
       axisformat(1)='%5.1f ' 
       ordinata='z' 
       axisformat(2)='%5.1f '
       
       axesname(1)=abscissa//char(0)  
       axesname(2)='y'//char(0)  
       axesname(3)=ordinata//char(0)  
       auxcolor1='red'//char(0) 
       auxcolor2='yellow'//char(0) 

                                                                        
        title=Trim(name_data)//char(0)
                                                                 
       ISTEU=1 
       BREITE=0.5 
       HOEHE=0.7 
       ntxt=LEN_TRIM(text) 
       TEXT=title 
       alpha=90. 
       OP(0)=0.            ! no rotation around z-axis of inscription   
       OP(1)=0.            ! phix                                       
       OP(2)=0.            ! phiz                                       
       OP(3)=0.            ! phiy                                       
       OP(4)=10.            ! Xb                                        
       OP(5)=10.            ! Yb                                        
       OP(6)=0.0           ! Zb                                         
       OP(7)=0.            ! strsx                                      
       OP(8)=0.            ! strsy                                      
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
!       --------x  axis -------------------------------             
       OP(0)=1 
       bsl=char(92) 
       dbsl='$'//bsl 
       form='f5.1' 
       alpha=0. 
       BREITE=0.5 
       HOEHE=0.7 
       TEXT=bsl//'rx' 
       ntxt=3 
       OP(1)=-90.*rad     ! phix                                        
       OP(2)=-90.*rad     ! phiz                                        
       OP(3)=0.           ! phiy                                        
       OP(4)=0.95           ! Xb                                          
       OP(5)=0.           ! Yb                                          
       OP(6)=0.           ! Zb                                          
       OP(7)=0.           ! strsx                                       
       OP(8)=-1.3*HOEHE   ! strsy                                       
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
       BREITE=1.2 
       HOEHE=1.25 
       TEXT=bsl//'x' 
       ntxt=11 
       OP(1)=-90.*rad     ! phix                                        
       OP(2)=-90.*rad     ! phiz                                        
       OP(3)=0.           ! phiy                                        
       OP(4)=2.           ! Xb                                          
       OP(5)=0.           ! Yb                                          
       OP(6)=0.           ! Zb                                          
       OP(7)=0.           ! strsx                                       
       OP(8)=-2.6*HOEHE   ! strsy                                       
!       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
       BREITE=0.3 
       HOEHE=0.3
       vxbeg=0.
       call trlnu(form,vxbeg,chr,nn,chl,im) 
       if(chr(nn:nn).eq.'0')nn=nn-1 
       TEXT=chr(:nn) 
!       call TXTPLO(OP,-1,TEXT,nn,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
       OP(1)=-90.*rad     ! phix                                        
       OP(2)=-90.*rad     ! phiz                                        
       OP(3)=0.           ! phiy                                        
       OP(4)=xbeg         ! Xb                                          
       OP(5)=0.           ! Yb                                          
       OP(6)=0.           ! Zb                                          
       OP(7)=Xl           ! strsx                                       
       OP(8)=-0.4*HOEHE   ! strsy                                       
!       call TXTPLO(OP,ISTEU,TEXT,nn,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
       vxend=1.                                                                 
       call trlnu(form,vxend,chr,nn,chl,im) 
       if(chr(nn:nn).eq.'0')nn=nn-1 
       TEXT=chr(:nn) 
       OP(1)=-90.*rad     ! phix                                        
       OP(2)=-90.*rad     ! phiz                                        
       OP(3)=0.           ! phiy                                        
       OP(4)=xend         ! Xb                                          
       OP(5)=0.           ! Yb                                          
       OP(6)=0.           ! Zb                                          
       OP(7)=0.           ! strsx                                       
       OP(8)=-0.4*HOEHE   ! strsy                                       
!       call TXTPLO(OP,ISTEU,TEXT,nn,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
!      -------- y axis -------------------------------              
                                                                        
       ISTEU=1 
       alpha=0. 
       BREITE=0.5 
       HOEHE=0.7 
       TEXT=bsl//'ry' 
       ntxt=3 
       call TXTPLO(OP,-1,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
       OP(1)=0.           ! phix                                        
       OP(2)=0.           ! phiz                                        
       OP(3)=-90.*rad     ! phiy                                        
       OP(4)=0            ! Xb                                          
       OP(5)=0.87           ! Yb                                        
       OP(6)=0.           ! Zb                                          
       OP(7)=-1.6*HOEHE     ! strsx                                     
       OP(8)=-Xl          ! strsy                                       
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
                                                                        
       BREITE=0.2 
       HOEHE=0.25 
       TEXT=bsl//'y  ' 
       ntxt=11 
!       call TXTPLO(OP,-1,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
       OP(1)=0.           ! phix                                        
       OP(2)=0.           ! phiz                                        
       OP(3)=-90.*rad     ! phiy                                        
       OP(4)=0            ! Xb                                          
       OP(5)=1.           ! Yb                                          
       OP(6)=0.           ! Zb                                          
       OP(7)=-3.5*HOEHE     ! strsx                                     
       OP(8)=-Xl          ! strsy                                       
!       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
       BREITE=0.3 
       HOEHE=0.3 
       call trlnu(form,vybeg,chr,nn,chl,im) 
       if(chr(nn:nn).eq.'0')nn=nn-1 
       TEXT=chr(:nn) 
       OP(1)=0.           ! phix                                        
       OP(2)=0.           ! phiz                                        
       OP(3)=-90.*rad     ! phiy                                        
       OP(4)=0            ! Xb                                          
       OP(5)=ybeg          ! Yb                                         
       OP(6)=0.           ! Zb                                          
       OP(7)=-0.4*HOEHE   ! strsx                                       
       OP(8)=0.0             ! strsy                                    
!       call TXTPLO(OP,ISTEU,TEXT,nn,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
                                                                        
       call trlnu(form,vyend,chr,nn,chl,im) 
       if(chr(nn:nn).eq.'0')nn=nn-1 
       TEXT=chr(:nn) 
!       call TXTPLO(OP,-1,TEXT,nn,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
       OP(1)=0.           ! phix                                        
       OP(2)=0.           ! phiz                                        
       OP(3)=-90.*rad     ! phiy                                        
       OP(4)=0            ! Xb                                          
       OP(5)=yend         ! Yb                                          
       OP(6)=0.           ! Zb                                          
       OP(7)=-0.4*HOEHE   ! strsx                                       
       OP(8)=-Xl          ! strsy                                       
!       call TXTPLO(OP,ISTEU,TEXT,nn,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
!      -------- z axis -------------------------------                  
       BREITE=.5 
       HOEHE=0.7 
        i=int(alog(xyzdz(6)+1.)/alog(10.)) 
        TEXT='z' 
        ntxt=16 
        form='f4.1' 
        h=0.8*xyzdz(6)/10**i
        h=1.0
        call trlnu(form,h,chr,nn,chl,im) 
        ch4=chl 
       alpha=0. 
       OP(0)=0.           ! no rotation around z-axis of inscription    
       OP(1)=0.           ! phix                                        
       OP(2)=0.           ! phiz                                        
       OP(3)=0.           ! phiy                                        
       OP(4)=-0.1        ! Xb                                          
       OP(5)=-0.1        ! Yb                                          
       OP(6)=0.9          ! Zb                                           
       OP(7)=0.           ! strsx                                       
       OP(8)=0.           ! strsy                                       
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 

       BREITE=.3 
       HOEHE=0.4                                                                         
       TEXT=ch4  
       ntxt=4 
       alpha=0. 
       call TXTPLO(OP,-1,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
       OP(0)=0.             ! no rotation around z-axis of inscription   
       OP(1)=0.             ! phix                                       
       OP(2)=0.             ! phiz                                       
       OP(3)=0.             ! phiy                                       
       OP(4)=0.             ! Xb                                         
       OP(5)=0.             ! Yb                                         
       OP(6)=0.75           ! Zb                                        
       OP(7)=0.             ! strsx                                      
       OP(8)=-Xl-0.4*HOEHE  ! strsy                                      
!       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
         ch4(1:1)=' ' 
         TEXT=ch4(2:4) 
         ntxt=3 
       alpha=0. 
       OP(0)=0.             ! no rotation around z-axis of inscription    
       OP(1)=0.             ! phix                                        
       OP(2)=0.             ! phiz                                        
       OP(3)=0.             ! phiy                                        
       OP(4)=0.             ! Xb                                          
       OP(5)=0.             ! Yb                                          
       OP(6)=0.02           ! Zb                                          
       OP(7)=0.             ! strsx                                       
       OP(8)=-XL-0.4*BREITE ! strsy                                     

!       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
!       write(6,'(a,8g12.6)')' min-max=', &                              
!               xyzdz(1),xyzdz(2),xyzdz(3),xyzdz(4),xyzdz(5),xyzdz(6)     
      return 
      END                                           

      
