      subroutine data2dread(n1,info) 
      use glbconst, only: MDBPLFT,infotext
      use comdat, only: cdata_str,ichanks,mfpt,nuofdatas,nchannelsp,&
                        readform,formdata
      use comthe, only: real_fr
      implicit none 
                                                                        
      integer,intent(in) :: n1
      integer,intent(out):: info
      character(len=132):: ch132,cp132
                                
      character(len=4), dimension(1:8) :: dacom
      integer,dimension(1:8) :: ldacom,iplace,iextra
      integer,dimension(1:16):: irow 
      real,   dimension(1:32):: out
      real        array,array1,h 
      common/plot/array(MDBPLFT),array1(MDBPLFT) 
      integer      i,ip,ipos,ir,ifound,ih,j,jj1,jj2,k,nt,nj,irn 
                                                                        
!     write(6,'(a,5i7)') '  iarray_sp,nstorFR=',iarray_sp,nstorFR       
!     only even number of channels are handled                          
!      write(6,'(a,i4,2x,a)')'dataread n1,readform=',                   
!     &  n1,readform  

!      write(6,*)'formdata=',formdata  
      ichanks(0)=2; ichanks(1)=1; ichanks(2)=nchannelsp
      do k=1,8 
       ldacom(k)=0 
       iplace(k)=0 
       iextra(k)=0 
      end do 
                                                                        
      ip=1 
      ih=0 
      nt=0 
      ch132=cdata_str 
      do while(ip.gt.0) 
       call nextchar(ch132,ih,ipos,cp132,ip) 
       ch132=cp132 
       ih=ip 
       nt=nt+1 
!       write(6,'(i5,2x,a)') ip,cp132(1:24)                               
                                                                        
       if(nt.eq.8.or.ip.eq.0)then 
        ip=0 
        dacom(nt)=' ' 
        ldacom(nt)=ip 
       else 
        dacom(nt)=cp132(1:ip) 
        ldacom(nt)=ip 
        end if 
      end do 
      nt=nt-1 
!      write(6,'(a,10a6)') ' dacom=',(dacom(i),i=1,nt)                  
!      write(6,'(a,10i5)') ' ldacom=',(ldacom(i),i=1,nt)                


    i=1
    do while(formdata(i).ne.' ')    
      ch132=formdata(i)
!      write(6,'(a,a)')'formdata(i)=',formdata(i)
      i=i+1 
      ip=1 
      ih=0 
      ir=0 
      nj=0 
      do while(ip.gt.0) 
       call nextchar(ch132,ih,ipos,cp132,ip) 
       ch132=cp132 
       ih=ip 
       nj=nj+1 
       ifound=10 
       if(nj.gt.9) ip=0 
       if(ip.gt.0) then 
        ifound=0 
!        write(6,'(i5,2x,a)') ip,cp132(1:24)                             
        do k=1,nt 
!        write(6,'(a,i2,a,a4,2x,a)') 'k=',k,' dacom(k)=',dacom(k),cp132(1:ip)
         if(cp132(1:ip).eq.dacom(k)) then 
          ir=ir+1 
          iplace(ir)=k 
          ifound=1 
         end if 
        end do 
       end if 
!      write(6,*)'ifound=',ifound
!       if(ifound.eq.0) then
!        ir=0;  goto 250 
!       end if
      end do
      if(ir.eq.nt.and.nj-1.eq.nt) goto 250
     end do

 250  continue
!      write(6,'(3(a,i2))') 'ir=',ir,' nj=',nj,' nt=',nt
      if(ir.eq.0.or.nj-1.ne.nt) then
        nuofdatas=0
        info=nt 
        infotext(1)='effi/data/read_data/format' 
        infotext(3)=' '
        print '(a)',' format: '//cdata_str(:12)//' on data file'
        print '(a)',' data formats provided by the theory are:'
        i=1
        do while(formdata(i).ne.' ')
         print '(2x,a16)',formdata(i)   
          i=i+1
        end do
        return
      end if

      do k=1,nt 
       if(dacom(k).eq.'y'.and.dacom(k+1)(1:1).ne.'d') then 
        iextra(iplace(k))=iplace(k) 
       end if 
      end do 

!      write(6,'(a,6i4)')   ' return, ifound=',ifound,ir,nt,nj                   
!      write(6,'(a,10i5)') ' ldacom=',(ldacom(i),i=1,8)                 
!      write(6,'(a,10i5)') ' iplace=',(iplace(i),i=1,8)                 
!      write(6,'(a,10i5)') ' iextra=',(iextra(i),i=1,8)                 
                                                                  
!     reading of data type n=1,2,...,8                                  
!     storing data of type istortype=1...8                              
      ip=-1 
      do k=1,ir 
       j=nt-iplace(k) 
       ip=ip+1 
       jj1=mfpt+ip*nchannelsp 
       if(iextra(k).gt.0) then 
        ip=ip+1 
       end if 
      end do 

      if(n1.eq.0) then
       nuofdatas=ip+1
!       write(6,'(a,6i6)') ' ip,nuofdatas=',ip,nuofdatas,nchannelsp
       return 
      end if                                                                  

      k=nchannelsp*nt 
!     write(6,'(a,6i6)') ' n1,nt,k,nchannelsp=',n1,nt,k,nchannelsp      
      i=index(readform,'free') 
      if(i.gt.0)then 
       ch132=readform(2:i) 
       call trlch(i+1,ch132,irn,out) 
        i=ichar(ch132(1:1))-48
       do i=1,irn 
        irow(i)=out(i) 
       end do 
                                                                        
       j=0 
       do while(j.lt.k) 
        read(n1,'(a)',end=50)ch132
        call trlch(80,ch132,ipos,out)
        do ip=1,irn 
         array(ip+j)=out(irow(ip)) 
        end do 
        j=j+irn 
       end do 
      else
       print'(3a,i6)','format used:',Trim(readform),'  numbers read in:',k
       read(n1,readform,end=50) (array(i),i=1,k) 
      end if 
      goto 60 
 50   info=25
      infotext(1)='effi/command/rd'
      infotext(3)= &
      '-subroutine data2dread()- "missing number of columns" or "EOF found"' 
      infotext(4)=' ' 
      goto 245 
   60 continue 

     
       ip=-1 
      do k=1,ir 
       j=nt-iplace(k) 
       ip=ip+1 
       jj1=mfpt+ip*nchannelsp 
!       write(6,'(a,8i7)') ' ir,iplace(k),nt,j,mfpt,jj1,iextra(k)=',&         
!                        ir,iplace(k),nt,j,mfpt,jj1,iextra(k)                 
       do i=1,nchannelsp 
        real_fr(jj1+i)=array(nt*i-j) 
       end do 

        if(iextra(k).gt.0) then 
        ip=ip+1 
        jj2=mfpt+ip*nchannelsp 
!       write(6,'(a,6i7)') ' ip,iplace(k),nt,j,jj2=',ip,iplace(k),nt,j,jj1,jj2
        do i=1,nchannelsp 
         h=real_fr(jj1+i) 
         if(h.gt.0) then 
          real_fr(jj2+i)=sqrt(h) 
         else 
          real_fr(jj2+i)=1. 
         end if 
        end do
!       write(6,'(i8,8f10.2)')jj2,(real_fr(jj2+i),i=1,6)    
       end if 
      end do
!      write(6,'(5i8)')mfpt,mdfpt,mxpt 
!      write(6,'(i8,8f10.2)')mfpt,(real_fr(mfpt+i),i=1,512,64)   
!      write(6,'(i8,8f10.2)')mxpt,(real_fr(mxpt+i),i=1,6)   
!      write(6,'(a,6i6)') 'cc ip,nchannelsp=',ip,nchannelsp 
      goto 245 
!     read error format?                                                
      info=24 
      infotext(1)='effi/command/rd'
      infotext(3)='-subroutine data2dread()- identified format:'//readform 
      infotext(5)=' ' 
  245 continue 
      return 
      END                                           
                                                                        
     subroutine punch2d(nout,info) 
     use glbconst, only: maxn,max8,maxsub,MDBPLFT,mplot,infplot,nwr,ncl
     implicit none
                                                                 
     integer,intent(in) :: nout
     integer,intent(out):: info
     integer,parameter:: max8subn=maxsub*max8,maxn6=max8*6,max16=maxn*16,&
                         idumpl=MDBPLFT*2-176*maxn-8*39-maxsub-        &
                         5*infplot-133 
     character(len=132):: ch132,cp132,title,plotstrdef,plotstrpu,iform,           &
                           cpunch,cpunchsu,cpunchw,cpunchstrj,chcom
     character(len=40) :: stringnumber
     character(len=24) :: axesname
     character(len=16) :: axisformat
     character(len=8)  :: kform
     character(len=4)  :: namechan,chdum
     character(len=2)  :: su

     integer     ifeder,ltext,int3d,npnt3d,ncolor,                     &
                 npntplot,nchanplot,n_subspectra,logx,logy,logf
     real        plotarray,xyzdz,vtxt,vtxtp 
     common/plot/plotarray(maxn6+max8subn),                            &
                 xyzdz(8),vtxt(2,max16),vtxtp(8,32),                  &
                 int3d(maxn*16),npnt3d(16),ifeder(max16),ltext(32),   &
                 npntplot(infplot),nchanplot(infplot),ncolor(maxsub),  &
                 n_subspectra,logx,logy,logf,                          &
                 namechan(infplot),kform(infplot),axisformat(3),       &
                 axesname(3),title,plotstrdef,plotstrpu,               &
                 chdum(idumpl)                                         

     character(len=8) ,dimension(1:2*infplot),save :: k2form
     integer,dimension(1:infplot),save:: iplace,lname,jp
     integer,dimension(maxsub):: npanum
     integer   i,if,ifound,ih,il,ip,ip1,ipk,ipos,ipw,k,l,jka,jkz,   &
               ir,isu,lfr,nch,nsequence,ntrimto0                                                                 

      info=0
      k=1 
      do while(kform(k).ne.' '.and.k.lt.infplot) 
       k2form(k)=kform(k) 
!       write(6,'(a)')kform(k)                                          
       k=k+1 
      end do 
      k=k-1 
      do i=1,k 
       k2form(k+i)=kform(k) 
      end do 
                                                                        
!      do ii=1,infplotarray*2                                           
!       scratch(ii)=plotarray(ii)                                       
!      end do                                                           
!      write(6,'(a)')(namechan(k),k=1,4)
      do k=1,infplot 
       l=index(namechan(k),' ') 
       lname(k)=l-1 
       if(lname(k).le.0) lname(k)=4 
      end do
      
      cpunch=plotstrpu 
      l=ntrimto0(cpunch) 
!      do k=1,l 
!       if(cpunch(k:k).eq.',')cpunch(k:k)=' ' 
!      end do 
      nsequence=1 
  100 continue 
!      write(6,'(2a)') 'print  100:',cpunch(1:60)                       
      jka=index(cpunch,'(') 
      jkz=index(cpunch,')') 
      cpunchstrj=' ' 
      if(jka.gt.0.and.jkz.gt.0) then 
       cpunchstrj=cpunch(jka+1:jkz-1) 
       if(jka.gt.1)then 
        if(cpunch(jka-1:jka-1).eq.'d')cpunchstrj='d'//cpunch(jka:jkz) 
       end if 
       nsequence=0 
       cpunchw=cpunch(jka+1:jkz-1) 
       cp132=cpunch(jkz+1:) 
       cpunch=cp132 
      else 
       cpunchstrj=cpunch 
       cpunchw=cpunch 
       cpunch=' ' 
      end if 
                                                                        
      do k=1,8 
       iplace(k)=0 
      end do 
                                                                        
      su=namechan(mplot+1) 
!     write(6,'(3a)')'namechan(mplot+1)=',namechan(mplot+1)             
      ir=0 
!      write(6,'(i3,a)')(lname(k),namechan(k),k=1,4)                                                                     
  200 continue 
!      write(6,'(3a)') ' 200: cpunchw=',cpunchw(1:30)
      isu=index(cpunchw,su) 
      if(isu.gt.0) then 
       ch132=cpunchw(1:isu-1) 
       cp132=cpunchw(isu:) 
       cpunchw=cp132  
       ipw=0 
       k=1 
       do while(k.le.mplot.and.ipw.eq.0)
        ipw=index(cpunchw(1:30),namechan(k)(1:lname(k))) 
!       write(6,'(i4,3a)') ipw,'=ipw: cpunchw,namechan(k)=', &           
!            cpunchw(1:30),namechan(k)(1:lname(k))                     
        k=k+1 
       end do 
       if(ipw.gt.0) then 
        cp132=cpunchw(ipw:) 
        cpunchsu=cpunchw(1:ipw-1) 
        cpunchw=cp132 
!        write(6,'(3a)') 'ipw.gt.0: cpunchw,cpunchsu=',    &                 
!         cpunchw(1:30),cpunchsu(1:30)                                 
       else 
        cpunchsu=cpunchw 
        cpunchw=' ' 
       end if 
      else 
       ch132=cpunchw 
!      write(6,'(3a)') 'isu.eq.0: cpunchw=',cpunchw(1:30)               
       cpunchsu=' '
       cpunchw=' ' 
      end if 
                                                                        
      ifound=0 
      ip=1 
      ih=0 
  210 continue 
      call nextchar(ch132,ih,ipos,cp132,ip) 
      ch132=cp132
      ih=ip 
      if(ip.gt.0) then 
       do k=1,infplot 
!       k=0                                                             
!       do while(ifound.eq.0.and.k.lt.infplot)                          
!        k=k+1                                                          
!        write(6,'(i4,a,i2,a,a4,2x,a)') ifound,' k=',k,' namechan(k)=',& 
!               namechan(k)(1:lname(k)),cp132(1:ip)                    
        if(namechan(k)(1:lname(k)).eq.cp132(1:ip)) then 
!         write(6,'(a,i2,a,a4,2x,a)') 'k=',k,' namechan(k)=', &          
!                        namechan(k),cp132(1:ip)                       
!          write(6,'(a)') cpunchw(1:80)                                 
         ir=ir+1 
         iplace(ir)=k 
         ifound=1 
        end if 
       end do 
!       write(6,'(a,10i4)') ' ir,ifound=',ir,ifound                     
       if(ifound.eq.0) then 
        write(nwr,'(3a)')                                               &
              '**error** ',cp132(1:ip),' is not a data type'           
       end if 
       goto 210 
      end if 
      nch=132 
      isu=index(cpunchsu,'su') 
      if(isu.gt.0) cpunchsu(isu:isu+1)=' ' 
      call panum(cpunchsu,n_subspectra,npanum,1) 
!      write(6,'(a,10i4)') ' npanum=',(npanum(i),i=1,8),n_subspectra               
!      write(6,'(a,10i4)') ' ir,mplot=',ir,mplot                        
      do k=1,npanum(2) 
       iplace(ir+k)=mplot+npanum(2+k) 
      end do 
      ir=ir+npanum(2) 
!      write(6,'(2a)') 'cpunchw=',cpunchw(1:60)                         
      if(cpunchw.ne.' ') goto 200 
                                                                        
      if(ir.eq.0) goto 1000 
      cp132='title'
      ch132=title
      chcom='effi/data/title' 
      call askstring(cp132,ch132,chcom,ncl,nwr)      
!      write(6,'(a,20i3)') ' nseq=0,iplace=',(iplace(i),i=1,ir)        
      title=ch132
      write(nout,'(a)') TRIM(title) 
                                                      
        ipk=iplace(1)
        ch132=k2form(ipk)
        il=ntrimto0(ch132)
        iform='('//ch132(1:il)
        if=il+1 
        do k=2,ir 
         ipk=iplace(k) 
         ch132=k2form(ipk) 
!        write(6,'(a,2x,a)') 'ipk,k2form',ipk,k2form(ipk)               
         il=ntrimto0(ch132)
         iform(if+1:if+1+il)=','//ch132(1:il) 
         if=if+1+il 
        end do 
        iform(if+1:if+1)=')' 
        lfr=if+1 
        write(nwr,'(17x,a,2x,a)') iform(:lfr),TRIM(cpunchstrj)
        write(nout,'(a,2x,a)') iform(:lfr),TRIM(cpunchstrj)

        ip1=iplace(1) 
        write(unit=stringnumber,fmt=300)nchanplot(ip1)
 300    format ('nu_channels=',i5)
        write(nout,'(a)') stringnumber 
                                                                        
        do k=1,ir 
         jp(k)=(iplace(k)-1)*max8 
!        write(6,'(a,3i5,2x,f15.6)') ' ir,iplace(k),jp(k),plotarray(j+1)=',& 
!                      ir,iplace(k),jp(k),plotarray(jp(k)+1)-1.        
        end do
        do i=1,nchanplot(iplace(1)) 
         write(nout,iform) (plotarray(jp(k)+i),k=1,ir) 
        end do 
        write(nout,'(a)') (axesname(i),i=1,3) 
       if(cpunch.ne.' ') goto 100 
 1000  continue 
      write(nout,'(a2)')'##' 
      return 
      END                                           
                                                                        
