      subroutine data3dread(n1,info) 
      use glbconst, only: max8,MDBPLFT,infotext
      use comdat, only: cdata_str,data_str,ichanks,mfpt,          &
                        nuofdatas,nchannelsp,readform
      use comthe, only: real_fr
      implicit none 
                                                                        
      integer,intent(in) :: n1
      integer,intent(out):: info
      character(len=132):: ch132,cp132   
                                
      character(len=4), dimension(1:8) :: dacom
      integer,dimension(1:8) :: ldacom,iplace,iextra

      logical,dimension(1:max8):: b_dat 
      real         array,h 
      common/plot/ array(MDBPLFT*2) 
      equivalence (array(1),b_dat(1)) 
      integer      i,ip,ipos,ir,ifound,ih,j,jj1,jj2,k,nt,nj,ig,mgrpt 

!     write(6,'(a,5i7)') '  iarray_sp,nstorFR=',iarray_sp,nstorFR       
!     only even number of channels are handled                          
!      write(6,'(a,2i4,2x,a)')'dataread n1,ks,readform=',               
!    &  n1,ks,readform                                                  
      do k=1,8 
       ldacom(k)=0 
       iplace(k)=0 
       iextra(k)=0 
      end do 

      ip=1 
      ih=0 
      nt=0 
!      write(6,'(2a)')'cdata_str=', cdata_str    ! from data file       
      ch132=cdata_str 
      do while(ip.gt.0) 
       call nextchar(ch132,ih,ipos,cp132,ip) 
       ch132=cp132 
       ih=ip 
       nt=nt+1 
!      write(6,'(i5,2x,a)') ip,cp132(1:24)                              
                                                                        
       if(nt.eq.8.or.ip.eq.0)then 
        ip=0 
        dacom(nt)=' ' 
        ldacom(nt)=ip 
       else 
        dacom(nt)=cp132(1:ip) 
        ldacom(nt)=ip 
       end if 
      end do 
      nt=nt-1 
!      write(6,'(a,10a6)') ' dacom=',(dacom(i),i=1,nt)                  
!      write(6,'(a,10i5)') ' ldacom=',(ldacom(i),i=1,nt)                
                                                                        
!      write(6,'(2a)') 'from th data_str=',data_str            ! from fr
      ch132=data_str 
      ip=1 
      ih=0 
      ir=0 
      nj=0 
      do while(ip.gt.0) 
       call nextchar(ch132,ih,ipos,cp132,ip) 
       ch132=cp132 
       ih=ip 
       nj=nj+1 
       ifound=10 
       if(nj.eq.8) ip=0 
       if(ip.gt.0) then 
        ifound=0 
!       write(6,'(i5,2x,a)') ip,cp132(1:24)                             
        do k=1,nt 
!        write(6,'(a,i2,a,a4,2x,a)') 'k=',k,' dacom(k)=',               
!     &                   dacom(k),cp132(1:ip)                          
         if(cp132(1:ip).eq.dacom(k)) then 
          ir=ir+1 
          iplace(ir)=k 
          ifound=1 
         end if 
        end do 
       end if 
       if(ifound.eq.0) then 
        do k=1,nt 
         if(cp132(1:1).eq.'d'.and.cp132(2:2).eq.dacom(k)) then 
!         write(6,'(a,i2,a,a4,2x,a)') 'found=0 k=',k,                   
!     &   ' dacom(k)=',dacom(k),cp132(1:2)                              
          iextra(ir)=k 
          ifound=1 
         end if 
!        write(6,'(a,2i5)') 'k,ifound=',k,ifound                        
        end do 
       end if 
       if(ifound.eq.0) then 
        info=23 
        infotext(1)='effi/data/read_data/format' 
        infotext(3)='expected data format not on data file' 
        infotext(4)='format: '//cdata_str(:12)//'expected format: '//data_str                                                    
        infotext(5)=' ' 
        goto 250 
       end if 
      end do 
!      write(6,'(a,i4)')   ' return, ifound=',ifound                    
!      write(6,'(a,10i5)') ' ldacom=',(ldacom(i),i=1,8)                 
!      write(6,'(a,10i5)') ' iplace=',(iplace(i),i=1,8)                 
!      write(6,'(a,10i5)') ' iextra=',(iextra(i),i=1,8)                 
                                                                        
!     reading of data type n=1,2,...,8                                  
!     storing data of type istortype=1...8                              
      nchannelsp=ichanks(ichanks(0))

      ip=-1 
      do k=1,ir 
       j=nt-iplace(k) 
       ip=ip+1 
       jj1=ip*nchannelsp 
       if(iextra(k).gt.0) then 
        ip=ip+1 
       end if 
      end do 
!      write(6,'(a,6i6)') 'cc ip,nchannelsp=',ip,nchannelsp             
      nuofdatas=(ip+2)
!      write(6,'(a,6i6)') ' nuofdatas=',nuofdatas                       
      if(n1.eq.0) return 
                                                                        
      k=nchannelsp*nt 
!      write(6,'(a,6i6)') ' n1,nt,k,nchannelsp=',n1,nt,k,nchannelsp     
!      write(6,'(a,a)') ' readform=',readform                           
      read(n1,readform,end=50,err=240) (array(i),i=1,k) 
                                                                        
      goto 60 
   50 info=25 
      infotext(3)='read found EOF' 
      infotext(4)=' ' 
      goto 250 
   60 continue 
                                                                        
      ip=-1 
      do k=1,ir 
       j=nt-iplace(k) 
       ip=ip+1 
       jj1=mfpt+ip*nchannelsp 
!       write(6,'(a,8i7)') ' ir,iplace(k),nt,j,jj1,iextra(k)=',&         
!                      ir,iplace(k),nt,j,jj1,iextra(k)                 
        do i=1,nchannelsp 
         real_fr(jj1+i)=array(nt*i-j) 
        end do 
                                                                        
        if(iextra(k).gt.0) then 
         ip=ip+1 
         jj2=mfpt+ip*nchannelsp 
!        write(6,'(a,6i7)') ' ip,iplace(k),nt,j,jj2=',                  
!     &                 ip,iplace(k),nt,j,jj2                           
         do i=1,nchannelsp 
          h=real_fr(jj1+i) 
          if(h.gt.0) then 
           real_fr(jj2+i)=sqrt(h) 
          else 
           real_fr(jj2+i)=1. 
          end if 
         end do 
        end if 
      end do 
                                                                        
      do i=1,nchannelsp 
       b_dat(i)=.true. 
      end do 

      mgrpt=mfpt+4*nchannelsp  ! address for group of points 
      ig=1                     ! group number
      do i=1,nchannelsp 
       real_fr(mgrpt+i)=ig 
       if(real_fr(mfpt+i).eq.-1)then 
        ig=ig+1 
        b_dat(i)=.false. 
       end if 
      end do 
                                                                      
                                                                        
        k=1 
        i=1 
        do while(i.lt.nchannelsp) 
         if(b_dat(i))then 
          ichanks(k)=i 
          j=i+1 
          do while(j.le.nchannelsp.and.b_dat(j)) 
           j=j+1 
          end do 
          ichanks(k+1)=j-1 
          i=j-1 
          if(i.lt.nchannelsp) k=k+2 
         end if 
         i=i+1 
        end do 
        ichanks(0)=k+1 
        if(ichanks(k).eq.0)ichanks(0)=k-1 
                                                                    
!     write(6,'(a,6i6)') 'cc ip,nchannelsp=',ip,nchannelsp              
      goto 250 
  240 continue 
!     read error format?                                                
      info=24 
      infotext(3)='read error of data file, identified format:' 
      infotext(4)=readform 
      infotext(5)=' ' 
  250 continue 
      return 
      END                                           

     subroutine punch3d(nout,info) 
     use glbconst, only: maxn,MDBPLFT,max8,maxsub,mplot,infplot,nwr
     use comdat, only: cdatas,vdatas,n_cdatas,n_vdatas
     implicit none
!    not yet altered for 3d                                            
                                                                        
     integer,intent(in) :: nout
     integer,intent(out):: info
     integer,parameter::idumpl=MDBPLFT*2-176*maxn-8*39-5*infplot       &
                         -maxsub-133, max16=maxn*16
     character(len=132):: ch132,cp132,title,plotstrdef,plotstrpu,iform,&
                          cpunch,cpunchw,cpunchstrj
     character(len=24) :: chl,chr,axesname
     character(len=16) :: axisformat
     character(len=8)  :: kform
     character(len=7)  :: form
     character(len=4)  :: namechan,chdum
     character(len=2)  :: su
     integer      n_subspectra,j6th,logx,logy,logf,                    &
                  int3d,npnt3d,ifeder,ltext,npntplot,nchanplot,ncolor  
     real         parray,xyzdz,vtxt,vtxtp 
     common/plot/ parray(maxn*112),xyzdz(8),vtxt(2,max16),vtxtp(8,32),&
                  int3d(max16),npnt3d(16),ifeder(max16),ltext(32),  &
                  npntplot(infplot),nchanplot(infplot),ncolor(maxsub), &
                  n_subspectra,logx,logy,logf,                         &
                  namechan(infplot),kform(infplot),axisformat(3),      &
                  axesname(3),title,plotstrdef,plotstrpu,              &
                  chdum(idumpl)                                      
                                                                       
     real         plotx,ploty,ploterry,plotres,plotxx,plotyy 
     dimension    plotx(max8),ploty(max8),ploterry(max8),plotres(max8),&
                  plotxx(max8),plotyy(max8)                            
     equivalence  (parray(1),plotx(1)),(parray(max8+1),ploty(1)),      &
                  (parray(max8*2+1),ploterry(1)),                      &
                  (parray(max8*3+1),plotres(1)),                       &
                  (parray(max8*4+1),plotxx(1)),                        &
                  (parray(max8*5+1),plotyy(1))                         
                                                                       
     character(len=8) ,dimension(1:2*infplot):: k2form
     integer,dimension(1:infplot):: iplace,lname,iplact
     real         rn 
     integer   i,if,ifound,ih,ii,il,ip,ipk,ipos,k,l,jka,jkz,   &
                j,jj,jch,j9th,ir,lfr,nch,nsequence                                                                     
!     structure on plot                                                 
!     xd,yd,zd,errz,res,  ...., xd,yd,zd,errz,res,....                  
!     from j6th+1                                                       
!     xt,yt,zt,...., xt,yt,zt,...  

      info=0                                     
      j9th=max8*9 
      j6th=max8*6 
      k=1 
      do while(kform(k).ne.' '.and.k.lt.infplot) 
       k2form(k)=kform(k) 
!       write(6,'(a)')kform(k)                                          
       k=k+1 
      end do 
      k=k-1 
      do i=1,k 
       k2form(k+i)=kform(k) 
      end do 
                                                                        
      do k=1,infplot 
       l=index(namechan(k),' ') 
       lname(k)=l-1 
       if(l.eq.0) lname(k)=4 
      end do 
                                                                        
      cpunch=plotstrpu 
      l=LEN_TRIM(cpunch) 
      do k=1,l 
       if(cpunch(k:k).eq.',')cpunch(k:k)=' ' 
      end do 
      nsequence=1 
  100 continue 
!      write(6,'(2a)') 'print  100:',cpunch(1:60)                       
      jka=index(cpunch,'(') 
      jkz=index(cpunch,')') 
      cpunchstrj=' ' 
      if(jka.gt.0.and.jkz.gt.0) then 
       cpunchstrj=cpunch(jka:jkz) 
       nsequence=0 
       cpunchw=cpunch(jka+1:jkz-1) 
       cp132=cpunch(jkz+1:) 
       cpunch=cp132 
      else 
       cpunchstrj=cpunch 
       cpunchw=cpunch 
       cpunch=' ' 
      end if 
                                                                        
      do k=1,8 
       iplace(k)=0 
      end do 
                                                                        
      su=namechan(mplot+1) 
      ir=0 
                                                                        
  200 continue 
!      write(6,'(3a)') ' 200: cpunchw=',cpunchw(1:30)                   
       ch132=cpunchw 
       cpunchw=' ' 
                                                                        
      ifound=0 
      ip=1 
      ih=0 
  210 continue 
      call nextchar(ch132,ih,ipos,cp132,ip) 
      ch132=cp132 
      ih=ip 
!     write(6,'(a,i5,2x,a)') 'ip,cp132(1:24)=',ip,cp132(1:24)           
                                                                        
      if(ip.gt.0) then 
       do k=1,infplot 
!       k=0                                                             
!       do while(ifound.eq.0.and.k.lt.infplot)                          
!        k=k+1                                                          
!        write(6,'(i4,a,i2,a,a4,2x,a)') ifound,' k=',k,' namechan(k)=', 
!     &          namechan(k)(1:lname(k)),cp132(1:ip)                    
        if(namechan(k)(1:lname(k)).eq.cp132(1:ip)) then 
!         write(6,'(a,i2,a,a4,2x,a)') 'k=',k,' namechan(k)=',           
!     &                   namechan(k),cp132(1:ip)                       
!         write(6,'(a)') cpunchw(1:80)                                  
         ir=ir+1 
         iplace(ir)=k 
         ifound=1 
        end if 
       end do 
!       write(6,'(a,10i4)') ' ir,ifound=',ir,ifound                     
       if(ifound.eq.0) then 
        write(nwr,'(3a)')                                               &
     &         '**error** ',cp132(1:ip),' is not a data type'           
       end if 
       goto 210 
      end if 
!      write(6,'(a)') cpunchsu(1:80)                                    
      nch=132 
                                                                        
!      write(6,'(2a)') 'cpunchw=',cpunchw(1:60)                         
      if(cpunchw.ne.' ') goto 200 
!     write(6,'(a,8f8.3)') 'rsyco=',(rsyco(ipk),ipk=1,8)                
                                                                        
      if(ir.eq.0) goto 1000 
      write(nout,'(a)') TRIM(title) 
                                                                        
!       write(6,'(a,20i3)') ' nseq=0,iplace=',(iplace(i),i=1,ir)        
        ipk=iplace(1) 
        ch132=k2form(ipk) 
        il=LEN_TRIM(ch132) 
        iform='('//ch132(1:il) 
        if=il+1 
        do k=2,ir 
         ipk=iplace(k) 
         ch132=k2form(ipk) 
!        write(6,'(a,2x,a)') 'ipk,k2form',ipk,k2form(ipk)               
         il=LEN_TRIM(ch132) 
         iform(if+1:if+1+il)=','//ch132(1:il) 
         if=if+1+il 
        end do 
        iform(if+1:if+1)=')' 
        lfr=if+1 
        write(nout,'(a,2x,a)') iform(:lfr),TRIM(cpunchstrj) 
        write(nwr,'(17x,a,2x,a)') iform(:lfr),TRIM(cpunchstrj) 

!       constants from data file                                        
        ch132=' ' 
        jj=1 
        j=1 
        do while(n_cdatas(j).ne.' ') 
         i=index(n_cdatas(j),')') 
         form=n_cdatas(j)(19:i-1) 
         if(j.eq.1) then 
          if(iplace(1).lt.6) then 
           rn=nchanplot(1) 
          else 
          jch=1 
          do while(parray(j6th+(jch-1)*3+3).gt.-1.) 
           jch=jch+1 
          end do 
           rn=nchanplot(6)-jch 
           jch=jch+1 
          end if 
         else 
          rn=cdatas(j) 
         end if 
         call trlnu(form,rn,chr,ii,chl,il) 
         ch132(jj:jj+19+il)=n_cdatas(j)(:16)//'='//chl(1:il) 
         jj=jj+19+il 
         if(jj.gt.80) then 
          write(nout,'(a)')ch132 
          ch132=' ' 
          jj=1 
         end if 
         j=j+1 
        end do 
        if(jj.gt.16)write(nout,'(a)')ch132 
                                                                        
!       variables from data file                                        
        ch132=' ' 
        jj=1 
        j=1 
        do while(n_vdatas(j).ne.' ') 
         i=index(n_vdatas(j),')') 
         form=n_vdatas(j)(19:i-1) 
         rn=vdatas(j) 
         call trlnu(form,rn,chr,ii,chl,il) 
         ch132(jj:jj+19+il)=n_vdatas(j)(:16)//'='//chl(1:il) 
         jj=jj+19+il 
         if(jj.gt.80) then 
          write(nout,'(a)')ch132 
          ch132=' ' 
          jj=1 
         end if 
         j=j+1 
        end do 
        if(jj.gt.16)write(nout,'(a)')ch132 
                                                                        
         do k=1,ir 
          if(iplace(k).gt.5)iplact(k)=iplace(k)-5 
         end do 
         if(iplace(1).lt.6) then 
          do i=1,nchanplot(1) 
           write(nout,iform) (parray(j9th+(i-1)*5+iplace(k)),k=1,ir) 
          end do 
         else 
          do i=jch,nchanplot(6) 
           write(nout,iform) (parray(j6th+(i-1)*3+iplact(k)),k=1,ir) 
          end do 
         end if 
         write(nout,'(a)') (axesname(i),i=1,3) 
       if(cpunch.ne.' ') goto 100 
 1000  continue 
      return 
      END                                           
                                                                        
