     subroutine corread(n1,lch,chlese,b_unify,info) 
     use glbconst, only: maxfr1,maxc,maxp,maxpl,maxco,maxvaco,      &
                         maxs,maxthlv,maxthss,b_noask,b_vers,                      &
                         infotext,nwr,nrd,enwr 
     use compar, only: maxc_sp,maxp_sp,maxscrs,maxmemth
     use comfrm, only: con,ncon,mr,mrs,mc,mcs,mrce,mrces,ncor,      &
                       np,kp,p,up,op,ddp,kpl,nthpl,kcp,ivadd,       &
                       cpstor,fpstor,mplthsp,mcthsp,mpaddsp,        &
                       ipladd,icadd,icladd,mconcor,                 &
                       mcl,mco,mp,mpl,mrcet,                        &
                       mvaddsp,mpadds,mvaddss,ivaddsp,icaddsp,      &
                       mkaddsp,mcaddsp,mplthss,mplths,mcthss,mcths, &
                       mkaddss,mkadds,mcaddss,mpaddss
     use comsto, only: nametheoryh,nconh,ncorh,nthplh,nph,ktheoh,   &
                       mplthsph,mpaddsph,mcthsph,mkaddsth,  &
                       i_cdatah,n_cdatah,ip_chanh,cdatah,i_vdatah,  &
                       n_vdatah,vdatah,mplthsh,mkaddsh,mcthsh,mpaddsh,&
                       istrssh,mplthssh,mpaddssh,mcthssh,mkaddssh,  &
                       nu_sdeviceh,mrh,mch,mcsh,mrsh,mrcesh,mrceh,  &
                       kcph,kplh,cpstorh,fpstorh,kph,ph,uph,oph,    &
                       ddph,mcaddsph,mcaddssh,mvaddsph,numc,        &
                       ivaddh,icaddh,mvaddssh,cph,fph,ipladdh,      &
                       mclh,mcoh,mph,mplh,mrceth,mvaddsh,ivaddsph,  &
                       mcaddsh,icaddsph,conh,icladdh     
                       
     use comdas, only: nametheory,ktheo,istrss,i_cdata,ip_chan,     &
                       n_cdata,b_cdata,cdata,i_vdata,n_vdata,       &
                       b_vdata,vdata,ip_chan
     use comeff, only: strth,strco,strtm,nu_sdevice,mcadds,mvadds,npl
     use comthe, only: theoryname,thfrcase,maxthfrcase

     implicit none 
     integer, intent(in) :: n1,lch
     logical, intent(in) :: b_unify
     integer, intent(out):: info
     character(len=132), intent(inout):: chlese          
     character(len=132):: ch132,cp132,cq132,chcom,property,name_theo,namtheo
     character(len=24) :: ch24,chl,chr,cj24
     character(len=32) :: ca32,cb32
     character(len=8)  :: ch8,ncova,thversion,chth
     character(len=7)  :: form
     character(len=6)  :: ch6
     character(len=4)  :: cmch
     character(len=2)  :: ch2
     character(len=1)  :: ch1,aa,bb
     character(len=4),dimension(32):: chf  
     integer  ks,kss,k,icon,iv,iva,ic,nospectrum,iset,ipos,iq,nn,      &
              nthar,iss,nfrtheo,l_nfrtheo,nth,lth,                     &
              i,jth,l_jth,j,mplth,mcth,iout,m_cs,m_vs,ith0,i_cs,ip,    &
              icop,ico,ith,i1,i2,jf,i_vs,ivap,ivaq,kk,jsp,jss,nn1,     &
              nn2,istr,ih,io,nout1,nout2,ii,icl,ik,jkk,lf,mkk,ij,jj,   &
              iha,ksh,mplold,mco_last,kmaxsp,ilese,im,mcl_o,        &
              k_theo0,k_theo1,icd,ird,kc,kch,ir,kci,jh,kks,ms,l,l_,lb, &
              jb,i0,ivd,jz,linenumber,ic2,lstr1,ncc,ispa,isco,kdevice    
     integer, dimension(maxs)::  numh
     integer, dimension(12)  ::  nu_deviceh
     real,    dimension(32)  ::  out
     real rn 
     logical b_file
     integer, dimension(:,:,:), allocatable:: memtheo


      allocate(memtheo(maxs,0:maxthss,maxmemth))

!     n1 = input unit                                                   
!     info>0 error goto 1000                                               
!     reading of transformation matrix from file                        
!      call savearsp(12) 
      call zerosto 
      call zerotrf 
      i0=ichar('0') 
      ncc=130 
      do ks=1,maxs 
       nametheoryh(ks)=' ' 
      end do 
      do k=1,maxc 
       nconh(k)=' ' 
      end do 
      do k=1,maxco 
       ncorh(k)=' ' 
      end do 
      do k=1,maxpl 
       nthplh(k)=' ' 
      end do 
      do k=1,maxp 
        nph(k)=' ' 
      end do 
      do k=1,maxvaco 
       strth(k,1)=' ' 
       strth(k,2)=' ' 
       strco(k)=' ' 
      end do 
      do k=1,maxco 
       strtm(k,1)=' ' 
       strtm(k,2)=' ' 
      end do 
                                                                        
      mcl_o=mcl 
      linenumber=0 
!      nf=3                                                             
!      open (unit=nf,file='corread.txt'                                 
!     &                    ,status='unknown'                            
!     &                    ,access='sequential'                         
!     &                    ,form='formatted')                           
                                                                        
      icon=0 
      iv=0 
      iva=0 
      ic=0 
      nospectrum=0 
      do iset=1,maxs 
       if(ktheo(iset,0,0).gt.0) nospectrum=1 
      end do 
                                                                        
      read(n1,'(a)') ch132
      linenumber=linenumber+1 
      write(nwr,'(a,a,/)')'written by effi ',TRIM(ch132)
                                  
!     write(6,'(a80)') ch132(1:npl)                                     
      read(n1,'(a)') ch132 
      linenumber=linenumber+1 
!     write(6,'(a80)') ch132(1:npl)                                     
      read (n1,'(a)',end=480) ch132 
      linenumber=linenumber+1 
  100 continue 
!      write(6,'(2a)') '63 :',ch132(1:75)                               
      cp132=' '//ch132(1:npl-2) 
      call nextchar(cp132,0,ipos,cq132,iq) 
      call trlch(ncc,ch132,nn,out) 
!      write(6,'(4i6)') (int(out(j)),j=1,nn)                            
      if(nn.lt.2) then 
       info=linenumber 
       infotext(1)='effi/structure/corread/infocode2' 
       infotext(2)='**error** wrong structure of file .par' 
       infotext(3)=                                                     &
     & 'n=2 numbers expected: set number and 2*number of theories'      
       infotext(4)=cp132 
       infotext(5)=' ' 
       goto 490 
      end if 
                                                                        
      iset=out(1) 
      nthar=out(2) 
      if(iset.gt.maxs) then 
       info=maxs 
       infotext(1)='effi/structure/set/maxs' 
       infotext(2)='**error** number of spectra exceeds maxs' 
       infotext(3)=' ' 
       goto 490 
      end if 
      do k=1,3 
       nu_deviceh(k)=k  
      end do 
      iss=0 
                                                                        
      ktheoh(iset,0,0)=nthar 
      read(n1,'(a)') property 
!      read(n1,'(a)') property 
      
      linenumber=linenumber+1
!      write(6,'(a)') property(:npl)                                    
!      read(n1,'(a)')name_theo
      read(n1,'(a)')name_theo
      property=ADJUSTL(property)
      name_theo=ADJUSTL(name_theo)

      linenumber=linenumber+1 
      i=index(name_theo,'v=') 
      if(i.gt.0) then 
       thversion=name_theo(i:) 
       name_theo(i:)=' ' 
      else 
       thversion=' ' 
      end if 
                                                                        
      nametheoryh(iset)=name_theo 
!      write(6,'(a)') name_theo(:npl)                                   
      call  getthnumber(0,nfrtheo,l_nfrtheo,property,name_theo,info) 
!      write(6,'(a,2i4)') 'corread global nth,lth=',nfrtheo,l_nfrtheo  
      info=0
      ktheoh(iset,0,1)=nfrtheo 
      ktheoh(iset,0,2)=l_nfrtheo 
      call distribthfr(nfrtheo,'thna',n1,info)  ! reading theoryname,thfrcase(i)

      j=index(theoryname,'=')
      if(j.eq.0)then
       print'(a,/,a)','missing version number (v=lmn) of the theory:', &
                  TRIM(theoryname)
       return
      end if
      ch132=theoryname(j:)
      if(nospectrum.eq.0)write(nwr,'(2a,a2,3a,a1)')      &
       ' reading FRAME THEORY:',TRIM(name_theo),' v',TRIM(ch132)


      l=LEN_TRIM(name_theo) 
      call versioncomp(l,name_theo,theoryname,thversion,property,b_vers) 
                                                                        
      if(info.gt.0)goto 1000 
      if(nthar.gt.3) then 
       do k=3,nthar,2 
        read(n1,'(a)') property 
        read(n1,'(a)') name_theo 
        property=ADJUSTL(property)
        name_theo=ADJUSTL(name_theo)
        linenumber=linenumber+2 
        i=index(name_theo,'v=') 
        if(i.gt.0) then 
         thversion=name_theo(i:) 
         name_theo(i:)=' ' 
        else 
         thversion=' ' 
        end if 
        l=LEN_TRIM(name_theo) 
!        write(6,'(a,/,a)')property(:80), name_theo(:80)                 
        call  getthnumber(1,nth,lth,property,name_theo,info) 
        if(info.gt.0) goto 1000 
        ktheoh(iset,0,k)=nth 
        ktheoh(iset,0,k+1)=lth 
        j=1 
        do while(j.le.maxthfrcase)   ! gfortran (11.1.06) 
         i=index(thfrcase(j),'(')-1 
         if(i.gt.1)then 
!          write(6,'(2i3,a,/,a)')i,l,thfrcase(j)(:72),name_theo(:l)     
          if(thfrcase(j)(:i).eq.name_theo(:l)) then 
!           write(6,'(i2,2x,a,/,a)')i,name_theo(:72),thfrcase(j)(:72)   
           call versioncomp(l,name_theo,thfrcase(j),thversion,property,b_vers) 
           j=maxthfrcase+1 
          end if 
         end if 
         j=j+1 
        end do 
        if(j.eq.maxthfrcase+1) then 
         namtheo=name_theo 
         call getnamev(1,nth,lth,property,name_theo) 
         theoryname=name_theo 
         call versioncomp(l,namtheo,theoryname,thversion,property,b_vers) 
!        write(6,'(a1,2x,a,/,a,/a)')'+',TRIM(property),TRIM(name_theo),theoryname
        end if 
       end do 
      end if 
      if(info.gt.0)goto 1000 
!-----mem----------------------------------------------------           
!-----mem----------------------------------------------------           
                                                                        
      read (n1,'(a80)',end=480) ch132(1:ncc) 
      linenumber=linenumber+1 
!     write(6,'(2a)') '196:',ch132(:75)                                
      cp132=' '//ch132(1:ncc-2) 
      call nextchar(cp132,0,ipos,cq132,iq) 
      call trlch(ncc,cq132,nn,out) 
      if(nn.ne.4) then 
       info=linenumber 
       infotext(1)='effi/structure/corread/infocode2' 
       infotext(2)='**error** wrong structure of file .par' 
       infotext(3)='n=4 numbers expected on the line:' 
       infotext(4)=cp132 
       infotext(5)=' ' 
       goto 490 
      end if 
      istr=0 
      mplth=out(1) 
      mplthsph(iset)=mplth 
      mpaddsph(iset)=out(2) 
      mcth=out(3) 
      mcthsph(iset)=mcth 
      mkaddsth(iset)=out(4) 
!-----mem----------------------------------------------------           
      nfrtheo=ktheoh(iset,0,1)
      l_nfrtheo=ktheoh(iset,0,2)
      memtheo(iset,0,1)=0 
      memtheo(iset,0,2)=0 
      memtheo(iset,1,1)=0 
      memtheo(iset,1,2)=0 

      isco=0; ispa=0
      call getfrnu_copa(nfrtheo,l_nfrtheo,ncova,istr,info)
      cp132=ncova
      call trlch(8,cp132,nn,out) 

      isco=isco+out(1); ispa=ispa+out(2) 
!     write(6,'(2a,2i3,a,4i4)')'ncova=',ncova,isco,ispa,' nth:',nfrtheo,l_nfrtheo,istr
       
      if(nthar.gt.2) then 
       do i=3,nthar,2 
        jth=ktheoh(iset,0,i) 
        l_jth=ktheoh(iset,0,i+1) 
        call getnu_copa(jth,l_jth,ncova,info)
        cp132=ncova 
        call trlch(8,cp132,nn,out) 
        isco=isco+out(1); ispa=ispa+out(2)
        j=(1+i)/2 
        memtheo(iset,j,1)=out(1)+memtheo(iset,j-1,1) 
        memtheo(iset,j,2)=out(2)+memtheo(iset,j-1,2) 
!       write(6,'(i1,a,20i3)')j,'v a corread memtheo=',memtheo(iset,j,2)
       end do 
       out(1)=mkaddsth(iset)-memtheo(iset,j,1) 
       out(2)=mpaddsph(iset)-memtheo(iset,j,2) 
!       isco=isco+out(1); ispa=ispa+out(2)
       do i=1,nthar,2 
        j=(1+i)/2 
        memtheo(iset,j,1)=out(1)+memtheo(iset,j,1) 
        memtheo(iset,j,2)=out(2)+memtheo(iset,j,2) 
!       write(6,'(i1,a,20i3)')j,'v b corread memtheo=',memtheo(iset,j,2)
       end do 
      else 
       j=1 
       memtheo(iset,1,1)=mkaddsth(iset) 
       memtheo(iset,1,2)=mpaddsph(iset) 
      end if 
!     write(6,'(a,8i5)')' ###',ispa,mpaddsph(iset),isco,mkaddsth(iset)
       if(abs(ispa-mpaddsph(iset))+abs(isco-mkaddsth(iset)).gt.0)then
        if(ispa.ne.mpaddsph(iset)) &
         print'(2(a,i2),a)','**mismatch** variable array size:',ispa,  &
         ' from structure code,', mpaddsph(iset),' from .par file'
        if(isco.ne.mkaddsth(iset)) &
         print'(2(a,i2),a)','**mismatch** constant array size:',isco,  &
         ' from structure code,', mkaddsth(iset),' from .par file'
        if(enwr(15).eq.'mism')then
         print'(/,a)',' theory sequence called:' 
         do i=3,nthar,2 
          jth=ktheoh(iset,0,i)
          l_jth=ktheoh(iset,0,i+1)
          cmch='name'                                                 
          call getthstring(jth,l_jth,cmch,ch132)                      
          print'(a)',TRIM(ch132)                           
         end do
         info=1
         infotext(1)='effi/subject/mismatch' 
         infotext(2)=' ' 
        end if
       end if
!                 0 20  0 13                                            
!orread memtheo=  0 20 23  0 13 13                                      
                                                                        
!      0 12 15  0 23 23                                                 
!       write(6,'(a,20i3)')'c corread memtheo=',(memtheo(iset,i,1),i=0,j
!       write(6,'(a,20i3)')'v corread memtheo=',(memtheo(iset,i,2),i=0,j
!-----mem----------------------------------------------------           
        read (n1,'(a)',end=480) ch132 
        linenumber=linenumber+1 
      if(mplth.gt.0)                                                    &
     &      call vcread(memtheo,n1,iset,iss,iv,iva,ic,icon,0,1,mplth)           
                                                                        
        read (n1,'(a)',end=480) ch132 
        linenumber=linenumber+1 
        if(mcth.gt.0)                                                   &
     &         call vcread(memtheo,n1,iset,iss,iv,iva,ic,icon,1,1,mcth)         
!-----------------------------------------------------------------------
!       change for c,vdatah,i_c,vdata,b_c,vdatah                        
!        write(6,'(a,i2)') ' ------number of spectrum iset=',iset       
        read(n1,'(a80)') ch132 
        linenumber=linenumber+1 
        call trlch(ncc,ch132,iout,out)
!         write(6,'(i2,2a)')iout,' 277:', ch132(:npl) 
        if(iout.ne.2) then 
         info=linenumber 
         infotext(1)='effi/structure/corread/infocode3' 
         infotext(2)='**error** wrong structure of file .par' 
         infotext(3)='n=2 numbers expected on the line:' 
         infotext(4)=ch132 
         infotext(5)=' ' 
         goto 490 
        end if 
                                                                        
        m_cs=out(1) 
        m_vs=out(2) 
        ith0=ktheoh(iset,iss,0) 
        i_cdatah(iset,0)=m_cs 
                                                                        
        if(m_cs.gt.0) then 
         i_cs=0 
         do while(i_cs.lt.m_cs) 
          read (n1,'(a)',end=480) ch132 
          linenumber=linenumber+1 
!          write(8,'(2a)') '171:',ch132(:npl)                           
          ip=1 
          do while(ip.gt.0) 
           call nextchar(ch132,0,ipos,cp132,ip) 
           iq=index(cp132,'=')+1 
           ip=index(cp132(iq:),']') 
           ip=iq+ip-1 
!          write(6,'(a)') cp132           ! 30.05.07                    
!          read(5,'(a)')                                                
           ch132=cp132(ip+1:) 
                                                                        
           if(ip.gt.0) then 
            cq132=cp132(:ip) 
            iq=index(cq132,'=') 
            cq132(iq:iq+1)=' ' 
            cp132=cq132(iq-5:iq-1) 
            call trlch(5,cp132,nn,out) 
            i_cs=i_cs+1 
            icop=out(1) 
            i_cdatah(iset,i_cs)=icop 
            n_cdatah(iset,i_cs)=cq132(1:iq-6) 
            if(index(cq132,'nu_chan').gt.0) ip_chanh(iset)=i_cs 
                                                                        
            ico=icop 
            ith=0 
            do while(ico.gt.0.and.ith.le.maxthss) 
             ith=ith+1 
             ico=icop-memtheo(iset,ith,1) 
!             write(6,'(a,5i4)')'icop,ico,ith,memtheo(iset,ith,1)=', &   
!                               icop,ico,ith,memtheo(iset,ith,1)       
            end do 
            if(ith.eq.0)ith=1 
            ico=icop-memtheo(iset,ith-1,1) 
            ith=2*ith 
            i1= ktheoh(iset,iss,ith-1) 
            i2= ktheoh(iset,iss,ith) 
!            ch2='th'                                                   
!            if(ith.eq.2) ch2='co'              ! 31.03.05 : help       
            ch2='to' 
            if(ith.eq.2) ch2='fo'  ! 07.11.07
            call itoc8(ch8,i1) 
            if(i1.lt.10)then 
              chth=ch2//'0'//ch8(2:2) 
            else 
              chth=ch2//ch8(2:3) 
            end if 
            call itoc8(ch8,i2) 
            if(i2.lt.10)then 
              chth(5:6)='0'//ch8(2:2)                                                    !! 26.09.06             
            else                         
              chth(5:6)=ch8(2:3)                !! 26.09.06             
            end if                       
            call itoc8(ch8,icop)               ! ico-> icop 9.9.05      
            if(icop.lt.10)then           
              chth(7:8)='0'//ch8(2:2)           !! 26.09.06             
            else                         
              chth(7:8)=ch8(2:3)                !! 26.09.06             
            end if                       
!           write(chth,'(a2,3i2)')ch2,i1,i2,icop                        
                                                                        
            n_cdatah(iset,i_cs)(25:32)=chth 
!            write(6,'(2a)') 'n_cdatah(iset,i_cs)=',n_cdatah(iset,i_cs) 
!            write(6,'(a)') n_cdatah(iset,i_cs)                         
                                                                        
            cp132=cq132(iq+2:ip-1) 
            cq132=cp132 
            call fout_a(cq132,chf,jf) 
            ch6=chf(1)(1:3) 
            if(ch6(1:1).eq.'i') then 
             ch6(4:6)=')  ' 
            else 
             ch6(4:6)='.'//chf(1)(4:4)//')' 
            end if 
            n_cdatah(iset,i_cs)(33:38)=ch6 
            call trlch(ip-iq,cp132,nn,out) 
            cdatah(iset,i_cs)=out(1) 
           end if 
          end do 
         end do  ! k  
        end if  ! mcth >0  
                                                                        
        i_vdatah(iset,0)=m_vs 
        if(m_vs.gt.0) then 
         i_vs=0 
         do while(i_vs.lt.m_vs) 
          read (n1,'(a)',end=480) ch132 
          linenumber=linenumber+1 
          ip=1 
          do while(ip.gt.0) 
!          write(8,'(a,a)')'+++', ch132(:75)                            
           call nextchar(ch132,0,ipos,cp132,ip) 
!          write(6,'(a)') cp132           ! 30.05.07                    
!          read(5,'(a)')                                                
           iq=index(cp132,'=')+1 
           ip=index(cp132(iq:),']') 
           ip=iq+ip-1 
           ch132=cp132(ip+1:) 
                                                                        
           if(ip.gt.0) then 
            cq132=cp132(:ip) 
            iq=index(cq132,'=') 
            cq132(iq:iq+1)=' ' 
            cp132=cq132(iq-5:iq-1) 
            call trlch(5,cp132,nn,out) 
            i_vs=i_vs+1 
            ivap=out(1) 
!            write(6,'(a,3i4)')'CORREAD i_vs,iset,icop=',i_vs,iset,icop 
            i_vdatah(iset,i_vs)=ivap 
            n_vdatah(iset,i_vs)=cq132(1:iq-6) 
                                                                        
            ivaq=ivap 
            ith=0 
            do while(ivaq.gt.0.and.ith.le.maxthlv/2-1) 
             ith=ith+1 
             ivaq=ivap-memtheo(iset,ith,2) 
!             write(6,'(a,5i4)')'ivap,ivaq,ith,memtheo(iset,ith,2)=',&   
!                               ivap,ivaq,ith,memtheo(iset,ith,2)      
            end do 
            if(ith.eq.0)ith=1 
            ivaq =ivap-memtheo(iset,ith-1,2) 
            ith=2*ith 
            ii=ktheoh(iset,iss,ith-1) 
            call itoc8(ch8,ii) 
            if(ii.lt.10)then 
             ch6='0'//ch8(2:2)                 ! 5.9.05  
            else 
             ch6=ch8(2:3) 
            end if 
            ii=ktheoh(iset,iss,ith) 
            call itoc8(ch8,ii) 
            if(ii.lt.10)then 
             ch6(3:4)='0'//ch8(2:2)            ! 5.9.05
            else 
             ch6(3:4)=ch8(2:3) 
            end if 
            call itoc8(ch8,ivap)               ! ivaq->ivap 9.9.05 
            if(ivap.lt.10)then 
             ch6(5:6)='0'//ch8(2:2)            ! 5.9.05    
            else 
             ch6(5:6)=ch8(2:3) 
            end if 
            if(ith.eq.2) then 
             chth='va'//ch6                  ! 31.03.05 :help  
            else 
             chth='th'//ch6 
            end if 
            n_vdatah(iset,i_vs)(25:32)=chth 
!           write(8,'(2a)') 'n_vdatah(iset,i_cs)=',n_vdatah(iset,i_vs)  
                                                                        
            cp132=cq132(iq+2:ip-1) 
            cq132=cp132 
            call fout_c(cq132,chcom,jf) 
            n_vdatah(iset,i_vs)(33:40)=chcom(5:jf) 
            call trlch(ip-iq,cp132,nn,out) 
!           write(8,'(4i6)') (int(out(ji)),ji=1,nn)                     
            vdatah(iset,i_vs)=out(1) 
           end if 
          end do 
         end do   ! k   
        end if    ! mplth >0      
!-----------------------------------------------------------------------
  110    continue 
!         write(6,'(a)') ' label 110'                                   
         do kk=1,4 
          read (n1,'(a)',end=480) ch132 
!         write(6,'(2a)') ' 471:',ch132(:75)                            
                                                                        
          k=index(ch132,'device(') 
          if(k.gt.0)then 
           call trlch(k+12,ch132,nn,out) 
           lstr1=out(1) 
           k=out(2) 
!          write(6,'(i3,a,2i4)')iset,'=iset device   lstr1,k=',lstr1,k        
           nu_deviceh(lstr1)=k ; kdevice=k
           istr=-10*lstr1 

          end if 
          k=index(ch132,'module=') 
          if(k.gt.0)then 
           ch2=ch132(k+7:) 
           k=ic2(ch2) 
           if(k.gt.9)then 
            istr=-(100*lstr1+k) 
!            write(6,'(a,a2,2x,i3)') 'module:',ch2,istr                 
           else 
            istr=-(10*lstr1+k) 
!            write(6,'(a,a2,2x,i3)') 'module:',ch2,istr                 
           end if 
          end if 
          k=index(ch132,'component=') 
          if(k.gt.0)then 
           call trlch(k+12,ch132,iout,out) 
           istr=out(1) 
!           write(6,'(a,a2,2x,i2)') 'component:',ch2,istr               
          end if 
          linenumber=linenumber+1 
!          write(6,'(2a)') '230:',ch132(:75)                            
          if(index(ch132,'level').gt.0) goto 115 
          if(index(ch132,'global').gt.0) goto 112 
          if(index(ch132,'##').gt.0) goto 112 
         end do 
  112    continue 
      do jsp=1,maxs 
       mplthsh(jsp,1)=mplthsh(jsp,0)+mplthsph(jsp) 
       mcthsh(jsp,1)=mcthsh(jsp,0)+mcthsph(jsp) 
       mpaddsh(jsp,1)=mpaddsh(jsp,0)+mpaddsph(jsp) 
       mkaddsh(jsp,1)=mkaddsh(jsp,0)+mkaddsth(jsp) 
        do jss=2,maxthss 
         mplthsh(jsp,jss)=mplthsh(jsp,jss-1)+mplthssh(jsp,jss-1) 
         mcthsh(jsp,jss)=mcthsh(jsp,jss-1)+mcthssh(jsp,jss-1) 
         mkaddsh(jsp,jss)=mkaddsh(jsp,jss-1)+mkaddssh(jsp,jss-1) 
         mpaddsh(jsp,jss)=mpaddsh(jsp,jss-1)+mpaddssh(jsp,jss-1) 
!         write(6,'(a,3i4)') 'jss=',jss                                 
        end do 
         if(jsp.lt.maxs) then 
         mplthsh(jsp+1,0)=mplthsh(jsp,maxthss)+mplthssh(jsp,maxthss) 
         mcthsh(jsp+1,0)=mcthsh(jsp,maxthss)+mcthssh(jsp,maxthss) 
         mpaddsh(jsp+1,0)=mpaddsh(jsp,maxthss)+mpaddssh(jsp,maxthss) 
         mkaddsh(jsp+1,0)=mkaddsh(jsp,maxthss)+mkaddssh(jsp,maxthss) 
         end if 
!         write(6,'(a,3i4)') 'jsp=',jsp                                 
      end do 
      mplh=mplthsh(maxs,maxthss) 
      mclh=mcthsh(maxs,maxthss) 
!       write(6,'(a,i2,a)') 'corread mpaddsh(1:)='                      
         nn1=2 
         nn2=0 
         call istvaddh(nn1,iset,nn2) 
                                                                        
!          3.4.07 verhindert icladd und ipladd Aufsummation ???         
          if(nospectrum.eq.0.or.b_unify) then 
           ic=0 
           iv=0 
          end if 
!        read(nrd,'(a)')                                                
         if(index(ch132,'global').gt.0) goto 100 
         if(index(ch132,'##').gt.0) goto 120 
  115    cp132=ch132 
         call trlch(ncc,ch132,iout,out) 
!         write(6,'(4e15.3)') (out(ji),ji=1,iout)                       
         if(iout.ne.1) then 
          info=linenumber 
          infotext(1)='effi/structure/corread/infocode4' 
          infotext(2)='**error** wrong structure of file .par' 
          infotext(3)='only number of theories expected on the line:' 
          infotext(4)=ch132 
          infotext(5)=ch132 
          infotext(6)=' ' 
          goto 490 
         end if 
!        ---------------- level ---------------------------
         if(index(cp132,'device level').gt.0.or.                        &
                                 index(cp132,'module level').gt.0) then
          if(index(cp132,'device level').eq.0)kdevice=0

          iss=iss+1 
          if(iss.gt.maxthss) then 
           info=maxthss 
           infotext(1)='effi/structure/corread/maxthsp' 
           infotext(2)=                                                 &
     &     '**error** number of structural units exceeds maxthsp'       
           infotext(3)=' ' 
           goto 490 
          end if 
          nthar=out(1) 
          ktheoh(iset,iss,0)=nthar 
          read(n1,'(a)') property 
          read(n1,'(a)') name_theo 
          property=ADJUSTL(property)
          name_theo=ADJUSTL(name_theo)
          linenumber=linenumber+2 
                                                                        
          i=index(name_theo,'v=') 
          if(i.gt.0) then 
           thversion=name_theo(i:) 
           name_theo(i:)=' ' 
          else 
           thversion=' ' 
          end if 
          l=LEN_TRIM(name_theo)
          call  getthnumber(0,nth,lth,property,name_theo,info) 
!         write(6,'(a,4i4)') 'corread sublevel nthar,nth,lth=',nthar,nth,lth           
          ktheoh(iset,iss,1)=nth 
          ktheoh(iset,iss,2)=lth 
          nfrtheo=ktheoh(iset,0,1)
          l_nfrtheo=ktheoh(iset,0,2)
                                                                        
          call distribthfr(nfrtheo,'thna',n1,info) 
!         write(6,'(a,/,a)')theoryname,thfrcase(l_nfrtheo)              
          call versioncomp(l,name_theo,theoryname,thversion,property,b_vers) 

          isco=0; ispa=0
          call getfrnu_copa(nth,lth,ncova,istr,info)
          cp132=ncova
          call trlch(8,cp132,nn,out) 
          isco=isco+out(1); ispa=ispa+out(2)        
          if(info.gt.0)goto 1000 
          if(nthar.gt.2) then 
           do k=3,nthar,2 
            read(n1,'(a)') property 
            linenumber=linenumber+1 
            read(n1,'(a)') name_theo 
            property=ADJUSTL(property)
            name_theo=ADJUSTL(name_theo)
!           write(6,'(i2,3a)')iss,' 581:', property(:40),name_theo(:40) 
                                                                        
            linenumber=linenumber+1 
            i=index(name_theo,'v=') 
            if(i.gt.0) then 
             thversion=name_theo(i:) 
             name_theo(i:)=' ' 
            else 
             thversion=' ' 
            end if 
            l=LEN_TRIM(name_theo) 
!            write(6,'(a)') name_theo(:npl)                             
            call  getthnumber(1,nth,lth,property,name_theo,info) 
!            write(6,'(a,4i4,/)')'corread sublevel nth,lth=',nth,lth    
            ktheoh(iset,iss,k)=nth 
            ktheoh(iset,iss,k+1)=lth 
            j=1 
            do while(j.le.maxthfrcase)           ! gfortran (11.1.06
             i=index(thfrcase(j),'(')-1 
             if(i.gt.1)then 
!              write(6,'(2i3,a,/,a)')i,l,thfrcase(j)(:72),name_theo(:l) 
              if(thfrcase(j)(:i).eq.name_theo(:l)) then 
!               write(6,'(i2,2x,a,/,a)')i,name_theo(:72),thfrcase(j)(:72
               call versioncomp(l,name_theo,thfrcase(j),thversion,property,b_vers) 
               j=maxthfrcase+1 
              end if 
             end if 
             j=j+1 
            end do 
            if(j.eq.maxthfrcase+1) then 
             namtheo=name_theo 
             call getnamev(1,nth,lth,property,name_theo) 
             theoryname=name_theo 
             call versioncomp(l,namtheo,theoryname,thversion,property,b_vers) 
            end if 
           end do 
          end if 
          if(info.gt.0)goto 1000 
                                                                        
          read (n1,'(a)',end=480) ch132 
          linenumber=linenumber+1 
!          write(6,'(2a)') '457:',ch132(:75)                            
          call trlch(ncc,ch132,iout,out) 
!          write(6,'(6f15.3)') (out(i),i=1,iout)                        
          if(iout.lt.4) then 
           info=5 
           infotext(1)='effi/structure/corread/infocode5' 
           infotext(2)='**error** wrong structure of file .par' 
           infotext(3)='n=4 numbers expected on the line:' 
           infotext(4)=ch132 
           infotext(5)=' ' 
           goto 490 
          end if 
!          write(6,'(a,2i4)') 'istr out1:',istr,-int(out(1))            
!          istr=-out(1)                                                 
!          if(abs(istr).gt.100) then                                    
!            lstruct1=-istr/100                                         
!            lstruct2=-istr-100*lstruct1                                
!           else                                                        
!            lstruct1=-istr/10                                          
!            lstruct2=-istr-10*lstruct1                                 
!          end if 
          istrssh(iset,iss)=istr 
          mplth=out(1) 
          mplthssh(iset,iss)=mplth 
          mpaddssh(iset,iss)=out(2) 
          mcth=out(3) 
          mcthssh(iset,iss)=mcth 
          mkaddssh(iset,iss)=out(4) 
                                                                        
!          write(6,'(a,i1,a1,i1,a2,2i4)')'corread mkaddssh,mpaddssh(',  
!     &       iset,',',iss,')=',mkaddssh(iset,iss),mpaddssh(iset,iss)   
!---------mem--------------------------------------------------         
!         write(6,'(a,2i4,a)') 'corread lstruct1,lstruct2=',            
!         & lstruct1,lstruct2                                           
          ith0=ktheoh(iset,iss,0) 
          nfrtheo=ktheoh(iset,0,1) 
          l_nfrtheo=ktheoh(iset,0,4) 
                                                                        
          memtheo(iset,1,1)=0 
          memtheo(iset,1,2)=0 
          isco=0; ispa=0
          if(kdevice.gt.0)then
           call getfrnu_copa(nfrtheo,l_nfrtheo,ncova,-10*kdevice,info)
          else
           call getfrnu_copa(nfrtheo,l_nfrtheo,ncova,istr,info)
          end if
          cp132=ncova
          call trlch(8,cp132,nn,out) 
          isco=isco+out(1); ispa=ispa+out(2)        

!          write(6,'(a,8i5)')'# ##',ispa,isco,istr,kdevice,nfrtheo,l_nfrtheo,iss

          if(ith0.gt.2) then 
           do i=3,ith0,2 
            jth=ktheoh(iset,iss,i) 
            l_jth=ktheoh(iset,iss,i+1) 
            call getnu_copa(jth,l_jth,ncova,info)
            cp132=ncova
             call trlch(8,cp132,nn,out) 
            isco=isco+out(1); ispa=ispa+out(2)
            j=(1+i)/2 
            memtheo(iset,j,1)=out(1)+memtheo(iset,j-1,1) 
            memtheo(iset,j,2)=out(2)+memtheo(iset,j-1,2) 
           end do 
           out(1)=mkaddssh(iset,iss)-memtheo(iset,j,1) 
           out(2)=mpaddssh(iset,iss)-memtheo(iset,j,2) 
           do i=1,ith0,2 
            j=(1+i)/2 
            memtheo(iset,j,1)=out(1)+memtheo(iset,j,1) 
            memtheo(iset,j,2)=out(2)+memtheo(iset,j,2) 
           end do 
          else 
           memtheo(iset,1,1)=mkaddssh(iset,iss) 
           memtheo(iset,1,2)=mpaddssh(iset,iss) 
           j=1 
          end if 
!          write(6,'(a,8i5)')'# ##',ispa,mpaddssh(iset,iss),isco,mkaddssh(iset,iss)
           if(abs(ispa-mpaddssh(iset,iss))+abs(isco-mkaddssh(iset,iss)).gt.0)then
            if(ispa.ne.mpaddssh(iset,iss)) &
            print'(2(a,i2),a)','**mismatch** variable array size:',ispa,  &
            ' from structure code,', mpaddssh(iset,iss),' from .par file'
            if(isco.ne.mkaddssh(iset,iss)) &
            print'(2(a,i2),a)','**mismatch** constant array size:',isco,  &
            ' from structure code,', mkaddssh(iset,iss),' from .par file'
            if(enwr(15).eq.'mism')then
             print'(/,a)',' theory sequence called:' 
             do i=3,ith0,2 
              jth=ktheoh(iset,iss,i)
              l_jth=ktheoh(iset,iss,i+1)
              cmch='name'                                                 
              call getthstring(jth,l_jth,cmch,ch132)                      
              print'(a)',TRIM(ch132)                           
             end do
             info=1
             infotext(1)='effi/structure/corread/mismatch' 
             infotext(2)=' ' 
            end if
           end if
                                                                        
!---------mem---------------------------------------------------        
           if(mplth.gt.0)                                               &
     &     call vcread(memtheo,n1,iset,iss,iv,iva,ic,icon,0,1,mplth)            
          if(mcth.gt.0)                                                 &
     &     call vcread(memtheo,n1,iset,iss,iv,iva,ic,icon,1,1,mcth)             
                  ! sublevel                                            
         end if 
                                                                        
         if(index(cp132,'component level').gt.0) then 
          iss=iss+1 
          if(iss.gt.maxthss) then 
           info=maxthss 
           infotext(1)='effi/structure/corread/maxthsp' 
           infotext(2)=                                                 &
     &     '**error** number of structural units larger than info'      
           infotext(3)=' ' 
           goto 490 
          end if 
          nthar=out(1) 
          ktheoh(iset,iss,0)=nthar 
          do k=1,nthar,2 
           read(n1,'(a)') property 
           read(n1,'(a)') name_theo 
           property=ADJUSTL(property)
           name_theo=ADJUSTL(name_theo)
           linenumber=linenumber+2 
!           write(6,'(a,2a)') '845 corread ',Trim(property),TRIM(name_theo)
                                                                             
           i=index(name_theo,'v=') 
           if(i.gt.0) then 
            thversion=name_theo(i:) 
            name_theo(i:)=' ' 
           else 
            thversion=' ' 
           end if 
           l=LEN_TRIM(name_theo) 
           call  getthnumber(1,nth,lth,property,name_theo,info) 
!          write(6,'(a,2i4)') 'corread subset nth,lth=',nth,lth         
           ktheoh(iset,iss,k)=nth 
           ktheoh(iset,iss,k+1)=lth 
           namtheo=name_theo 
           call getnamev(1,nth,lth,property,name_theo) 
           theoryname=name_theo 
           call versioncomp(l,namtheo,theoryname,thversion,property,b_vers) 
          end do 
          if(info.gt.0)goto 1000 
          read (n1,'(a)',end=480) ch132 
          linenumber=linenumber+1 
!          write(6,'(2a)') '744:',ch132(:75)                            
          call trlch(ncc,ch132,iout,out) 
!         write(6,'(5f15.3)') (out(ji),ji=1,iout)                       
          if(iout.lt.4) then 
           info=linenumber 
           infotext(1)='effi/structure/corread/infocode6' 
           infotext(2)='**error** wrong structure of file .par' 
           infotext(3)='n=4 numbers expected on the line:' 
           infotext(4)=ch132 
           infotext(5)=' ' 
           goto 490 
          end if 
!          write(6,'(a,2i4)') 'istr out1:',istr,int(out(1))             
          istrssh(iset,iss)=istr 
          mplth=out(1) 
          mplthssh(iset,iss)=mplth 
          mpaddssh(iset,iss)=out(2) 
          mcth=out(3) 
          mcthssh(iset,iss)=mcth 
          mkaddssh(iset,iss)=out(4) 

!---------mem-------------------------------------------------- 
          isco=0; ispa=0        
          ith0=ktheoh(iset,iss,0) 
          do i=1,ith0,2 
           jth=ktheoh(iset,iss,i)
           l_jth=ktheoh(iset,iss,i+1)
           call getnu_copa(jth,l_jth,ncova,info) 
           cp132=ncova
           call trlch(8,cp132,nn,out) 
           isco=isco+out(1); ispa=ispa+out(2)
           if(i.eq.1) then 
            memtheo(iset,1,1)=out(1) 
            memtheo(iset,1,2)=out(2) 
           else 
            j=(1+i)/2 
            memtheo(iset,j,1)=out(1)+memtheo(iset,j-1,1) 
            memtheo(iset,j,2)=out(2)+memtheo(iset,j-1,2) 
           end if 
          end do
!         write(6,'(a,8i5)')'## #',ispa,mpaddssh(iset,iss),isco,mkaddssh(iset,iss)
          if(abs(ispa-mpaddssh(iset,iss))+abs(isco-mkaddssh(iset,iss)).gt.0)then
           if(ispa.ne.mpaddssh(iset,iss)) &
           print'(2(a,i2),a)','**mismatch** variable array size:',ispa,  &
           ' from structure code,', mpaddssh(iset,iss),' from .par file'
           if(isco.ne.mkaddssh(iset,iss)) &
            print'(2(a,i2),a)','**mismatch** constant array size:',isco,  &
           ' from structure code,', mkaddssh(iset,iss),' from .par file'
           if(enwr(15).eq.'mism')then
            print'(/,a)',' theory sequence called:' 
            do i=1,ith0,2 
             jth=ktheoh(iset,iss,i)
             l_jth=ktheoh(iset,iss,i+1)
             cmch='name'                                                 
             call getthstring(jth,l_jth,cmch,ch132)                      
            end do
            info=1
            infotext(1)='effi/structure/corread/mismatch' 
            infotext(2)=' ' 
           end if
          end if
!---------mem---------------------------------------------------        
         if(mplth.gt.0)                                                 &
     &     call vcread(memtheo,n1,iset,iss,iv,iva,ic,icon,0,0,mplth)            
           call vaext(iva) 
          if(mcth.gt.0)                                                 &
     &     call vcread(memtheo,n1,iset,iss,iv,iva,ic,icon,1,0,mcth)             
                  ! subset                                              
         end if 
         do k=1,maxfr1 
          nu_sdevice(iset,k)=nu_deviceh(k) 
          nu_sdeviceh(iset,k)=nu_deviceh(k) 
         end do 
!       write(6,'(i3,a,16i4)')iset,'=iset nu_dev=',(nu_deviceh(k),k=1,4)
                                                                        
       goto 110 
  120 continue 
                                                                        
      read(n1,'(a)') ch1 
      linenumber=linenumber+1 
                                                                        
                                                                        
       write(nwr,'(a)') ' transformation matrices' 
   80 continue 
       read (n1,'(a)') cp132 
       linenumber=linenumber+1 
       write(nwr,'(a)') cp132(1:npl) 
       ip=0 
       k=0 
   70  k=k+1 
          call nextchar(cp132,ip,ipos,ch132,ih) 
          call trlch(ih,ch132,nn,out) 
!          write(6,'(a,4e15.3)')                                        
!     &       'corread mcoh=',(out(i),i=1,nn)                           
                                                                        
          io=out(1) 
          if(io.eq.0) then 
           if(k.gt.1) goto 80 
           goto 10 
          else 
           mcoh=io 
          end if 
          call nextchar(ch132,ih,ipos,cp132,ip) 
!          write(6,'(i3,2x,a)')ip,cp132(:70)                            
          ncorh(mcoh)=cp132(1:ip) 
          call nextchar(cp132,ip,ipos,ch132,ih) 
!          write(6,'(a)')ch132(:80)                                     
          call trlch(ncc,ch132,nn,out) 
           nout1=out(1) 
           nout2=out(2) 
           mrh(mcoh)=out(1) 
           mch(mcoh)=out(2) 
!          write(6,'(a,3i4)')'corread mcoh,mrh,mch=',     &              
!                               mcoh,mrh(mcoh),mch(mcoh)               
           ip=index(cp132(16:),')')+16 
        goto 70 
   10 continue 
         mcsh(1)=0 
         mrsh(1)=0 
         mrcesh(1)=0 
         do j=1,maxco 
          mrceh(j)=mrh(j)*mch(j) 
         end do 
         do j=2,maxco 
          mrsh(j)=mrsh(j-1)+mrh(j-1) 
          mcsh(j)=mcsh(j-1)+mch(j-1) 
          mrcesh(j)=mrcesh(j-1)+mrceh(j-1) 
         end do 
         mplh=mrsh(maxco)+mrh(maxco) 
         mrceth=mrcesh(maxco)+mrceh(maxco) 
!     read kcp,nthpl,cp                                                 
                                                                        
!      write(6,'(a,12i4)') 'corread mrh=',(mrh(i),i=1,mcoh)             
!      write(6,'(a,12i4)') 'corread mch=',(mch(i),i=1,mcoh+1)           
!      write(6,'(a,12i4)') 'corread mcsh=',(mcsh(i),i=1,mcoh+1)         
!      write(6,'(a,i4)') ' corread mcoh=',mcoh                          
      ii=1 
      icl=132 
      do kk=1,mcoh 
       if(mch(kk).gt.0) then 
        read (n1,'(a)',end=480) ch132 
        linenumber=linenumber+1 
                                                                        
!        write(6,'(i3,2a)')kk,'  603:',ch132(:75)                       
        call trlch(icl,ch132,nn,out) 
!        write(6,'(15i4)') (int(out(ji)),ji=1,nn)                       
        do i=1,nn 
         ik=ii-1+i 
         kcph(ik)=out(i) 
        end do 
        ii=ii+nn 
!        write(6,'(a,i2,a2,2i4)')' mrh,mch(',kk,')=',mrh(kk),mch(kk)    
!        read(5,'(a)')                                                  
        do j=1,mrh(kk) 
         read (n1,'(a)',end=480) cp132 
         linenumber=linenumber+1 
!         write(6,'(a,i4,2a)') '824 j=',j,' cp132=',cp132(1:60)         
         call nextchar(cp132,0,ipos,ch132,ih) 
!        write(6,'(a)') Trim(ch132)                                           
         call trlch(ih,ch132,nn,out) 
!        write(6,'(10f6.1)') (out(i),i=1,nn)                            
         jkk=out(1) 
!         write(6,'(a,3i5)') ' nn,jkk=',nn,jkk                          
         kplh(mrsh(kk)+j)=jkk 
!        write(6,'(2(a,i3))') ' **kplh(',mrsh(kk)+j,')=',jkk            
         call nextchar(ch132,ih,ipos,cp132,ip) 
!        write(6,'(a)') Trim(cp132)                                           
                                                ! 6.4.98                
         nthplh(jkk)=cp132(1:ip) 
!         ip=24                                                         
         call nextchar(cp132,ip,ipos,ch132,ih) 
!         write(6,'(a)') ch132                                          
         cp132=ch132 
         call fout_a(cp132,chf,lf) 
         call trlch(icl,ch132,nn,out) 
!         if(lf.ne.nn) write(6,'(i4,16a5)') nn,(chf(ji),ji=1,lf)        
         mkk=mrcesh(kk)+(j-1)*mch(kk) 
         do ic=1,nn 
          cpstorh(mkk+ic)=out(ic) 
          fpstorh(mkk+ic)=chf(ic) 
         end do 
!         write(nf,'(10f8.2)') (cpstorh(i),i=1,100)                     
                 ! mrh(kk)                                              
        end do 
        ic=nn 
        do while(ic.lt.mch(kk)) 
          read(n1,'(a)') ch1 
          read (n1,'(a)',end=480) ch132 
          linenumber=linenumber+2 
!          write(6,'(a,/,a)') '642:',ch132(:npl)                        
          call trlch(icl,ch132,nn,out) 
!         write(6,'(4e15.3)') (out(ji),ji=1,nn)                         
          do i=1,nn 
           ik=ii-1+i 
           kcph(ik)=out(i) 
          end do 
          ii=ii+nn 
          do j=1,mrh(kk) 
           read (n1,'(a)',end=480) ch132 
           linenumber=linenumber+1 
!          write(6,'(a)') ch132                                         
           cp132=ch132 
           call fout_a(cp132,chf,lf) 
           call trlch(icl,ch132,nn,out) 
!          write(6,'(4e15.3)') (out(ji),ji=1,nn)                        
           mkk=mrcesh(kk)+(j-1)*mch(kk) 
           do i=1,nn 
            ij=mkk+ic+i 
            cpstorh(ij)=out(i) 
            fpstorh(ij)=chf(i) 
           end do 
                  ! mrh(kk)                                             
          end do 
          ic=ic+nn 
        end do 
        read(n1,'(a)') ch2 
        linenumber=linenumber+1 
       end if   ! mch(kk).gt.0  
      end do     ! kk=1,mcoh 
                                                                        
      call vaext(iva) 
                                                                        
!     write(6,'(a,12i4)') '*mrh=',(mrh(i),i=1,mcoh)                     
!     write(6,'(a,12i4)') '*mch=',(mch(i),i=1,mcoh)                     
                                                                        
      read(n1,'(a)') ch2 
      linenumber=linenumber+1 
                                                                        
!     parameter                                                         
      icl=80 
      read (n1,'(a)',end=480) ch132 
      linenumber=linenumber+1 
      call trlch(icl,ch132,nn,out) 
!     write(6,'(4e15.3)') (out(ji),ji=1,nn)                             
      mph=out(1) 
      do k=1,mph 
       read (n1,'(a)',end=480) ch132 
       linenumber=linenumber+1 
!       write(6,'(2a)') '656:',ch132(:75)                               
       infotext(4)=ch132 
!      write(6,'(a)') ch132(1:npl)                                      
       call nextchar(ch132,0,ipos,cp132,ip) 
       call nextchar(cp132,ip,ipos,ch132,ih) 
       call trlch(ih,ch132,nn,out) 
!      write(6,'(6e12.3)') (out(jj),jj=1,nn)                            
       kph(k)=out(1) 
       call nextchar(ch132,ih,ipos,cp132,ip) 
       nph(k)=cp132(1:ip) 
!       ip=24                                  ! 6.4.98                 
                                                                        
       call nextchar(cp132,ip,ipos,ch132,ih) 
       cp132=ch132 
       call trlch(ncc,ch132,nn,out) 
       ih=0 
       if(nn.ne.4) then 
        cp132=TRIM(ch132)//'  0.0 0.0 0.0' 
        ih=index(nph(k),'*') 
        kph(k)=3 
        if(ih.gt.0) kph(k)=2 
       end if 
       call fout_c(cp132,cq132,jf) 
       nph(k)(25:60)=cq132(2:jf) 
!       write(6,'(i4,a)')k, nph(k)                                           
!      write(6,'(4e15.3)') (out(ij),ij=1,nn)                            
       if(nn.gt.4.or.nn.lt.1.) then 
        info=linenumber 
        infotext(1)='effi/structure/corread/infocode7' 
        infotext(2)='**error** wrong structure of file .par' 
        infotext(3)='n=3,4 numbers expected on the line:' 
        infotext(5)=' ' 
        goto 490 
       end if 
       infotext(4)=' ' 
       ph(k)=out(1) 
        uph(k)=0.0 
        oph(k)=0.0 
       if(ih.eq.0) then 
        uph(k)=out(2) 
        oph(k)=out(3) 
       end if 
       ddph(k)=0.0 
       if(nn.eq.4) ddph(k)=out(4) 
      end do   ! k=1,mph   
                                                                        
      do ks=1,maxs 
       if(ktheoh(ks,0,0).gt.0) then 
        call istvaddh(1,ks,0) 
       else 
        mcaddsph(ks)=0 
        do kss=0,maxthss 
          mcaddssh(ks,kss)=0 
        end do 
        mvaddsph(ks)=0 
        do kss=0,maxthss 
          mvaddssh(ks,kss)=0 
        end do 
       end if 
      end do 
      write(nwr,'(a,i5)')' number of parameters =',mph, &
                         '            variables =',mplh, &
                         '            constants =',mclh
                                                                        
      numc(1)=mvaddsh(1,maxthss) 
      do ks=2,maxs 
       numc(ks)=mvaddsh(ks,maxthss)-mvaddsh(ks-1,maxthss) 
      end do 
      do i=1,mplh 
       ivaddh(i)=0 
      end do 
      j=0 
      jj=0 
!      write(6,'(a)') 'line 606  corread kplh='                         
!       write(8,'(20i4)') (kplh(i),i=1,mplh)                            
      do ks=1,maxs 
!       write(8,'(a,2i4)') ' ks,numc(ks)=', ks,numc(ks)                 
!       write(8,'(20i4)') (ivaddsph(ks,i),i=1,numc(ks))                 
       if(ktheoh(ks,0,0).gt.0) then 
        if(ks.gt.1) jj=mvaddsh(ks-1,maxthss) 
        do i=1,numc(ks) 
         ii=ivaddsph(ks,i) 
         if(ii.gt.0) then 
          j=j+1 
          ivaddh(j)=ii+jj 
         end if 
        end do 
       end if 
      end do 
                                                                        
      numc(1)=mcaddsh(1,maxthss) 
      do ks=2,maxs 
        numc(ks)=mcaddsh(ks,maxthss)-mcaddsh(ks-1,maxthss) 
       end do 
!       write(6,'(20i4)') (numc(i),i=1,10)                              
       do i=1,mclh 
        icaddh(i)=0 
       end do 
       j=0 
      jj=0 
      do ks=1,maxs 
       if(ktheoh(ks,0,0).gt.0) then 
        if(ks.gt.1) jj=mcaddsh(ks-1,maxthss) 
!       write(6,'(20i4)') (icaddsph(ks,i),i=1,mclh)                     
        do i=1,numc(ks) 
         ii=icaddsph(ks,i) 
         if(ii.gt.0) then 
          j=j+1 
          icaddh(j)=ii+jj 
         end if 
        end do 
       end if 
      end do 
!      close(unit=8)                                                    
                                                                        
!---------------------------------------------------------------------- 
      if(b_unify) then 
                                                                        
       if(mcoh+mco.gt.maxco)then 
        write(nwr,'(a,i2,a3,i2,a1)')                                    &
     &   ' number of transformation matrices becomes too large (',      &
     &      mcoh+mco,' > ',maxco,')'                                    
        goto 1000 
       end if 
                                                                        
       if(mplh+mpl.gt.maxpl)then 
        write(nwr,'(a,i2,a3,i2,a1)')                                    &
     &   ' number of variables becomes too large (',                    &
     &      mplh+mph,' > ',maxpl,')'                                    
        goto 1000 
       end if 
                                                                        
       if(mclh+mcl.gt.maxc)then 
        write(nwr,'(a,i2,a3,i2,a1)')                                    &
     &   ' number of constants becomes too large (',                    &
     &      mclh+mcl,' > ',maxc,')'                                     
        goto 1000 
       end if 
                                                                        
       if(mph+mp.gt.maxp)then 
        write(nwr,'(a,i2,a3,i2,a1)')                                    &
     &   ' number of parameters becomes too large (',                   &
     &      mph+mp,' > ',maxp,')'                                       
        goto 1000 
       end if 
                                                                        
       iset=maxs 
       do while(ktheo(iset,0,0).eq.0) 
        iset=iset-1 
       end do 
                                                                        
       do i=1,mplh 
        jz=0 
        aa=nthplh(i) 
        bb=nthplh(i)(2:2) 
        j=ichar(aa)-i0 
        jb=0 
        if(j.gt.0.and.j.le.9) then 
          k=ichar(bb)-i0 
          jz=j+iset 
          jb=1 
          if(k.gt.0.and.k.le.9) then 
           jb=2 
           jz=10*j+k+iset 
          end if 
         j=jz/10 
         k=jz-10*j+i0 
         if(j.gt.0) then 
          if(jb.eq.1) then 
           chr=nthplh(i)(2:) 
           nthplh(i)(1:2)=char(j+i0)//char(k) 
           nthplh(i)(3:23)=chr 
          else 
           nthplh(i)(1:2)=char(j+i0)//char(k) 
          end if 
         else 
          nthplh(i)(1:1)=char(k) 
         end if 
        end if 
       end do 
                                                                        
       do i=1,mclh 
        k=index(nconh(i),'vm_SC')
        jz=0 
        aa=nconh(i) 
        bb=nconh(i)(2:2) 
        k=ichar(bb)-i0                                                                         
        j=ichar(aa)-i0 
 
        jb=0 
        if(j.gt.0.and.j.lt.maxs) then 
         jz=j+iset 
         if(j.le.9)then
          jb=1
          if(k.gt.0.and.k.le.9) then 
           jb=2 
           jz=10*j+k+iset 
          end if
         else
          jb=2
         end if
         j=jz/10 
         k=jz-10*j+i0 
         if(j.gt.0) then 
          if(jb.eq.1) then 
           chr=nconh(i)(2:) 
           nconh(i)(1:2)=char(j+i0)//char(k) 
           nconh(i)(3:23)=chr 
          else 
           nconh(i)(1:2)=char(j+i0)//char(k) 
          end if 
         else 
          nconh(i)(1:1)=char(k) 
         end if 
        end if 
       end do 
                                                                        
       k_theo1=0 
       do ks=1,maxs 
        if(ktheoh(ks,0,0).gt.0) then 
         k_theo1=k_theo1+1 
         do k=1,maxfr1 
          nu_sdeviceh(iset+k_theo1,k)=nu_sdeviceh(ks,k) 
         end do 
                                                                        
         icd=i_cdatah(ks,0) 
         ivd=i_vdatah(ks,0) 
         do i=1,ivd 
          jz=0 
          aa=n_vdatah(ks,i) 
          bb=n_vdatah(ks,i)(2:2) 
          j=ichar(aa)-i0 
          jb=0 
          if(j.gt.0.and.j.le.9) then 
           k=ichar(bb)-i0 
           jz=j+iset 
           jb=1 
           if(k.gt.0.and.k.le.9) then 
            jb=2 
            jz=10*j+k+iset 
           end if 
           j=jz/10 
           k=jz-10*j+i0 
           if(j.gt.0) then 
            if(jb.eq.1) then 
             chr=n_vdatah(ks,i)(2:) 
             n_vdatah(ks,i)(1:2)=char(j+i0)//char(k) 
             n_vdatah(ks,i)(3:23)=chr 
            else 
             n_vdatah(ks,i)(1:2)=char(j+i0)//char(k) 
            end if 
           else 
            n_vdatah(ks,i)(1:1)=char(k) 
           end if 
          end if 
         end do 
                                                                        
         if(k_theo1+iset.gt.maxs)then 
          write(nwr,'(a,i2,a3,i2,a1)')                                  &
     &   ' number of sets becomes too large (',                         &
     &      k_theo1+iset,' > ',maxs,')'                                 
          goto 1000 
         end if 
                                                                        
         do i=1,icd 
          jz=0 
          aa=n_cdatah(ks,i) 
          bb=n_cdatah(ks,i)(2:2) 
          j=ichar(aa)-i0 
          jb=0 
          if(j.gt.0.and.j.le.9) then 
           k=ichar(bb)-i0 
           jz=j+iset 
           jb=1 
           if(k.gt.0.and.k.le.9) then 
            jb=2 
            jz=10*j+k+iset 
           end if 
           j=jz/10 
           k=jz-10*j+i0 
           if(j.gt.0) then 
            if(jb.eq.1) then 
             chr=n_cdatah(ks,i)(2:) 
             n_cdatah(ks,i)(1:2)=char(j+i0)//char(k) 
             n_cdatah(ks,i)(3:23)=chr 
            else 
             n_cdatah(ks,i)(1:2)=char(j+i0)//char(k) 
            end if 
           else 
            n_cdatah(ks,i)(1:1)=char(k) 
           end if 
          end if 
         end do 
        end if 
                ! ks                                                    
       end do 
                                                                        
       do i=1,mph 
        jz=0 
        aa=nph(i) 
        bb=nph(i)(2:2) 
        j=ichar(aa)-i0 
        jb=0 
        if(j.gt.0.and.j.le.9) then 
         k=ichar(bb)-i0 
         jz=j+iset 
         jb=1 
         if(k.gt.0.and.k.le.9) then 
          jb=2 
          jz=10*j+k+iset 
         end if 
         j=jz/10 
         k=jz-10*j+i0 
         if(j.gt.0) then 
          if(jb.eq.1) then 
           chr=nph(i)(2:) 
           nph(i)(1:2)=char(j+i0)//char(k) 
           nph(i)(3:23)=chr 
          else 
           nph(i)(1:2)=char(j+i0)//char(k) 
          end if 
         else 
          nph(i)(1:1)=char(k) 
         end if 
        end if 
!       write(6,'(i3,2x,a)')i,nph(i)                                    
       end do 
                                                                        
                                                                        
                                                                        
                                                                        
!       call saveh(nwr,1,b_unify)                                       
!       call saveh(nwr,4,b_unify)                                       
!       call saveh(nwr,5,b_unify)                                       
!       call saveh(nwr,6,b_unify)                                       
       goto 1000 
      end if     ! b_unify
!---------------------------------------------------------------        
!      write(6,'(a)') ' numc='                                          
!      write(6,'(20i4)') (numc(i),i=1,10)                               
!      write(6,'(a)') ' mvaddsh='                                       
!      write(6,'(20i4)') (mvaddsh(1,i),i=0,19)                          
!      write(6,'(20i4)') (mvaddsh(2,i),i=0,19)                          
!      write(6,'(a)') 'corread mplths='                                 
!      write(6,'(20i4)') (mplths(1,i),i=0,19)                           
!      write(6,'(20i4)') (mplths(2,i),i=0,19)                           
!       write(6,'(a)') 'corread ivaddsph(2,i=1...) ='                   
!       write(6,'(20i4)') (ivaddsph(2,i),i=1,20)                        
!       write(6,'(a)') ' ivaddh(1:)='                                   
!       write(6,'(20i4)') (ivaddh(i),i=1,maxthss)                       
!       write(6,'(a)') ' istrssh(1:)='                                  
!       write(6,'(20i4)') (istrssh(1,i),i=0,10)                         
!       read(nrd,'(a)')                                                 
                                                                        
      rewind n1 
!                                                                       
!     end of data                                                       
!      write(nf,'(10f8.2)') (cpstorh(i),i=1,maxsto)                     
!      close(unit=nf)                                                   
                                                                        
      kk=0 
      do i=1,maxs 
       if(ktheo(i,0,0).eq.0) kk=kk+1 
      end do 
                                                                        
!     first reading of a transformation matrix                          
                                ! first reading                         
      if(kk.eq.maxs) then 
                                                                        
       if(nospectrum.eq.1) then 
!       if more than one spectrum the extension is adjusted to the spect
        ks=1 
        do k=1,mplh 
         ch24=nthplh(k) 
         call nreplchar(ks,ch24) 
!        write(6,'(a,i4,2a)') ' k=',k,' v- nthplh=',ch24                
         nthplh(k)(1:24)=ch24 
        end do 
        do k=1,mph 
!         write(6,'(a,i4,2a)') ' k=',k,' v- nph=',nph(k)                
         ch24=nph(k) 
         call nreplchar(ks,ch24) 
!        write(6,'(2a)') '           ch24=',ch24                        
         nph(k)(1:23)=ch24 
        end do 
        do k=1,mclh 
         ch24=nconh(k)(1:24) 
         call nreplchar(ks,ch24) 
!        write(6,'(a,i4,2a)') ' k=',k,' v- nconh=',ch24                 
         nconh(k)(1:23)=ch24 
        end do 
       end if   !  more spectra   
!---- ------------------------------------------                        
       do k=1,mclh 
        ch24=' ' 
        if(nconh(k)(1:1).eq.'#') then 
         ch24=nconh(k)(2:24) 
         call nreplchar(0,ch24) 
!         write(6,'(a,2x,a)')nconh(k)(:24),ch24                         
         nconh(k)(1:23)=ch24 
        end if 
        ncon(k)=nconh(k) 
        con(k)=conh(k) 
       end do 
       mcl=mclh 
       mp=mph 
       mpl=mplh 
       mco=mcoh 
!         write(6,'(a,3i4)') 'corread mplh,mclh=',mplh,mclh             
                                                                        
       do kk=1,mco 
        mr(kk)=mrh(kk) 
        mc(kk)=mch(kk) 
        ncor(kk)=ncorh(kk) 
       end do 
       do kk=1,maxco 
        mrs(kk)=mrsh(kk) 
        mcs(kk)=mcsh(kk) 
        mrce(kk)=mrceh(kk) 
        mrces(kk)=mrcesh(kk) 
       end do 
       do k=1,mrceth 
        cpstor(k)=cpstorh(k) 
        fpstor(k)=fpstorh(k) 
       end do 
       mrcet=mrceth 
                                                                        
                                                                        
       do ks=1,maxs 
        mplthsp(ks)=mplthsph(ks) 
        mcthsp(ks)=mcthsph(ks) 
        mpaddsp(ks)=mpaddsph(ks) 
        mvaddsp(ks)=mvaddsph(ks) 
        mkaddsp(ks)=mkaddsth(ks) 
        mcaddsp(ks)=mcaddsph(ks) 
        nametheory(ks)=nametheoryh(ks) 
        do kss=0,maxthss 
         if(ktheoh(ks,0,0).gt.0) then 
          do j=0,maxthlv 
           ktheo(ks,kss,j)=ktheoh(ks,kss,j) 
          end do 
         end if 
         istrss(ks,kss)=istrssh(ks,kss) 
         mplthss(ks,kss)=mplthssh(ks,kss) 
         mplths(ks,kss)=mplthsh(ks,kss) 
         mcthss(ks,kss)=mcthssh(ks,kss) 
         mcths(ks,kss)=mcthsh(ks,kss) 
         mkaddss(ks,kss)=mkaddssh(ks,kss) 
         mkadds(ks,kss)=mkaddsh(ks,kss) 
         mcaddss(ks,kss)=mcaddssh(ks,kss) 
         mcadds(ks,kss)=mcaddsh(ks,kss) 
         mpaddss(ks,kss)=mpaddssh(ks,kss) 
         mpadds(ks,kss)=mpaddsh(ks,kss) 
         mvaddss(ks,kss)=mvaddssh(ks,kss) 
         mvadds(ks,kss)=mvaddsh(ks,kss) 
        end do 
                                                                        
        do i=0,maxp_sp 
         ivaddsp(ks,i)=ivaddsph(ks,i) 
        end do 
        do i=0,maxc_sp 
         icaddsp(ks,i)=icaddsph(ks,i) 
        end do 
       end do 
                                                                        
       do k=1,mph 
        iha=index(nph(k)(1:5),'#') 
!        if(nospectrum.eq.1) iha=0                                      
                                                ! 18.07.05              
        iha=0 
        if(iha.gt.0) then 
!        if(nph(k)(1:1).eq.'#') then                                    
         ch24=nph(k)(iha+1:iha+23) 
!           write(6,'(2a)') '857 ',ch24                                 
         call nreplchar(0,ch24) 
!           write(6,'(2a)') '859 ',ch24                                 
!         write(6,'(i4,a,a24)') k,'corread (1:1).eq.#=',ch24            
         nph(k)(1:23)=ch24 
        end if 
        np(k)=nph(k) 
        kp(k)=kph(k) 
        p(k)=ph(k) 
        up(k)=uph(k) 
        op(k)=oph(k) 
        ddp(k)=ddph(k) 
!       write(6,'(i3,2x,a)')k,np(k)                                   
       end do 
                                                                        
       do k=1,maxpl 
        kpl(k)=kplh(k) 
        nthpl(k)=nthplh(k) 
       end do 
!       write(6,'(a)') 'line 1156  corread kplh='                       
!       write(6,'(20i4)') (kplh(i),i=1,130)                             
                                                                        
!       write(6,'(a)') ' L987 (kp(j),j=1,mph):'                         
!       write(6,'(20i4)') (kp(j),j=1,mph)                               
!       write(6,'(20i4)') (kcph(j),j=1,60)                              
       do k=1,maxp 
        kcp(k)=kcph(k) 
       end do 
                                                                        
       do k=1,mpl 
        ivadd(k)=ivaddh(k) 
        ipladd(k)=ipladdh(k) 
       end do 
       do i=1,mcl 
        mconcor(i)=i 
        icadd(i)=icaddh(i) 
        icladd(i)=icladdh(i) 
       end do 
                                                                        
                                                                        
       do ksh=1,maxs 
        if(ktheo(ksh,0,0).gt.0) then 
         cmch='name' 
         call theostr(ksh,cmch,ch132,info) 
         i_cdata(ksh,0)=i_cdatah(ksh,0) 
         ip_chan(ksh)=ip_chanh(ksh) 
         do i=1,i_cdatah(ksh,0) 
          i_cdata(ksh,i)=i_cdatah(ksh,i) 
          n_cdata(ksh,i)=n_cdatah(ksh,i) 
          b_cdata(ksh,i)=.true. 
          cdata(ksh,i)=cdatah(ksh,i) 
         end do 
         i_vdata(ksh,0)=i_vdatah(ksh,0) 
         do i=1,i_vdatah(ksh,0) 
          i_vdata(ksh,i)=i_vdatah(ksh,i) 
          n_vdata(ksh,i)=n_vdatah(ksh,i) 
          b_vdata(ksh,i)=.true. 
          vdata(ksh,i)=vdatah(ksh,i) 
         end do 
        end if 
       end do 
                                                                        
       chlese='  ks=1' 
                                                                        
!       write(6,'(i5,2x,a24)') (i,ncon(i),i=1,mcl) ; read(5,*)
       
       do k=1,mcl 
         i=index(ncon(k),'hdb') 
         do j=k+1,mcl 
          l=24 
          do while(ncon(k)(l:l).eq.' ') 
           l=l-1 
          end do 
          l=l+1 
          if(i.gt.0)then 
           if(ncon(k)(i:l).eq.ncon(j)(i:l)) then 
            mconcor(j)=k 
            con(j)=con(k) 
           end if 
          else
           ch24=ncon(k)(1:l)
           l_=index(ch24,'_') 
           l=l_ 
           do while(ch24(l:l).eq.'_') 
            l=l+1 
           end do
           lb=l_-lch
           if(lch.eq.0)lb=1
           chl=ch24(lb:l_)//ch24(l:24) 

           l=24 
           do while(ncon(j)(l:l).eq.' ') 
            l=l-1 
           end do 
           l=l+1 
           cj24=ncon(j)(1:l)
           l_=index(cj24,'_') 
           l=l_ 
           do while(cj24(l:l).eq.'_') 
            l=l+1 
           end do 
           lb=l_-lch
           if(lch.eq.0)lb=1
           chr=cj24(lb:l_)//cj24(l:24) 

           if(chl.eq.chr) then 
!           write(6,'(a,2i3,a3,4a24)')'####(',k,j,')= ',chl,ncon(k),chr,ncon(j) ;read(5,*)
!           if(ncon(k)(:l).eq.ncon(j)(:l)) then 
!            ncon(k)(1:1)='0' 
            mconcor(j)=k 
            con(j)=con(k) 
           end if 
          end if 
         end do 
       end do 
!      write(6,'(a)') ' line 936  corread  return +++++ ipladd '        
!      write(6,'(15i5)') (ipladd(i),i=1,15)                             
       do k=1,mcl 
        mconcor(k)=mconcor(mconcor(k))   ! 5.5.05  
       end do 

       call pcorr(info) 

       goto 1000 
      end if  ! first reading      
                                                                        
!____________________________________________________________________   
                                                                        
!      call savearsp(12) 
                                                                        
!____________________________________________________________________   
!     pcinsert                                                          
      do k=1,maxs 
       numh(k)=ktheo(k,0,0) 
      end do 
      mplold=mpl 
!      call savearsp(13) 
      call savearsp(12) 

! SP SP SP SP S SP SP SP SP SP SP SP SP SP SP SP SPP SP SP SP SP SP SP S
      mco_last=mco 
      do ksh=1,maxs 
       if(ktheoh(ksh,0,0).gt.0) then 
                                                                        
!       selection of ks with ktheo(ks,0,0)=0                            
        ks=0 
        kmaxsp=0 
!       write(6,'(a)') ' numh='                                         
!       write(6,'(20i4)') (numh(i),i=1,maxs)                            
        if(numh(maxs).ne.0) then 
         kmaxsp=1 
         k=1 
        else 
         k=1 
         do while(numh(k).eq.0.and.k.lt.maxs) 
          k=k+1 
         end do 
        end if 
  150   if(numh(k).gt.0.and.k.lt.maxs) then 
         if(kmaxsp.eq.0) then 
          k=k+1 
          do while(numh(k).eq.0.and.k.lt.maxs) 
           k=k+1 
          end do 
          if(k.lt.maxs) goto 150 
         else 
          do while(numh(k).ne.0.and.k.lt.maxs) 
           k=k+1 
          end do 
          if(k.lt.maxs) goto 150 
         end if 
        else 
         if(numh(k).gt.0) then 
          info=6 
          infotext(1)='effi/structure/corread/set/free' 
          infotext(2)='**error** no free number available' 
          infotext(3)=' ' 
          goto 1000 
         else 
          ks=k 
         end if 
        end if 
        if(ks.eq.0) then 
         k=maxs 
         do while(numh(k).eq.0) 
          k=k-1 
         end do 
         ks=k+1 
        end if 
        nth=ktheoh(ksh,0,1) 
        lth=ktheoh(ksh,0,2) 
        call getname(0,nth,lth,property,name_theo) 
!        nfrtheo=ktheoh(ksh,0,0)                                        
  155   write(nwr,'(3a,i2,a1)')                                         &
     &      ' FRAME THEORY: ',TRIM(property),                           &
     &          ' for set [',ks,']'                                     
!       if(ktheo(ks,0,0).ne.0) write(6,'(a,i4,a)')                      
!    &              ' L155 ks=',ks,chlese(1:60)                         
                                                                        
        ilese=index(chlese,'=') 
        if(ilese.gt.0) then 
         ch132=chlese(ilese+1:ilese+4) 
         call trlch(10,ch132,iout,out) 
         iset=out(1) 
         if(ktheo(iset,0,0).eq.0) ks=iset 
         goto 158 
        end if 
        if(b_noask) then 
         ch132=' ' 
         write(nwr,'(a)') 
        else 
         read(nrd,'(a)') ch132 
        end if 
        write(nwr,'(1x,a1,a3)') char(27),'[2A' 
        call lc_character(ch132) 
        if(ch132(1:2).eq.'he') then 
         chcom='effi/corread/set/select' 
         call help(chcom) 
         goto 155 
        end if 
        ch1=ch132(1:1) 
        if(ch1.eq.'*'.or.ch1.eq.'q') then 
         chlese='*' 
         goto 1000 
        end if 
        if(ch1.eq.' ') goto 158 
        call trlch (ncc,ch132,iout,out) 
        if(iout.eq.1) then 
         k=out(1) 
         write(nwr,'(2a)')'                                        ',   &
     &                 '                                        '       
         write(nwr,'(1x,a1,a3)') char(27),'[3A' 
         if(ktheo(k,0,0).gt.0) then 
         ch132=nametheory(k) 
         write(nwr,'(a,i2,2a)') ' ***  set=',k,                         &
     &                        ' is occupied:',TRIM(ch132)               
         else 
          ks=k 
          if(ks.gt.maxs)ks=maxs 
         end if 
         goto 155 
        end if 
                                                                        
  158   continue 
        if(ks.gt.maxs) then 
         info=6 
         infotext(1)='effi/structure/corread/set/free' 
         infotext(2)='**error** maximum number of spectra reached' 
         infotext(3)=' ' 
         goto 1000 
        end if 
        write(nwr,'(a)') ' inserting FRAME THEORY' 
        form='i2' 
        rn=ks 
        call trlnu(form,rn,chr,nn,chl,im) 
        chlese='  ks='//chl(1:5) 
        numh(ks)=ktheoh(ksh,0,0) 
                                                                        
!        write(6,'(a,3i4,a,15i4)')' mplh,ks,ksh=',mplh,ks,ksh,          
!     &                              ' numh=',(numh(i),i=1,maxs)        
!       read(nrd,'(a)')                                                 
                                                                        
        i_cdata(ks,0)=i_cdatah(ksh,0) 
        ip_chan(ks)=ip_chanh(ksh) 
        do i=1,i_cdatah(ksh,0) 
         i_cdata(ks,i)=i_cdatah(ksh,i) 
         n_cdata(ks,i)=n_cdatah(ksh,i) 
         b_cdata(ks,i)=.true. 
         cdata(ks,i)=cdatah(ksh,i) 
        end do 
        i_vdata(ks,0)=i_vdatah(ksh,0) 
        do i=1,i_vdatah(ksh,0) 
         i_vdata(ks,i)=i_vdatah(ksh,i) 
         n_vdata(ks,i)=n_vdatah(ksh,i) 
         b_vdata(ks,i)=.true. 
         vdata(ks,i)=vdatah(ksh,i) 
        end do 
                                                                        
        do k=1,maxfr1 
         nu_sdevice(ks,k)=nu_sdeviceh(ksh,k) 
        end do 
                                                                        
!       do i=1,maxp_sp                                                  
!        ivaddsp(ks,i)=ivaddsph(ksh,i)                                  
!       end do                                                          
        do i=1,maxc_sp 
         icaddsp(ks,i)=icaddsph(ksh,i) 
        end do 

!       write(6,'(a,12i4)') '**mch=',(mch(i),i=1,mcoh)                  
        do j=0,maxthlv 
         ktheo(ks,0,j)=ktheoh(ksh,0,j) 
        end do 
        cmch='name' 
        call theostr(ks,cmch,ch132,info) 
                                                                        
! ssp ssp ssp ssp ssp ssp ssp ssp ssp ssp ssp ssp ssp ssp ssp ssp ssp ss
        do kss=0,maxthss 

!         call savearsp(31) 
         call savearsp(21) 
!        nn=21                                                          
!        call shift(nn)                                                 
!         k=1                                                           
!         kk=0                                                          
!          call delh(-k,kk)                                             
!         i1=1                                                          
!         b_unify=.false.                                               
!         call saveh(i1,b_unify)                                        
!         read(5,'(a)')                                                 
                                                                        
         if(ktheoh(ksh,kss,0).gt.0) then 
!         call savehh(6,1,5)                                            
!         if(ks.ne.ksh) then                                            
!         end if                                                        
                                                                        
!         write(6,'(a,15i4)') ' mplth=',mplth                           
!         write(6,'(a,15i4)') ' mplthsh(1,0:)=',(mplthsh(1,i),i=0,14)   
!         write(6,'(a,15i4)') ' mplthsh(2,0:)=',(mplthsh(2,i),i=0,14)   
!         write(6,'(a,15i4)') ' mplthsh(maxs,0:)=',                     
!    &                       (mplthsh(maxs,i),i=0,14)                   
!         write(6,'(a)') ' mplths='                                     
!         write(6,'(20i4)') (mplths(1,i),i=1,20)                        
!         write(6,'(20i4)') (mplths(2,i),i=1,20)                        
                                                                        
!         write(6,'(a,i4)') ' b************ ks=',ks                     
!         write(6,'(a,10i3)') ' mplthsph(1..)=',(mplthsph(k),k=1,ms)    
!          do iset=1,maxs                                               
!           if(ktheoh(iset,0,0).gt.0) then                              
!           write(6,'(ai2,a,20i3)')                                     
!    &      '  mplths(',iset,',0..)=',(mplthsh(iset,k),k=0,maxthss)     
!           write(6,'(ai2,a,20i3)')                                     
!    &     'mplthss(',iset,',0..)=',(mplthssh(iset,k),k=0,maxthss)      
!           end if                                                      
!          end do                                                       
                                                                        
!         write(6,'(a,10i4)') ' before delh ktheoh(1..,0,0)=',           
!     &                              (ktheoh(i,0,0),i=1,maxs)           
!         write(6,'(a)') ' corread vor del ks  ipladdh='                
!         write(6,'(20i4)') (ipladdh(i),i=1,mplh)                       
                                                                        
         do k=maxs,1,-1 
          if(k.ne.ksh.and.ktheoh(k,0,0).gt.0) then 
           kk=0 
           call delh(-k,kk) 
          end if 
         end do 
!         i1=1                                                          
!         b_unify=.false.                                               
!         call saveh(i1,b_unify)                                        
!         read(5,'(a)')                                                 
                                                                        
!        write(6,'(a)') ' corread del ks ipladdh='                      
!        write(6,'(20i4)') (ipladdh(i),i=1,mplh)                        
         k_theo0=ktheoh(ksh,0,0) 
         k_theo1=ktheoh(ksh,0,1) 
         do kk=maxthss,0,-1 
!         do kk=6,5,-1                                                  
          if(kk.ne.kss.and.ktheoh(ksh,kk,0).gt.0) then 
           call delh(ksh,kk) 
!            i1=8                                                       
!            b_unify=.false.                                            
!            call saveh(i1,1,b_unify)                                   
!            read(5,'(a)')                                              
          end if 
         end do 
!         close(unit=8)                                                 
!         i1=1                                                          
!         b_unify=.false.                                               
!         call saveh(i1,b_unify)                                        
!         write(6,'(a,30i4)') '***mrh=',(mrh(i),i=1,mcoh)               
                                                                        
         ktheoh(ksh,0,0)=k_theo0 
         ktheoh(ksh,0,1)=k_theo1 
!        write(6,'(a)') ' corread vor istvaddh(1,..) ivaddsph,ipladdh=' 
!        write(6,'(20i4)') (ivaddsph(ksh,i),i=0,20)                     
!        write(6,'(20i4)') (ipladdh(i),i=1,mplh)                        
         nn1=2 
         nn2=kss 
         call istvaddh(nn1,ksh,nn2) 
         do iset=1,maxs 
          if(ktheoh(iset,0,0).gt.0) then 
           call istvaddh(1,iset,0) 
          else 
           mcaddsph(iset)=0 
           do iss=0,maxthss 
            mcaddssh(iset,iss)=0 
           end do 
           mvaddsph(iset)=0 
           do iss=0,maxthss 
            mvaddssh(iset,iss)=0 
           end do 
          end if 
         end do 
                                                                        
                                                                        
         numc(1)=mvaddsh(1,maxthss) 
         do iset=2,maxs 
          numc(iset)=mvaddsh(iset,maxthss)-mvaddsh(iset-1,maxthss) 
         end do 
!        write(6,'(a,10i4)') ' numc(1..)=',(numc(i),i=1,10)             
!        write(6,'(a,10i4)') ' ktheoh(1..,0,0)=',                       
!    &                            (ktheoh(i,0,0),i=1,maxs)              
         do i=1,mplh 
          ivaddh(i)=0 
         end do 
         j=0 
         jj=0 
         do iset=1,maxs 
          if(ktheoh(iset,0,0).gt.0) then 
!          write(6,'(a,i2,a,10i4)') ' ivaddsph(',iset,',0:)=',          
!    &                        (ivaddsph(iset,i),i=1,10)                 
           if(iset.gt.1) jj=mvaddsh(iset-1,maxthss) 
           do i=1,numc(iset) 
            ii=ivaddsph(iset,i) 
            if(ii.gt.0) then 
             j=j+1 
             ivaddh(j)=ii+jj 
            end if 
           end do 
          end if 
         end do 
!        write(6,'(a)') 'B corread ivaddsph(ksh,0..),kplh(1..)='        
!        write(6,'(20i4)') (ivaddsph(1,i),i=0,mplh)                     
!        write(6,'(20i4)') (ivaddh(i),i=1,j)                            
!         write(6,'(20i4)') (kplh(i),i=1,130)                           
                                                                        
!        write(6,'(a)') '############################################'  
!          i1=1                                                         
!         b_unify=.false.                                               
!         call saveh(i1,b_unify)                                        
!         read(5,'(a)')                                                 
                                                                        
                                                                        
         do k=1,mplh 
          ch24=nthplh(k) 
          call nreplchar(ks,ch24) 
          nthplh(k)(1:24)=ch24 
         end do 
         do k=1,mph 
          iha=index(nph(k)(1:5),'#') 
          if(iha.eq.0) then 
           ch24=nph(k) 
           call nreplchar(ks,ch24) 
!           write(6,'(2a)') '1315 ',ch24                                
           nph(k)(1:23)=ch24 
          else 
           ch24=nph(k)(iha+1:24) 
           call nreplchar(ks,ch24) 
           nph(k)(1:23)='#'//ch24 
          end if 
         end do 
                                                                        
         do k=1,mclh 
          if(nconh(k)(1:1).ne.'#') then 
           ch24=nconh(k) 
           call nreplchar(ks,ch24) 
!           write(6,'(2a)') '1327 ',ch24                                
           nconh(k)(1:23)=ch24 
          else 
           ch24=nconh(k)(2:24) 
           call nreplchar(0,ch24) 
!           write(6,'(2a)') '1332 ',ch24                                
           nconh(k)(1:23)=ch24 
          end if 
         end do 
                                                                        
!        call savehh(6,1,5)                                             
                                                                        
         if(mcl+mclh.gt.maxc) then 
          write(nwr,900) ' *** number of constants larger than ',maxc 
          goto 500 
         end if 
         if(mpl+mplh.gt.maxpl) then 
          write(nwr,900) ' *** number of variables larger than ',maxpl 
          goto 500 
         end if 
         if(mp+mph.gt.maxp) then 
          write(nwr,900) ' *** number of parameters larger than ',maxp 
          goto 500 
         end if 
  900    format(a,i3) 
                                                                        
                                                                        
         do k=0,maxthlv 
          ktheo(ks,kss,k)=ktheoh(ksh,kss,k) 
         end do 
         if(nametheoryh(ksh).ne.' ')nametheory(ks)=nametheoryh(ksh) 
!        minimal change (consequences not clear) Okt 21 2008            
         mcthsp(ks)=mcthsph(ksh) 
         mcthss(ks,kss)=mcthssh(ksh,kss) 
         mkaddsp(ks)=mkaddsth(ksh) 
         mkaddss(ks,kss)=mkaddssh(ksh,kss) 
         mcaddsp(ks)=mcaddsph(ksh) 
         mcaddss(ks,kss)=mcaddssh(ksh,kss) 
         mplthsp(ks)=mplthsph(ksh) 
         mplthss(ks,kss)=mplthssh(ksh,kss) 
         mpaddsp(ks)=mpaddsph(ksh) 
         mpaddss(ks,kss)=mpaddssh(ksh,kss) 
         mvaddsp(ks)=mvaddsph(ksh) 
         mvaddss(ks,kss)=mvaddssh(ksh,kss) 
                                                                        
         icd=0 
         ird=0 
         kc=0 
         info=-1 
!         write(6,'(20i4)') (kplh(i),i=1,2)                             
!         read(5,'(a)')                                                 
         call pcinsert(info,ks,kss,kc,ird,icd,mplth,0) 
                                                                        
                                                                        
         mplth=0 
!         write(6,'(a,5i4)')'corread maxco,mco,mcoh=',maxco,mco,mcoh    
         do kch=1,mcoh 
!         write(6,'(3a,6i4)')'corread  ncorh(kch)=', &                   
!             ncorh(kch),' kch,mch,mrh=',kch,mch(kch),mrh(kch)          

          if(mch(kch).gt.0) then 
           ird=mrh(kch) 
           icd=mch(kch) 
           do ir=1,ird 
            mkk=mrcesh(kch)+(ir-1)*icd 
            do ic=1,icd 
             cph(ir,ic)=cpstorh(mkk+ic) 
             fph(ir,ic)=fpstorh(mkk+ic) 
!            write(6,'(a,2i4,a,f8.2,2x,a4)') ' ir,icd=',ir,icd,         
!     &        'cph,fph(ir,ic)=',cph(ir,ic),fph(ir,ic)                  
            end do 
           end do 
           kci=0 
           do kc=1,mco_last 
            if(ncor(kc).eq.ncorh(kch)) then 
             kci=kc 
!             write(6,'(2a,4x,a,a,6i4)')'corread ',                     
!     &         ncor(kc),ncorh(kch),' kci=',kci                         
            end if 
!            write(6,'(a,4x,a,a,6i4)')                                  
!     &                ncor(kc),ncorh(kch),' kci=',kci,kch              
           end do 
                                                                        
                                                                        
           if(kci.eq.0) then 
             mco=mco+1 
             kci=mco 
             ncor(kci)=ncorh(kch) 
!           write(6,'(a,4x,a,a,6i4)') ncor(kci),ncorh(kch),' kci=',kci  
           end if 
           mco_last=mco 
           mplth=mplth+ird 
!           write(6,'(a,4x,a,a,10i4)') ncor(kci),ncorh(kch),            
!     &     ' mco,ksh,ks,kss,ird,icd,mplth=',                           
!     &       mco,ksh,ks,kss,ird,icd,mplth                              
!         write(6,'(a)') 'corread kph,nph'                              
!          write(6,'(4(i4,a))') (kph(j),nph(j)(:20),j=1,mph)            
           info=-2 
           call pcinsert(info,ks,kss,kci,ird,icd,mplth,1) 
!          write(6,'(a,i4)') ' line 1186 corread  -end if -  ks=',ks    
           if(info.gt.0)  goto 500 
!           write(6,'(a,6i4)') 'b ks,kss,kci,ird,icd,mplth=',           
!     &                         ks,kss,kci,ird,icd,mplth                
!           call save(6,2,5)                                            
!           read(nrd,'(a)')                                             
                                                                        
!         write(6,'(a)') ' line 1115 corread ipladdh '                  
!          write(6,'(15i5)') (ipladdh(i),i=1,mplh)                      
!         write(6,'(15i5)') (kplh(i),i=1,mplh)                          
           do j=1,mplh-ird 
            jh=kplh(j) 
            nthplh(jh)=nthplh(kplh(j+ird)) 
            ipladdh(jh)=ipladdh(kplh(j+ird)) 
           end do 
                                                                        
           do j=1,mph-icd 
            jh=kcph(j) 
            jj=kcph(j+icd) 
            nph(jh)=nph(jj) 
            kph(jh)=kph(jj) 
            ph(jh)=ph(jj) 
            uph(jh)=uph(jj) 
            oph(jh)=oph(jj) 
            ddph(jh)=ddph(jj) 
           end do 
          end if  ! mch>0  
!         write(6,'(a,6i4)')' kch=',kch                                
         end do   ! kch   

         icd=0 
         kc=1 
!        write(6,'(a,4x,a,a,5i4)') ncor(kc),ncorh(kc),                  
!    &       ' ksh,ks,kss,ird,mplth=',ksh,ks,kss,ird,mplth              
         kks=ks 
!        write(6,'(a,i4)') ' line 1221 corread  ipladd kks=',kks        
                                                                        
         info=-3 
         call pcinsert(info,ks,kss,kc,ird,icd,mplth,1) 
!        write(6,'(a,i4)') 'corread info=',info                         
         if(info.gt.0) goto 500 
         i=kss/10 
         k=10*i 
         if(kss.eq.k) then 
          if(i.gt.0)  write(nwr,'(1x,a1,a3)') char(27),'[2A' 
           ch132='calculating .' 
           do j=1,i 
            ch132(13+j:13+j)='.' 
           end do 
           write(nwr,'(a)')ch132 
          end if 
         end if  ! ktheoh(ksh,kss,0)>0      
        end do   ! kss   
                                                                        
! ssp ssp ssp ssp ssp ssp ssp ssp ssp ssp ssp ssp ssp ssp ssp ssp ssp ss
        do kss=1,maxthss 
         istrss(ks,kss)=istrssh(ksh,kss) 
        end do 
        call istvadd(2,ks) 
       end if  ! ktheoh(ksh,0,0)>0       
      end do   ! ksh  
! SP SP SP SP SP SP SP SP SP SP SP SP SP SP SP SP SP SP SP SP SP SP SP S
                                                                        
      do ks=1,maxs 
       if(ktheo(ks,0,0).gt.0) then 
        call istvadd(1,ks)   ! 2?       
       end if 
      end do 
                                                                        
      do ks=1,maxs 
       numc(ks)=mvadds(ks,maxthss)-mvadds(ks,0) 
      end do 
      ms=maxs 
      do while(numc(ms).eq.0) 
       ms=ms-1 
      end do 
!     write(6,'(i4,4x,10i4)') ms,(numc(i),i=1,10)                       
      do i=1,mpl 
       ivadd(i)=0 
      end do 
      j=0 
      do ks=1,ms 
       do i=1,numc(ks) 
        ik=ivaddsp(ks,i) 
        if(ik.gt.0) then 
         j=j+1 
         ivadd(j)=ik+mvadds(ks,0) 
        end if 
       end do 
      end do 
                                                                        
      do ks=1,ms 
       numc(ks)=mcadds(ks,maxthss)-mcadds(ks,0) 
      end do 
      do i=1,mcl 
       icadd(i)=0 
      end do 
      j=0 
      do ks=1,ms 
       do i=1,numc(ks) 
        ik=icaddsp(ks,i) 
        if(ik.gt.0) then 
         j=j+1 
         icadd(j)=ik+mcadds(ks,0) 
        end if 
       end do 
      end do 
                                                                        
!       constants of equal name                                         
!       write(6,'(a,2(i3,a1))') ' corread icadd(',mcl_o,'-',mcl,')'     
!       do k=1,mcths(2,maxthss)                                         
!         write(6,'(a,i2,a2,i2,2x,a24,a1,f10.4)')                       
!    &   'icadd(',k,')=',icadd(k),ncon(k),'=',con(k)                    
!       end do                                                          

         do i1=mcl_o+1,mcl 
          ch24=ncon(i1) 
          l=1 
          do while(ch24(l:l).eq.' ') 
           l=l+1 
          end do 
          if(l.gt.1) ncon(i1)(1:24)=ch24(l:) 
         end do 
                                                                        
         do i1=mcl_o+1,mcl 
          mconcor(i1)=i1                !5.5.05  
         end do 
                                                                        
         do i1=mcl_o+1,mcl 
          ca32=ncon(i1) 
          l=index(ca32,'#') 
          if(l.gt.0) ca32(l:l)=' ' 
                                                                        
          do i2=1,mcl_o 
           cb32=ncon(i2) 
           if(ca32(2:24).eq.cb32(2:24).and.ca32(1:1).eq.'0') then 
            l=24 
            do while(cb32(l:l).eq.' ') 
             l=l-1 
            end do 
            i=index(ca32(:5),'hdb') 
            ncon(i1)(:32)='0'//cb32(2:) 
            ncon(i2)(:32)='0'//cb32(2:) 
            if(mconcor(i2).eq.i2.and.i.gt.0)                            &
            write(nwr,'(a,i4,a,i3,1x,a)')                               &
                      ' constant ',i1,' correlated with ',i2,cb32(1:l)
            mconcor(i1)=i2 
           end if 
          end do 
         end do 
         do k=1,mcl 
          mconcor(k)=mconcor(mconcor(k)) ! 5.5.05  
         end do 
!         do k=1,mcl                                                    
!          write(6,'(a,i2,a,i2)')'mconcor(',k,')=',mconcor(k)           
!         end do                                                        
      goto 1000 
                                                                        
  480 continue 
      info=1 
      infotext(1)='effi/structure/corread/parfile' 
      infotext(2)='**error** read command runs on end' 
      infotext(3)=' ' 
  490 goto 1000 
  500 continue 
      write(nwr,'(a,i2,a)') ' *** spectrum ',ks,' is incomplete' 
      write(nwr,'(a,a)') ' the command {rm} does not work properly',    &
     & ' for this spectrum - start again'                               
                                                                        
 1000 continue 
      inquire(file='storage.cmpl',exist=b_file)
      if(b_file)call rmfile(' storage.cmpl'//char(0))  
      deallocate(memtheo)
      return 
      END                                           
                                                                        
                                                                        
                                                                        
                                                                        
      subroutine vcread(memtheo,n1,iset,iss,iv,ivar,ic,icon,icase,ifr,jk) 
      use glbconst, only: maxs,maxthss
      use compar, only: maxmemth
      use comsto, only: ipladdh,nvarh,nconh,icladdh,conh,ktheoh
      implicit none 
      integer, intent(in), dimension(maxs,0:maxthss,maxmemth)::memtheo
      integer   n1,iv,iset,iss,ivar,ic,icon,icase,ifr,jk 
      real, dimension(32):: out
      character(len=132):: ch132,cp132,cq132
      character(len=8)  :: ch8,chth
      character(len=6)  :: ch6
      character(len=2)  :: ch2
      character(len=4), dimension(32):: chf                          
      integer   i0,ith0,ivth,ivap,iva,ii,ith,icth,ip,ih,ipos,iout,     &
               isl,icop,ico,i1,i2,jo,jc,jf,mplth,mcth,nn           
      ith0=ktheoh(iset,iss,0) 
      i0=ichar('0') 
      if(icase.eq.0) then 
       mplth=jk 
       ivth=0 
       do while(ivth.lt.mplth) 
        read (n1,'(a)') ch132 
!        write(6,'(i2,2x,2a)')ifr,'vv', ch132(:120)                     
        jo=1 
        cp132=' ' 
        do while(jo.gt.0) 
         jo=index(ch132,'(') 
         jc=index(ch132,')') 
         if(jo.gt.0) then 
          cp132=ADJUSTL(ch132(1:jo-1)) 
          iv=iv+1 
          ivth=ivth+1 
          cq132=ch132(jo:jc) 
          call trlch(jc,cq132,iout,out) 
          ivap=out(1) 
          ipladdh(iv)=ivap 
                                                                        
!          write(8,'(a,i3,a2,i3)') 'ipladdh(',iv,')=',ipladdh(iv)       
          iva=ivap 
          ith=0 
          do while(iva.gt.0.and.ith.lt.maxthss) 
           ith=ith+1 
           iva=ivap-memtheo(iset,ith,2) 
!             write(6,'(a,5i4)')'ivap,iva,ith,memtheo(iset,ith,2)=',&    
!                          ivap,iva,ith,memtheo(iset,ith,2)       
          end do 
          if(ith.eq.0)ith=1 
          iva=ivap-memtheo(iset,ith-1,2) 
          ith=2*ith 
          ii=ktheoh(iset,iss,ith-1) 
          call itoc8(ch8,ii) 
          if(ii.lt.10)then 
           ch6='0'//ch8(2:2) 
          else 
           ch6=ch8(2:3) 
          end if 
                                                                        
          ii=ktheoh(iset,iss,ith) 
          call itoc8(ch8,ii) 
          if(ii.lt.10)then 
           ch6(3:4)='0'//ch8(2:2)          ! 5.9.05
          else 
           ch6(3:4)=ch8(2:3) 
          end if 
          call itoc8(ch8,ivap)               ! iva->ivap5.9.05  
          if(ivap.lt.10)then 
           ch6(5:6)='0'//ch8(2:2) 
          else 
           ch6(5:6)=ch8(2:3) 
          end if 
          if(ifr.eq.1.and.ith.eq.2) then 
           chth='fr'//ch6 
          else 
           chth='th'//ch6 
          end if 
          cp132(25:32)=chth 
          ivar=ivar+1 
          nvarh(ivar)=cp132(:32) 
!          write(6,'(i4,2a,6i3)')iva,' corread nvarh=',cp132(:38)       
          ch132(1:jc+1)=' ' 
         end if 
        end do 
       end do 
      else 
       mcth=jk 
       icth=0 
       do while(icth.lt.mcth) 
        read (n1,'(a)') ch132 
!       write(6,'(2a)')'cc', ch132(:120)                               
        ip=1 
        ih=0 
        do while(ip.gt.0) 
         call nextchar(ch132,ih,ipos,cp132,ip) 
         ip=index(cp132,'=') 
         if(ip.gt.0) then 
          cp132(ip:ip)=' ' 
          icon=icon+1 
          isl=ip-6 
          nconh(icon)(1:isl)=cp132(1:isl) 
                                                                        
          ch132=cp132(ip-5:ip-1) 
          call trlch(80,ch132,nn,out) 
          ic=ic+1 
          icth=icth+1 
          icop=out(1) 
          icladdh(ic)=icop 
!          write(6,'(a,i3,a2,i3)') 'icladdh(',ic,')=',icladdh(ic)       
!          write(6,'(i4,2x,a)')icop,nconh(icon)                         
          ico=icop 
          ith=0 
          do while(ico.gt.0.and.ith.le.maxthss) 
           ith=ith+1 
           ico=icop-memtheo(iset,ith,1) 
!          write(6,'(a,5i4)')'icon,icop,ico,ith,memtheo(iset,ith,1)=',  
!     &                       icon,icop,ico,ith,memtheo(iset,ith,1)     
          end do 
          if(ith.eq.0)ith=1 
          ico=icop-memtheo(iset,ith-1,1) 
          ith=2*ith 
          i1= ktheoh(iset,iss,ith-1) 
          i2= ktheoh(iset,iss,ith) 
          ch2='th' 
!          if(ith.eq.2) then                                            
                                                  ! 5.9.05              
            if(ith.eq.2.and.ifr.eq.1) ch2='fr' 
!            write(6,'(a)')nconh(icon)                                  
            if(nconh(icon)(2:4).eq.'hdb') then 
             i1=ichar(nconh(icon)(5:5))-i0 
             i2=ichar(nconh(icon)(6:6))-i0 
             ch2='hb' 
            end if 
!          end if                                                       
!          write(6,'(a,i3,2x,a)')ch2,icon,nconh(icon)                   
                                                                        
          call itoc8(ch8,i1) 
          if(i1.lt.10) then 
           chth=ch2//'0'//ch8(2:2)          ! 5.9.05 
          else 
           chth=ch2//ch8(2:3) 
          end if 
          call itoc8(ch8,i2) 
          if(i2.lt.10) then 
           chth(5:6)='0'//ch8(2:2) 
          else 
           chth(5:6)=ch8(2:3) 
          end if 
          call itoc8(ch8,icop) 
           if(icop.lt.10) then 
           chth(7:8)='0'//ch8(2:2) 
          else 
           chth(7:8)=ch8(2:3) 
          end if 
          nconh(icon)(25:32)=chth
!         write(6,'(a)') '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'          
!         write(6,'(a,i6,f15.6)') 'corread icon=',icon,out(1)           
          call nextchar(cp132,ip-1,ipos,ch132,ih) 
          jf=index(ch132,' ') 
          cp132=ch132(1:jf) 
          call fout_a(cp132,chf,jf) 
          ch6=chf(1)(1:3) 
          if(ch6(1:1).eq.'i') then 
           ch6(4:6)=')  ' 
          else 
           ch6(4:6)='.'//chf(1)(4:4)//')' 
          end if 
          nconh(icon)(33:38)=ch6 
          call trlch(ih,ch132,nn,out) 
!         write(6,'(a,i6,f15.6)') 'corread icon=',icon,out(1)           
          conh(icon)=out(1) 
!          write(6,'(i4,2a)') icon,' nconh(icon)=',nconh(icon)          
         end if 
        end do 
       end do 
      end if 
      return 
      END                                           
                                                                        
      subroutine vaext(iva) 
      use comsto, only: nvarh,nthplh
      implicit none 
      integer   iva,i,j 
      character ch24*24 
!      do i=1,iva                                                       
!       write(6,'(a)')nthplh(i)                                         
!      end do                                                           
!      write(6,'(a)')                                                   
      do i=1,iva 
       ch24=nthplh(i) 
       do j=1,iva 
        if(nvarh(j)(1:1).ne.'@') then 
         if(nvarh(j)(1:24).eq.ch24) then 
          nthplh(i)=nvarh(j) 
          nvarh(j)(1:1)='@' 
         end if 
        end if 
       end do 
      end do 
!      do i=1,iva                                                       
!       write(6,'(a)')nthplh(i)                                         
!      end do                                                           
!      write(6,'(a)')                                                   
!      do i=1,iva                                                       
!       write(6,'(a)')nvarh(i)                                          
!      end do    
      return 
      END                                           
                                                                        
      subroutine savearsp(n1)  
      use glbconst, only: MDBPLFT
      implicit none
      character(len=4) :: carray_fr
      common/plot/carray_fr(2*MDBPLFT)  
      integer   n1
       open(unit=1,file='storage.cmpl'                      &
                 ,status='unknown'                          &
                 ,form='unformatted')   
        if(n1.eq.12)write(1) carray_fr 
        if(n1.eq.21) read(1) carray_fr 
      close(unit=1) 
      return 
      END                                           

                                                                        
      subroutine theonumber(nth_str,iset,iss,ith1,ith2) 
      implicit none 
      integer iset,iss,ith1,ith2,im,nn 
      real    rn 
      character nth_str*8,chr*24,chl*24,form*7 
      form='i2' 
      rn=iset 
      call trlnu(form,rn,chr,nn,chl,im) 
      nth_str(1:2)=chl(1:2) 
      rn=iss 
      call trlnu(form,rn,chr,nn,chl,im) 
      nth_str(3:4)=chl(1:2) 
      rn=ith1 
      call trlnu(form,rn,chr,nn,chl,im) 
      nth_str(5:6)=chl(1:2) 
      rn=ith2 
      call trlnu(form,rn,chr,nn,chl,im) 
      nth_str(7:8)=chl(1:2) 
!      write(6,'(2a)') 'corread nth_str=',nth_str                       
      return 
      END                                           
                                                                        
      subroutine versioncomp(l,name_theo,theoryname,thversion,property,b_vers) 
      use glbconst, only: enwr,nwr,nrd
      implicit none 
      integer   l,i,j 
       character(len=132),intent(in):: name_theo,property
       character(len=72), intent(in):: theoryname
       character(len=8),  intent(in):: thversion
       logical,           intent(in):: b_vers
       character(len=132):: ch132
       character(len=72) :: ntheo,prop

      return
      i=index(theoryname,'v=')+2 
      if(i.gt.2.and.enwr(3)(2:2).eq.'n')then 
       if(theoryname(i:i+2).ne.thversion(3:5)) then 
        if(thversion.ne.' ') then 
         write(nwr,'(/,a)')'**version** are different'
         write(nwr,'(4x,a,3x,2a)')TRIM(name_theo(:l+5)),'par-file generated by version ', &
         thversion 
         write(nwr,'(4x,a,3x,2a,/)')TRIM(theoryname(:i-3)),'current version of the theory ',&
         theoryname(i-2:i+4)
         
         if(b_vers)then
          write(nwr,'(a)')'type {enter} or {he/enter}'
          read(nrd,'(a)')ch132
          if(index(ch132,'he').gt.0)then
           ch132='effi/version/compare'
           call help(ch132)
          end if
          ntheo=name_theo(:l+5)
          prop=property
          i=LEN_TRIM(prop)
          do j=1,i-1
           if(prop(j:j).eq.' ')prop(j:j)='_'
          end do
          ch132='<'//TRIM(prop)//'>'//'/version/'//ntheo
          call help(ch132)
         end if
        else 
         write(nwr,'(/,a)')'**version** not given in .par file' 
        end if 
       end if 
      end if 
      return 
      END                                           
