      subroutine corerr(mf,chisq,                                       &
     &                  covar,dpm,dvpm,u,AA,BB,CC,AY,indx,kfu)       
      use glbconst, only: maxp,maxpl,maxpf,nwr
      use comfrm, only: mco,mc,mcs,cpstor,mrs,mr,mrces,kcp,kpl
      implicit none 
                                                                        
      integer mf,k,l,ltr,ir,mk,ic1,jp1,ic2,jp2,k1,k2,lpl
      real(kind=8), dimension(mf,mf):: AA,BB,CC
      real(kind=8), dimension(mf)   :: AY
      real(kind=4), dimension(mf,mf):: u,covar       
      real(kind=4), dimension(maxp) :: dpm
      real(kind=4), dimension(maxpl):: dvpm
      integer     , dimension(maxpf):: indx
      integer     , dimension(maxp) :: kfu
      real :: chisq,g2 
                                                                        
       do k=1,mf 
        do l=1,mf 
         AA(k,l)=dble(covar(k,l)) 
        end do 
       end do 
                                                                        
                                                                        
       call invert(mf,AA,BB,CC,AY,indx) 
                                                                        
       do k=1,mf 
        do l=1,mf 
         u(k,l)=BB(k,l) 
        end do 
       end do 
       l=0 
       do k=1,mf 
        if(u(k,k).le.0.0) then 
         u(k,k)=-u(k,k)+0.001 
         l=l+1 
        end if 
       end do 
                                                                        
       if(l.gt.0) write(nwr,'(a)')'**diagonal** element negativ' 
                                                                        
      do k=1,mf 
       g2=sqrt(u(k,k)) 
       do l=k,mf 
        u(k,l)=u(k,l)/g2/sqrt(u(l,l)) 
        u(l,k)=u(k,l) 
       end do 
       dpm(k)=g2*sqrt(chisq) 
      end do 
                                                                        
      do ltr=1,mco 
       do ir=1,mr(ltr) 
        mk=mrces(ltr)+(ir-1)*mc(ltr) 
        g2=0. 
        do ic1=1,mc(ltr) 
         jp1=kcp(mcs(ltr)+ic1) 
         k1=kfu(jp1) 
         if(k1.gt.0) then 
          do ic2=1,mc(ltr) 
           jp2=kcp(mcs(ltr)+ic2) 
           k2=kfu(jp2) 
           if(k2.gt.0) then 
            g2=g2+                                                      &
     &         dpm(k1)*cpstor(mk+ic1)*u(k1,k2)*cpstor(mk+ic2)*dpm(k2)   
           end if 
          end do 
         end if 
        end do 
        lpl=kpl(mrs(ltr)+ir) 
        dvpm(lpl)=sqrt(g2) 
       end do   ! lpl (ir)   
      end do    ! ltr 
                                                                        
      return 
      END                                           
                                                                        
      subroutine print(npr,n1,mf,chisq,chi_p) 
      use glbconst, only: maxn,max8,maxsub,maxp,maxpl,maxpf,  &
                          MDBPLFT,maxs,maxthss,nwr
      use comfrm, only: nthpl,np,mp,mco,p,mr,mrs,pl,kpl
      use comths, only: covar,kf
      use comdat, only: b_datset
      use comdas, only: ktheo,istrss,namedata
      use comeff, only: npl,ncol
      implicit none                                                        
      integer   npr,n1,mf
      real      chisq,chi_p,g2
      real(kind=8), dimension(maxpf,maxpf):: AA,BB,CC
      real(kind=4), dimension(maxpf,maxpf):: u       
      real(kind=8), dimension(maxpf):: AY
      real(kind=4), dimension(maxp) :: dpm
      real(kind=4), dimension(maxpl):: dvpm
      integer     , dimension(maxpf):: indx
      integer     , dimension(maxp) :: kfu

     real             :: datx,errx,sym,subspectrum,parray,thfkd  
     integer,parameter:: max4=4*maxn, jdumpl=8*(max4+2)+4*(max4/2)+max4, &
                         idumpl= maxn*180+jdumpl,                        &
                         kdumpl=3*max4+max4*maxsub,                      &
                         ldumpl=MDBPLFT*2-idumpl-kdumpl
    common/plot/parray(idumpl),datx(max4),errx(max4),sym(max4),          &
                subspectrum(max4,maxsub),thfkd(ldumpl)
                                                                        
      character(len=132):: property,name_theo
      character(len=80) :: aform
      character(len=36) :: cft
      character(len=5)  :: ch5
      character(len=1)  :: ch1


      logical   b_le9,b_pr 
      integer   i0,icom,j1,k,i,info,ir,j,klev,ks,kss,length,lpl,  &
                lth,ltr,mm,nth,nthar
!     n1=1 correlation matrix on terminal                               
!     n1=2 parameters (+-errors) and correlation matrix on terminal     
!     n1=3 .............................................on file         
!     n1=4 variable (+-errors) and .....................on file         
                                                                        
      i0=ichar('0') 
      icom=0 
      if(n1.gt.2) icom=1 
      j1=n1 
                                                                        
      do k=1,mp 
       kfu(k)=0 
      end do 
      do k=1,mf 
       kfu(kf(k))=k 
      end do 
                                                                        
      call corerr(mf,chisq,                                             &
     &            covar,dpm,dvpm,u,AA,BB,CC,AY,indx,kfu)             
!      correlation matrix                                               
!      write(6,'(a,4i4)')' print mf,npr,n1=',mf,npr,n1                  
      call window(1) 
      call perrcor(npr,ncol(1),mf,kf,u) 
      if(npr.ne.nwr) call perrcor(nwr,80,mf,kf,u) 
                                                                        
      if(j1.eq.1) goto 100 
                                                                        
!     parameter, errors                                                 
      write(npr,6857) chisq,chi_p 
      write(nwr,'(/,a)')'parameter and errors' 
      do k=1,mf 
       mm=kf(k) 
       aform='(i3,2x,a24,'//np(mm)(25:32)//',1x,a2,'                    &
     &       //np(mm)(25:32)//')'                                       
       if(mm.gt.0) write(nwr,aform)mm,np(mm),p(mm),'+-',dpm(k) 
      end do 
      write(nwr,'(a)') 
                                                                        
!     print results                                                     
!     final printout                                                    
      if(npr.ne.nwr) then 
       write(npr,6857) chisq,chi_p 
 6857  format(1x,/,' chi**2 =',f10.6, 5x,f7.2,                        &
                    ' percent within statistical error')                              
       write(npr,'(/,a,/)')'parameter and errors' 
       do k=1,mf 
        mm=kf(k) 
        aform='(i3,2x,a24,'//np(mm)(25:32)//',1x,a2,'                   &
     &       //np(mm)(25:32)//')'                                       
        if(mm.gt.0) write(npr,aform)mm,np(mm),p(mm),'+-',dpm(k) 
       end do 
       write(npr,'(a)') 
      end if 
                                                                        
                                                                        
      if(j1.le.2) goto 100 
!-----------------------                                                
      do ks=1,maxs 
       nthar=abs(ktheo(ks,0,0)) 
       if(nthar.gt.0) then 
        write(npr,'(/,a,i3)') 'set number ',ks 
        if(ks.le.9) then 
          ch1=char(ks+i0) 
          b_le9=.true. 
        else 
          b_le9=.false. 
          ch1=char(ks-10+i0) 
        end if 
        if(b_datset(ks))write(npr,'(1h ,a)') namedata(ks)(:npl-1) 
        nthar=abs(ktheo(ks,0,0)) 
        nth=ktheo(ks,0,1) 
        lth=ktheo(ks,0,2) 
        call getname(0,nth,lth,property,name_theo) 
        write(npr,'(a,/a)')TRIM(property),TRIM(name_theo) 
        if(nthar.gt.3) then 
         do klev=3,nthar,2 
          nth=ktheo(ks,0,klev) 
          lth=ktheo(ks,0,klev+1) 
          call getname(1,nth,lth,property,name_theo) 
          write(npr,'(5x,a,/,5x,a)')TRIM(property),TRIM(name_theo) 
         end do 
        end if 
        if(icom.eq.1) then 
         i=0 
         do kss=1,maxthss 
          nthar=abs(ktheo(ks,kss,0)) 
          if(nthar.gt.0) then 
           if(istrss(ks,kss).gt.0) then 
            i=i+1 
            nth=ktheo(ks,kss,1) 
            lth=ktheo(ks,kss,2) 
            call getname(1,nth,lth,property,name_theo) 
            write(npr,'(1h ,i2,a2,a)') i,') ',TRIM(name_theo) 
                                                                        
            do klev=3,nthar,2 
             nth=ktheo(ks,kss,klev) 
             lth=ktheo(ks,kss,klev+1) 
             call getname(1,nth,lth,property,name_theo) 
             write(npr,'(5x,a,/,5x,a)')TRIM(property),TRIM(name_theo) 
            end do 
           end if 
          end if 
         end do 
                     ! icom=1                                           
        end if 
!      end if                                                           
!      end do                                                           
                                                                        
!-------------------------                                              
       if(b_le9) then 
        property='p  s'//ch1 
       else 
        property='p  s1'//ch1 
       end if 
       call paident(info,property) 
       call fvadjust(1,length) 
!       write(6,'(a,i4)')' print length=',length                        
                                                                        
       if(j1.ge.4) then 
        write(npr,'(/,a)') '       variable                 value' 
        do ltr=1,mco 
         j=0 
         do ir=1,mr(ltr) 
          lpl=kpl(mrs(ltr)+ir) 
          b_pr=.false. 
          if(b_le9) then 
           if(nthpl(lpl)(1:1).eq.ch1) b_pr=.true. 
          else 
           if(nthpl(lpl)(2:2).eq.ch1) b_pr=.true. 
          end if 
          if(b_pr) then 
           if(j.eq.0) then 
            write(npr,'(a)') 
            j=1 
           end if 
           call identpl(lpl,ch5,length) 
           cft='(i4,1x,a24,1x,'//ch5//')' 
!            write(6,'(a,a40)')' print cft=',cft                        
           g2=dvpm(lpl) 
           if(g2.eq.0.)write(npr,cft) lpl,nthpl(lpl),pl(lpl) 
           if(g2.gt.0.) then 
            cft='(i4,1x,a24,1x,'//ch5//',1x,a2,'//ch5//')' 
            write(npr,cft) lpl,nthpl(lpl),pl(lpl),'+-',g2 
           end if 
                  ! b_pr                                                
          end if 
                  ! lpl (ir)                                            
         end do 
                  ! ltr                                                 
        end do 
       end if 
      end if 
      end do 
  100 continue 
      return 
!     ******************************************************************
      END                                           
                                                                        
      subroutine perrcor(npr,npl,mf,kf,u) 
      dimension u(mf,mf),kf(mf) 
      character(len=36) :: aformat,bformat
      character(len=2)  :: ch2

      kk=npl/7 
      if(mf.le.kk)then 
       mff=mf 
      else 
       mff=kk 
      end if 
      write(npr,'(a)')' error correlations ' 
                                                                        
      i0=ichar('0') 
      i=kk/10 
      j=kk-10*i+i0 
      ch2=char(i+i0)//char(j) 
      aformat='(3x,'//ch2//'i7)' 
      write(npr,aformat) (kf(k),k=1,mff) 
      write(npr,'(i4,25f7.3)') kf(1),(u(1,l),l=1,mff) 
      do k=2,mff 
       i=(k-1)/10 
       j=k-1-10*i+i0 
       ch2=char(i+i0)//char(j) 
       bformat='(i4,'//ch2//'(7x),'//'25f7.3)' 
       write(npr,bformat) kf(k),(u(k,l),l=k,mff) 
      end do 
      if(mf.gt.kk)then 
       mfr=mf-kk 
       if(mfr.gt.kk)then 
        mfr=2*kk 
       else 
        mfr=mf 
       end if 
       write(npr,aformat) (kf(k),k=mff+1,mfr) 
       do k=1,kk 
        write(npr,'(i4,25f7.3)') kf(k),(u(k,l),l=kk+1,mfr) 
       end do 
       write(npr,'(i4,25f7.3)') kf(mff+1),(u(mff+1,l),l=mff+1,mfr) 
       do k=mff+2,mfr 
        i=(k-mff-1)/10 
        j=k-mff-1-10*i+i0 
        ch2=char(i+i0)//char(j) 
        bformat='(i4,'//ch2//'(7x),'//'25f7.3)' 
        write(npr,bformat) kf(k),(u(k,l),l=k,mfr) 
       end do 
      end if 
      return 
      END                                           
                                                                        
      SUBROUTINE LUDCMP(A,N,INDX,D) 
      real*8 A,SUM,DUM,AAMAX,VV,TINY 
      DIMENSION A(N,N),INDX(N),VV(100) 
      PARAMETER (TINY=1.0d-20) 
      D=1. 
      DO  I=1,N 
        AAMAX=0.d0 
        DO J=1,N 
          IF (ABS(A(I,J)).GT.AAMAX) AAMAX=ABS(A(I,J)) 
        END DO
!        IF (AAMAX.EQ.0.) PAUSE 'Singular matrix.'                      
        IF (AAMAX.EQ.0.d0) AAMAX=TINY 
        VV(I)=1./AAMAX 
       END DO 
       DO  J=1,N 
        IF (J.GT.1) THEN 
          DO I=1,J-1 
            SUM=A(I,J) 
            IF (I.GT.1)THEN 
              DO K=1,I-1 
                SUM=SUM-A(I,K)*A(K,J) 
              END DO 
              A(I,J)=SUM 
            END IF 
          END DO
        END IF 
        AAMAX=0. 
        DO  I=J,N 
          SUM=A(I,J) 
          IF (J.GT.1)THEN 
            DO  K=1,J-1 
              SUM=SUM-A(I,K)*A(K,J) 
            END DO
            A(I,J)=SUM 
          END IF 
          DUM=VV(I)*ABS(SUM) 
          IF (DUM.GE.AAMAX) THEN 
            IMAX=I 
            AAMAX=DUM 
          END IF 
        END DO
        IF (J.NE.IMAX)THEN 
          DO  K=1,N 
            DUM=A(IMAX,K) 
            A(IMAX,K)=A(J,K) 
            A(J,K)=DUM 
          END DO
          D=-D 
          VV(IMAX)=VV(J) 
        END IF 
        INDX(J)=IMAX 
        IF(J.NE.N)THEN 
          IF(A(J,J).EQ.0.)A(J,J)=TINY 
          DUM=1./A(J,J) 
          DO  I=J+1,N 
            A(I,J)=A(I,J)*DUM 
          END DO
        ENDIF 
      END DO 
      IF(A(N,N).EQ.0.)A(N,N)=TINY 
      RETURN 
      END                                           
                                                                        
      SUBROUTINE LUBKSB(A,N,INDX,B) 
       real*8 A,B,SUM 
      DIMENSION A(N,N),INDX(N),B(N) 
      II=0 
      DO I=1,N 
        LL=INDX(I) 
        SUM=B(LL) 
        B(LL)=B(I) 
        IF (II.NE.0)THEN 
          DO J=II,I-1 
            SUM=SUM-A(I,J)*B(J) 
          END DO
        ELSE IF (SUM.NE.0.) THEN 
          II=I 
        ENDIF 
        B(I)=SUM 
      END DO 
      DO I=N,1,-1 
        SUM=B(I) 
        IF(I.LT.N)THEN 
          DO J=I+1,N 
            SUM=SUM-A(I,J)*B(J) 
          END DO
        ENDIF 
        B(I)=SUM/A(I,I) 
      END DO 
      RETURN 
      END                                           
                                                                        
      subroutine trf_arrdbl(k,uu,u) 
      real*8 u,uu 
      dimension uu(k),u(k) 
        do j=1,k 
         uu(j)=u(j) 
        end do 
      return 
      END                                           
                                                                        
      subroutine invert(n2,AA,BB,CC,AY,indx) 
                                                                        
      real*8 AA,BB,CC,AY 
      dimension AA(n2,n2),BB(n2,n2),CC(n2,n2),                          &
     &          AY(n2),indx(n2)                                         
       k=n2*n2 
       call trf_arrdbl(k,CC,AA) 
                                                                        
       call LUDCMP(AA,n2,indx,D) 
       DO K=1,n2 
        DO L=1,n2 
         AY(L)=0. 
        end do 
        AY(K)=1. 
        CALL LUBKSB(AA,n2,indx,AY) 
        do J=1,n2 
         BB(K,J)=AY(J) 
        end do 
       end do 
                                                                        
!       write(6,'(a)') ' BB*CC='                                        
!       do i=1,n2                                                       
!       do j=1,n2                                                       
!        h=0.                                                           
!        do k=1,n2                                                      
!          h=h+CC(i,k)*BB(k,j)                                          
!        end do                                                         
!        uu(j)=h                                                        
!       end do                                                          
!       write(6,'(8e10.2)') (uu(kk),kk=1,n2)                            
!       end do                                                          
                                                                        
      return 
      END                                           
