      subroutine calpl(cmch) 
      use glbconst, only: maxtrf,maxprd
      use comfrm, only: p,np,pl,mcl,mco,mpl,mprdn,kcp,kpl,mcs,mc,mrces,    &
                        mr,mrs,kcof,cpstor,ivadd,icadd,con,mconcor
      use comeff, only: contrf
      use comthe, only: vartrf
      implicit none 

      character(len=4):: cmch 
      real     hh,array_tr  
      integer  inf_tr                              
      common/comtr/array_tr(maxtrf),inf_tr(maxprd) 
!     dimension icv(maxco)structure_ks                                  
!     calculation of the pl (theory parameters) from p (fitting paramete
!     by the correlation matrices                                       
      integer  i,ip,j0,j2,j,j1,ii,k,ib_array,ic,ir,mk
                                                                
      j=-2 
   10 j=j+3 
      j0=mprdn(j) 
      if(j0.gt.0) then 
       j1=mprdn(j+1) 
       j2=mprdn(j+2) 
       p(j0)=p(j1)*p(j2)
       goto 10 
      end if 
                                                                        
!     ntr=inf_tr(ii+3)       ! 3 number of the transformation matrix    
!     mtr=inf_tr(ii+5)       ! 5 matrix on which parameters array_tr are
!     ie_array=inf_tr(ii+6)  ! 6 pointer on array_tr                    
!     ib_array=inf_tr(ii+7)  ! 7 pointer on array_tr                    
!     inf_tr(1)=ip-1         ! total number of tr-matrices @v           
!     inf_tr(3)              ! mvpt(kss)+1                              
                                                                        
      if(inf_tr(1).gt.0) then 
       do ip=1,inf_tr(1) 
        ii=4+36*(ip-1) 
                               ! inf_tr(ii+3)                           
                               ! matrix on which parameters array_tr are
        k=inf_tr(ii+5) 
        if(k.gt.0) then 
                               ! pointer on array_tr of transformation m
         ib_array=inf_tr(ii+7) 
         do ic=1,mc(k) 
          j=kcp(mcs(k)+ic) 
          p(j)=array_tr(ib_array+ic) 
         end do 
        end if 
       end do 
      end if 
                                                                        
      if(cmch.eq.'test') then 
       do k=1,mco 
        do ir=1,mr(k) 
         mk=mrces(k)+(ir-1)*mc(k) 
          hh=0. 
         do ic=1,mc(k) 
          j=kcp(mcs(k)+ic) 
          hh=hh+cpstor(mk+ic)*p(j)
         end do
         j=kpl(mrs(k)+ir) 
         pl(j)=hh 
        end do 
       end do 
      else 
       do k=1,mco 
        if(kcof(k).eq.k) then 
         do ir=1,mr(k) 
          mk=mrces(k)+(ir-1)*mc(k) 
          hh=0. 
          do ic=1,mc(k) 
           j=kcp(mcs(k)+ic) 
           hh=hh+cpstor(mk+ic)*p(j) 
           end do 
          j=kpl(mrs(k)+ir) 
          pl(j)=hh 
         end do 
        end if 
       end do 
      end if 
                                                                        
!      do k=1,mco                                                       
!       j=kpl(mrs(k)+1)                                                 
!       write(6,'(a,2i4,f15.4)')'subr k,ivadd(j),pl(j)=',k,ivadd(j),pl(j
!      end do                                                           
                                                                        
                                                                        
!      write(6,'(i4,a,a4)') mpl,' calpl cmch=',cmch                    
!      write(6,'(20i4)') (kpl(i),i=1,mpl)                             
!      write(6,'(a,i3)') 'icadd(i)=',mcl                              
!      write(6,'(20i4)') (icadd(i),i=1,mcl)                           
!      write(6,'(20i4)') (ivadd(i),i=1,mpl)                           
!      write(6,'(20i4)') (ivadd(kpl(i)),i=1,mpl)                       
!      write(6,'(a,a4)') ' calpl cmch pl=',cmch                        
!      write(6,'(8f12.4)') (pl(i),i=1,mpl)                             
      do j=1,mpl 
       i=kpl(j) 
!       if(ivadd(i).eq.0) then                                          
!        write(11,'(2i5,a,10i7)')j,kpl(j), ' calpl ivadd(1..)=',&         
!                             ivadd(kpl(j))               
!       else                                                            
        vartrf(ivadd(i))=pl(i) 
!       end if                                                          
      end do 
      if(cmch.eq.'test') then 
!      write(6,'(2i5,i5)')(j,icadd(j),mconcor(j),j=1,mcl)
       do j=1,mcl 
!       if(icadd(j).eq.0) then                                          
!        write(6,'(a,10i7)')'calpl icadd(1..)=',(icadd(jj),jj=j-3,j)    
!       else                                                            
        contrf(icadd(j))=con(mconcor(j)) 
!       end if                                                          
       end do 
      end if 
      return 
      END                                           
                                                                        
      subroutine panum(chin,max,npanum,nd) 
      use glbconst, only: nwr
      use comeff, only: npl
      implicit none
      integer, intent(in) :: max
      integer, intent(inout):: nd
      character(len=132), intent(in):: chin
      integer,dimension(max+3):: npanum
      character(len=132):: ch132
      character(len=24) :: chl,chr
      character(len=7)  :: form
      integer, dimension(0:32):: mj     
      real,     dimension(32):: out(32)
      real     rn 
      integer  norder,i,i0,ia,ic,il,im,j,jch,jj,jm,jn,          &
           k,ka,kk,n1,n2,mjch,nch,nn,npa
      
      if(max.eq.0.or.nd.eq.1) npanum=0
      ch132=chin
       nch=index(ch132,'(') 
       if(nch.gt.0) then 
        ch132(nch:)=' ' 
        nch=nch+6 
       else 
        nch=npl+6 
        if(npl+1.lt.132) ch132(npl+1:)=' ' 
       end if 
       if(nch.gt.132) nch=132 
                                                                        
       norder=nd 
!       write(6,'(i4,2a)') norder,' ch_panum  ',ch132(1:20)              
!      max = maximal index                                              
!      norder =  1   character is analysed and indices are ordered      
!      norder =  0   zeros are removed                                  
!      norder = -1 , npanum array is already there : label 300          
!                    indices are ordered,                               
!      norder = -2   ch132 contains ordered elements of npanum           
                                                                        
       if(norder.lt.0) goto 300 
       if(index(ch132,'a').gt.0) then 
         do k=1,max 
         npanum(k+2)=k 
        end do 
        npanum(2)=max 
        goto 1000  ! return 
       end if 
                                                                        
       jn=0 
       jm=0 
       i0=ichar('0') 
       j=0 
       jch=0 
       mj(0)=1 
       k=1 
  100  continue 
        if(ch132(k:k).ne.' '.and.ch132(k:k).ne.',') then 
         j=j+1 
         ic=ichar(ch132(k:k))-i0 
         if(ic.lt.10.and.ic.ge.0) then 
           jn=jn+1 
!           write(6,'(i4,4x,a)')jn,ch132(k:k+30)                         
           do i=1,5 
            ic=ichar(ch132(k+i:k+i))-i0 
            if(ic.ge.10.or.ic.lt.0) goto 110 
           end do 
  110      k=k+i-1 
         else 
          if(ch132(k:k).eq.'-') then 
           jch=jch+1 
           mj(jch)=j 
           do i=1,5 
            ic=ichar(ch132(k+i:k+i))-i0 
            if(ic.lt.10.and.ic.ge.0) goto 120 
           end do 
           jm=-1 
  120      k=k+i-1 
          end if 
         end if 
        end if ! ne.nbl, ne.nko       
         if(k.gt.nch-5) goto 200 
         k=k+1 
        goto 100 
  200  continue 
                                                                        
       call trlch(nch,ch132,npa,out) 
       if(jn.gt.32.or.jm.lt.0) then 
        npa=0 
        write(nwr,'(a,/,a,i2,a)') 'the integer b in a-b is missing',   &
     &  'or too many numbers (',jn,' > 32)'                             
       end if 
!       write(6,'(a,2i4,/,a,/,32f8.1)') ' panum ch132=',jn,npa,ch132,out  
        if(npa.eq.0) then 
         do k=2,max
            npanum(k)=0 
         end do 
         goto 1000   ! return     
        end if 
        do k=1,npa 
          nn=out(k) 
          out(k)=abs(nn) 
        end do 
       if(jch.gt.0) then 
        ka=2 
          if(mj(1).gt.2) then 
           ia=0 
           do k=1,mj(1)-2 
             ia=ia+1 
             npanum(ka+ia)=out(k) 
           end do 
           ka=ka+ia 
          end if 
        if(jch.gt.1) then   ! jch> 1  
          do j=1,jch-1 
            if(mj(j)-j.lt.1) then 
             n1=1 
            else 
             n1=out(mj(j)-j) 
            end if 
             n2=out(mj(j)-j+1) 
             if(n2.lt.1) n2=max 
             nn=1 
             if(n2.lt.n1) nn=-1 
           ia=0 
!           write(6,'(a,5i4)')'a subr n1,n2=',n1,n2                     
           do k=n1,n2,nn 
             ia=ia+1 
             npanum(ka+ia)=k 
           end do 
           n1=mj(j)-j+2 
           n2=mj(j+1)-j-2 
!           write(6,'(a,5i4)')'b subr n1,n2=',n1,n2                     
           if(n1.le.n2) then 
           do k=n1,n2 
             ia=ia+1 
             npanum(ka+ia)=out(k) 
           end do 
           end if 
           ka=ka+ia 
          end do 
        end if  !   jch > 1  

         mjch=mj(jch)-jch 
         if (npa.ge.mjch+1.and.mjch.gt.0) then 
             n1=out(mjch) 
             n2=out(mjch+1) 
             if(n2.lt.1) n2=max 
             nn=1 
             if(n2.lt.n1) nn=-1 
           ia=0

!           if(ka+abs(n2-n1).gt.max)then
!            if(nn.gt.0)n2=max-ka-n1
!            if(nn.lt.0)n1=max-ka-n2
!           end if 

           do k=n1,n2,nn 
             ia=ia+1 
             npanum(ka+ia)=k 
           end do 
            n1=mjch+1 
            if(npa.gt.n1) then 
            do k=n1+1,npa 
              ia=ia+1 
              npanum(ka+ia)=out(k) 
            end do 
           end if 
           ka=ka+ia 
         end if 
                                                                        
         if (npa.eq.mjch.and.mjch.gt.0) then 
             n1=out(mjch) 
             n2=max 
           ia=0 
           do k=n1,n2 
             ia=ia+1 
             npanum(ka+ia)=k 
           end do 
           ka=ka+ia 
         end if 
         if (mjch.eq.0) then 
             n1=1 
             n2=out(1) 
           ia=0 
           do k=n1,n2 
             ia=ia+1 
             npanum(ka+ia)=k 
           end do 
           if(npa.gt.1) then 
           do k=2,npa 
             ia=ia+1 
             npanum(ka+ia)=out(k) 
           end do 
           end if 
           ka=ka+ia 
         end if 
         npanum(2)=ka-2  
      else
         npanum(2)=npa   
         do k=1,npa 
          npanum(k+2)=out(k) 
         end do
       end if
       if(npanum(2).gt.max)then
        write(nwr,'(2x,2(i2,a))') npanum(2),' numbers > ',max,      &
                                    ', the members of the list'
        nd=10
        goto 1000
       end if
       do k=1,npanum(2) 
        if(npanum(k+2).gt.max)then
         write(nwr,'(2x,i2,2a,i2)') npanum(k+2),' is not out of the list',&
          ' with numbers le:', max
         nd=10
         goto 1000
        end if  
       end do 
                                                                        
       if(norder.eq.0) then 
        npa=npanum(2)+2 
        npanum(npa+1)=0 
        k=2 
  250   k=k+1 
        jj=0 
        do j=k+1,npa 
         if(npanum(k).eq.npanum(j).or.npanum(k).eq.0)then 
          do kk=j,npa 
           npanum(kk)=npanum(kk+1) 
          end do 
          jj=jj+1 
          npanum(npa)=0 
         end if 
        end do 
        npa=npa-jj 
        if(npa.gt.k+1) goto 250 
        j=npanum(2)+2 
        do while(npanum(j).eq.0) 
         j=j-1 
        end do 
        npanum(2)=j-2 
!        npanum(2)=npa-3                                                
        goto 1000  ! return         
       end if 
                                                                        
  300  npa=npanum(2)+2 
       npanum(npa+1)=0 
       if(npa.ge.3) then 
!       natural order                                                    
        do k=3,npa 
           do kk=k+1,npa 
            if(npanum(k).gt.npanum(kk))then 
                i=npanum(k) 
                npanum(k)=npanum(kk) 
                npanum(kk)=i 
            end if 
           end do 
        end do 
        k=2
     
!       elimination of multiple constants                               
  400   k=k+1 
        if(npanum(k).eq.npanum(k+1))then 
         npa=npa-1 
         do kk=k+1,npa 
          npanum(kk)=npanum(kk+1) 
         end do 
         k=k-1 
         npanum(npa+1)=0 
        end if 
        if(k.lt.npa-1) goto 400 
        npanum(2)=npa-2 
                                                                        
        if(npanum(3).eq.0)then 
         do k=3,npa+1 
           npanum(k)=npanum(k+1) 
         end do 
         npanum(npa+2)=0 
         npanum(2)=npa-3 
        end if 
                                                           
       end if ! npa .gt.3   
!      write(6,'(a,10i4)') 'zer npanum=',(npanum(i),i=1,max+2)             
                                                                        
       if(norder.eq.-2) then 
        ch132=' ' 
        j=2 
        do k=1,npanum(2) 
         kk=npanum(k+2) 
         if(kk.gt.0) then 
          il=log10(float(kk))+2 
         else 
          il=2 
         end if 
         if(j.gt.128) goto 1000 ! return                             
         if(j.gt.128) goto 1000 
          j=j+il 
          rn=il 
          form='i2' 
          call trlnu(form,rn,chr,nn,chl,im) 
          form='i'//chl(1:im) 
          rn=kk 
          call trlnu(form,rn,chr,nn,chl,im) 
          ch132(j:j+il)=chl(1:il) 
         end do 
        end if 
 1000  continue 
!       write(6,'(a,15i4)') 'npanum(1..)=',(npanum(i),i=1,max+2)
       return 
      END                                           

      subroutine seqnum(chin,max,npanum,nd) 
      use glbconst, only: nwr
      use comeff, only: npl
      implicit none
      integer, intent(in) :: max
      integer, intent(inout):: nd
      character(len=132), intent(in):: chin
      integer,dimension(max):: npanum
      character(len=132):: ch132
      character(len=24) :: chl,chr
      character(len=7)  :: form
      integer, dimension(0:32):: mj     
      real,     dimension(32):: out(32)
      real     rn 
      integer  norder,i,i0,ia,ic,il,im,j,jch,jj,jm,jn,          &
           k,ka,kk,n1,n2,mjch,nch,nn,npa
      
      if(max.eq.0.or.nd.eq.1) npanum=0
      ch132=chin
       nch=index(ch132,'(') 
       if(nch.gt.0) then 
        ch132(nch:)=' ' 
        nch=nch+6 
       else 
        nch=npl+6 
        if(npl+1.lt.132) ch132(npl+1:)=' ' 
       end if 
       if(nch.gt.132) nch=132 
                                                                        
       norder=nd 
!       write(6,'(i4,2a)') norder,' ch_panum  ',ch132(1:20)              
!      max = maximal index                                              
!      norder =  1   character is analysed and indices are ordered      
!      norder =  0   zeros are removed                                  
!      norder = -1 , npanum array is already there : label 300          
!                    indices are ordered,                               
!      norder = -2   ch132 contains ordered elements of npanum           
                                                                        
       if(norder.lt.0) goto 300 
       if(index(ch132,'a').gt.0) then 
         do k=1,max 
         npanum(k+2)=k 
        end do 
        npanum(2)=max 
        goto 1000  ! return 
       end if 
                                                                        
       jn=0 
       jm=0 
       i0=ichar('0') 
       j=0 
       jch=0 
       mj(0)=1 
       k=1 
  100  continue 
        if(ch132(k:k).ne.' '.and.ch132(k:k).ne.',') then 
         j=j+1 
         ic=ichar(ch132(k:k))-i0 
         if(ic.lt.10.and.ic.ge.0) then 
           jn=jn+1 
!           write(6,'(i4,4x,a)')jn,ch132(k:k+30)                         
           do i=1,5 
            ic=ichar(ch132(k+i:k+i))-i0 
            if(ic.ge.10.or.ic.lt.0) goto 110 
           end do 
  110      k=k+i-1 
         else 
          if(ch132(k:k).eq.'-') then 
           jch=jch+1 
           mj(jch)=j 
           do i=1,5 
            ic=ichar(ch132(k+i:k+i))-i0 
            if(ic.lt.10.and.ic.ge.0) goto 120 
           end do 
           jm=-1 
  120      k=k+i-1 
          end if 
         end if 
        end if ! ne.nbl, ne.nko       
         if(k.gt.nch-5) goto 200 
         k=k+1 
        goto 100 
  200  continue 
                                                                        
       call trlch(nch,ch132,npa,out) 
       if(jn.gt.32.or.jm.lt.0) then 
        npa=0 
        write(nwr,'(a,/,a,i2,a)') 'the integer b in a-b is missing',   &
     &  'or too many numbers (',jn,' > 32)'                             
       end if 
!       write(6,'(a,2i4,/,a,/,32f8.1)') ' panum ch132=',jn,npa,ch132,out  
        if(npa.eq.0) then 
         do k=2,max
            npanum(k)=0 
         end do 
         goto 1000   ! return     
        end if 
        do k=1,npa 
          nn=out(k) 
          out(k)=abs(nn) 
        end do 
       if(jch.gt.0) then 
        ka=2 
          if(mj(1).gt.2) then 
           ia=0 
           do k=1,mj(1)-2 
             ia=ia+1 
             npanum(ka+ia)=out(k) 
           end do 
           ka=ka+ia 
          end if 
        if(jch.gt.1) then   ! jch> 1  
          do j=1,jch-1 
            if(mj(j)-j.lt.1) then 
             n1=1 
            else 
             n1=out(mj(j)-j) 
            end if 
             n2=out(mj(j)-j+1) 
             if(n2.lt.1) n2=max 
             nn=1 
             if(n2.lt.n1) nn=-1 
           ia=0 
!           write(6,'(a,5i4)')'a subr n1,n2=',n1,n2                     
           do k=n1,n2,nn 
             ia=ia+1 
             npanum(ka+ia)=k 
           end do 
           n1=mj(j)-j+2 
           n2=mj(j+1)-j-2 
!           write(6,'(a,5i4)')'b subr n1,n2=',n1,n2                     
           if(n1.le.n2) then 
           do k=n1,n2 
             ia=ia+1 
             npanum(ka+ia)=out(k) 
           end do 
           end if 
           ka=ka+ia 
          end do 
        end if  !   jch > 1  

         mjch=mj(jch)-jch 
         if (npa.ge.mjch+1.and.mjch.gt.0) then 
             n1=out(mjch) 
             n2=out(mjch+1) 
             if(n2.lt.1) n2=max 
             nn=1 
             if(n2.lt.n1) nn=-1 
           ia=0

!           if(ka+abs(n2-n1).gt.max)then
!            if(nn.gt.0)n2=max-ka-n1
!            if(nn.lt.0)n1=max-ka-n2
!           end if 

           do k=n1,n2,nn 
             ia=ia+1 
             npanum(ka+ia)=k 
           end do 
            n1=mjch+1 
            if(npa.gt.n1) then 
            do k=n1+1,npa 
              ia=ia+1 
              npanum(ka+ia)=out(k) 
            end do 
           end if 
           ka=ka+ia 
         end if 
                                                                        
         if (npa.eq.mjch.and.mjch.gt.0) then 
             n1=out(mjch) 
             n2=max 
           ia=0 
           do k=n1,n2 
             ia=ia+1 
             npanum(ka+ia)=k 
           end do 
           ka=ka+ia 
         end if 
         if (mjch.eq.0) then 
             n1=1 
             n2=out(1) 
           ia=0 
           do k=n1,n2 
             ia=ia+1 
             npanum(ka+ia)=k 
           end do 
           if(npa.gt.1) then 
           do k=2,npa 
             ia=ia+1 
             npanum(ka+ia)=out(k) 
           end do 
           end if 
           ka=ka+ia 
         end if 
         npanum(2)=ka-2  
      else
         npanum(2)=npa   
         do k=1,npa 
          npanum(k+2)=out(k) 
         end do
       end if
       if(npanum(2).gt.max)then
        write(nwr,'(2x,2(i2,a))') npanum(2),' numbers > ',max,      &
                                    ', the members of the list'
        nd=10
        goto 1000
       end if
       do k=1,npanum(2) 
        if(npanum(k+2).gt.max)then
         write(nwr,'(2x,i2,2a,i2)') npanum(k+2),' is not out of the list',&
          ' with numbers le:', max
         nd=10
         goto 1000
        end if  
       end do 
                                                                        
       if(norder.eq.0) then 
        npa=npanum(2)+2 
        npanum(npa+1)=0 
        k=2 
  250   k=k+1 
        jj=0 
        do j=k+1,npa 
         if(npanum(k).eq.npanum(j).or.npanum(k).eq.0)then 
          do kk=j,npa 
           npanum(kk)=npanum(kk+1) 
          end do 
          jj=jj+1 
          npanum(npa)=0 
         end if 
        end do 
        npa=npa-jj 
        if(npa.gt.k+1) goto 250 
        j=npanum(2)+2 
        do while(npanum(j).eq.0) 
         j=j-1 
        end do 
        npanum(2)=j-2 
!        npanum(2)=npa-3                                                
        goto 1000  ! return         
       end if 
                                                                        
  300  npa=npanum(2)+2 
       npanum(npa+1)=0 
       if(npa.ge.3) then 
!      natural order                                                    
        do k=3,npa 
           do kk=k+1,npa 
            if(npanum(k).gt.npanum(kk))then 
                i=npanum(k) 
                npanum(k)=npanum(kk) 
                npanum(kk)=i 
            end if 
           end do 
        end do 
        k=2 
!       elimination of multiple constants                               
  400   k=k+1 
        if(npanum(k).eq.npanum(k+1))then 
         npa=npa-1 
         do kk=k+1,npa 
          npanum(kk)=npanum(kk+1) 
         end do 
         k=k-1 
         npanum(npa+1)=0 
        end if 
        if(k.lt.npa-1) goto 400 
        npanum(2)=npa-2 
                                                                        
        if(npanum(3).eq.0)then 
         do k=3,npa+1 
           npanum(k)=npanum(k+1) 
         end do 
         npanum(npa+2)=0 
         npanum(2)=npa-3 
        end if 
                                    ! npa .gt.3                         
       end if 
!      write(6,'(a,10i4)') 'zer npanum=',(npanum(i),i=1,max+2)             
                                                                        
       if(norder.eq.-2) then 
        ch132=' ' 
        j=2 
        do k=1,npanum(2) 
         kk=npanum(k+2) 
         if(kk.gt.0) then 
          il=log10(float(kk))+2 
         else 
          il=2 
         end if 
         if(j.gt.128) goto 1000 ! return                             
         if(j.gt.128) goto 1000 
          j=j+il 
          rn=il 
          form='i2' 
          call trlnu(form,rn,chr,nn,chl,im) 
          form='i'//chl(1:im) 
          rn=kk 
          call trlnu(form,rn,chr,nn,chl,im) 
          ch132(j:j+il)=chl(1:il) 
         end do 
        end if 
 1000  continue 
!       write(6,'(a,15i4)') 'npanum(1..)=',(npanum(i),i=1,max+2)
       return 
      END                                           
      

      subroutine pameter(ms,mss,numco,icall) 
      use glbconst, only: maxc,maxp,maxthss
      use comfrm, only: mco,mp,mpl,kpl,kcp,mc,mrs,mcs,mrces,            &
                        np,mplths,mplthsp,mplthss,cpstor
      use comscd, only: npanum
      implicit none                                                                        
      integer      ms,mss,numco,icall
      character(len=132):: dummy   
      character(len=24) :: ch24
      character(len=132):: cb10,cf10

      integer       mscr1,mscr2,mscr3,mscr4,k,j0,je,i,ica,ir,is,j,jco,  &
                   k1,k2,kj,knum,l,lb,ls,lf,mkk,mssh,np1,np4,np4k,np1j
 
                                                                  
!     selects parameter numbers of spectrum ms, subspectrum mss         
!     mss=0 only global parameters of the spectrum                      
!     mss=-1 all parameters of the spectrum with all subspectra         
!     the number of the parameters are stored in npanum(3-  )           
!     numco = number of transformation matrix                           
!           = -1 (<=0) all transformation matrices                      
                                                                        
      icall=1 
      mscr1=maxc 
      mscr2=mscr1+maxp 
      mscr3=mscr2+maxc 
      mscr4=mscr3+maxp 
                                                                        
!       write(6,'(a,5i6)') ' pameter(ms,mss,numco),npanum(mscr1+2)=',   
!     & ms,mss,numco,npanum(mscr1+2)                                    
!      jj=npanum(mscr1+2)+2                                             
!      write(6,'(a,20i3)') ' pa_a_mscr1 ',(npanum(mscr1+k),k=1,jj)      
!      write(6,'(a)') ' pa_npanum '
!      write(6,'(20i3)') (npanum(k),k=1,60)             
                                                                        
      if(npanum(mscr1+2).gt.0) then 
       do k=1,mscr1 
         npanum(mscr4+k)=npanum(mscr1+k) 
       end do 
      else 
       npanum(mscr4+2)=0 
      end if 
      if(numco.eq.-2) then 
       if(npanum(2).eq.0.and.npanum(mscr1+2).eq.0) then 
        do k=1,mp 
         npanum(mscr1+k+2)=k 
        end do 
        npanum(mscr1+2)=mp 
       else 
        do k=1,npanum(2)+2 
         npanum(mscr1+k)=npanum(k) 
        end do 
       end if 
       npanum(mscr1+1)=1 
       goto 200 
      end if 

      if(ms.le.0) then 
        j0=1 
        je=mpl 
        goto 50 
      end if 
                                                                        
      mssh=mss 
      if(mss.eq.-1) then 
       mssh=0 
       je=mplths(ms,maxthss)+mplthss(ms,maxthss) 
      else 
       if(mssh.le.maxthss) then 
        je=mplths(ms,0)+mplthsp(ms) 
       end if 
      end if 
                                                                        
      j0=mplths(ms,mssh) 
      if(mssh.gt.0) then 
       je=j0+mplthss(ms,mssh) 
      end if 
       j0=j0+1 
                                                                        
   50 continue 
      knum=mscr1+2 
      do k=1,maxp 
       npanum(mscr1+k)=0 
      end do 
!        write(6,'(a,20i3)') ' mrs(k)=',(mrs(k),k=1,mco)                
!        write(6,'(a,20i3)') ' mr(k)=',(mr(k),k=1,mco)                  
!        write(6,'(a,20i3)') ' mcs(k)=',(mcs(k),k=1,mco)                
!        write(6,'(a,20i3)') ' mc(k)=',(mc(k),k=1,mco)                  
      do kj=j0,je 
       do j=1,mpl 
         if(kj.eq.kpl(j)) goto 100
       end do 
  100  continue 
       jco=0 
       do k=1,mco 
        if(j.gt.mrs(k)) then 
         jco=jco+1 
        end if 
       end do 
       if(numco.gt.0) then 
        if(jco.ne.numco) then 
         goto 110 
        end if 
       end if 
!       write(6,'(a,10i5)') ' j,kpl(j),k,mrs(k),jco=',j,kpl(j),k,mrs(k),jco

        ir=j-mrs(jco) 
        ica=mcs(jco) 
!       write(6,'(a,12i5)')' ica,kcp(ica+i)=',ica,(kcp(ica+i),i=1,mc(jco))

        if(mc(jco).eq.0) goto 110 

        do i=1,mc(jco)
          ch24=np(kcp(ica+i)) 
          is=index(ch24,'*') 
          k=0 
          mkk=mrces(jco)+(ir-1)*mc(jco)+i 
          if(cpstor(mkk).ne.0.0) k=1
          if(k.eq.0.and.is.eq.0) then 
            do l=1,mc(jco) 
              ch24=np(kcp(ica+l)) 
              ls=index(ch24,'*') 
              if(ls.gt.0) then 
               if(ls.ge.10) then 
                cf10=ch24(ls-10:ls-1) 
               else 
                cf10=ch24(:ls-1) 
               end if 
               cb10=ch24(ls+1:) 
               lf=10 
               do while(cf10(lf:lf).eq.' ') 
                lf=lf-1 
               end do 
               lb=10 
               do while(cb10(lb:lb).eq.' ') 
                lb=lb-1 
               end do 
                                                                        
               ch24=np(kcp(ica+i)) 
               k1=index(ch24,cf10(1:lf)) 
               k2=index(ch24,cb10(1:lb)) 
                                                                        
               if(k1.gt.0.or.k2.gt.0) then 
                  mkk=mrces(jco)+(ir-1)*mc(jco)+l 
                  if(cpstor(mkk).ne.0.0) k=1 
               end if 
              end if 
            end do 
          end if 

          if(k.eq.1) then 
           knum=knum+1 
           npanum(knum)=kcp(ica+i) 
          end if 
       end do
       
  110  continue 

      end do 
!      nnn=knum-mscr3-2                                                 
!      write(6,'(a,20i3)') ' pa!npanum ',(npanum(k+mscr3+2),k=1,nnn)    
      npanum(mscr1+2)=knum-mscr1-2 
      npanum(mscr1+1)=1 
!     parameter number of  npanum and (ms,mss,numco)                    
!     array npanum is used: mp <= maxscr/5!!                            
                                                                        
  200 continue 
                                                                        
       np1=npanum(mscr1+2) 
       np4=npanum(mscr4+2) 
                                                                        
       if(np1.eq.0) then 
        if (np4.eq.0) then 
         npanum(2)=1 
         npanum(3)=1 
        else 
         do k=2,np4+2 
          npanum(k)=npanum(mscr4+k) 
         end do 
        end if 
       else 
        if (np4.eq.0) then 
         do k=2,np1+2 
          npanum(k)=npanum(mscr1+k) 
         end do 
        else 
         l=0 
         do j=3,np1+2 
         l=l+1 
         np1j=npanum(mscr1+j) 
         npanum(l+2)=np1j 
                                                                        
         do k=3,np4+2 
          np4k=npanum(mscr4+k) 
          if(np4k.ne.np1j.and.np4k.gt.0) then 
           l=l+1 
           npanum(l+2)=np4k 
           npanum(mscr4+k)=0 
          end if 
         end do 
         end do 
         npanum(2)=l 
        end if 
       end if 
       k=npanum(2)
       i=-1
       call panum(dummy,k,npanum,i) 
       if(i.ne.-1) then
        print'(2a)','error in the list:',TRIM(dummy)
        return
       end if         
       npanum(mscr1+1)=1 
       npanum(1)=1 
       do k=2,npanum(2)+2 
         npanum(mscr1+k)=npanum(k) 
         npanum(k)=0 
       end do 
                                                                        
      return 
      END                                           
                                                                        
      subroutine orderco(kk) 
      use comfrm, only: kcp,cpstor,fpstor,kpl,mp,mpl,mcs,mr,mrces,kcp, &
                        mc,mrs,mrce
      use comscd, only: npanum,kcpst,scratch,fscratch
      implicit none
      integer kk,k,kmc,kmr,i,n,nj,j,mkk,mkki,mkkia,mkkib

        k=mcs(kk) 
        kmc=mc(kk) 
        kmr=mr(kk) 
        do i=1,kmc 
         kcpst(i)=kcp(k+i) 
        end do 
                                                                        
        do i=1,kmc 
         n=mp+1 
         do j=1,kmc 
          if(kcpst(j).lt.n) then 
           nj=j 
           n=kcpst(j) 
          end if 
         end do 
          npanum(i)=nj 
          kcpst(nj)=mp+1 
        end do 
                                                                        
        do i=1,kmc 
         kcpst(i)=kcp(k+i) 
        end do 
        do i=1,kmc 
         kcp(k+i)=kcpst(npanum(i)) 
        end do 
                                                                        
                                                                        
        mkk=mrces(kk) 
        do j=mkk+1,mkk+mrce(kk) 
         scratch(j)=cpstor(j) 
         fscratch(j)=fpstor(j) 
        end do 
                                                                        
        do j=1,kmc 
        do i=1,kmr 
         mkki=mkk+(i-1)*kmc 
         cpstor(mkki+j)=scratch(mkki+npanum(j)) 
         fpstor(mkki+j)=fscratch(mkki+npanum(j)) 
        end do 
        end do 
                                                                        
                                                                        
                                                                        
        k=mrs(kk) 
        do i=1,kmr 
         kcpst(i)=kpl(k+i) 
        end do 
                                                                        
        do i=1,kmr 
         n=mpl+1 
         do j=1,kmr 
          if(kcpst(j).lt.n) then 
           nj=j 
           n=kcpst(j) 
          end if 
         end do 
          npanum(i)=nj 
          kcpst(nj)=mp+1 
        end do 
                                                                        
        do i=1,kmr 
         kcpst(i)=kpl(k+i) 
        end do 
        do i=1,kmr 
         kpl(k+i)=kcpst(npanum(i)) 
        end do 
                                                                        
                                                                        
        mkk=mrces(kk) 
        do j=mkk+1,mkk+mrce(kk) 
         scratch(j)=cpstor(j) 
        end do 
                                                                        
        do i=1,kmr 
         mkkia=mkk+(i-1)*kmc 
         mkkib=mkk+(npanum(i)-1)*kmc 
        do j=1,mc(kk) 
         cpstor(mkkia+j)=scratch(mkkib+j) 
        end do 
        end do 
                                                                        
       return 
      END                                           
                                                                        
      subroutine paident(info,chin) 
      use glbconst, only: maxs,maxc,maxp,maxfr1,maxfr2,maxthss,infotext,nwr
      use comfrm, only: mcl,mco,mp,mc,kp
      use comscd, only: npanum                                                                      
      use comeff, only: npl
      implicit none
      integer info
      character(len=132):: chin,chrt,chst,cp132,ch132 
      character(len=12) :: form
      character(len=4)  :: ch4
      character(len=2)  :: ch2
      character(len=1)  :: ch1

      real out(32)
      integer jss,i0,icall,k,i1,i10,ifr,ifrfi,ih,ii,ij,ip,ipa,ipos,    &
              ir,j,knpl,ms,mscr1,mscr2,mscr3,mscr4,msh,mss,mstruct1,   &
              mstruct2,mstruct3,ncase,nn,ns,numco
                                                                        
      logical ptrue,l_free,l_fix,l_fit 
      integer numstr1(maxfr1),numstr2(maxfr2),numss(maxthss) 

                                                                        
       i0=ichar('0') 
       info=0 
       if(mp.eq.0) then 
        info=3 
        infotext(1)='effi/parameter/selection ' 
        infotext(2)=chin 
        infotext(3)='no parameter and no constants defined yet' 
        infotext(4)=' ' 
        return 
       end if 
                                                                        
       chst=' '//chin 
!      write(6,'(/,a,/,a)') ' input paident=',chst(1:80)                
      mscr1=maxc 
      mscr2=mscr1+maxp 
      mscr3=mscr2+maxc 
      mscr4=mscr3+maxp 
       icall=0 
  406  if(chst(1:2).eq.'he') then 
       info=1 
       infotext(1)='effi/parameter/constant/selection' 
       if(ch1.eq.'p')infotext(1)='effi/parameter/selection ' 
       if(ch1.eq.'c')infotext(1)='effi/constant/selection ' 
       infotext(2)='typed command='//chin 
       infotext(3)=' ' 
       return 
      end if 
                                                                        
!     interpretation of command                                         
                                                                        
      call nextchar(chst,0,ipos,cp132,ip) 
!        write(6,'(a,i4,/,a)') ' paident ip, cp132=',ip,cp132           
      ch1=cp132(1:1) 
      if(ch1.eq.'P')ch1='p' 
      if(ch1.eq.'C')ch1='c' 
                                                                        
      if(ip.eq.0.or.ip.gt.1) then 
       chst='he' 
       goto 406 
      end if 
      ptrue=.false. 
      l_free=.false. 
      l_fix=.false. 
      l_fit=.false. 
      if(ch1.eq.'p')  ptrue=.true. 
                                                                        
                                         ! p,c ...                      
      if(ptrue.or.ch1.eq.'c') then 
       do k=1,mscr1 
        npanum(k)=0 
       end do 
       if(ptrue) then 
        do k=mscr1+1,mscr2 
         npanum(k)=0 
        end do 
       else 
        do k=mscr2+1,mscr3 
         npanum(k)=0 
        end do 
       end if 
                                                                        
       call nextchar(cp132,1,ipos,ch132,ih) 
                                                        ! p,c           
       if(ih.eq.0.or.ch132(1:1).eq.'a') then 
        if(ptrue) then 
         call pameter(-1,-1,0,icall) 
        else 
         call constants(-1,-1,icall) 
        end if 
        goto 500 
       end if 
       ch2=' ' 
       chst=ch2//ch132(1:npl-2) 
       knpl=-1 
       k=1 
                                              ! search for s, ss, m     
  100  k=k+1 
       knpl=knpl+1 
!       write(6,'(a1,a,5i4)')chst(k:k),'=ch1 ; subr paident npl,k,knpl='
!     &             npl,k,knpl                                          
!       write(6,'(a,a)') '//chst=',chst                                 
                                                                        
       if(chst.eq.' '.or.knpl.ge.130) goto 250 
       ch1=chst(k:k) 
                                             ! s                        
       if(ch1.eq.'s'.or.ch1.eq.'S') then 
        ncase=1 
        ch1=chst(k+1:k+1) 
                                             ! ss                       
        if(ch1.eq.'s'.or.ch1.eq.'S') then 
         ch132=chst(k+2:npl) 
         call nextchar(ch132,0,ipos,chrt,ip) 
         call trlch(ip,chrt,nn,out) 
         call nextchar(chrt,ip,ipos,ch132,ih) 
         if(nn.eq.1) then 
            ms=out(1)
            
          if(ms.gt.0.and.ms.le.maxs) then 
           msh=ms 
           call structure_ks(ms,                                        &
     &        mstruct1,numstr1,mstruct2,numstr2,mstruct3,numss)         
           if(ms.eq.-1) then 
            form='(a1,i1,a)' 
            if(msh.gt.9) form='(a1,i2,a)' 
            write(nwr,form) 's',msh,' is not available' 
           end if 
          else 
           ms=-1 
          end if 
         else 
          chrt=chst(1:k-1) 
          chst=chrt(1:k-1)//ch132 
          knpl=knpl+k-1 
          k=1 
          goto 200 
         end if 
         call trlch(ih,ch132,nn,out) 
         if(nn.eq.1) then 
          jss=out(1) 
          if(jss.gt.0) then 
           if(jss.gt.mstruct3) jss=mstruct3 
           mss=numss(jss) 
          else 
           mss=-1 
          end if 
          call nextchar(ch132,ih,ipos,chrt,ir) 
          ch132=chst(1:k-1) 
          chst=ch132(1:k-1)//chrt 
          knpl=knpl+k-1 
          k=1 
         else 
          mss=-1 
         end if 
         if(ptrue) then 
          call pameter(ms,mss,0,icall) 
         else 
          call constants(ms,mss,icall) 
         end if 
         goto 200 
        else 
         chrt=chst(k+1:npl) 
!        write(6,'(2a)')' chrt=',chrt(:30)                              
         call nextchar(chrt,0,ipos,ch132,ih) 
         call nextchar(ch132,ih,ipos,chrt,ir) 
         call trlch(ih,ch132,nn,out) 
         ms=out(1) 
         ns=out(2) 
         if(nn.eq.1) then 
          if(ms.gt.0) then 
           msh=ms 
           call structure_ks(ms,                                        &
     &        mstruct1,numstr1,mstruct2,numstr2,mstruct3,numss)         
           if(ms.eq.-1) then 
            form='(a1,i1,a)' 
            if(msh.gt.9) form='(a1,i2,a)' 
            write(nwr,form) 's',msh,' is not available' 
           end if 
          else 
           ms=-1 
          end if 
          ch132=chst(1:k-1) 
          chst=ch132(1:k-1)//chrt 
          knpl=knpl+k-1 
          k=1 
         else if(nn.eq.2.and.ns.lt.0) then 
          ns=-ns 
          if(ns.lt.ms) then 
           ih=ms 
           ms=ns 
           ns=ih 
          end if 
          do ih=ms,ns 
           i10=ih/10 
           i1=ih-10*i10 
           if(ih.gt.9) then 
            ch4='s'//char(i10+i0)//char(i1+i0) 
           else 
            ch4='s'//char(i1+i0) 
           end if 
           chst(1+(ih-ms)*4:)=ch4 
          end do 
          chst(1+4*(ns-ms+1):)=chrt 
!         write(6,'(2a)')' chst=',chst(:50)                             
          k=1 
         else 
          goto 200 
         end if 
         if(ptrue) then 
          call pameter(ms,-1,0,icall) 
         else 
          call constants(ms,-1,icall) 
         end if 
                                              ! ss                      
        end if 
                                              ! s                       
       end if 
                                                                        
       if(.not.ptrue) goto 200 
                                              ! m                       
       if(ch1.eq.'m'.or.ch1.eq.'M') then 
        chrt=chst(k+1:) 
        call nextchar(chrt,0,ipos,ch132,ih) 
        call nextchar(ch132,ih,ipos,chrt,ir) 
        call trlch(ih,ch132,nn,out) 
!        write(6,'(2i3,2a)')ipos,ir,'  chrt=',chrt                      
        ms=out(1) 
        ns=out(2) 
        if(nn.eq.2.and.ns.lt.0) then 
          ns=-ns 
          if(ns.lt.ms) then 
           ih=ms 
           ms=ns 
           ns=ih 
          end if 
          do ih=ms,ns 
           i10=ih/10 
           i1=ih-10*i10 
           if(ih.gt.9) then 
            ch4='m'//char(i10+i0)//char(i1+i0) 
           else 
            ch4='m'//char(i1+i0) 
           end if 
           chst(1+(ih-ms)*4:)=ch4 
          end do 
          chst(1+4*(ns-ms+1):)=chrt 
!          write(6,'(2a)')' chst=',chst(:40)                            
          k=1 
         else if(nn.eq.1) then 
         numco=out(1) 
         if(numco.le.0) then 
          numco=1 
          chrt(ih:)='1' 
         end if 
         if(numco.gt.mco) numco=mco 
         if(mc(numco).eq.0) then 
          chst=' ' 
          goto 200 
         end if 
         ch132=chst(1:k-1) 
         chst=ch132(1:k-1)//'  '//chrt 
         knpl=knpl+ih+1 
!         write(6,'(i3,2a)')k,'  chst=',chst(1:50)                      
         call pameter(-1,-1,numco,icall) 
        else 
         goto 200 
        end if 
                !                           m                           
       end if 
                                            ! f                         
       if(ch1.eq.'f') then 
        if(chst(k+1:k+1).eq.'r') l_free=.true. 
        if(chst(k+1:k+1).eq.'i') l_fix=.true. 
        if(chst(k+1:k+1).eq.'t') l_fit=.true. 
        chst(k:k+1)='  ' 
                                            ! f                         
       end if 
                                                                        
  200  continue 
                                                ! search for s,ss,m,fi,f
       goto 100 
                                                                        
  250  continue 
!       write(6,'(a,/,a)') ' paident 250 chst=',chst(1:80)              
       if(ptrue) then 
        ih=1
        call panum(chst,mp,npanum,ih) 
        if(ih.ne.1) then
         print'(2a)','error in the list:',TRIM(chst)
         info=ih
         return
        end if         
                                            !  j-k ,i,l                  
!        write(6,'(a)')'subr  (npanum(k),k=3,npanum(2)+2)'              
!        write(6,'(20i4)') (npanum(k),k=3,npanum(2)+2)                  
        call pameter(-1,-1,-2,icall) 
       else 
        ih=1
        call panum(chst,mcl,npanum,ih) 
        if(ih.ne.1) then
         print'(2a)','error in the list:',TRIM(chst)
         info=ih
         return
        end if                                                     !  j-k ,i,l                 
        call constants(-1,-2,icall) 
!        write(6,'(a)')'subr c  (npanum(k+mscr2),k=3,..)'               
!        write(6,'(20i4)') (npanum(k+mscr2),k=3,npanum(2+mscr2)+2)      
       end if 
                                                 ! p,c                  
      end if 
                                                                        
      if(l_free.or.l_fix.or.l_fit) then 
       npanum(mscr1+1)=1 
       ii=mscr1+2 
       ij=npanum(ii) 
       ifr=ii 
       ifrfi=0 
       if(l_free) ifrfi=1 
       if(l_fit) ifrfi=7 
       do j=1,ij 
        ipa=npanum(j+ii) 
        if(kp(ipa).eq.ifrfi) then 
         ifr=ifr+1 
         npanum(ifr)=ipa 
        end if 
       end do 
       npanum(ii)=ifr-ii 
      end if 
                                                                        
  500 if(npanum(mscr1+1)+npanum(mscr2+1).eq.0) then 
         write(nwr,'(a)')                                               &
     &     ' a command line begins with letter p or c '                 
         chst(1:2)='he' 
         goto 406 
       end if 
       if(icall.eq.0) then 
         write(nwr,'(a)') ' no command !' 
         chst(1:2)='he' 
         goto 406 
       end if 
                                                                        
       return 
      END                                           
                                                                        
      subroutine comtrans
      use glbconst, only: maxtrf,maxprd
      use comfrm, only: ncor,mco,mr,mrs,kpl,ivadd
      implicit none
      character(len=8):: ch8 
      real         array_tr
      integer      inf_tr
      common/comtr/array_tr(maxtrf),inf_tr(maxprd) 
      integer  ip,k,i,ii,j,jj,irow  
      ip=1 
      do k=1,mco 
       i=index(ncor(k),'@v') 
                                                                        
       if(i.gt.0) then 
        ii=4+38*(ip-1) 
!       inf_tr(ii+1)=ith      ! 1 theory number set inside theory       
!       inf_tr(ii+2)=icase    ! 1 theory number set inside theory       
        inf_tr(ii+3)=k        ! 2 number of transformation matrix  
        ch8=ncor(k)(i+2:i+3) 
!        write(6,'(a,i2,a2,a,2x,a)')'ncor(',k,')=',ncor(k),ch8          
        call c8toi(ch8,irow) 
                                                                        
        inf_tr(ii+4)=mr(k)    ! 4 rows  of the transformation matrix  
!       mtr=inf_tr(ii+5)      ! 5 matrix on which array_tr is mapped    
!       ie_array=inf_tr(ii+5) ! 6 pointer on array_tr                   
!       ib_array=inf_tr(ii+6) ! 7 pointer on array_tr                   
                                                                        
        jj=mr(k)/irow 
        do j=0,jj-1 
         i=kpl(mrs(k)+j*irow+1) 
         inf_tr(ii+8+j*2)=ivadd(i)  ! up to 16 pointers on vartrf 
        end do 
        ip=ip+1 
       end if 
      end do 
      inf_tr(1)=ip-1             ! total number of tr-matrices @v  
!     inf_tr(2)                  !                                      
!     inf_tr(3)                  ! mvpt(kss)+1                          
!     inf_tr(4)                  !                                      
!     write(6,'(a,10i4)')'subr  inf_tr=',(inf_tr(k),k=1,8)             
      return 
      END                                           
                                                                       
                                                                                   
                                                                        
                                                                                  
