  subroutine information(version,cdate)
      implicit none 
      character(len=12), intent(inout):: cdate
      character(len=8), intent(in):: version
      
      character(len=1)  :: ch1
      character(len=3)  :: month
      character(len=8)  :: ch8
      character(len=16) :: cinet,terminal      
      character(len=132):: workdir,userenv
      character(len=64) :: effihepath,effiutpath,editor,effishell

      character(len=80):: user,logname,date,hostid,host,net,disksize,  &
                          hepath,utpath,term,edt,shell,colfile,effihome
      common/info/user,logname,date,hostid,host,net,disksize,hepath,    &
                  utpath,term,edt,shell,colfile,workdir,effihome,userenv
      logical b_file                                                                  
      character(len=3),dimension(1:13) :: monat=& 
                (/'Jan','Feb','Mar','Apr','May','Jun','Jul','Aug',     & 
                'Sep','Oct','Nov','Dec','Nom'/)
      
      integer  i,i0,ip,il,im,iy,ly,lm
   
      i0=ichar('0')                                                     
                                                                        
      call infouser(cinet)                                              
!      write(6,'(a,a)')'logname   =',logname(:60)                      
!      write(6,'(a,a)')'today     =',date(:60)                         
!      write(6,'(a,a)')'hostid    =',hostid(:60)                       
!      write(6,'(a,a)')'hostname  =',host(:60)                         
!      write(6,'(a,a)')'net       =',net(:60)                          
!      write(6,'(a,a)')'disksize  =',disksize(:60)                     
!      write(6,'(a,a)')'effihepath=',hepath(:60)                       
!      write(6,'(a,a)')'effiutpath=',utpath(:60)                       
!      write(6,'(a,a)')'terminal  =',term(:16)                         
!      write(6,'(a,a)')'editor    =',edt(:16)                          
!      write(6,'(a,a)')'shell     =',shell(:16)                        
!      write(6,'(a,a)')'colfile   =',colfile       
!      write(6,'(a,a)')'utpath    =',utpath      
!      write(6,'(a,a)')'userenv   =',userenv       

      effihepath=hepath(:64)                                            
      effiutpath=utpath(:64)                                            
      effishell=shell(:16)                                              
      terminal=term(:16)                                                
      editor=edt(:16)                                                   
                                                                        
      ch8=date(1:2)                                                     
      call c8toi(ch8,lm)                                                 
      ch8=date(7:8)
      call c8toi(ch8,ly)       

      
      month=cdate(1:3)
      im=1
      do while(month.ne. monat(im))
         im=im+1
      end do
      ch8=cdate(7:8)      
      call c8toi(ch8,iy)
      
      !    comparison cdate with date  na,nx
      il=ly-iy
     if(il.ge.5.and.il.le.6)then
      print'(4(/,a))',' This version is more than 5 years old !',   &
                     ' Web search for the homepage:',                &
                     ' EFFI: simultaneous fitting of spectroscopic data', &
                     ' the homepage 5 years ago: http://nucssp.rmki.kfki.hu/~spiering/' 
      print'(/,a)',' reminder (ret)'
      read(*,*)
     end if
     if(il.gt.10)then
      print'(4(/,a))',' This version is more than 10 years old !',   &
                     ' Web search for the homepage:',                 &
                     ' EFFI: simultaneous fitting of spectroscopic data',&
                     ' the homepage 5 years ago: http://nucssp.rmki.kfki.hu/~spiering/' 
      print'(/,a)',' reminder (ret)'
      read(*,*)  
     end if
                                                                        
    inquire(file='effi',exist=b_file)
    if(b_file) then
     print '(/,a,/,a)','   effi installed','   use a different directory '
      print '(/,11(a,/))',   &
   char(27)//'[1m  Directory of projects'//char(27)//'[0m',                 &
 ' The directory /effi/project has several subdirectories which contain',   &
 ' examples. The data of the examples are stored in /EFFI/xxx/data.',           &
 ' Have a look at the examples.',                                           &
 ' Any directory can be defined for the own projects. The data can, of course,',&
 ' be taken from anywhere.',                                                &
 ' When opening a new command window as a first step the script path  has to be',&
 ' executed. The script requires the environment variable EFFIHOME:',      &    
 '                                          export EFFIHOME=$HOME/abcd/efgh',&
 ' if the directory EFFI is $HOME/abcd/efgh/EFFI.',                         &
 ' (the directory developer should not become muddled).'    
   cdate=' '
    return
  end if
 
  inquire(file='history.txt',exist=b_file)
    
       open(unit=4,file='history.txt'                                   &
                 ,status='unknown'                                      &
                 ,access='sequential'                                   &
                 ,form='formatted'                                      &
                 ,err=71)
    goto 70
   71  continue 
    print '(a)', 'fatal error** history.txt file could not be opened'
    cdate=' '
    return
70  continue
       ch1=char(0)
       write(4,'(a,a)')'version: ',version                     
       write(4,'(a,a)')'installed: ',cdate
       i=60
       do while(term(i:i).eq.ch1)
          i=i-1
       end do
       il=60
       do while(shell(il:il).eq.ch1)
          il=il-1
       end do
       ip=60
       do while(host(ip:ip).eq.ch1)
          ip=ip-1
       end do
       write(4,'(a,4x,a,4x,a)')  term(:i),shell(:il),host(:ip)
       im=60
       do while(date(im:im).eq.ch1)
          im=im-1
       end do
       write(4,'(a)')'history started: '//date(11:im)
       close(unit=4)
      return                                                            
    END subroutine information


