     program grouptheory 
     implicit none
     integer,parameter :: maxco=64
     character(len=132):: queryar,helpar,type,chstr,deffile,                        &
                          querytype,chin,chcom,ch132
     character(len=16) :: ext,winfile
     character(len=80) :: localhepath,chdf
     character          ch0*1,ch1*1,ch2*2,cg2*2   
      integer           ld,lw,laenge,lpart
      common/localpath/ localhepath 
      common/scrd/ queryar(maxco),helpar(maxco),ext(maxco),type(maxco),&
                   ld(maxco),lw(maxco),laenge(maxco),lpart(0:maxco)
     CHARACTER(len=6),dimension(1:24):: namc4,namc3,elnam 

      real     mat(3,3,24),h33(3,3),vect(3),                           &
               matc3(3,3,24),matc4(3,3,24),                            &
               tritra(3,3),trivec(3),                                  &
               rotaxis(3,24),rotatri(3,24)                                 
     integer   lm(24,24),ndg(24),nc2y(2),indx(576),nsu(24),            &
               nsuold(24),nsucom(24),ncoset(24)                        
     real      theta(24),phi(24),omega(24),                            &
               alpha(24),beta(24),gamma(24),dindx(576)                           

     logical   b_write 
     character filetype*32,prompt*4,form*7,chbold*6,chnorm*6                                  
     real      out(32),arcos, &
               alowlimit,uplimit,h,rad,pi,sq3,sq2,value 
     integer   mch(132),lj(577),iprd(24,24),inv(24)
     integer   readaline,nrd,nwr,icol,lou,                             &
               i,i0,ii,j,j1,j2,jj,jn,jsu,k,kk,kwin,l,lc,len,lg,lk,     &
               ll,llc,lq,m,mm,nh,n,nj,nj2,nn,mg,ng,ngold,              &
               id1,npl,ncol,nrows,ixpixel,iypixel,led   

     common/term/id1,npl,ncol(8),nrows(8),ixpixel(8),iypixel(8),       &
                 winfile,led                                                                       
                                                                       
       localhepath='/Octahedral_tr.help' 
       lou=3 
       nwr=6 
       nrd=5 
       icol=79 
       kwin=1 
       call window(kwin) 
       npl=ncol(kwin) 
       chbold=char(27)//'[1m' 
       chnorm=char(27)//'[0m' 
                                                                        
       pi=4.0*atan(1.0) 
       rad=pi/180.0 
       i0=ichar('0') 
                                                                        
                                                                        
    1  len=7 
       deffile='group.dat' 
       filetype='for_the_record' 
       ext='dat' 
       chcom='results' 
       call readfile(filetype,deffile,ext,len,chcom,icol,nrd,nwr) 
       if(len.eq.0)goto 1 
                                                                        
       OPEN(UNIT=lou,FILE=deffile,FORM='FORMATTED',                     &
     &                STATUS='unknown')                                 
                                                                        
         pi=atan(1.)*4. 
!    vector in center of gravity in the 1/48-part of the sphere         
         sq3=1./sqrt(3.) 
         sq2=1./sqrt(2.) 
                                                                        
         vect(1)=sq2+sq3 
         vect(2)=sq3 
         vect(3)=1.+vect(1) 
         h=0. 
         do i=1,3 
          h=h+vect(i)**2 
         end do 
         h=sqrt(h) 
         do i=1,3 
          vect(i)=vect(i)/h 
         end do 
!         vect(1)=0.                                                    
!         vect(2)=0.                                                    
!         vect(3)=1.                                                    
                                                                        
                                                                        
           do i=1,3 
            h=0. 
            do j=1,3 
             h=h+tritra(j,i)*vect(j) 
            end do 
            trivec(i)=h 
           end do 
                                                                        
                                                                        
          ng=2 
          do k=1,ng 
           ndg(k)=nc2y(k) 
          end do 
                                                                        
!        Matrixdarstellung der 24 Gruppenelemente von O                 
!        C4-Achse  = z-Achse                                            
         sq2=sqrt(2.) 
         sq3=sqrt(3.) 
                                                                        
         do k=1,24 
          do i=1,3 
          do j=1,3 
           matc4(i,j,k)=0.0 
          end do 
           rotaxis(i,k)=0. 
          end do 
         end do 
                                                                        
!        1-Elememt                                                      
          namc4(1)='E     ' 
          namc3(1)='E     ' 
          do i=1,3 
           matc4(i,i,1)=1.0 
           rotaxis(i,1)=0. 
          end do 
          omega(1)=0 
!  2       c4-rotation z-axis                                           
          namc4(2)='C4z   ' 
                                 ! in the XZ plane                      
          namc3(2)='C4zXZ ' 
          rotaxis(3,2)=1. 
          omega(2)=90 
          matc4(1,2,2)=-1. 
          matc4(2,1,2)=1. 
          matc4(3,3,2)=1. 
!  3       c4**2                                                        
          namc4(3)='C4z*  ' 
          namc3(3)='C4zXZ* ' 
          rotaxis(3,3)=1. 
          omega(3)=180 
          matc4(1,1,3)=-1. 
          matc4(2,2,3)=-1. 
          matc4(3,3,3)=1. 
!  4       c4**3                                                        
          namc4(4)='C4z** ' 
          namc3(4)='C4zXZ**' 
          rotaxis(3,4)=1. 
          omega(4)=270 
          matc4(1,2,4)=1. 
          matc4(2,1,4)=-1. 
          matc4(3,3,4)=1. 
!  5       c4-rotation x-axis                                           
          namc4(5)='C4x   ' 
                                  ! in the Yx plane                     
          namc3(5)='C4xYx ' 
          rotaxis(1,5)=1. 
          omega(5)=90 
          matc4(1,1,5)=1. 
          matc4(2,3,5)=-1. 
          matc4(3,2,5)=1. 
!  6       c4**2                                                        
          namc4(6)='C4x*  ' 
          namc3(6)='C4xYx*' 
          rotaxis(1,6)=1. 
          omega(6)=180 
          matc4(1,1,6)=1. 
          matc4(2,2,6)=-1. 
          matc4(3,3,6)=-1. 
!  7       c4**3                                                        
          namc4(7)='C4x** ' 
          namc3(7)='C4xYx**' 
          rotaxis(1,7)=1. 
          omega(7)=270 
          matc4(1,1,7)=1. 
          matc4(2,3,7)=1. 
          matc4(3,2,7)=-1. 
!  8       c4-rotation y-axis                                           
          namc4(8)='C4y   ' 
                                     ! in the Yx plane                  
          namc3(8)='C4yYx ' 
          rotaxis(2,8)=1. 
          omega(8)=90 
          matc4(1,3,8)=1. 
          matc4(2,2,8)=1. 
          matc4(3,1,8)=-1. 
!  9       c4**2                                                        
          namc4(9)='C4y*  ' 
          namc3(9)='C4yYx*' 
          rotaxis(2,9)=1. 
          omega(9)=180 
          matc4(1,1,9)=-1. 
          matc4(2,2,9)=1. 
          matc4(3,3,9)=-1. 
!  10      c4**3                                                        
          namc4(10)='C4y** ' 
          namc3(10)='C4yYx**' 
          rotaxis(2,10)=1. 
          omega(10)=90 
          matc4(1,3,10)=-1. 
          matc4(2,2,10)=1. 
          matc4(3,1,10)=1. 
!  11      c2-rotation c2xy                                             
          namc4(11)='C2xy  ' 
                                       ! in the XZ plane                
          namc3(11)='C2xyXZ ' 
          rotaxis(1,11)=1./sq2 
          rotaxis(2,11)=1./sq2 
          omega(11)=180 
          matc4(1,2,11)=1. 
          matc4(2,1,11)=1. 
          matc4(3,3,11)=-1. 
!  12      c2-rotation c2-xy                                            
          namc4(12)='C2-xy ' 
          namc3(12)='C2Y   ' 
          rotaxis(1,12)=-1./sq2 
          rotaxis(2,12)=1./sq2 
          omega(12)=180 
          matc4(1,2,12)=-1. 
          matc4(2,1,12)=-1. 
          matc4(3,3,12)=-1. 
!  13      c2-rotation c2xz                                             
          namc4(13)='C2xz  ' 
          namc3(13)='C2xz ' 
          rotaxis(1,13)=1./sq2 
          rotaxis(3,13)=1./sq2 
          omega(13)=180 
          matc4(1,3,13)=1. 
          matc4(2,2,13)=-1. 
          matc4(3,1,13)=1. 
!  14      c2-rotation c2-xz                                            
          namc4(14)='C2-xz ' 
          namc3(14)='C2-xz ' 
          rotaxis(1,14)=-1./sq2 
          rotaxis(3,14)=1./sq2 
          omega(14)=180 
          matc4(1,3,14)=-1. 
          matc4(2,2,14)=-1. 
          matc4(3,1,14)=-1. 
!  15      c2-rotation c2yz                                             
          namc4(15)='C2yz  ' 
          namc3(15)='C2yz ' 
          rotaxis(2,15)=1./sq2 
          rotaxis(3,15)=1./sq2 
          omega(15)=180 
          matc4(1,1,15)=-1. 
          matc4(2,3,15)=1. 
          matc4(3,2,15)=1. 
!  16      c2-rotation c2-yz                                            
          namc4(16)='C2-yz ' 
          namc3(16)='C2-yz ' 
          rotaxis(2,16)=-1./sq2 
          rotaxis(3,16)=1./sq2 
          omega(16)=180 
          matc4(1,1,16)=-1. 
          matc4(2,3,16)=-1. 
          matc4(3,2,16)=-1. 
!  17      c3-rotation {1,1,1}                                          
          namc4(17)='C3111 ' 
          namc3(17)='C3Z   ' 
          rotaxis(1,17)=1./sq3 
          rotaxis(2,17)=1./sq3 
          rotaxis(3,17)=1./sq3 
          omega(17)=120 
          matc4(1,3,17)=1. 
          matc4(2,1,17)=1. 
          matc4(3,2,17)=1. 
!  18      c3**2                                                        
          namc4(18)='C3111*' 
          namc3(18)='C3Z*  ' 
          rotaxis(1,18)=1./sq3 
          rotaxis(2,18)=1./sq3 
          rotaxis(3,18)=1./sq3 
          omega(18)=240 
          matc4(1,2,18)=1. 
          matc4(2,3,18)=1. 
          matc4(3,1,18)=1. 
!  19      c3-rotation {-1,1,1}                                         
          namc4(19)='C3-11 ' 
                                     ! in the Yz plane                  
          namc3(19)='C3Yz ' 
          rotaxis(1,19)=-1./sq3 
          rotaxis(2,19)=1./sq3 
          rotaxis(3,19)=1./sq3 
          omega(19)=120 
          matc4(1,2,19)=-1. 
          matc4(2,3,19)=1. 
          matc4(3,1,19)=-1. 
!  20      c3**2                                                        
          namc4(20)='C3-11*' 
          namc3(20)='C3Yz*' 
          rotaxis(1,20)=-1./sq3 
          rotaxis(2,20)=1./sq3 
          rotaxis(3,20)=1./sq3 
          omega(20)=240 
          matc4(1,3,20)=-1. 
          matc4(2,1,20)=-1. 
          matc4(3,2,20)=1. 
!  21      c3-rotation {1,-1,1}                                         
          namc4(21)='C31-1 ' 
                                     ! in the z-Y plane                 
          namc3(21)='C3z-Y ' 
          rotaxis(1,21)=1./sq3 
          rotaxis(2,21)=-1./sq3 
          rotaxis(3,21)=1./sq3 
          omega(21)=120 
          matc4(1,2,21)=-1. 
          matc4(2,3,21)=-1. 
          matc4(3,1,21)=1. 
!  22      c3**2                                                        
          namc4(22)='C31-1*' 
          namc3(22)='C3z-Y*' 
          rotaxis(1,22)=1./sq3 
          rotaxis(2,22)=-1./sq3 
          rotaxis(3,22)=1./sq3 
          omega(22)=240 
          matc4(1,3,22)=1. 
          matc4(2,1,22)=-1. 
          matc4(3,2,22)=-1. 
!  23      c3-rotation {-1,-1,1}                                        
          namc4(23)='C3--1 ' 
          namc3(23)='C3Zz  ' 
          rotaxis(1,23)=-1./sq3 
          rotaxis(2,23)=-1./sq3 
          rotaxis(3,23)=1./sq3 
          omega(23)=120 
          matc4(1,3,23)=-1. 
          matc4(2,1,23)=1. 
          matc4(3,2,23)=-1. 
!  24      c3**2                                                        
          namc4(24)='C3--1*' 
                                      ! in the Zz plane                 
          namc3(24)='C3Zz* ' 
          rotaxis(1,24)=-1./sq3 
          rotaxis(2,24)=-1./sq3 
          rotaxis(3,24)=1./sq3 
          omega(24)=240 
          matc4(1,2,24)=1. 
          matc4(2,3,24)=-1. 
          matc4(3,1,24)=-1. 
                                                                        
!        transformation of the matrices to the coordinate system z={1,1,
         sq3=1./sqrt(3.) 
         sq2=1./sqrt(2.) 
                                                                        
         tritra(1,1)=sq2*sq3 
         tritra(1,2)=-sq2 
         tritra(1,3)=sq3 
         tritra(2,1)=sq2*sq3 
         tritra(2,2)=sq2 
         tritra(2,3)=sq3 
         tritra(3,1)=-sq3/sq2 
         tritra(3,2)=0. 
         tritra(3,3)=sq3 
                                                                        
         do l=1,24 
           do i=1,3 
           do j=1,3 
            h=0. 
            do k=1,3 
            do kk=1,3 
             h=h+tritra(k,i)*matc4(k,kk,l)*tritra(kk,j) 
            end do 
            end do 
            matc3(i,j,l)=h 
           end do 
           end do 
         end do 
!        calculation of all rotation axis with z|| {1,1,1}              
         do l=1,24 
           do i=1,3 
            h=0. 
            do j=1,3 
             h=h+tritra(j,i)*rotaxis(j,l) 
            end do 
            rotatri(i,l)=h 
           end do 
         end do 
!--------------------                                                   
         write(nwr,'(//,2a,/2a,/)')                                     &
     &  ' The octaeder group O is mapped on 3x3 rotation matrices.',    &
     &  ' The group table',                                             &
     &  ' of the 24 elements (they have different names',               &
     &  ' depending on the PAS):'                                       
         write(nwr,'(a6,24i3,/)') '  x   ',(m,m=1,24) 
        ng=24 
        do l=1,24 
         lg=l 
         do mg=1,24 
          do i=1,3 
          do j=1,3 
          h=0. 
           do k=1,3 
            h=h+matc4(i,k,lg)*matc4(k,j,mg) 
           end do 
           h33(i,j)=h 
          end do 
          end do 
                                                                        
!         identification of h33                                         
                                                                        
          do mm=1,24 
           h=0 
           do ii=1,3 
           do jj=1,3 
              h=h+ abs(h33(ii,jj)-matc4(ii,jj,mm)) 
           end do 
           end do 
           if(h.lt.1.e-3) then 
            iprd(lg,mg)=mm 
            goto 5 
           end if 
          end do 
    5     continue 
                  ! m                                                   
         end do 
                                                                        
         write(nwr,'(i3,3x,24i3)') lg,(iprd(lg,m),m=1,24) 
         do mm=1,24 
           h=0 
           do ii=1,3 
           do jj=1,3 
              h=h+ abs(matc4(jj,ii,l)-matc4(ii,jj,mm)) 
           end do 
           end do 
           if(h.lt.1.e-3) then 
            inv(l)=mm 
            goto 6 
           end if 
         end do 
    6    continue 
                 ! l                                                    
        end do 
        write(nwr,'(/,a)')' the list of invers of the elements' 
        write(nwr,'(6x,24i3)') (inv(m),m=1,24) 
        write(nwr,'(a,/)') 
!---------------------------------------------------------------        
!        U2 (11,...,16)                                                 
!        C2 ( 3,6,9)                                                    
!        C3 (17,18; 19,20; 21,22; 23,24)                                
!        C4 ( 1  2  3  4;   1  5  6  7;   1  8  9 10)                   
!        U4 ( 1  3 11 12; ---                                           
!        D3 ( 1 12 14 16 17 18;  1 11 13 16 19 20;                      
!             1 12 13 15 23 24;  1 11 14 15 21 22)                      
!        D4 ( 1  2  3  4  6  9 11 12;   1  3  6  8  9 10 13 14;         
!             1  3  5  6  7  9 15 16)                                   
!         T ( 1  3  6  9 17 18 19 20 21 22 23 24)                       
! ---------------------------------------------------------------       
        do l=1,24 
         do m=1,24 
           j=iprd(m,l) 
           dindx(m)=float(iprd(j,inv(m))) 
         end do 
         call INDEXX(24,dindx,indx) 
         do j=1,24 
          lj(j)=dindx(indx(j)) 
         end do 
         lj(25)=0 
         jsu=24 
         ng=1 
         m=1 
         do while(m.le.jsu) 
          nsu(ng)=lj(m) 
          do while(lj(m).eq.lj(m+1)) 
           m=m+1 
          end do 
          ng=ng+1 
          m=m+1 
         end do 
         ng=ng-1 
!         write(nwr,'(6x,24i3)') (nsu(m),m=1,ng)                        
        end do 
!--------------------                                                   
   15  continue 
       lq=2 
       lk=lq 
       do k=1,lq 
        ext(k)=' ' 
       end do 
       chdf='Principal' 
       chdf(80:80)='#' 
       chin='defined with respect to 2 coordinate systems ' 
       helpar(1)='PASC4' 
       helpar(2)='PASC3' 
       queryar(1)='Principal Axes System z-axis || C4' 
       queryar(2)='Principal Axes System z-axis || C3' 
       call query(lq,lk,chin,chdf) 
       if(lq.eq.1) ch2='C4' 
       if(lq.eq.2) ch2='C3' 
                                                                        
       if(lq.eq.1) then 
        do l=1,24 
          do i=1,3 
          do j=1,3 
           mat(i,j,l)=matc4(i,j,l) 
          end do 
          end do 
          elnam(l)=namc4(l) 
        end do 
                                                                        
        theta(1)=0. 
        phi(1)=0. 
        do l=2,24 
         theta(l)=arcos(rotaxis(3,l)) 
         h=1.0-rotaxis(3,l)**2 
         if(h.le.0.0) then 
          phi(l)=0.0 
         else 
          h=sqrt(h) 
          phi(l)=arcos(rotaxis(1,l)/h) 
          if(rotaxis(2,l).lt.0) phi(l)=2.0*pi-phi(l) 
         end if 
         call eulerangle(theta(l),phi(l),omega(l),                      &
     &                  alpha(l),beta(l),gamma(l))                      
        end do 
        write(lou,'(/,a,/)')                                            &
     &        ' z-axis parallel C4'                                     
        write(lou,'(/,10x,a,a,/)')'    rot-axes(x,y,z)        theta',   &
     &  '   phi  omega        euler angle'                              
        do l=1,24 
         write(lou,'(i2,1x,a,1x,3(a1,f6.3),a4,2(f7.2),a1,i5,a4,         &
     &       3(f6.1),a1)')                                              &
     &    l,elnam(l),                                                   &
     &   '(',rotaxis(1,l),',',rotaxis(2,l),',',rotaxis(3,l),')  (',     &
     &    theta(l)/rad,phi(l)/rad,',',int(omega(l)),')  (',             &
     &    alpha(l),beta(l),gamma(l),')'                                 
        end do 
                                                                        
       else if(lq.eq.2)then 
                                                                        
        ii=ii+1 
        do l=1,24 
          do i=1,3 
          do j=1,3 
           mat(i,j,l)=matc3(i,j,l) 
          end do 
          end do 
          elnam(l)=namc3(l) 
        end do 
                                                                        
        theta(1)=0. 
        phi(1)=0. 
        do l=2,24 
         theta(l)=arcos(rotatri(3,l)) 
         h=1.0-rotatri(3,l)**2 
         if(h.le.0.0) then 
          phi(l)=0.0 
         else 
          h=sqrt(h) 
          phi(l)=arcos(rotatri(1,l)/h) 
          if(rotatri(2,l).lt.0) phi(l)=2.0*pi-phi(l) 
         end if 
         call eulerangle(theta(l),phi(l),omega(l),                      &
                        alpha(l),beta(l),gamma(l))                      
        end do 
                                                                        
        write(lou,'(/,a,/)')                                            &
              ' z-axis parallel C3'                                     
        write(lou,'(/,10x,a,a,/)')'    rot-axes(x,y,z)        theta',   &
        '   phi  omega        euler angle'                              
        do l=1,24 
         write(lou,                                                     &
         '(i2,1x,a,1x,3(a1,f6.3),a4,2(f7.2),a1,i5,a4,3(f6.1),a1)')      &
          l,elnam(l),                                                   &
         '(',rotatri(1,l),',',rotatri(2,l),',',rotatri(3,l),')  (',     &
          theta(l)/rad,phi(l)/rad,',',int(omega(l)),')  (',             &
          alpha(l),beta(l),gamma(l),')'                                 
        end do 
       else 
        goto 15 
       end if 
                                                                        
                                                                        
       ng=1 
       write(nwr,'(/,a,/)') ' Generation of subgroups of group O:' 
       do i=1,4 
        j1=(i-1)*6+1 
        j2=j1+5 
        write(nwr,'(6(i3,x,a,3x))') (j,elnam(j),j=j1,j2) 
       end do 
    9  write(nwr,'(/,a)')                                               &
     &' selection of one or several elements of O (2-24):'              
       ch0=char(0) 
       chstr='3 6 9' 
       call addhist(chstr(1:5)//ch0) 
       ch132=' ' 
       prompt='>'//ch0 
       i=readaline(mch,prompt) 
       if(i.gt.0) then 
        do j=1,i 
         ch132(j:j)=char(mch(j)) 
        end do 
        call addhist(ch132(:i)//ch0) 
       end if 
       call trlch(npl,ch132,nn,out) 
                                                                        
       j=ng 
       if(nn.eq.0) goto 9 
        do i=1,nn 
         k=out(i) 
!         if(nn.eq.1.and.k.eq.1) goto 9                                 
         if(k.gt.0.and.k.le.24) then 
          nsu(j)=k 
          j=j+1 
         end if 
        end do 
!       end if                                                          
       ng=j-1 
                                                                        
!     verschiedene Elemente werden auf nsuold geschrieben               
      jj=0 
      do j=1,ng-1 
!        do i=j+1,ng                                                    
        i=j 
   12   continue 
        i=i+1 
          if(nsu(j).eq.nsu(i).and.nsu(i).gt.0) then 
           jj=jj+1 
           do k=i,ng-1 
            nsu(k)=nsu(k+1) 
           end do 
           i=i-1 
           nsu(ng)=0 
          end if 
        if(i.lt.ng) goto 12 
      end do 
      ng=ng-jj 
      b_write=.true. 
                                                                        
                                                                        
                                                                        
   11 continue 
!      write(6,'(a,24i3)')'11 nsu=',(nsu(k),k=1,ng)                     
      do j=1,ng 
       nsuold(j)=nsu(j) 
       dindx(j)=float(nsu(j)) 
      end do 
      ngold=ng 
      jsu=ng 
      do l=1,ng 
       lg=nsu(l) 
       do m=1,ng 
        mg=nsu(m) 
        jsu=jsu+1 
        dindx(jsu)=float(iprd(lg,mg)) 
                ! m                                                     
       end do 
                ! l                                                     
       end do 
       call INDEXX(jsu,dindx,indx) 
                                                                        
       do m=1,jsu 
        lj(m)=dindx(indx(m)) 
       end do 
       lj(jsu+1)=0 
                                                                        
       ng=1 
       m=1 
       do while(m.le.jsu) 
        nsu(ng)=lj(m) 
        do while(lj(m).eq.lj(m+1)) 
         m=m+1 
        end do 
        ng=ng+1 
        m=m+1 
       end do 
       ng=ng-1 
                                                                        
       if(b_write)then 
        write(nwr,'(i3,a)')ng,' generated elements e(i)*e(k):' 
        jn=ng/6 
        nj2=ng-1-jn*6 
        do i=1,jn+1 
         j1=(i-1)*6+1 
         j2=j1+5 
         if(i.eq.jn+1) j2=j1+nj2 
         write(nwr,'(6(i3,x,a,3x))') (nsu(j),elnam(nsu(j)),j=j1,j2) 
        end do 
       end if 
                                                                        
!      Vergleich mit urspruenglicher Menge                              
       if(ng.eq.ngold) then 
                                                                        
!        U2 (11,...,16)                                                 
!        C2 (3,6,9)                                                     
!        C3 (17,18; 19,20; 21,22; 23,24)                                
!        C4 ( 1  2  3  4;   1  5  6  7;   1  8  9 10)                   
!        U4                                                             
!        D3 ( 1 12 14 16 17 18;  1 11 13 16 19 20;                      
!             1 12 13 15 23 24;  1 11 14 15 21 22)                      
!        D4 ( 1  2  3  4  6  9 11 12;   1  3  6  8  9 10 13 14;         
!             1  3  5  6  7  9 15 16)                                   
!         T ( 1  3  6  9 17 18 19 20 21 22 23 24)                       
        if(ng.eq.2)then 
         if(nsu(2).le.9)then 
          cg2='C2' 
         else 
          cg2='U2' 
         end if 
        else if(ng.eq.3)then 
          cg2='C3' 
        else if(ng.eq.4)then 
         if(nsu(2).eq.2.or.nsu(2).eq.5.or.nsu(2).eq.8)then 
          cg2='C4' 
         else 
          cg2='D2' 
         end if 
        else if(ng.eq.6)then 
         cg2='D3' 
        else if(ng.eq.8)then 
         cg2='D4' 
        else if(ng.eq.12)then 
         write(nwr,'(/,a6,a)')chbold,'subset is the T-subgroup'//chnorm 
         write(lou,'(//,a)')'       T-subgroup of O' 
        end if 
        if(ng.lt.12) then 
         write(nwr,'(/,a6,a)')                                          &
     &     chbold,'subset is a '//cg2//'-subgroup'//chnorm              
         write(lou,'(//,a)')'       a '//cg2//'-subgroup of O' 
        end if 
         write(lou,'(a)') '                 Euler angle' 
        jn=ng/6 
        nj2=ng-1-jn*6 
        do i=1,jn+1 
         j1=(i-1)*6+1 
         j2=j1+5 
         if(i.eq.jn+1) j2=j1+nj2 
                                                                        
!         write(nwr,'(12(i3,x,a,3x,3(a1,f7.3),a1,/))')                  
!     &   (nsu(j),elnam(nsu(j)),                                        
!     & '(',alpha(nsu(j)),',',beta(nsu(j)),',',gamma(nsu(j)),')',j=j1,j2
!         write(nwr,'(1x,a1,a3)') char(27),'[2A'                        
                                                                        
         write(lou,'(12(i3,x,a,3x,3(a1,f7.3),a1,/))')                   &
     &   (nsu(j),elnam(nsu(j)),                                         &
     & '(',alpha(nsu(j)),',',beta(nsu(j)),',',gamma(nsu(j)),')',j=j1,j2)
                                                                        
        end do 
       end if 
                                                                        
       if(ng.eq.24) then 
        ch1='n' 
        chcom='new set' 
        querytype='trivial subgroup {U=O}: restart' 
        call yesno(querytype,ch1,chcom,icol,nrd,nwr) 
        if(ch1.eq.'n'.or.ch1.eq.'N') goto 200 
        ng=1 
        goto 9 
       end if 
                                                                        
       if(.not.b_write) b_write=.true. 
                                                                        
  109  write(nwr,'(/,a)')                                               &
     & ' selection of further elements (index 2-24):'                   
       ch132=' ' 
       prompt='>'//ch0 
       i=readaline(mch,prompt) 
       if(i.gt.0) then 
        do j=1,i 
         ch132(j:j)=char(mch(j)) 
        end do 
        call addhist(ch132(:i)//ch0) 
       end if 
       call trlch(npl,ch132,nn,out) 
                                                                        
!       if(nn.eq.0) goto 9                                              
       j=ng 
       if(nn.gt.0)then 
        do i=1,nn 
         k=out(i) 
         if(nn.eq.1.and.k.eq.1) goto 109 
         if(k.gt.0.and.k.le.24) then 
          j=j+1 
          nsu(j)=k 
         end if 
        end do 
        ng=j 
       else 
        if(ng.eq.ngold) goto 200 
        querytype=' test of the subset for group property' 
        ch1='y' 
        chcom='group property' 
        call yesno(querytype,ch1,chcom,icol,nrd,nwr) 
        if(ch1.eq.'n'.or.ch1.eq.'N') goto 200 
       end if 
       goto 11 
                                                                        
  200 continue 
       chdf='left' 
  201  lq=5 
       lk=lq 
       do k=1,lq 
        ext(k)=' ' 
       end do 
       chdf(80:80)='#' 
       chin=' subsets of  O deduced from the subgroup U' 
       helpar(1)='left cosets' 
       helpar(2)='right cosets' 
       helpar(3)='invers/cosets' 
       helpar(4)='conjugated elements' 
       helpar(5)='exit' 
       queryar(1)='left cosets {e(i)*U}' 
       queryar(2)='right cosets {U*e(i)}' 
       queryar(3)='left cosets {e(i)*U}**-1' 
       queryar(4)='set conjugated elements {e(i)*U*e(i)**(-1)}' 
       queryar(5)='exit' 
       call query(lq,lk,chin,chdf) 
       if(lq.eq.0) goto 200 
       if(lq.eq.5) goto 500 
                                                                        
       if(lq.eq.1) then 
        write(nwr,'(/,a)')' U and left cosets {e(i)*U} of subgroup U' 
        do l=1,24 
         lg=l 
         do m=1,ng 
           mg=nsu(m) 
           lm(l,m)=iprd(lg,mg) 
                  ! m                                                   
         end do 
!        write(nwr,'(i3,3x,24i3)') l,(lm(l,m),m=1,ng)                   
                 ! l                                                    
        end do 
       end if 
                                                                        
       if(lq.eq.2) then 
        write(nwr,'(/,a)')' U and right cosets {U*e(i)} of subgroup U' 
        do l=1,24 
         lg=l 
         do m=1,ng 
           mg=nsu(m) 
           lm(l,m)=iprd(mg,lg) 
                  ! m                                                   
         end do 
!        write(6,'(i3,3x,24i3)') l,(lm(l,m),m=1,ng)                     
                 ! l                                                    
        end do 
       end if 
                                                                        
       if(lq.eq.3) then 
        write(nwr,'(/,a)')' right cosets {U*e(i)}**-1 of subgroup U' 
        do l=1,24 
         lg=l 
         do m=1,ng 
           mg=inv(nsu(m)) 
           lm(l,m)=iprd(inv(lg),mg) 
                  ! m                                                   
         end do 
!        write(6,'(i3,3x,24i3)') l,(lm(l,m),m=1,ng)                     
                 ! l                                                    
        end do 
       end if 
                                                                        
                                                                        
       if(lq.eq.4) then 
       write(nwr,'(/,a)')                                               &
     &' U and the set of conjugated elements {e(i)*U*e(i)**(-1)}'       
        do l=1,24 
         lg=l 
         do m=1,ng 
           mg=nsu(m) 
           jj=iprd(lg,mg) 
           lm(l,m)=iprd(jj,inv(lg)) 
                  ! m                                                   
         end do 
!        write(6,'(i3,3x,24i3)') l,(lm(l,m),m=1,ng)                     
                 ! l                                                    
        end do 
       end if 
                                                                        
!        Durchschnittsmenge O-nsu = nsucom                              
         nh=24 
         do l=1,24 
          nsucom(l)=l 
         end do 
         do l=1,nh-1 
          lc=nsucom(l) 
          ll=l 
  300     continue 
           ll=ll+1 
           if(ll.gt.nh) goto 310 
           llc=nsucom(ll) 
           nj=0 
           do m=1,ng 
            do n=1,ng 
             if(abs(lm(lc,m)-lm(llc,n)).gt.0)nj=nj+1 
            end do 
           end do 
           if(nj.eq.ng*(ng-1)) then 
!            write(6,'(2x,24i3)') (nsucom(m),m=1,nh)                    
            nh=nh-1 
            if(ll.le.nh) then 
            do j=ll,nh 
             nsucom(j)=nsucom(j+1) 
            end do 
!          write(6,'(15x,2(a,i2,2x,4i3))')                              
!     &    '  lc=',lc,(lm(lc,m),m=1,4),'  llc=',llc,(lm(llc,m),m=1,4)   
            end if 
            ll=ll-1 
           end if 
          goto 300 
  310     continue 
         end do 
!          write(6,'(2x,24i3)') (nsucom(m),m=1,nh)                      
                                                                        
       do m=1,nh 
        do k=1,ng 
         ncoset(k)=lm(nsucom(m),k) 
        end do 
!          write(6,'(2x,24i3)') ( ncoset(k),k=1,ng)                     
                                                                        
        jn=(ng-1)/6 
        nj2=ng-1-jn*6 
        do i=1,jn+1 
         j1=(i-1)*6+1 
         j2=j1+5 
         if(i.eq.jn+1) j2=j1+nj2 
         if(i.eq.1) then 
                                                                        
         write(nwr,'(1h ,i2,a3,6(i3,x,a,x))') m,':  ',                  &
     &        (ncoset(j),elnam(ncoset(j)),j=j1,j2)                      
         else 
                                                                        
         write(nwr,'(1h ,a5,6(i3,x,a,x))') '     ',                     &
     &        (ncoset(j),elnam(ncoset(j)),j=j1,j2)                      
         end if 
        end do 
              ! m                                                       
       end do 
                                                                        
!      on file ---------------                                          
       if(lq.eq.1) then 
       write(lou,'(/,a)')                                               &
     &' U and left cosets {e(i)*U} of subgroup U'                       
       end if 
       if(lq.eq.2) then 
       write(lou,'(/,a)')                                               &
     &' U and right cosets {U*e(i)} of subgroup U'                      
       end if 
       if(lq.eq.3) then 
       write(lou,'(/,a)')                                               &
     &' U and right cosets {U*e(i)}**(-1) of subgroup U'                
       end if 
       if(lq.eq.4) then 
       write(lou,'(/,a)')                                               &
     &' U and the set of conjugated elements {e(i)*U*e(i)**(-1)}'       
       end if 
                                                                        
       if(nh.eq.0)then 
        write(nwr,'(a)')' no coset' 
        chdf='Tensor' 
        ng=24 
        goto 201 
       end if 
                                                                        
       do m=1,nh 
        do k=1,ng 
         ncoset(k)=lm(nsucom(m),k) 
        end do 
        jn=(ng-1)/6 
        nj2=ng-1-jn*6 
        do i=1,jn+1 
         j1=(i-1)*6+1 
         j2=j1+5 
         if(i.eq.jn+1) j2=j1+nj2 
         if(i.eq.1) then 
         write(lou,'(1h ,i2,a3,6(i3,x,a,x))') m,':  ',                  &
     &        (ncoset(j),elnam(ncoset(j)),j=j1,j2)                      
         else 
         write(lou,'(1h ,a5,6(i3,x,a,x))') '     ',                     &
     &        (ncoset(j),elnam(ncoset(j)),j=j1,j2)                      
         end if 
        end do 
              ! m                                                       
       end do 
!      on file ---------------                                          
                                                                        
       lq=4 
       lk=lq 
       do k=1,lq 
        ext(k)=' ' 
       end do 
       chdf='gege' 
       chdf(80:80)='#' 
       chin=' subsets of  O deduced from the subgroup U' 
       helpar(1)='subsets' 
       helpar(2)='group property' 
       helpar(3)='invariance' 
       helpar(4)='exit' 
       queryar(1)='generation of further subsets' 
       queryar(2)='selection of subset i and test for group property' 
       queryar(3)='Tensor T: R*T*R^+  with R(U)' 
       queryar(4)='exit' 
       call query(lq,lk,chin,chdf) 
       if(lq.eq.3) goto 400 
       if(lq.eq.4) goto 500 
       if(lq.eq.2) then 
        form='i3' 
        alowlimit=1 
        uplimit=nh+1 
        value=2 
        querytype=' subset out of the list ' 
        chcom='group/subset/list' 
        call askvallim(querytype,form,                                  &
     &                  alowlimit,uplimit,value,chcom,npl,nrd,nwr)      
        i=value 
        do k=1,ng 
         nsu(k)=lm(nsucom(i),k) 
        end do 
!        write(6,'(a,24i3)')' nsu=',(nsu(k),k=1,ng)                     
        jsu=ng 
        goto 11 
       end if 
       if(lq.eq.1)then 
        goto 200 
       end if 
                                                                        
  400 continue 
      call subgrouptrans(ch2,ng,nsu) 
  500 continue 
      close(unit=lou) 
                                                                        
      stop 
      END                                           
                                                                        
                                                                        
                                                                        
      real function arcos(h) 
                                                                        
      pi2=2.0*atan(1.0) 
      hh=h*h 
      if(hh.ge.1.0) then 
       arcos=0.0 
       if(h.lt.0.0) arcos=2.0*pi2 
      else 
       s=sqrt(1.0-hh) 
       if(abs(h).lt.0.001) then 
        arcos=pi2 
       else 
        arcos=atan(s/h) 
        if(h.lt.0.0) arcos=2.0*pi2+arcos 
       end if 
      end if 
      return 
      END                                           
                                                                        
                                                                        
      subroutine eulerangle(theta,phi,omega,alpha,beta,gamma) 
      implicit none
      real    theta,phi,omega,alpha,beta,gamma,arcos,&
              uveca(3,3),uvecb(3,3), &
              pi,rad,xalpha,xbeta,xgamma,cosa,sina,cosb,sinb,cosg,sing, &
              omcosg,dx,dy,dz,h,st
      integer i,k
                                                                        
      pi=4.0*atan(1.0) 
      rad=pi/180.0 
                                                                        
      do k=1,3 
       do i=1,3 
        uveca(i,k)=0.0 
       end do 
      end do 
      do k=1,3 
       uveca(k,k)=1.0 
      end do 
                                                                        
                                                                        
       xalpha=phi 
       xbeta=theta 
       xgamma=omega*rad 
                                                                        
       cosa=cos(xalpha) 
       sina=sin(xalpha) 
       cosb=cos(xbeta) 
       sinb=sin(xbeta) 
                                                                        
       cosg=cos(xgamma) 
       sing=sin(xgamma) 
       omcosg=1.0-cosg 
                                                                        
       dx=sinb*cosa 
       dy=sinb*sina 
       dz=cosb 
                                                                        
       uvecb(1,1)=dx**2*omcosg +cosg 
       uvecb(1,2)=dx*dy*omcosg+dz*sing 
       uvecb(1,3)=dx*dz*omcosg-dy*sing 
                                                                        
       uvecb(2,1)=dx*dy*omcosg-dz*sing 
       uvecb(2,2)=dy**2*omcosg+cosg 
       uvecb(2,3)=dz*dy*omcosg+dx*sing 
                                                                        
       uvecb(3,1)=dx*dz*omcosg+dy*sing 
       uvecb(3,2)=dy*dz*omcosg-dx*sing 
       uvecb(3,3)=dz**2*omcosg+cosg 
                                                                        
!       do k=1,3                                                        
!        do i=1,3                                                       
!         uvec(i,k)=uvecb(k,i)                                          
!        end do                                                         
!       end do                                                          
!      do k=1,3                                                         
!       do i=1,3                                                        
!         uvecb(k,i)=uvec(k,i)                                          
!        end do                                                         
!       end do                                                          
                                                                        
!      vectors uveca and uvecb are known                                
!      calculation of Euler angle alpha,beta,gamma                      
       h=0.0 
       do k=1,3 
        h=h+uveca(3,k)*uvecb(3,k) 
       end do 
       beta=arcos(h) 
       st=sin(beta) 
       if(beta.lt.0.001) then 
        beta=0.0 
        beta=beta/rad 
        h=0.0 
        do k=1,3 
         h=h+uveca(1,k)*uvecb(1,k) 
        end do 
        alpha=arcos(h) 
        h=0.0 
        do k=1,3 
         h=h+uveca(1,k)*uvecb(2,k) 
        end do 
        if(h.gt.0.0) alpha=2.0*pi-alpha 
        gamma=0.0 
             ! beta=0                                                   
       else 
                                   ! sin(beta)=0                        
        if(abs(st).lt.0.001) then 
         h=0.0 
         do k=1,3 
          h=h+uveca(1,k)*uvecb(1,k) 
         end do 
         gamma=0.0 
         alpha=arcos(-h) 
         h=0.0 
         do k=1,3 
          h=h+uveca(1,k)*uvecb(2,k) 
         end do 
         if(h.gt.0.0) alpha=2.0*pi-alpha 
        else 
         h=0.0 
         do k=1,3 
          h=h+uveca(1,k)*uvecb(3,k) 
         end do 
         alpha=arcos(h/st) 
         h=0.0 
         do k=1,3 
          h=h+uveca(2,k)*uvecb(3,k) 
         end do 
         if(h.lt.0.0) alpha=2.0*pi-alpha 
                                                                        
         h=0.0 
         do k=1,3 
          h=h+uveca(3,k)*uvecb(1,k) 
         end do 
         gamma=arcos(-h/st) 
         h=0.0 
         do k=1,3 
          h=h+uveca(3,k)*uvecb(2,k) 
         end do 
        if(h.lt.0.0) gamma=2.0*pi-gamma 
               ! sin(beta)#0                                            
       end if 
               ! beta=0                                                 
       end if 
       beta=beta/rad 
       alpha=alpha/rad 
       gamma=gamma/rad 
                                                                        
       return 
      END                                           
                                                                        
                                                                        
                                                                        
!      subroutine help(chin)                                            
!      character chin*132                                               
!      write(6,'(8(a,/))')                                              
!     & ' This program has no helpfile!',                               
!     & ' The subroutines for input of numbers and strings are taken',  
!     & ' from the program EFFI, which has an elaborate helpfile.',     
!     & ' ',                                                            
!     & ' Withsome knowledge about group theory',                       
!     & ' from a helpfile can be abstained.',                           
!     & ' Without any knowledge the helpfile would be a textbook.'      
!      return                                                           
!      end                                                              
                                                                        
      SUBROUTINE INDEXX(N,ARRIN,INDX) 
      implicit none
      real  ARRIN(N),Q
      integer N,INDX(N),   &
              I,J,IR,INDXT,L 
      DO J=1,N 
        INDX(J)=J 
      END DO 
      L=N/2+1 
      IR=N 
   10 CONTINUE 
        IF(L.GT.1)THEN 
          L=L-1 
          INDXT=INDX(L) 
          Q=ARRIN(INDXT) 
        ELSE 
          INDXT=INDX(IR) 
          Q=ARRIN(INDXT) 
          INDX(IR)=INDX(1) 
          IR=IR-1 
          IF(IR.EQ.1)THEN 
            INDX(1)=INDXT 
            RETURN 
          ENDIF 
        ENDIF 
        I=L 
        J=L+L 
   20   IF(J.LE.IR)THEN 
          IF(J.LT.IR)THEN 
            IF(ARRIN(INDX(J)).LT.ARRIN(INDX(J+1)))J=J+1 
          ENDIF 
          IF(Q.LT.ARRIN(INDX(J)))THEN 
            INDX(I)=INDX(J) 
            I=J 
            J=J+J 
          ELSE 
            J=IR+1 
          ENDIF 
        GO TO 20 
        ENDIF 
        INDX(I)=INDXT 
      GO TO 10 
      END                                           
