      SUBROUTINE POWELL(P,XI,N,NP,FTOL,ITER,FRET)

      DIMENSION P(NP),XI(NP,NP)
      PARAMETER (NMAX=16,ITMAX=100)
      DIMENSION PT(NMAX),PTT(NMAX),XIT(NMAX),ST(NMAX)
      Sret=FRET
      FRET=FUNC(P,N)
      DO J=1,N
        PT(J)=P(J)
      end do
      ITER=0
1     ITER=ITER+1
      FP=FRET
      IBIG=1                      ! changed from 0 to 1
      DEL=0.
      DO I=1,N
        DO J=1,N
          XIT(J)=XI(J,I)
        END DO
        CALL LINMIN(P,XIT,N,FRET)
        IF(ABS(FP-FRET).GT.DEL)THEN
          DEL=ABS(FP-FRET)
          IBIG=I
        ENDIF
      END DO
      IF(2.*ABS(FP-FRET).LE.FTOL*(ABS(FP)+ABS(FRET)))then
         FRET=Sret;
         do J=1,N
           P(J)=ST(J)
         end do         
        RETURN
       end if
       IF(ITER.EQ.ITMAX)then
         print*, 'Powell exceeding maximum iterations.'
         FRET=Sret;
         do J=1,N
           P(J)=ST(J)
         end do         
         return
      end if
      DO J=1,N
        PTT(J)=2.*P(J)-PT(J)
        XIT(J)=P(J)-PT(J)
        PT(J)=P(J)
      END DO
      FPTT=FUNC(PTT,N)
      if(FPIT.lt.Sret) Then
         Sret=FPTT
         St=PTT
      end if   
      IF(FPTT.GE.FP)GO TO 1
      T=2.*(FP-2.*FRET+FPTT)*(FP-FRET-DEL)**2-DEL*(FP-FPTT)**2
      IF(T.GE.0.)GO TO 1
      CALL LINMIN(P,XIT,N,FRET)
      DO J=1,N
        XI(J,IBIG)=XIT(J)
      END DO
      GO TO 1
      END
