  subroutine Nrottrans
      implicit none
     integer,parameter :: maxco=64
     character(len=132):: queryar,helpar,type,                        &
                          querytype,chcom,ch132
     character(len=16) :: ext
     character(len=80) :: localhepath
     character(len=3),dimension(1:3):: ebi
     character          ch1*1   
      integer           ld,lw,laenge,lpart
      character(len=132):: infotext
      character(len=4)  :: enwr  

      common/infenw/ enwr(16),infotext(8)
      common/localpath/ localhepath 
      common/scrd/ queryar(maxco),helpar(maxco),ext(maxco),type(maxco),&
                   ld(maxco),lw(maxco),laenge(maxco),lpart(0:maxco)

      real      out(32),uveca(3,3),uvecb(3,3),d1(-1:1,-1:1)
               
      complex   hc,dj1,dj2,drt 
      dimension dj1(-1:1,-1:1),dj2(-1:1,-1:1),drt(-1:1,-1:1)

      real    alpha,beta,cosa,cosb,cosg,        &
              dx,dy,dz,fm,fn,gamma,omcosg,         &
              pi,rad,sina,sinb,sing

      integer nwr,nrd,nn,m,n,ncl,k,kg,iomb,iome,iomstep

      nrd=5
      ncl=80
      nwr=6
      ebi(1)='ebx' 
      ebi(2)='eby' 
      ebi(3)='ebz' 
                                                                        
      pi=4.0*atan(1.0) 
      rad=pi/180.0 


 41    querytype='Three Euler angles (alpha,beta,gamma) 2. transformation:'
       chcom='read/euler_angles' 
       ch132='0,0,0' 
       call askstring(querytype,ch132,chcom,ncl,nrd,nwr) 
       ch1=ch132(1:1) 
       if(ch1.eq.'*'.or.ch1.eq.'q')return 
       call trlch(80,ch132,nn,out) 
       if(nn.ne.3) goto 41 
       alpha=out(1) 
       beta=out(2) 
       gamma=out(3) 

        call dewigner(1,beta*rad,d1) 
        do m=-1,1 
         do n=-1,1 
          fm=float(m)*alpha*rad 
          fn=float(n)*gamma*rad 
          dj2(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*d1(m,n) 
         end do 
        end do 
       
       

      ebi(1)='ebx' 
      ebi(2)='eby' 
      ebi(3)='ebz' 
                                                                        
      pi=4.0*atan(1.0) 
      rad=pi/180.0 
       querytype='rotation axes (theta,phi):' 
       chcom='read/rotation_axes' 
       ch132='45, 0' 
 10     call askstring(querytype,ch132,chcom,ncl,nrd,nwr) 
       ch1=ch132(1:1) 
       if(ch1.eq.'*'.or.ch1.eq.'q')return
                                                                        
       call trlch(80,ch132,nn,out) 
       if(nn.ne.2) goto 10 
       alpha=out(2)*rad 
       beta=out(1)*rad 

       cosa=cos(alpha) 
       sina=sin(alpha) 
       cosb=cos(beta) 
       sinb=sin(beta) 

       uveca=0.0
       uveca(1,1)=1. 
       uveca(2,2)=1. 
       uveca(3,3)=1.
       querytype='do omega=om_b,om_e,om_step' 
       chcom='read/rotation_axes' 
       ch132='0, 360, 10' 
 11     call askstring(querytype,ch132,chcom,ncl,nrd,nwr) 
       ch1=ch132(1:1) 
       if(ch1.eq.'*'.or.ch1.eq.'q')return
                                                                        
       call trlch(80,ch132,nn,out) 
       if(nn.ne.3) goto 11       
       iomb=out(1); iome=out(2); iomstep=out(3)
       
    do kg=iomb,iome,iomstep   
       gamma=kg*rad 

                                                                        
       cosg=cos(gamma) 
       sing=sin(gamma) 
       omcosg=1.0-cosg 
                                                                        
       dx=sinb*cosa 
       dy=sinb*sina 
       dz=cosb 
                                                                        
       uvecb(1,1)=dx**2*omcosg +cosg 
       uvecb(1,2)=dx*dy*omcosg+dz*sing 
       uvecb(1,3)=dx*dz*omcosg-dy*sing 
                                                                        
       uvecb(2,1)=dx*dy*omcosg-dz*sing 
       uvecb(2,2)=dy**2*omcosg+cosg 
       uvecb(2,3)=dz*dy*omcosg+dx*sing 
                                                                        
       uvecb(3,1)=dx*dz*omcosg+dy*sing 
       uvecb(3,2)=dy*dz*omcosg-dx*sing 
       uvecb(3,3)=dz**2*omcosg+cosg 

       call ua_ubtoeuler(uveca,uvecb,beta,alpha,gamma)  

        call dewigner(1,beta*rad,d1) 
        do m=-1,1 
         do n=-1,1 
          fm=float(m)*alpha*rad 
          fn=float(n)*gamma*rad 
          dj1(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*d1(m,n) 
         end do 
        end do 


        do m=-1,1 
         do n=-1,1 
          hc=(0.,0.) 
          do k=-1,1 
           hc=hc+dj1(m,k)*dj2(k,n) 
          end do 
          drt(m,n)=hc 
         end do 
        end do 
                                                                        
       uvecb(1,1)=0.5*real(drt(1,1)-drt(-1,1)-drt(1,-1)+drt(-1,-1)) 
       uvecb(1,2)=-0.5*aimag(drt(1,1)+drt(-1,1)-drt(1,-1)-drt(-1,-1)) 
       uvecb(1,3)=-1./sqrt(2.)*real(drt(0,1)-drt(0,-1)) 
                                                                        
       uvecb(2,1)=0.5*aimag(drt(1,1)-drt(-1,1)+drt(1,-1)-drt(-1,-1)) 
       uvecb(2,2)=0.5*real(drt(1,1)+drt(-1,1)+drt(1,-1)+drt(-1,-1)) 
       uvecb(2,3)=-1./sqrt(2.)*aimag(drt(0,1)+drt(0,-1)) 
                                                                        
       uvecb(3,1)=-1./sqrt(2.)*real(drt(1,0)-drt(-1,0)) 
       uvecb(3,2)=1./sqrt(2.)*aimag(drt(1,0)+drt(-1,0)) 
       uvecb(3,3)=real(drt(0,0)) 

      call ua_ubtoeuler(uveca,uvecb,beta,alpha,gamma) 

!       write(11,'(/,a)') 'unit vectors of system Sb in system S ' 
!      do k=1,3 
!       write(11,'(6x,a3,a,3(f8.3,a5))')ebi(k),'=',                     &
!                 uvecb(k,1),' ex +',uvecb(k,2),' ey +',uvecb(k,3),' ez'
!      end do 
                                                                        
      write(nwr,'(a,i4,a,3(f7.2,a))') 'omega=',kg,                   &
                '  D1,mn(alpha=',alpha,',beta=',beta,',gamma=',gamma,')'

    end do
    return
    end

   subroutine ua_ubtoeuler(uveca,uvecb,beta,alpha,gamma)
    implicit none
       real, intent(out):: beta,alpha,gamma
       real, intent(in),dimension(3,3):: uveca,uvecb
      real, parameter:: pi=3.1415923,rad=pi/180.0
       real h,st,arcos
       integer k
!      vectors uveca and uvecb are known                                
!      calculation of Euler angle alpha,beta,gamma                      
       h=0.0 
       do k=1,3 
        h=h+uveca(3,k)*uvecb(3,k) 
       end do 
       beta=arcos(h) 
       st=sin(beta) 
       if(beta.lt.0.001) then 
        beta=0.0 
        beta=beta/rad 
        h=0.0 
        do k=1,3 
         h=h+uveca(1,k)*uvecb(1,k) 
        end do 
        alpha=arcos(h) 
        h=0.0 
        do k=1,3 
         h=h+uveca(1,k)*uvecb(2,k) 
        end do 
        if(h.gt.0.0) alpha=2.0*pi-alpha 
        gamma=0.0 
             ! beta=0                                                   
       else 
                                   ! sin(beta)=0                        
        if(abs(st).lt.0.001) then 
         h=0.0 
         do k=1,3 
          h=h+uveca(1,k)*uvecb(1,k) 
         end do 
         gamma=0.0 
         alpha=arcos(-h) 
         h=0.0 
         do k=1,3 
          h=h+uveca(1,k)*uvecb(2,k) 
         end do 
         if(h.gt.0.0) alpha=2.0*pi-alpha 
        else 
         h=0.0 
         do k=1,3 
          h=h+uveca(1,k)*uvecb(3,k) 
         end do 
         alpha=arcos(h/st) 
         h=0.0 
         do k=1,3 
          h=h+uveca(2,k)*uvecb(3,k) 
         end do 
         if(h.lt.0.0) alpha=2.0*pi-alpha 
                                                                        
         h=0.0 
         do k=1,3 
          h=h+uveca(3,k)*uvecb(1,k) 
         end do 
         gamma=arcos(-h/st) 
         h=0.0 
         do k=1,3 
          h=h+uveca(3,k)*uvecb(2,k) 
         end do 
        if(h.lt.0.0) gamma=2.0*pi-gamma 
               ! sin(beta)#0                                            
       end if 
               ! beta=0                                                 
       end if 
       beta=beta/rad 
       alpha=alpha/rad 
       gamma=gamma/rad 
      
      return
      end
