      subroutine stringend(ch,il) 
      implicit none
      integer il
      character*132 ch 
      if(ch.eq.' ') then 
       il=0 
       return 
      end if 
      if(il.eq.0)il=132 
      do while(ch(il:il).eq.' ') 
       il=il-1 
      end do 
      return 
      END                                           
                                                                        
                                                                        
       subroutine chcenter(ch,ch1,ncol) 
       implicit none
       integer ncol,l,ncl,k,i
       character*132 ch,ch1*1 
        call stringlength(ch,l) 
        i=(ncol-l)/2 
        do k=l,1,-1 
         ch(i+k:i+k)=ch(k:k) 
        end do 
        do k=1,i 
         ch(k:k)=ch1 
        end do 
        k=i+l+1 
        do while(k.le.ncol) 
         ch(k:k)=ch1 
         k=k+1 
        end do 
        return 
      END                                           
                                                                        
      subroutine trlnu(formatch,rn,chr,nn,chl,im) 
      implicit none
      real rn,z,e10
      integer nn,im                                                                             
!     M. Alflen  13.9.89, H. Spiering Mai 1995                          
                                                                        
!     translates number rn to characters of given format written on ch  
!     inn,     integer                                                  
!     fnn.mm   real f - format                                          
!     enn.mm   real e - format                                          
!     ann.mm   real allplo format = e-format 10**k                      
!     sign is printed for a leading '+' (+i, +f, +e, and +ann.mm)       
!                                                                       
                                                                        
      integer, dimension(-2:15):: ii 
      character formatch*7,chr*24,chl*24,chf*16,fch*1,chexp*4 
      logical bi,bf,be,ba
      integer i,ij,iueb,i0,ip,k,mm,ipex,iex,ibex,iep,j,jex,k10
                                                                        
!      write(6,'(3a,g15.5)')'trlnu formatch=',formatch,'...rn=',rn      
      if(abs(rn).gt.1.e10)formatch='e15.5' 
      ii=0
      bi=.false. 
      bf=.false. 
      be=.false. 
      ba=.false. 
      chf=' ' 
      chl=' ' 
      chr=' ' 
      z=rn 
!     analyse formatch                                                  
      i0=ichar('0') 
      ip=0 
      do k=1,7 
       if(formatch(k:k).ne.' ') goto 10 
      end do 
   10 nn=0 
!      write(6,'(i2,2a)')k,'=k formatch=',formatch                      
      mm=0 
      if(formatch(k:k).eq.'+') ip=1 
       k=k+ip 
       fch=formatch(k:k) 
       k=k+1 
      nn=ichar(formatch(k:k))-i0 
       k=k+1 
      if(formatch(k:k).eq.' '.or.k.gt.7) goto 20 
      if(formatch(k:k).ne.'.') then 
        nn=10*nn+ichar(formatch(k:k))-i0 
        k=k+1 
      end if 
      if(formatch(k:k).eq.'.') then 
       k=k+1 
       mm=ichar(formatch(k:k))-i0 
       k=k+1 
       if(k.gt.7) goto 20 
       if(formatch(k:k).ne.' ') then 
        mm=10*mm+ichar(formatch(k:k))-i0 
       end if 
      end if 
   20 continue 
      if(nn.gt.24) then 
       chl='************************' 
       chr='************************' 
       return 
      end if 
                                                                        
      if(fch.eq.'i'.or.fch.eq.'I') bi=.true. 
      if(fch.eq.'f'.or.fch.eq.'F') bf=.true. 
      if(fch.eq.'e'.or.fch.eq.'E') be=.true. 
      if(fch.eq.'a'.or.fch.eq.'A') ba=.true. 
                                                                        
      ipex=ip 
      j=0 
      if(z.lt.0.) then 
        z=-z 
        chf(1:1)='-' 
        j=1 
        ip=1 
      else 
       if(ip.eq.1) then 
        chf(1:1)='+' 
        j=1 
       end if 
      end if 
                                                                        
      if(z.eq.0.) then 
       iex=0 
      else 
       iex=int(log10(z)+0.00001) 
      end if 
      if(z.lt.0.99999) iex=iex-1 
      e10=10.**iex 
                                                                        
      if(bi) im=iex 
      if(bf)  im=mm+iex 
      if(im.lt.0) im=-1 
      if(be.or.ba) im=mm 
!       write(6,'(a,2i3,2x,5g15.6)')'im,iex,z,e10=',im,iex,z,e10
                                                                        
       ii(-1)=0 
       do k=0,im+1 
        i=int(z/e10+0.000001) 
        z=z-e10*float(i) 
        e10=e10/10. 
        ii(k)=i 
       end do
 
       if(ii(im+1).gt.5) then 
        ii(im)=ii(im)+1 
        do k=im,0,-1 
         if(ii(k).gt.9) then 
          ii(k-1)=ii(k-1)+1 
          ii(k)=0 
         end if 
        end do 
       end if 
       iueb=0 
 
      if(ii(-1).gt.0) then 
        iueb=-1 
        if(be.or.ba) iex=iex+1 
        if(bi.or.bf) ip=ip+1 
       end if 
                                                                        
!     e-formatch and allplo-formatch                                    
      if(be.or.ba) then 
       jex=0 
       chexp=' ' 
       if(iex.lt.0) then 
        ibex=-iex 
        chexp(1:1)='-' 
        jex=1 
       else 
        ibex=iex 
        if(ipex.eq.1) then 
         chexp(1:1)='+' 
         jex=1 
        end if 
       end if 
       if(ibex.eq.0) then 
        ij=0 
       else 
        ij=int(log10(float(ibex))) 
       end if 
       do k=ij,0,-1 
        k10=10**k 
        i=int(ibex/k10) 
        jex=jex+1 
        chexp(jex:jex)=char(i+i0) 
        ibex=ibex-k10*i 
       end do 
                                                                        
       do k=iueb,mm 
        j=j+1 
        chf(j:j)=char(ii(k)+i0) 
       end do 
!       write(6,'(3i3,a,a)')jex,ip,j,'=j chf=',chf                      
       im=ip+1+mm 
       if(mm.eq.0) then 
         chl=chf(1:ip+1)//'.' 
       else 
         chl=chf(1:ip+1)//'.'//chf(ip+2:im) 
       end if 
       if(be) then 
        chl=chl(1:im+1)//fch//chexp(1:jex) 
        im=im+2+jex 
       else 
        chl=chl(1:im+1)//'*10@u'//chexp(1:jex)//'@n' 
        im=im+8+jex 
       end if 
!       write(6,'(a,a)')' chl=',chl                                     
       goto 100 
      end if ! be or ba
                                                                        
!     i-formatch                                                        
      if(bi) then 
       if(iex.ge.iueb) then 
        do k=iueb,iex 
         j=j+1 
         chf(j:j)=char(ii(k)+i0) 
        end do 
         chl(1:j)=chf(1:j) 
        im=iex+ip+1 
       else 
        im=nn 
        chl(nn:nn)='0' 
       end if 
       goto 100 
      end if   ! bi
                                                                        
!     f-formatch                                                        
      if(bf) then 
!       write(6,'(4i3,a,10i3)')iex,iueb,ip,mm,'=iex,iueb,ip,mm trlnu ii=',(ii(k),k=-1,9)         
       if(iex.ge.0) then 
        do k=iueb,mm+iex 
         j=j+1 
         chf(j:j)=char(ii(k)+i0) 
        end do 
        iep=iex+ip+1 
        im=iep+1+mm 
        chl=chf(1:iep)//'.'//chf(iep+1:im) 
       else 
        do k=1,iueb-iex 
         j=j+1 
         chf(j:j)='0' 
        end do 
        do k=iueb,mm+iex 
         j=j+1 
         chf(j:j)=char(ii(k)+i0) 
        end do 
        im=ip+1+mm 
        if(iueb.eq.-1) then 
         ip=ip-1 
        else 
         im=im+1 
        end if 
        if(mm.eq.0) then 
          chl=chf(1:ip+1)//'.' 
        else 
          chl=chf(1:ip+1)//'.'//chf(ip+2:im) 
        end if 
       end if 
      end if 
                                                                        
  100 continue 
       k=nn-im 
       if(k.lt.0) then 
         chr='***'//chl(1:im)//'***' 
         chl='***'//chl(1:im)//'***' 
       else 
         chr(k+1:nn)=chl(1:im) 
       end if 
!      write(6,'(4a)')'trlnu chr=',chr,'...chl=',chl                    
                                                                        
      return 
      END                                           
                                                                        
      subroutine itoc8(ch,nn) 
      implicit none
!     H. Spiering 1.2000                                                
!     translates integer n to characters of given format written on chn 
      integer nn,n,m,i,im,i10,i0,k 
      character ch*8 
      ch=' ' 
      n=nn 
      i0=ichar('0') 
      m=n 
      im=0 
      do while(m.ne.0) 
       m=m/10 
       im=im+1 
      end do 
      i10=10**(im-1) 
      if(n.lt.0) then 
       ch(1:1)='-' 
       n=-n 
      end if 
      do k=2,im+1 
       i=n/i10 
       n=n-i10*i 
       i10=i10/10 
       ch(k:k)=char(i+i0) 
      end do 
      return 
      END                                           
                                                                        
      subroutine iptoc8(ch,nn) 
!     H. Spiering 1.2000                                                
!     translates integer n to characters of given format written on chn 
      integer nn,n,m,i,im,i10,i0 
      character ch*8 
      ch=' ' 
      n=nn 
      i0=ichar('0') 
      m=n 
      im=0 
      do while(m.ne.0) 
       m=m/10 
       im=im+1 
      end do 
      i10=10**(im-1) 
      do k=1,im 
       i=n/i10 
       n=n-i10*i 
       i10=i10/10 
       ch(k:k)=char(i+i0) 
      end do 
      nn=im 
      return 
      END                                           
                                                                        
      subroutine c8toi(ch,n) 
      implicit none
!     H. Spiering 1.2000                                                
!     translates character of integer n to integer, ch has stringlength8
      character ch*8 
      integer n,i0,iv,k,i9 
      i0=ichar('0') 
      i9=ichar('9') 
      do k=1,8 
       if(ichar(ch(k:k)).gt.i9) ch(k:k)=' ' 
      end do 
      do k=1,8 
       if(ch(k:k).ne.' ') goto 10 
      end do 
!      write(6,'(a,i4,a)')' comtool k,ch=',k,ch                         
   10 if(k.le.8) then 
       iv=1 
       if(ch(k:k).eq.'+') k=k+1 
       if(ch(k:k).eq.'-') then 
        k=k+1 
        iv=-1 
       end if 
       n=0 
       do while(ch(k:k).ne.' '.and.k.le.8) 
        n=n*10+ichar(ch(k:k))-i0 
        k=k+1 
       end do 
       n=n*iv 
      else 
       n=0 
      end if 
                                                                        
      return 
      END                                           
                                                                        
      subroutine trlch(n_ch,chin,iout,out) 
      implicit none
      character chin*132,ch*132 
      real      out(32),pt 
      integer nch,n_ch, &
              i,ic,i0,nsig,k,k1,k2,nex,nnum,iout 
!     program translates numbers (all possible fortran formates,        
!     separated by at least one blank or other character) given as ch*13
!     to iout real numbers (max.32) stored in the vector out.           
!     nch characters of ch(1:nch) are analysed.                         
      nch=n_ch 
      if(nch.gt.132) nch=132 
      ch=chin 
      i0=ichar('0') 
      nsig=1 
      pt=1. 
      k1=0 
      k2=0 
      nex=0 
      nnum=0 
      iout=0 
      do k=1,32 
       out(k)=0. 
      end do 
                                                                        
      k=0 
   10 k=k+1 
      i=ichar(ch(k:k))-i0 
      if(i.ge.0.and.i.lt.10) then 
       nnum=1 
       if (pt.eq.1.) then 
        out(iout+1)=out(iout+1)*10.+float(i) 
       else 
        out(iout+1)=out(iout+1)+float(i)*pt 
        pt=pt/10. 
       end if 
       if(k.eq.nch) goto 50 
       goto 100 
      end if 
                                                                        
      if(ch(k:k).eq.'e'.or.ch(k:k).eq.'E') then 
       if(nex.eq.1) goto 50 
       do i=k-1,1,-1 
        if(ch(i:i).eq.'.') then 
         nex=-1 
         goto 50 
        end if 
        ic=ichar(ch(i:i))-i0 
        if(ic.lt.0.or.ic.gt.9) goto 100 
       end do 
      end if 
                                                                        
      if(pt.lt.1.)then 
       k=k-1 
       goto 50 
      end if 
                                                                        
      if (ch(k:k).eq.'.') then 
        pt =0.1 
        goto 100 
      end if 
      if(ch(k:k).eq.'-') then 
        if(nsig.eq.1) k1=k 
        if(nsig.eq.-1) k2=k 
        nsig=-1 
      end if 
      if(nnum.eq.1) goto 50 
      if(nex.eq.1.and.ch(k:k).eq.' ') nex=0 
      goto 100 
                                                                        
   50 if(k1.lt.k) then 
       out(iout+1)=nsig*out(iout+1) 
       if(k2.lt.k1) then 
        nsig=1 
       else 
        k1=k2 
       end if 
      end if 
      nnum=0 
      pt=1. 
      if (nex.le.0) goto 60 
      out(iout)=out(iout)*10.**out(iout+1) 
      nex=0 
      out(iout+1)=0. 
      iout=iout-1 
   60 if (iout.eq.32) goto 110 
      iout=iout+1 
      k1=0 
      k2=0 
      if(nex.eq.-1) nex=1 
                                                                        
  100 if(k.lt.nch) goto 10 
  110 return 
      END                                           
                                                                        
      subroutine lc_character(ch) 
      implicit none 
      character*132 ch 
      integer i,l,in
       call stringlength(ch,l) 
       do i=1,l 
        in=ichar(ch(i:i)) 
        if(in.lt.91.and.in.gt.64) in=in+32 
        ch(i:i)=char(in) 
       end do 
      return 
      END                                           
                                                                        
       subroutine nextcharb(chl,il,ip,cha,ia) 
       implicit none 
!      charackters seperated by blanks only                             
       character*132 chl,cha 
       integer i,il,ip,ia,j,k,kj,npl 
                                                                        
       do k=132,il+1,-1 
        if(chl(k:k).ne.' ') goto 5 
       end do 
    5  npl=k+1 
!       write(6,'(2i4,2a)') il,npl,' nextcharb chl=',chl(1:20)          
                                                                        
       cha=' ' 
       if(il.gt.0) then 
        do k=il+1,npl 
          if(chl(k:k).eq.' ') then 
          i=k 
          goto 10 
          end if 
        end do 
   10   continue 
       else 
         i=1 
       end if 
!       write(6,'(3i3,2a)') il,npl,i,' nextcharb chl=',chl(1:20)        
                                                                        
       j=npl 
       do k=i,npl 
        if(chl(k:k).ne.' ') then 
         j=k 
         goto 20 
        end if 
       end do 
   20  continue 
       ip=k 
                                                                        
       do k=j,npl 
        kj=k-j+1 
        cha(kj:kj)=chl(k:k) 
       end do 
!    the first character is stripped, cha starts with the second symbol 
!       write(6,'(i3,2a)') j,' nextcharb cha=',cha(1:20)                
       ia=npl-1 
       do k=1,npl 
        if(cha(k:k).eq.' ') then 
         ia=k-1 
         goto 30 
        end if 
       end do 
   30  return 
      END                                           
                                                                        
      subroutine stringlength(ch,il)
      implicit none
      character*132 ch 
      integer   i,il,k,j

      if(ch.eq.' '.or.ichar(ch(1:1)).eq.0) then 
       il=0 
       return 
      end if 
      do k=1,131 
       if(ch(k:k).ne.' ') goto 10 
      end do 
   10 do j=131,k,-1 
       if(ch(j:j).ne.' ') goto 20 
      end do 
   20 continue 
      il=j-k+1 
      j=k-1 
                                                                        
      do i=1,il 
       ch(i:i)=ch(j+i:j+i) 
      end do 
      ch(il+1:il+k)=' ' 
      return 
      END                                           
                                                                        
                                                                        
      subroutine fout_a(ch132,chf,n)
      implicit none 
      character ch132*132,chf(32)*4, ch24*24,chfh*4 
      integer n,i0,i1,i10,ie,ink,ip,ml,k,l,l24,m
                                                                        
      n=0 
      i0=ichar('0') 
      ml=132 
      do while(ch132(ml:ml).eq.' ') 
       ml=ml-1 
      end do 
      do k=1,ml 
       if(ch132(k:k).eq.',') ch132(k:k)=' ' 
      end do 
!      write(6,'(2a)') 'fout_a:',ch132(:ml)                             
                                                                        
  100 if(ml.le.0) goto 1000 
      l=1 
      do while(ch132(l:l).eq.' '.and.l.le.ml) 
       l=l+1 
      end do 
                                                                        
!      write(6,'(a,i03,f05.1,4x,a)') ' L100 ',l,float(ml),ch132(l:ml)   
      if(l.le.ml) then 
       n=n+1 
       m=l+1 
       do while(ch132(m:m).ne.' '.and.m.le.ml) 
        m=m+1 
       end do 
                   ! l-m                                                
       m=m-1 
                                                                        
       ch24=ch132(l:m) 
!       write(6,'(a,2i3,4x,a24)') 'l,m,ch24=',l,m,ch24                  
       ml=ml-m 
       if(ml.gt.0) then 
        do k=1,ml 
         ch132(k:k)=ch132(k+m:k+m) 
        end do 
!       write(6,'(2a)') 'ch132(:ml)=',ch132(:ml)                        
       end if 
                                                                        
       l24=m-l+1 
       ip=index(ch24,'.') 
       if(ip.gt.0) then 
        ip=ip-1 
        ie=index(ch24,'e')+index(ch24,'E') 
        if(ie.gt.0) then 
!        exponent                                                       
         chfh(1:2)='e0' 
         l24=l24+2 
         ink=ie-ip-2 
        else 
         chfh(1:2)='f0' 
         ink=l24-ip-1 
        end if 
        if(l24.lt.10) then 
         chfh(3:3)=char(i0+l24) 
        else 
         i10=l24/10 
         i1=l24-10*i10+i0 
         chfh(2:3)=char(i0+i10)//char(i1) 
        end if 
        chfh(4:4)=char(i0+ink) 
                ! ip>0                                                  
       else 
         chfh(1:2)='i0' 
         l24=l24 
         if(l24.lt.10) then 
          chfh(3:3)=char(i0+l24) 
         else 
          i10=l24/10 
          i1=l24-10*i10+i0 
          chfh(2:3)=char(i0+i10)//char(i1) 
         end if 
         chfh(4:4)=' ' 
               ! ip=0                                                   
        end if 
       else 
        goto 1000 
       end if 
       chf(n)=chfh 
!       write(6,'(a,5i3,4x,a24,2x,a4)')                                 
!     &            'l,m,ip,ie,ink,ch24=',l,m,ip,ie,ch24,chfh            
                                                                        
       goto 100 
 1000  continue 
       return 
      END                                           
                                                                        
      subroutine fout_c(ch132,chfmt,j) 
      implicit none 
      integer i0,i1,i10,ie,ink,ip,j,j1,k,l24,m,n,ml,l
      character ch132*132,chf(16)*5,ch24*24,chfh*5,chfmt*132 
                                                                        
      n=0 
      i0=ichar('0') 
      if(ch132.eq.' ') then 
       ml=4 
       ch132='0.0' 
      else 
       ml=132 
      end if 
      do while(ch132(ml:ml).eq.' ') 
       ml=ml-1 
      end do 
      do k=1,ml 
       if(ch132(k:k).eq.',') ch132(k:k)=' ' 
      end do 
!      write(6,'(2a)') 'fout_c:',ch132(:ml)                             
                                                                        
                                                                        
  100 if(ml.le.0) goto 1000 
      l=1 
!      write(6,'(a,2i3,4x,a)') ' L100 ',l,ml                            
      do while(ch132(l:l).eq.' '.and.l.le.ml) 
       l=l+1 
      end do 
                                                                        
!      write(6,'(a,2i3,4x,a)') ' L100 ',l,ml,ch132(l:ml)                
      if(l.le.ml) then 
       n=n+1 
       chfh=' ' 
       m=l+1 
       do while(ch132(m:m).ne.' '.and.m.le.ml) 
        m=m+1 
       end do 
                   ! l-m                                                
       m=m-1 
       ch24=ch132(l:m) 
!       write(6,'(a,2i3,4x,a24)') 'l,m,ch24=',l,m,ch24                  
       ml=ml-m 
       if(ml.gt.0) then 
        do k=1,ml 
         ch132(k:k)=ch132(k+m:k+m) 
        end do 
!       write(6,'(2a)') 'ch132(:ml)=',ch132(:ml)                        
       end if 
                                                                        
       l24=m-l+1 
       ip=index(ch24,'.') 
       if(ip.gt.0) then 
        ip=ip-1 
        ie=index(ch24,'e')+index(ch24,'E') 
        if(ie.gt.0) then 
!        exponent                                                       
         l24=l24+2 
         chfh(1:2)='e0' 
         ink=ie-ip-2 
        else 
         chfh(1:2)='f0' 
         ink=l24-ip-1 
        end if 
        l24=l24+1 
        if(l24.lt.10) then 
         chfh(3:5)=char(i0+l24)//'.'//char(i0+ink) 
        else 
         i10=l24/10 
         i1=l24-10*i10+i0 
         chfh(2:5)=char(i0+i10)//char(i1)//'.'//char(i0+ink) 
        end if 
                ! ip>0                                                  
       else 
         chfh(1:2)='f0' 
         l24=l24+1 
         if(l24.lt.10) then 
          chfh(3:5)=char(i0+l24)//'.0' 
         else 
          i10=l24/10 
          i1=l24-10*i10+i0 
          chfh(2:5)=char(i0+i10)//char(i1)//'.0' 
         end if 
               ! ip=0                                                   
        end if 
       else 
        goto 1000 
       end if 
       chf(n)=chfh 
!       write(6,'(2i4,a,a5)')n,lf(n),' chf(n)=',chf(n)                  
       goto 100 
 1000  continue 
!       write(6,'(i4,a)') n,' L1000'                                    
                                                                        
       j=1 
       do k=1,n 
        j1=j 
        j=j1+9 
!        write(6,'(a,2i4)')' j1,j=',j1,j                                
        chfmt(j1:j-1)=',1x,'//chf(k)(1:5) 
!       write(6,'(i4,a,a)')k,' chfmt=',chfmt(:60)                       
       end do 
       chfmt(j:j)=')' 
       return 
      END                                           
                                                                        
                                                                        
      subroutine fcolumn(chf,lf,chfmt) 
      implicit none 

      integer lf,i0,i1,i10,lmin,k,l
      character chf(24)*4,chfmt(24)*5 
                                                                        
                                                                        
      i0=ichar('0') 
      lmin=3 
      do k=1,lf 
       if(chf(k)(2:2).eq.' ') then 
        l=ichar(chf(k)(3:3))-i0 
       else 
        l=(ichar(chf(k)(2:2))-i0)*10+ichar(chf(k)(3:3))-i0 
       end if 
!       write(6,'(a,2i4)')' lmin,l=',lmin,l                             
       if(l.gt.lmin) lmin=l 
      end do 
                                                                        
      do k=1,lf 
       if(chf(k)(1:1).eq.'i') then 
        if(lmin.lt.10) then 
         chfmt(k)=chf(k)(1:1)//char(i0+lmin) 
        else 
         i10=lmin/10 
         i1=lmin-10*i10+i0 
         chfmt(k)=chf(k)(1:1)//char(i0+i10)//char(i1) 
        end if 
       else 
        if(lmin.lt.10) then 
         chfmt(k)=chf(k)(1:1)//char(i0+lmin)//'.'//chf(k)(4:4) 
        else 
         i10=lmin/10 
         i1=lmin-10*i10+i0 
         chfmt(k)=chf(k)(1:1)//char(i0+i10)//char(i1)//'.'//chf(k)(4:4) 
        end if 
       end if 
      end do 
      return 
      END                                           
                                                                        
                                                                        
         subroutine nextchar(chl,il,ip,cha,ia) 
       implicit none 
       character*132 chl,cha 
       integer i,il,ip,ia,j,k,kj,npl 
                                                                        
       if(il.gt.130)il=130 
       do k=131,il+1,-1 
        if(chl(k:k).ne.' ') goto 5 
       end do 
    5  npl=k+1 
!       write(6,'(2i4,2a)') il,npl,' nextchar chl=',chl(1:20)           
                                                                        
       cha=' ' 
       if(il.gt.0) then 
        do k=il+1,npl 
          if(chl(k:k).eq.' '.or.chl(k:k).eq.',') then 
          i=k 
          goto 10 
          end if 
        end do 
   10   continue 
       else 
         i=1 
       end if 
!       write(6,'(3i3,2a)') il,npl,i,' nextchar chl=',chl(1:20)         
                                                                        
       j=npl 
       do k=i,npl 
        if(chl(k:k).ne.' '.and.chl(k:k).ne.',') then 
         j=k 
         goto 20 
        end if 
       end do 
   20  continue 
       ip=k 
                                                                        
       do k=j,npl 
        kj=k-j+1 
        cha(kj:kj)=chl(k:k) 
       end do 
!    the first character is stripped, cha starts with the second symbol 
!       write(6,'(i3,2a)') j,' nextchar cha=',cha(1:20)                 
       ia=npl-1 
       do k=1,npl 
        if(cha(k:k).eq.' '.or.cha(k:k).eq.',') then 
         ia=k-1 
         goto 30 
        end if 
       end do 
   30  return 
      END                                           
                                                                        
                                                                        
      subroutine ask1string(querytype,chstr,chcom,ncol,nrd,nwr,nba,wrb)
      implicit none 
      character*132 ch132,cp132,chstr,querytype,chcom,wrb*1,ch0*1,      &
     &              prompt*4                                            
      integer mch(132),i,readaline, ncol,nrd,nwr,nba,j,ld,ls
                                                                        
       ch0=char(0) 
       ld=ncol 
       ch132=querytype 
       call stringend(ch132,ld) 
       call stringlength(chstr,ls) 
       if(wrb.eq.'r') then 
        read(nba,'(a)') ch132 
!        write(6,'(a)')ch132(:80)                                       
        i=index(ch132,'[')+1 
        ld=132 
        call stringend(ch132,ld) 
        write(nwr,'(a)')ch132(1:ld) 
        chstr=ch132(i:ld-1) 
!        read(5,'(a)')                                                  
        return 
       end if 
   10  ch132=querytype(1:ld-1)//' ['//chstr(1:ls)// ']           ' 
!       write(nwr,'(a,a2,a,a1)')querytype(1:ld-1),' [',chstr(1:ls),']'  
       if(wrb.eq.'d') then 
        ch132='*' 
        write(nwr,'(a)')ch132(2:80) 
       else 
        write(nwr,'(a)')ch132(1:ld+ls+2) 
        call addhist(ch132(1:ld+ls+2)//ch0) 
        ch132=' ' 
        prompt='> '//ch0 
        i=readaline(mch,prompt) 
        if(i.gt.0) then 
         do j=1,i 
          ch132(j:j)=char(mch(j)) 
         end do 
!         call addhist(ch132(:i)//ch0)                                  
        end if 
        cp132=ch132 
        call lc_character(cp132) 
        if(cp132(1:2).eq.'he') then 
         call help(chcom) 
         goto 10 
        end if 
                                                                        
       end if 
!       write(6,'(a)') 'combuff ch132=',ch132(1:4)//'ende 1-4'          
       if(i.eq.0.or.ch132(1:1).eq.'*') then 
        if(wrb.eq.'w'.or.wrb.eq.'d') write(nba,'(a,a2,a,a1)')           &
     &     querytype(1:ld-1),' [',chstr(1:ls),']'                       
        write(nwr,'(1x,a1,a3)') char(27),'[2A' 
        return 
       end if 
       i=index(ch132,'[')+1 
       if(i.gt.1)then 
        j=index(ch132,']')-1 
        chstr=ch132(i:j) 
        ls=j-i+1 
       else 
        chstr=ch132 
        call stringlength(chstr,ls) 
       end if 
       cp132=' ' 
       write(nwr,'(1x,a1,a3)') char(27),'[3A' 
       write(nwr,'(a,/,a)') cp132(:ncol),cp132(:ncol) 
       write(nwr,'(1x,a1,a3)') char(27),'[3A' 
       goto 10 
      END                                           
                                                                        
      subroutine ask2strings(querytype,chstr,chcom,ncol,nrd,nwr,nba,wrb) 
      implicit none
      character*132 ch132,cp132,chstr(2),querytype(2),chcom,            &
     &              wrb*1,nblank*48,ch0*1,prompt*4                      
      integer mch(132),i,readaline,ncol,nrd,nwr,nba,jld1,ld1,ld2, &
              ld,ld2a,ld2o,ll,ls,ls1,ls2,nbl,ia,il,j,ip 
                                                                        
       ch0=char(0) 
       if(wrb.eq.'r') then 
        read(nba,'(a)') ch132 
!        write(6,'(a)')ch132(:80)                                       
        ld1=ncol 
        call stringend(ch132,ld1) 
        write(nwr,'(a)')ch132(:ld1) 
        i=index(ch132,'[')+1 
        j=index(ch132,']')-1 
        chstr(1)=ch132(i:j) 
        cp132=ch132(j+2:) 
        if(index(cp132,']').gt.0) j=j+1 
        i=index(cp132,'[')+1 
        j=index(cp132,']')-1 
        chstr(2)=cp132(i:j) 
!        write(6,'(2a)')chstr(1)(:30),chstr(2)(:30)                     
          return 
       end if 
       ld1=ncol 
       call stringend(querytype(1),ld1) 
       call stringlength(chstr(1),ls1) 
       ld2=ncol 
       call stringend(querytype(2),ld2) 
       call stringlength(chstr(2),ls2) 
       ld=ld1+ls1+ld2 
       ld2o=ld2 
       nblank=' ' 
       nbl=2 
!       write(6,'(a,6i4)')'ld1,ls1,ld2,ls2=',ld1,ls1,ld2,ls2            
   10  ch132=querytype(1)(1:ld1-1)//'['//chstr(1)(1:ls1)//']'//         &
     & nblank(1:nbl)//querytype(2)(1:ld2-1)//'['//chstr(2)(1:ls2)//'] ' 
       ll=ld1+ls1+nbl+ld2+ls2+3 
!       write(nwr,'(2(a,a1,a,a1,a))')                                   
!     &     querytype(1)(1:ld1-1),'[',chstr(1)(1:ls1),']',nblank(1:nbl),
!     &     querytype(2)(1:ld2-1),'[',chstr(2)(1:ls2),']  '             
       if(wrb.eq.'d') then 
        ch132='*' 
        write(nwr,'(a)')ch132(2:ll) 
       else 
        write(nwr,'(a)')ch132(1:ll) 
        call addhist(ch132(1:ll)//ch0) 
        ch132=' ' 
         prompt='> '//ch0 
        i=readaline(mch,prompt) 
        if(i.gt.0) then 
         do j=1,i 
          ch132(j:j)=char(mch(j)) 
         end do 
!         call addhist(ch132(:i)//ch0)                                  
        end if 
        cp132=ch132 
        call lc_character(cp132) 
        if(cp132(1:2).eq.'he') then 
         call help(chcom) 
         goto 10 
        end if 
        ls=ld1+ls1+ld2+ls2 
       end if 
!      write(6,'(a)') 'combuff ch132=',ch132(1:4)//'ende 1-4'           
       if(i.eq.0.or.ch132(1:1).eq.'*') then 
        if(wrb.eq.'w'.or.wrb.eq.'d') write(nba,'(2(a,a1,a,a1,a))')      &
     &     querytype(1)(1:ld1-1),'[',chstr(1)(1:ls1),']',nblank(1:nbl), &
     &     querytype(2)(1:ld2-1),'[',chstr(2)(1:ls2),']  '              
        write(nwr,'(1x,a1,a3)') char(27),'[2A' 
        return 
       end if 
       i=index(ch132,'[')+1 
       if(i.gt.1)then 
        j=index(ch132,']')-1 
        chstr(1)=ch132(i:j) 
        ls1=j-i+1 
        cp132=ch132(j+2:) 
        i=index(cp132,'[')+1 
        j=index(cp132,']')-1 
        chstr(2)=cp132(i:j) 
        ls2=j-i+1 
       else 
        il=0 
        if(ch132(1:1).eq.',') il=1 
        call nextcharb(ch132,il,ip,cp132,ia) 
        if(ip.gt.ls1+ld1.or.ch132(1:1).eq.',') then 
         if(ch132(1:1).eq.',') then 
          ch132=' ' 
          ch132(ls1+3:)=cp132(1:ia) 
         end if 
         cp132=ch132 
         goto 20 
        end if 
        if(cp132(ia+1:ia+1).ne.' ') then 
         ls1=ia+1 
         do while(ch132(ls1:ls1).ne.' ') 
          ls1=ls1+1 
         end do 
         ls1=ls1-1 
         chstr(1)=ch132(1:ls1) 
        else 
         ls1=ia 
         chstr(1)=cp132(1:ls1) 
        end if 
                                                                        
   20   call nextcharb(cp132,ls1,ip,ch132,ls) 
         if(ls.ne.0) then 
         ls2=ls+1 
         do while(ch132(ls2:ls2).ne.' ') 
          ls2=ls2+1 
         end do 
          ls2=ls2-1 
          chstr(2)=ch132(1:ls2) 
         end if 
        end if 
        cp132=' ' 
        write(nwr,'(1x,a1,a3)') char(27),'[3A' 
        write(nwr,'(a,/,a)') cp132(:ncol),cp132(:ncol) 
        write(nwr,'(1x,a1,a3)') char(27),'[3A' 
!       calculation of                                                  
        ld2a=ld2-(ld-ld1-ls1) 
        if(ld2a.gt.0)then 
         nbl=2 
        else 
         nbl=-ld2a+2 
        end if 
       goto 10 
      END                                           
                                                                        
!      subroutine help(chcom)                                           
!      character*132 chcom                                              
!      return                                                           
!      end                                                              
                                                                        
                                                                        
      subroutine askdstring(querytype,chstr,chcom,ncol,nrd,nwr,nba,wrb) 
      implicit none
      character*132 ch132,cp132,chstr,querytype,chcom,wrb*1 
                                                                        
      character*80 user,logname,date,hostid,host,net,disksize,          &
     &             hepath,utpath,term,edt,shell,colfile,workdir*132     
      common/info/ user,logname,date,hostid,host,net,disksize,          &
     &             hepath,utpath,term,edt,shell,colfile,workdir         
                                                                        
      character*132 chblank,deffile,exten*16,filetype*32,ch0*1,         &
     &              prompt*4                                            
      integer mch(132),i,readaline,ncol,nrd,nwr,nba,ld,ii,j,ll,ls,ipos 
      
                                                                        
       ch0=char(0) 
       ld=ncol 
       ch132=querytype 
       call stringend(ch132,ld) 
       call stringlength(chstr,ls) 
       if(wrb.eq.'r') then 
        read(nba,'(a)') ch132 
        i=index(ch132,'[')+1 
        ld=ncol 
        call stringend(ch132,ld) 
        write(nwr,'(a)')ch132(1:ld) 
        chstr=ch132(i:ld-1) 
!        read(5,'(a)')                                                  
        return 
       end if 
   10  ch132=querytype(1:ld-1)//' ['//chstr(1:ls)//'] ' 
                                                                        
!      write(nwr,'(a,a2,a,a1)')querytype(1:ld-1),' [',chstr(1:ls),']'   
       if(wrb.eq.'d') then 
        ch132='*' 
        write(nwr,'(a)')ch132(2:80) 
       else 
        write(nwr,'(a)')ch132(1:ld+ls+3) 
        call addhist(ch132(1:ld+ls+2)//ch0) 
        ch132=' ' 
        prompt='> '//ch0 
        i=readaline(mch,prompt) 
        if(i.gt.0) then 
         do j=1,i 
          ch132(j:j)=char(mch(j)) 
         end do 
        end if 
        ii=i 
        if(i.gt.0)then 
         i=index(ch132,'[')+1 
         if(i.gt.1)then 
          j=index(ch132,']')-1 
          chstr=ch132(i:j) 
          ls=j-i+1 
          ch132=chstr 
         end if 
         deffile=ch132 
         if(ch132(1:5).eq.'$HOME'.or.ch132(1:5).eq.'$home') then 
          deffile=logname 
          call nextchar(deffile,0,ipos,chblank,ll) 
          deffile='/home/'//chblank(1:ll)//ch132(6:) 
         else if(ch132(1:2).eq.'~/') then 
          deffile=logname 
          call nextchar(deffile,0,ipos,chblank,ll) 
          deffile='/home/'//chblank(1:ll)//ch132(2:) 
         end if 
         ch132=deffile 
         i=index(ch132,'.') 
         if(i.eq.0) then 
          call stringlength(ch132,ll) 
          deffile=ch132(:ll)//'.'//'dat' 
          ch132=deffile 
         end if 
        end if 
                                                                        
!         ~/xapl/allplo/allplo.dat                                      
!         /home/spiering/xapl/allplo/allplo.dat                         
        write(nwr,'(1x,a1,a3)') char(27),'[2A' 
        cp132=ch132 
        call lc_character(cp132) 
        if(cp132(1:2).eq.'he') then 
         call help(chcom) 
         goto 10 
        end if 
       end if 
!       write(6,'(a)') 'combuff ch132=',ch132(1:4)//'ende 1-4'          
       if(ii.eq.0.or.ch132(1:1).eq.'*') then 
        if(wrb.eq.'w'.or.wrb.eq.'d') write(nba,'(a,a2,a,a1)')           &
     &     querytype(1:ld-1),' [',chstr(1:ls),']'                       
!        write(nwr,'(1x,a1,a3)') char(27),'[2A'                         
        return 
       end if 
       chstr=ch132 
       call stringlength(chstr,ls) 
       cp132=' ' 
       write(nwr,'(1x,a1,a3)') char(27),'[2A' 
       write(nwr,'(a,/,a)') cp132(:ncol),cp132(:ncol) 
       write(nwr,'(1x,a1,a3)') char(27),'[3A' 
       goto 10
     END subroutine askdstring



      subroutine trlch16(jnstr,len,out,iout) 
      implicit none
        
      integer, dimension(132), intent(in) :: jnstr
      integer, intent(in):: len
      real,    dimension(16),  intent(out):: out
      real :: pt
      integer:: i0,ie,ice,ib,im,ip, &
              i,ic,nsig,k,k1,k2,nex,nnum,iout 
!     program translates numbers (all possible fortran formates,        
!     separated by at least one blank or other character) given by ascii
!     numbers jnstr(i) , i=1,...,len , len<132
!     to iout real numbers (max.16) stored in the vector out.           

      i0=ichar('0'); ie=ichar('e'); ice=ichar('E') 
      im=ichar('-'); ip=ichar('.'); ib=ichar(' ')

      nsig=1; pt=1.0; k1=0; k2=0; nex=0; nnum=0; iout=0 
      out=0.0
     
      k=0 
   10 k=k+1 
      i=jnstr(k)-i0 
      if(i.ge.0.and.i.lt.10) then 
       nnum=1 
       if (pt.eq.1.) then 
        out(iout+1)=out(iout+1)*10.+float(i) 
       else 
        out(iout+1)=out(iout+1)+float(i)*pt 
        pt=pt/10. 
       end if 
       if(k.eq.len) goto 50 
       goto 100 
      end if 
                                                                        
      if(jnstr(k).eq.ie.or.jnstr(k).eq.ice) then 
       if(nex.eq.1) goto 50 
       do i=k-1,1,-1 
        if(jnstr(i).eq.ip) then 
         nex=-1 
         goto 50 
        end if 
        ic=jnstr(i)-i0 
        if(ic.lt.0.or.ic.gt.9) goto 100 
       end do 
      end if 
                                                                        
      if(pt.lt.1.)then 
       k=k-1 
       goto 50 
      end if 
                                                                        
      if (jnstr(k).eq.ip) then 
        pt =0.1 
        goto 100 
      end if 
      if(jnstr(k).eq.im) then 
        if(nsig.eq.1) k1=k 
        if(nsig.eq.-1) k2=k 
        nsig=-1 
      end if 
      if(nnum.eq.1) goto 50 
      if(nex.eq.1.and.jnstr(k).eq.ib) nex=0 
      goto 100 
                                                                        
   50 if(k1.lt.k) then 
       out(iout+1)=nsig*out(iout+1) 
       if(k2.lt.k1) then 
        nsig=1 
       else 
        k1=k2 
       end if 
      end if 
      nnum=0 
      pt=1. 
      if (nex.le.0) goto 60 
      out(iout)=out(iout)*10.**out(iout+1) 
      nex=0 
      out(iout+1)=0. 
      iout=iout-1 
   60 if (iout.eq.16) goto 110 
      iout=iout+1 
      k1=0 
      k2=0 
      if(nex.eq.-1) nex=1 
                                                                        
  100 if(k.lt.len) goto 10 
  110 return     
    END subroutine trlch16
