#include <stdio.h>
#include <unistd.h> /* defines STDIN_FILENO */
#include <string.h>
#include <fcntl.h>
#include <stdlib.h>

#include <termios.h>
static struct termios stored_settings;

#define store store_
#define term term_

#define writeoup writeoup_
#define readoup readoup_
#define openterm openterm_

#define maxn 1024
#define STRL maxn*8
#define STR  768       /* appl_mod.f90:  marray_sp=maxn*768 */
#define BUFL STRL*STR 
#define bufid1 9016

extern struct term{
      int id1,npl,ncol[8],nrows[8],xpixel[8],ypixel[8];
      char winfile[16];
} term;

extern struct store{
      char  string_fr[STRL][STR];
} store;



void readoup(char *hch){
  int dfile,id1;
   dfile = open(hch,O_RDONLY);
   /*printf("open(hch,O_RDONLY) dfile=%d \n",dfile);*/
     term.id1=read(dfile,store.string_fr[0],BUFL);
   /*printf("reado(int *n,char *file) dfile= %d \n",dfile);*/
   close(dfile);
}
void writeoup(char *hch){
   int dfile;
   dfile = open(hch,O_WRONLY);
   /*printf("writeo(int *n,char *file) dfile= %d i=%d\n",dfile,i);*/
   write(dfile,store.string_fr[0],term.id1);
   close(dfile);
}

void openterm(char term[]){
   FILE *dfile;
   char str[64],tm[16];
   char c;
   int i,j;

   term[63]='\0';
   dfile = fopen("terminfo","r");
   if(dfile!=0)system("rm terminfo");
   i=63;
   do {c = term[i];i=i-1;} while (c != '-'); 
   i=i+4;j=0;              
   do {c = term[i];tm[j]=c; i++; j++;} while (c != '&');                
   tm[j-2]='\0';               
   /*printf("tm=%s\n",tm);*/
   dfile = fopen(tm, "wr");
   strcpy(str, "tty > terminfo");
   fprintf(dfile, "%s\n",str);
   strcpy(str, "sleep 1d");
   fprintf(dfile, "%s\n",str);
   fclose(dfile);
   strcpy(str, "chmod +x ");
   strcat(str,tm);
   system(str);
   system(term);

   do{
     sleep(1); 
   dfile = fopen("terminfo","r");
   }while(dfile==0);
   fclose(dfile);

   strcpy(str,"rm ");
   strcat(str,tm);
   system(str);

   dfile = fopen("terminfo","r");
   do {c = fscanf(dfile, "%s", tm); 
   } while (c != EOF);                
   fclose(dfile);
   /*printf(" tm=%s\n",tm);*/

   str[0]=0;
   strcat(str,"ps t"); /* system dependent*/
   strcat(str,&tm[5]);
   strcat(str," >> terminfo");
   system(str);
   sync;
  }
