     subroutine th_22indexRELAXsad(isubthe,icase,iput,iget,info) 
!    sad= source,absorber,detector : lstr1case=1,2,3 (comthe.for)      
       use glbconst, only: maxfr1,maxfr2,maxthss,maxscrd,icstrf,ivstrf,nwr,enwr
     use comthe, only: array_fr,nproc,theoryname,mLG,ifrcase,lstr1case
     implicit none 
     integer, intent(inout):: isubthe   
     integer, intent(in)   :: icase,iput,iget
     integer, intent(out)  :: info      
                                                                       
      integer,parameter::istr=38+4*(maxfr1+maxfr2)+3*maxthss 
      integer       dstr,iposLG,iadd                                          
      common/struct/dstr(istr+1),iposLG,iadd(6)

      integer       ibe,jpolsource,jpolabsorber,iflag_basis,idum,    &
                    nLG,nAS,nSC,idum2,ak8,sk8,ien
      real          srw8 
      common/strLOC/jpolsource,jpolabsorber,ibe(10),iflag_basis,     &
                    idum,nLG,nAS,nSC,idum2,ak8,sk8,srw8,ien(11)      

     logical       b_vsp,b_v_max,b_dumvsp 
     common/bvstrf/b_vsp(4),b_v_max,b_dumvsp(ivstrf-5) 
                                                                       
!    storage use nst2_8 for 4 complex numbers of r_ik                  
     real          c1,gamnat,e_xsi,flag_SAMP,flag_Voigt,offset,dumc 
     common/acmaps/c1,gamnat,e_xsi,flag_SAMP,flag_Voigt,offset,dumc(icstrf-6) 
     real          avm,sftr,aisom,w_Gauss,wLorentz,dumv 
     logical       b_vm,b_sftr,b_isom,b_w_Gauss,b_wLorentz,b_dumv 
     common/avmaps/avm,sftr,aisom,w_Gauss,wLorentz(8),dumv(ivstrf-12) 
     common/bvmaps/b_vm,b_sftr,b_isom,b_w_Gauss,b_wLorentz(8),           &
                   b_dumv(ivstrf-12)                                    
                                                                       
                                                                       
     logical   b_pc
     integer   nE,iflag_SAMP,iflag_Voigt,i,ii,id,ip,ir,jges,jn,           &
               n,ni,nget,nall,n_all,nst
     real      Eagd,w_Lorentz,gamma,srw 
     real, save :: start,finish, wstart,wfinish
     complex   fp1p1,fm1m1,fm1p1,fp1m1,rtr,dtr,hc,hci
     complex, dimension(:), allocatable :: cLG,temp
     complex, dimension(:,:), allocatable :: tempid
     integer, dimension(0:nproc-1):: first,last
     integer  OMP_GET_THREAD_NUM,nproc_local,idp,nal
     
     if(isubthe.lt.0) then
       theoryname='2x2_ref_index_dynamic_sad    v=160' 
       if(ifrcase.le.4) then 
!        i=2 
!        if(jpolsource.eq.1) i=4 
!        if(-isubthe.eq.1) then 
!         c1=i*(nSC+1)+1 
!        end if 
        if(-isubthe.eq.2) then 
         c1=8*(nAS+1) 
!        if(-isubthe.eq.3) c1=i*(nSC+1) 
        end if 
       end if

       if(ifrcase.eq.5) then 
        c1=2*(nAS+1) 
        if(jpolabsorber.eq.1) c1=c1*4 
       end if
       return 
      end if 
!       write(6,'(a,6f10.2)')'th_22refindexf avm,sftr,aisom,w_Gauss,w_Lorentz=',& 
!                      avm,sftr,aisom,w_Gauss,w_Lorentz               
      hci=cmplx(0.,1.) 
      iflag_SAMP=flag_SAMP 
      iflag_Voigt=flag_Voigt 
      nst=4 
                                                                        
      call get_theory(isubthe,info) 
      if(info.gt.0) return 
!       write(6,'(a,5f10.4,/,50x,5l5)')                                 
!     &  'th_22refindexf avm,sftr,aisom,w_Gauss,w_Lorentz=',            
!     &                  avm,sftr,aisom,w_Gauss,w_Lorentz,              
!     &             b_vm,b_sftr,b_isom,b_w_Gauss,b_w_Lorentz            
                                                                        
      b_pc=b_v_max.or.b_isom.or.b_w_Gauss.or.isubthe.gt.0 
      do i=1,8
       b_pc=b_pc.or.b_wLorentz(i)
      end do
      if(.not.b_pc.or.info.gt.0) then 
       isubthe=-abs(isubthe) 
       goto 400 
      else 
        isubthe=abs(isubthe) 
      end if 
                                                                        
      nget=real(array_fr(iget+1))+2
      n_all=real(array_fr(nget-1))           ! nput+2 in gpg_22nuclearRelax
      jges=aimag(array_fr(nget-1)) 
                                                                        
!      write(6,'(a,8i8)')&
!      '  refindexRELAX iget,nget,iput,lstr1case,jges,n_all=', &    
!              iget,nget,iput,lstr1case,jges,n_all                           

      goto (100,200,300),lstr1case 
!---------------------- source ------------------------------------     
  100 continue 
   print'(a)',' relaxation  theories are not expected for the source' 
  goto 400 
!------------------------ absorber ----------------------------------   
  200  continue 
!    write(6,'(a,5i6)') '2x2_ref n_all,icase,iflag_SAMP=',n_all,icase,iflag_SAMP,NAS                    

     
     do nall=1,n_all
      ip=nget+5*jges*(nall-1)      
      do jn=ip,ip+(jges-1)*5,5
       Eagd=real(array_fr(jn+1))+aisom 
       nE=ifix(Eagd/srw8+0.5)          ! nE <= sk8
       if (abs(nE).gt.ak8)&
       write(nwr,'(2(a,f10.4),a,i8)')              &
       '**** E(absorber)=',Eagd,' out of range ',ak8*srw8,'[mm/s]',jn+1   
      end do  ! jn=  
     end do   !  nall=1,n_all  

     do n=iput+1,iput+(nAS+1)*8 
       array_fr(n)=(0.,0.) 
     end do
   
     allocate(cLG(-nAS:nAS))
     allocate(temp(8*(nAS+1)),tempid(0:nproc-1,8*(nAS+1)))   
     if(enwr(15).eq.'time') then
        call cpu_time(start); call wall_time(wstart)
     end if
     
     srw=srw8*float(nst)
   
     ii=n_all/nproc; ir=n_all-ii*nproc

      do id=0,nproc-1
       first(id) = id*(n_all/nproc)+1
        last(id) = (id+1)*(n_all/nproc)
      end do
      if(ir.gt.0) then
       first(0)=1; last(0)=1+ii
       do id=1,ir-1
         first(id) = last(id-1)+1
         last(id) = first(id)+ii
       end do
       do id=ir,nproc-1
         first(id) = first(id)+ir
         last(id) = last(id)+ir
       end do
    end if
!print*, ' n_all:',n_all
!print*, ' first:',first
!print*, '  last:',last
nproc_local=nproc; if(ii.eq.0)nproc_local=ir
CALL OMP_SET_NUM_THREADS(nproc_local)
!$OMP PARALLEL  DEFAULT(NONE),  PRIVATE(id,idp,temp,nal,ip,jn,Eagd,gamma) &
!$OMP PRIVATE(w_Lorentz,w_Gauss,fp1p1,fm1m1,fp1m1,fm1p1,rtr,dtr,n,ni,hc,cLG)&
!$OMP SHARED(nget,jges,aisom,gamnat,srw,e_xsi,array_fr) &
!$OMP SHARED(first,last,iflag_Voigt,nAS,tempid,hci,nproc_local)
!$OMP DO

    do idp=0,nproc_local-1
      id = OMP_GET_THREAD_NUM()
      temp=(0.,0.)
      w_Gauss=0.0
      DO nal=first(id),last(id)
       ip=nget+5*jges*(nal-1)        
       do jn=ip,ip+(jges-1)*5,5 
        Eagd=real(array_fr(jn+1))+aisom
        gamma=gamnat-2*aimag(array_fr(jn+1))
        w_Lorentz=gamma/gamnat-1.

        call aLORGAU(Eagd,gamnat,e_xsi,srw,w_Lorentz,w_Gauss,iflag_Voigt,nAS,cLG)
        fp1p1=array_fr(jn+2)
        fm1m1=array_fr(jn+3)
        fp1m1=array_fr(jn+5)
        fm1p1=array_fr(jn+4)
        rtr=-(fp1p1+fm1m1)/2.*hci                  
        dtr=(fp1p1-fm1m1)/2.
        do n=0,nAS 
         ni=8*n      
         hc=cLG(n)
         temp(ni+1)=temp(ni+1)-hc*rtr  
         temp(ni+2)=temp(ni+2)-hc*dtr  
         temp(ni+3)=temp(ni+3)-hc*fp1m1
         temp(ni+4)=temp(ni+4)-hc*fm1p1 
         hc=cLG(-n)
         temp(ni+5)=temp(ni+5)-hc*rtr  
         temp(ni+6)=temp(ni+6)-hc*dtr  
         temp(ni+7)=temp(ni+7)-hc*fp1m1
         temp(ni+8)=temp(ni+8)-hc*fm1p1
!         if(abs(n).le.1)print*,temp(ni+1),rtr
        end do      !   n=
       end do       !   jn=
       if(nal.eq.last(id))tempid(id,:)=temp
      end do        ! nal=
     end do
!$OMP END PARALLEL   
      do id=0,nproc_local-1 
       do n=1,(nAS+1)*8 
         array_fr(iput+n)=array_fr(iput+n)+tempid(id,n)
       end do
      end do

     if(enwr(15).eq.'time') then
       call cpu_time(finish); call wall_time(wfinish)
       print '(" cpu/wall time = ",2f10.4," seconds.")',&
                    finish-start,wfinish-wstart
     end if
    deallocate(cLG,temp,tempid)
    goto 400 
                                                                      
!------------------------------detector-----------------------------------   
  300  continue 
   print'(a)',' only scalar theories are expected' 
                                                                        
  400 return 
      END                                           

      
