      SUBROUTINE TXTPLO(OP,ISTEU,ITEXT,NTEXT,BREITE,HOEHE,alpha,X2,Y2,Z2) 
     use glbconst, only: maxn,MDBPLFT

     
!?>?? logical, parameter :: debug = .false.                             
!-----------------------------------------------------------------------
!                                                                       
!      Sammlung SUBROUTINES fuer Benson-Ansteuerung mit ALLPLO etc.     
!                    25-SEP-1989                                        
!                                                                       
!       Sie enthaelt folgende Subroutines:                              
!       SCALE,VELO,NUMERO,NAXFOR,NFRAME                                 
!       TRANS, ZEICH, TXTPLO, saemtliche Zeichensatze, sowie aus        
!       der Benson-Library  die Subroutines:                            
!       IBENA, TRAA,  POSA, BECENA                                      
!                                                                       
!       pluma modifiziert fuer Rueckgabe der Federposition              
!       M. Alflen  23-aug-1989                                          
!                                                                       
!       txtplo modifiziert fuer Wahl der Feder                          
!       M. Alflen  25-aug-1989                                          
!                                                                       
!       line modifiziert fuer Wahl der Feder                            
!       M. Alflen  29-aug-1989                                          
!                                                                       
!	txtplo modifiziert fuer Umlaute                                       
!	M. Alflen                                                             
!                                                                       
!       zeich um 19 Zeichen erweitert                                   
!       A.Vef      09-aug-1994                                          
                                                                        
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!      PLOTTET EINEN TEXTSTRING  ITEXT  MIT  NTEXT  ZEICHEN IN VERSCHIED
!      SCHRIFTTYPEN  ( ROMAN, ITALIC, SCRIPT, GREEK )  MIT GROSSEN UND  
!      KLEINEN BUCHSTABEN SOWIE SONDERZEICHEN                           
!      DIE VERWENDUNG ALS OBERER ODER UNTERER INDEX IST MOEGLICH        
!      AUSSERDEM VERSCHIEDENE SYMBOLE ( SCHRIFTART 'ZEICHEN' ),         
!      DIE AUCH ZENTRIERT GEZEICHNET WERDEN KOENNEN                     
!                                                                       
!                                 EBERHARD MEISSNER  17.05.83           
!                                                                       
!      modifiziert fuer federwahl                                       
!                                                                       
!                                 M. Alflen  25.8.89                    
!	modifiziert fuer Umlaute                                              
!				  M. Alflen 28.2.1990                                              
!       modifications             h.spiering 27.5.2008                  
!                  \y\Y   symbols included to the text                  
!                  $_,$^  according to Latex                            
!                  + 22 Zeichen called by name $\name                   
!                         according to Latex                            
!                  9 colors called by @n                                
!                  extra changes of charracter size                     
!                                   shift of upper and lower index      
!       further in routines like addtxt.f:                              
!                                                                       
!                  box rotates, colored area                            
!                  colored frame areas                                  
!                  colored background                c                  
!-----------------------------------------------------------------------
!      FUER DEN BENUTZER:                                               
!      -UMSCHALTUNG DER SCHRIFTTYPEN:                                   
!       \R  ODER  \r   :  ROMAN  (VOREINSTELLUNG)                       
!       \I  ODER  \i   :  ITALIC                                        
!       \S  ODER  \s   :  SCRIPT                                        
!       \G  ODER  \g   :  GREEK                                         
!       \Z  ODER  \z   :  ZEICHEN (signs)                               
!       \y             :  Symbol 01-33                                  
!       \Y             :  gefuelltes Symbol 01-33                       
                                                                        
!        \,        2/5 : Leerzeichen                                    
!        \!       -1/5 : Leerzeichen                                    
                                                                        
!       \"a \"o \"u    : Umlaute                                        
!                                                                       
                                                                        
                                                                        
!       $              :  Zurueck zum NORMALBUCHSTABEN  (VOREINSTELLUNG)
!       $^             :  OBERER INDEX                                  
!       $_             :  UNTERER INDEX                                 
!       $P  ODER  $p   :  POSITION FUER SPAETEREN RUECKSPRUNG           
!       $B  ODER  $b   :  RUECKSPRUNG ZUR GEMERKTEN POSITION            
!       $F  ODER  $f   :  SPRUNG VORWAERTS ZUM BISHERIGEN TEXTENDE      
!       $H       *1.2  :  Buchstabengroesse                             
!       $h       /1.2  :  Buchstabengroesse                             
!       $U   (14+...)  :  > shift oberer Index                          
!       $u   (14-...)  :  < shift oberer Index                          
!       $D   (-7-...)  :  > shift unterer Index                         
!       $d   (-7+...)  :  < shift unterer Index                         
!       $m       m     :  multiple Zeichnung  (bold-m fach)             
!       $\name         :  name of Zeichen up to 16 characters           
                                                                        
!      -UMSCHALTUNG Gross/Kleinschreibung und der Feder                 
!       @u oder @U     :  Grosschreibung                                
!       @l oder @L     :  Kleinschreibung                               
!       @c oder @C     :  case Standard                                 
                                                                        
!       @n   n = 0...N :  Wahl der Farbe (x11_ps_colors.txt legt N fest)
!-----------------------------------------------------------------------
!      FUER DEN PROGRAMMIERER :                                         
!      -DIE ELEMENTE VON  ITEXT  MUESSEN IM FORMAT  A1  BESCHRIEBEN SEIN
!      -KOORDINATEN DER LINKEN UNTEREN ECKE DES STRINGS,                
!       Schrift wird in der y,z Ebene geschrieben.                      
!       (alte X0,Y0 == 0)                                               
!       alpha dreht den String in der x,z Ebene.                        
!                                                                       
!       BEI  ISTEU=2  DIE DES ZENTRUMS DES ERSTEN ZEICHEN DES STRINGS   
!      -BREITE  UND  HOEHE  GELTEN FUER EINEN GROSSBUCHSTABEN WIE       
!       ETWA "A"  ( UNTERLAENGEN UND SCHMALERE BUCHSTABEN KOMMEN VOR )  
!      -COSA, SINA  SIND DER COSINUS UND DER SINUS DES WINKELS, DEN     
!       DER TEXTSTRING MIT DER X-RICHTUNG DES PLOTTERS EINSCHLIESST     
!       wird mit alpha berechnet                                        
!      -X2,Y2  SIND DIE KOORDINATEN DER RECHTEN UNTEREN ECKE DES STRINGS
!       BEIM RUECKSPRUNG IN DAS RUFENDE PROGRAMM                        
!      -ISTEU >= 0   PLOTTEN VON  TEXT :                                
!             = 1   STARTKOORDINATE LINKE UNTERE ECKE                   
!             = 2   STARTKOORDINATE ZENTRUM DES ERSTEN ZEICHENS         
!             = 3   WIE  = 2  MIT VERBINDEN DER MITTEN DER ZEICHEN      
!             = -1  BERECHNUNG VON  X2,Y2  OHNE PLOT                    
!-----------------------------------------------------------------------
!     OP,ISTEU,ITEXT,NTEXT,BREITE,HOEHE,alpha,X2,Y2,Z2) 
      implicit none 
      integer     NTEXT,ISTEU 
      real        OP,BREITE,HOEHE,alpha,X2,Y2,Z2 
      dimension   OP(0:8) 
                                                                        
      character*1 IIC,ITEXT,                 &
                  chtxt,ch1,fsym*16                          
      DIMENSION  ITEXT(NTEXT) 
      integer    KOORD(75)                                                                        
                                                                        
!      parameter   (max8subn=maxsub*max8,                               
!     &            idumplot=MDBPLFT*2-176*maxn-8*39-5*infplot-maxsub-100)
!      common/plot/plotx(max8),ploty(max8),ploterry(max8),plotres(max8),
!     &            plotxx(max8),plotyy(max8),plotsub(max8subn),         
!     &            xyzdz(8),vtxt(2,maxn*16),vtxtp(8,32),                 
!     &            int3d(maxn*16),npnt3d(16),ifeder(maxn*16),ltext(32),  
!     &            npntplot(infplot),nchanplot(infplot),ncolor(maxsub), 
!     &            n_subspectra,logx,logy,logf,                         
!     &            namechan(infplot),kform(infplot),axisformat(3),      
!     &            axesname(3),title,plotstrdef,plotstrpu,              
!     &            bgcolor,fgcolor,datacolor,thcolor,rescolor,          
!     &            auxcolor1,auxcolor2,auxcolor3,chardum(idumplot)      
                                                                        
                                                                        
      integer      ifeder,ltext,jcw,int3d,npnt3d
      real         plotdum,xyzdz,vtxt,vtxtp 
      character    chardum*4 
      real, parameter  ::  rad=0.0174533
      integer,parameter:: idumplot=2*MDBPLFT-176*maxn-8*39,max16=maxn*16,  &
                          max112=7*max16,max16_128=max16-128
      common/plot/plotdum(max112),xyzdz(8),vtxt(2,max16),vtxtp(8,32),&
     &            int3d(max16),npnt3d(16),ifeder(max16),ltext(32),   &
     &            chardum(idumplot)                                     

      integer ITYPE,INDEX,I6BIT,JTYPE,JNDEX,J6BIT,jumlaut,MARK,         &
     &        IC,i,j,jpm,IZEICH,IB,IX,IY,jumsiz,KC,IPEN,                &
     &        mult,nmult,iloop,isymbol,k,ICOLOR,npenup               
                                                                        
      logical isymfill 
      real    XB,YB,ZB,XF,YF,ZF,X1,Y1,Z1,H,B,                           &
     &        HX,HY,X,Y,DX,DY,XSHIFT,YSHIFT,WID,HEI,YOFF,XOFF,          &
     &        XHALF,YHALF,XX1,XX2,YY1,YY2,XS,YS,bsize,usize,dsize,      &
     &        penfill,g6,g5,COSA,SINA                                   
                                                                        
!      parameter (IBSL=char(92),IAFFE=char(64),IDACH=char(94),          
!     &           IUMLAUT=char(34), IBLANK=char(32),i0=48)              
      character(len=1),parameter:: IBSL='\\',IAFFE='@',IDACH='^',      &
                                       IUMLAUT='"', IBLANK=' '
      integer,parameter::i0=48                         
                                                                        
!      GROSSE BUCHSTABEN                                                
character(len=1),parameter,dimension(1:26):: &
       ICHAR1=(/'A','B','C','D','E','F','G','H','I','J','K','L','M', &
                'N','O','P','Q','R','S','T','U','V','W','X','Y','Z'/) 
!      KLEINE BUCHSTABEN 
character(len=1),parameter,dimension(1:26):: &                                               
       ICHAR2=(/'a','b','c','d','e','f','g','h','i','j','k','l','m', &
                'n','o','p','q','r','s','t','u','v','w','x','y','z'/) 
!      NUMERISCHE- UND SONDERZEICHEN 
character(len=1),parameter,dimension(1:37):: &                                   
       ICHAR3=(/'0','1','2','3','4','5','6','7','8','9','.',',',':', &
                ';','!','?','<','>','&','$','/','(',')','*','-','+', &
                '=',IBSL,'"','#','[',']','%','_','{','}','|'/)       
character(len=16),parameter,dimension(1:43):: &
    sonderz=(/'Int             ','Aring           ','underscore      ',&
              'hat             ','rightarrow      ','leftarrow       ',&
              'leftrightarrow  ','Rightarrow      ','Leftarrow       ',&
              'Leftrightarrow  ','vert            ','uparrow         ',&
              'downarrow       ','updownarrow     ','cdot            ',&
              'parallel        ','neq             ','sim             ',&
              'perp            ','approx          ','hbar            ',&
              'at              ','backslash       ','number          ',&
              'section         ','infty           ','int             ',&
              'oint            ','sqrt            ','overscore       ',&
              'frac            ','nabla           ','partial         ',&
              'cap             ','supset          ','subset          ',&
              'cup             ','tilde           ','propto          ',&
              'geqq            ','leqq            ','pm              ',&
              'mp              '/)                                      

!      UMGEORDNETE STARTWERTE FUER GROSSE UND KLEINE GRIECH. BUCHSTABEN 
integer,dimension(1:26),parameter:: &
           ICHARG=(/1,2,7,4,5,21,3,22,9,0,10,11,12,                    &
                   13,15,16,8,17,18,19,20,0,24,14,23,6/)                
!      UMGEORDNETE STARTWERTE FUER ROMAN NUMERISCHE/SONDERZEICHEN       
integer,dimension(1:37),parameter:: &
         ICHARN=(/1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,27,28,        &
                 29,30,21,22,23,20,24,25,26,17,18,37,31,32,33,34,      &
                 35,36,38/)                                             
                                                                        
      if(NTEXT.eq.0)return 
      penfill=0.1 
!      write(6,'(80a1)')(ITEXT(i),i=1,NTEXT)                            
!      IBLANK=' '                                                       
!      IBSL=char(92)   ! \                                              
!      IAFFE=char(64)  ! @                                              
!      IDACH=char(94)  ! ^                                              
!      IUMLAUT='"'                                                      
!      i0=ichar('0')                                                    
      npenup=-1 
!       write(6,'(a,i2,2x,80a1)')' TEXTPLO NTEXT ITEXT=',               
!     &                     NTEXT,(ITEXT(i),i=1,NTEXT)                  
!       write(6,'(a)')'X0,Y0,ISTEU,ITEXT,NTEXT,BREITE,HOEHE,COSA,SINA'  
!       write(6,'(2f10.2,i3,4g12.3)')X0,Y0,ISTEU,BREITE,HOEHE,COSA,SINA 
                                                                        
      if(ISTEU.gt.-1) then 
       j=1 
       do while(ltext(j).ne.0.and.j.lt.32) 
        j=j+1 
       end do 
       if(j.eq.1)then 
        jcw=0 
       else 
        jcw=abs(ltext(j-1)) 
       end if 
       do i=1,8 
        vtxtp(i,j)=OP(i) 
       end do 
      end if 
      
                                                                 
      COSA=cos(alpha*rad) 
      SINA=sin(alpha*rad)
                                                                        
!      VORBESETZEN VON SCHRIFTART (ROMAN) , INDEX (NORMAL), 6-BIT-ASCII 
      ITYPE = 1 
      INDEX = 1 
      I6BIT = 0 
!      VORBESETZEN DER UMSCHALTINDIKATOREN                              
      JTYPE = 0 
      JNDEX = 0 
      J6BIT = 0 
      jumlaut=0 
!      VORBESETZUNG DER BUCHHALTER VON  @M, @B, @F                      
      MARK = 0 
      XB = 0. 
      YB = 0. 
      XF = 0. 
      YF = 0. 
!                                                                       
      X1 = 0. 
      Y1 = 0. 
      Z1=HOEHE 
      H = HOEHE/21. 
      B = BREITE/20. 
      bsize=1. 
      usize=0. 
      dsize=0. 
      nmult=1 
      ICOLOR=0 
                                                                        
                                                                        
!      SCHLEIFE UEBER ALLE  NTEXT  ZEICHEN                              
      IC=0 
      DO while(IC.lt.NTEXT) 
       IC=IC+1 
       chtxt= ITEXT(IC) 
!      WAR DAS LETZTE ZEICHEN EIN UMSCHALTZEICHEN, SO DUERFEN NUR       
!      BESTIMMTE ZEICHEN AUFTRETEN :   VERZWEIGUNG                      
      IF ( JTYPE.NE.0 ) GO TO 500 
      IF ( JNDEX.NE.0 ) GO TO 600 
      IF ( J6BIT.NE.0 ) GO TO 700 
!      ES WURDE KEIN SCHALTZEICHEN ERWARTET                             
!                                                                       
!      BLANK ODER UMSCHALTZEICHEN ?                                     
   50 IF ( chtxt.EQ.IBLANK) goto 800 
      IF ( chtxt.EQ.IBSL )  GO TO 810 
      IF ( chtxt.EQ.'$' )   GO TO 820 
      IF ( chtxt.EQ.IAFFE)  GO TO 830 
!      ES HANDELT SICH WEDER UM EIN BLANK NOCH UM EIN UMSCHALTZEICHEN   
!                                                                       
!      GROSSBUCHSTABE ?                                                 
  100 continue
      DO I=1,26 
       J = I 
       IF ( chtxt.EQ.ICHAR1(I) ) GO TO 120 
      END DO 
!      KEIN GROSSBUCHSTABE, WEITERSUCHEN                                
      GO TO 200 
!      GROSSBUCHSTABE ERKANNT, VERZWEIGUNG NACH SCHRIFTTYP              
!      FALLS JEDOCH  I6BIT  GESETZT IST, SOLL EIN KLEINER               
!      BUCHSTABE GEZEICHNET WERDEN                                      
  120 IF ( I6BIT.eq.2 ) GO TO 220 
      GO TO (130,140,150,160,170), ITYPE 
  130 CALL GROMAN (J,KOORD) 
      GO TO 400 
  140 CALL GITALI (J,KOORD) 
      GO TO 400 
  150 CALL GSCRIP (J,KOORD) 
      GO TO 400 
!      GRIECHISCHE BUCHSTABEN : ANDERE REIHENFOLGE DES ALPHABETS : UMORD
  160 J = ICHARG(J) 
!      "J" UND "V" GIBT ES NICHT : WIE BLANK BEHANDELN                  
      IF ( J.EQ.0 ) GO TO 800 
      CALL GGREEK (J,KOORD) 
      GO TO 400 
!      SCHRIFTART  ZEICHEN :  BUCHSTABE ALS ZIFFER "0" INTERPRETIERT    
  170 J = 0 
      GO TO 360 
!                                                                       
!      KLEINBUCHSTABE ?                                                 
  200 continue
      DO I=1,26 
       J = I 
       IF ( chtxt.EQ.ICHAR2(I) ) GO TO 215 
      END DO 
!      KEIN KLEINBUCHSTABE, WEITERSUCHEN                                
      GO TO 300 
!      KLEINBUCHSTABE ERKANNT, VERZWEIGUNG NACH SCHRIFTTYP              
  215 IF ( I6BIT.eq.1 ) GO TO 120 
  220 GO TO (230,240,250,260,270), ITYPE 
  230 CALL KROMAN (J,KOORD) 
      GO TO 400 
  240 CALL KITALI (J,KOORD) 
      GO TO 400 
  250 CALL KSCRIP (J,KOORD) 
      GO TO 400 
!      GRIECHISCHE BUCHSTABEN : ANDERE REIHENFOLGE DES ALPHABETS : UMORD
  260 J = ICHARG(J) 
!      "J" UND "V" GIBT ES NICHT : WIE BLANK BEHANDELN                  
      IF ( J.EQ.0 ) GO TO 800 
      CALL KGREEK (J,KOORD) 
      GO TO 400 
!      SCHRIFTART  ZEICHEN :  BUCHSTABE ALS ZIFFER "0" INTERPRETIERT    
  270 J = 0 
      GO TO 360 
!                                                                       
!      NUMERISCHES- ODER SONDERZEICHEN ?                                
  300 continue
      DO I=1,37 
       J = I 
       IF ( chtxt.EQ.ICHAR3(I) ) GO TO 320 
      END DO 
!      KEIN NUMERISCHES- ODER SONDERZEICHEN                             
!      KANN NICHT IDENTIFIZIERT WERDEN : WIE BLANK BEHANDELN            
      GO TO 800 
!      NUM./SONDERZEICHEN ERKANNT, VERZWEIGUNG NACH SCHRIFTTYP          
  320 GO TO (330,340,340,330,350,350), ITYPE 
!      ROMAN  NUM./SONDERZEICHEN : ANDERE REIHENFOLGE : UMORDNEN        
  330 J = ICHARN(J) 
      CALL NROMAN (J,KOORD) 
      GO TO 400 
  340 CALL NSCRIP (J,KOORD) 
      GO TO 400 
!      ZEICHEN: J=1,..,10  ENTSPRICHT ZIFFERN  0,..,9                   
  350 IF ( J.LE.10 ) J = J-1 
!      J > 10 :  KEINE ZIFFER, WIE "0" BEHANDELN                        
      IF ( J.GT.10 ) J = 0 
!                                                                       
!      AUSWERTUNG FUER ZEICHEN (ITYPE=5)                                
!      HINTER \Z WURDE EINE ZIFFER (J=0,..,9) ODER EIN ANDERES ZEICHEN  
!      GEFUNDEN (INTERPRETIERT ALS J=0). JE ZWEI SOLCHER ZEICHEN WERDEN 
!      PAARWEISE ALS ZWEISTELLIGE INTEGERZAHL INTERPRETIERT.            
  360 IZEICH =J 
      if(IC+1.le.NTEXT)then 
       J=ichar(ITEXT(IC+1))-i0 
       if(J.ge.0.and.J.le.9)then 
        IC=IC+1 
        IZEICH=10*IZEICH+J 
       end if 
      end if 
      J=IZEICH 
      IF ( J.ge.1) GO TO 380 
!      J = 0  ODER J > 32 :  FALSCHE EINGABE                            
!      MIT GEHOBENER FEDER NACH (X1,Y1), BEI  ISTEU = 3  GESENKTE FEDER 
  370 IPEN = npenup 
      IF ( ISTEU.EQ.3 ) IPEN  = ICOLOR 
      CALL TRAA (X1,Y1,IPEN,jcw) 
      GO TO 1000 
!     VORHANDENES ZEICHEN                                               
  380 if(ITYPE.eq.5)then 
        CALL ZEICH (J,KOORD) 
        if(j.lt.0)goto 370 
      else if(ITYPE.eq.6)then 
       isymbol=J 
       if(J.lt.1.or.J.gt.33) goto 370 
       goto 490 
      end if 
      GO TO 400 
!                                                                       
!      DIE ZIELKOORDINATEN  KOORD  SIND VON DER RICHTIGEN SUBROUTINE UEB
  400 if(J.lt.0)goto 491 
      IPEN = npenup 
!      BREITE DES BUCHSTABENS  = IB                                     
      IB = KOORD(1) 
!      FALLS  ISTEU=0 , SOLL NUR  X2,Y2  BERECHNET WERDEN               
!      DAHER WERDEN DIE FAHRBEFEHLE UEBERSPRUNGEN                       
      IF ( ISTEU.eq.-1) GO TO 900 
!      FALLS  ISTEU = 3 :  VERBINDEN DER (X1,Y1)                        
      IF ( ISTEU.EQ.3 ) CALL TRAA (X1,Y1,ICOLOR,jcw) 
!      SCHLEIFE UEBER DIE FAHRBEFEHLE EINES BUCHSTABENS                 
                                                                        
      jpm=1 
      do mult=1,nmult 
       jpm=-jpm 
       XS=X1+float(mult-1)*0.0125 
       YS=Y1+float(mult-1)*0.0125 
                                                                        
       DO J=2,75 
        if(KOORD(J).lt.0) then 
         IY = ( KOORD(J) - 30 ) / 100 
        else 
         IY = ( KOORD(J) + 30 ) / 100 
        end if 
        IX = KOORD(J) - 100*IY 
!       IX = 50, IY = 50 :  BUCHSTABE ZU ENDE                            
!       IX = 50, IY =  0 :  PENUP (SONST STETS PENDOWN)                  
        IF ( IX.NE.50 ) GO TO 420 
        IF ( IY.EQ.50 ) GO TO 480 
        IF ( IY.NE. 0 ) GO TO 420 
!       50, 0  GEFUNDEN :  PENUP   UND DANN NEUEN KOORDINATENPUNKT ANSTEU
        IPEN = npenup 
        GO TO 470 
!       NORMALER KOORDINATENPUNKT                                        
  420   CONTINUE 
!       FALLS  ISTEU=2 : ZENTRIEREN DER ZEICHEN/BUCHSTABEN               
        IF ( ISTEU.NE.2 ) GO TO 421 
        IX = IX - IB/2 
        IY = IY - 10 
!       VERZWEIGUNG JE NACH INDEX                                        
  421   GO TO (430,440,450), INDEX 
!       NORMALES TEXTFORMAT                                              
  430   HX = IX 
        HY = IY 
        GO TO 460 
!       OBERER INDEX                                                     
  440   HX =  0.6*IX 
        HY = (14.+usize)/bsize + 0.6*IY 
        GO TO 460 
!       UNTERER INDEX                                                    
  450   HX =  0.6*IX 
        HY = -(7.+dsize)/bsize + 0.6*IY 
!       BERECHNUNG DER ABSOLUTEN KOORDINATEN                             
  460   X = XS + ( HX*B*COSA - HY*H*SINA ) 
        Y = YS + ( HY*H*COSA + HX*B*SINA ) 
        CALL TRAA (X,Y,IPEN,jcw) 
        IPEN = ICOLOR 
  470   continue
       END DO 
                                                                        
  480  CONTINUE 
!                                                                       
!      Umlaute zeichnen                                                  
!                                                                       
       IF (JUMLAUT .EQ. 1) THEN 
        DX = 6.66 * ( B*SINA ) 
        DY = 6.66 * ( B*COSA ) 
        XSHIFT = 19.95 * (H*COSA ) 
        YSHIFT =-19.95 * (H*SINA ) 
        IF (ITYPE .EQ. 3 .AND. JUMSIZ .EQ. 0) THEN 
         XSHIFT=XSHIFT*.8 
         YSHIFT=YSHIFT*.8 
        END IF 
        IF (JUMSIZ .EQ. 1) THEN 
          YSHIFT=YSHIFT*1.25 
          XSHIFT=XSHIFT*1.25 
        END IF 
        WID=1.60*B 
        HEI=1.68*H 
        IF (INDEX .GT. 1) THEN 
         IF (INDEX .EQ. 2) THEN 
          YOFF=yshift*.33 
          XOFF=xshift*.33 
         END IF 
         IF (INDEX .EQ. 3) THEN 
          YOFF=-yshift*.8 
          XOFF=-xshift*.8 
         END IF 
         DX=DX*.66 
         DY=DY*.66 
       WID=WID*.66 
       HEI=HEI*.66 
        ELSE 
         YOFF=0. 
         XOFF=0. 
        END IF 
        XHALF= DX/.33*IB/40 
        YHALF= DY/.33*IB/40 
        XX1 = YS + (XHALF-DX/2.) + (XOFF+XSHIFT) 
        XX2 = YS + (XHALF+DX/2.) + (XOFF+XSHIFT) 
        YY1 = XS + (YOFF+YSHIFT) + (YHALF-DY/2.) 
        YY2 = XS + (YOFF+YSHIFT) + (YHALF+DY/2.) 
        CALL BECENA(YY1,XX1,IPEN,14,WID,HEI,COSA,SINA,jcw) 
        CALL BECENA(YY2,XX2,IPEN,14,WID,HEI,COSA,SINA,jcw) 
        CALL TRAA(XS,YS,npenup,jcw) 
       END IF 
       IPEN = npenup 
                ! mult                                                  
      end do 
      JUMLAUT=0 
                                                                        
      goto 491 
  490 continue 
      IPEN=ICOLOR 
      YS=Y1+H*11*SINA+B*10*COSA 
      XS=X1-B*10*SINA+H*11*COSA 
!      write(6,'(a,i3,6f10.3)')'ISTEU,YS,XS,Y1,X1=',ISTEU,YS,XS,Y1,X1   
      if(ISTEU.gt.0) then 
      if(isymfill) then 
         iloop=ifix(amin1(B*14,H*16)/penfill)+1 
                                         ! fill up symbol               
         do k=1,iloop 
          g5=B*14-(k-1)*penfill 
          if ( g5 .gt. 0 ) then 
           g6=H*16-(k-1)*penfill 
           if ( g6 .gt. 0 ) then 
            if ( isymbol .ne. 33 ) then 
                                                                 ! plot 
             call becena(XS,YS,IPEN,isymbol,g5,g6,COSA,SINA,jcw) 
            else 
             g5=(g5+g6)/4. 
                                                              ! plot cir
             CALL BCERCA (XS,YS,IPEN,g5,90.,360.,jcw) 
            end if 
           end if 
          end if 
         end do 
      else 
       if ( isymbol .ne. 33 ) then 
        g5=B*14 
        g6=H*16 
        call becena(XS,YS,IPEN,isymbol,g5,g6,COSA,SINA,jcw) 
       else 
        g5=(B*14+H*16)/4. 
                                                         ! plot circle  
        CALL BCERCA (XS,YS,IPEN,g5,90.,360.,jcw) 
       end if 
      end if 
      end if 
                                                                        
  491 continue 
                                                                        
!      BUCHST./ZIFFER/ZEICHEN ABGEARBEITET                              
!      FALLS  ISTEU = 2,3 :  MIT GEHOBENER FEDER NACH (X1,Y1)           
      IF ( ISTEU.EQ.2 .OR. ISTEU.EQ.3 ) CALL TRAA (X1,Y1,npenup,jcw) 
      GO TO 900 
!                                                                       
!      ES WIRD EINE STEUERUNG DES SCHRIFTTYPES ERWARTET                 
!      ZULAESSIGE ZEICHEN SIND :                                        
!          \R,r       ROMAN         ITYPE = 1                           
!          \I,i       ITALIC        ITYPE = 2                           
!          \S,s       SCRIPT        ITYPE = 3                           
!          \G,g       GREEK         ITYPE = 4                           
!          \Z,z       ZEICHEN       ITYPE = 5                           
!          \,        2/5   Leerzeichen                                  
!          \!       -1/5   Leerzeichen                                  
                                                                        
!          \"a \"o \"u      Umlaute                                     
                                                                        
  500 JTYPE = 0 
      if( chtxt.eq.'r'.or.chtxt.eq.'R')then 
!      SCHRIFTTYP  ROMAN  GEWUENSCHT                                    
       ITYPE = 1 
      else if( chtxt.eq.'i'.or.chtxt.eq.'I')then 
!      SCHRIFTTYP  ITALIC  GEWUENSCHT                                   
       ITYPE = 2 
      else if( chtxt.eq.'s'.or.chtxt.eq.'S')then 
!      SCHRIFTTYP  SCRIPT  GEWUENSCHT                                   
       ITYPE = 3 
      else if( chtxt.eq.'g'.or.chtxt.eq.'G')then 
!      SCHRIFTTYP  GREEK  GEWUENSCHT                                    
       ITYPE = 4 
      else if( chtxt.eq.'z'.or.chtxt.eq.'Z')then 
!      SCHRIFTART  ZEICHEN  GEWUENSCHT                                  
       ITYPE = 5 
      else if( chtxt.eq.'y')then 
!      SCHRIFTART  Symbol  GEWUENSCHT                                   
       ITYPE = 6 
       isymfill=.false. 
      else if( chtxt.eq.'Y')then 
!      SCHRIFTART  Symbol  GEWUENSCHT                                   
       ITYPE = 6 
       isymfill=.true. 
      else if( chtxt.eq.',')then 
!      Blank der Groesse \, gefunden                                    
       GO TO 801 
      else if( chtxt.eq.'!')then 
!      Blank der Groesse \! gefunden (Ruecksetzung)                     
       GO TO 802 
      else if( chtxt.eq.'"')then 
!      \" gefunden (UMLAUT)                                             
       GO TO 840 
      else if( chtxt.eq.'$')then 
!      \$  gefunden Steuerzeichen $ wird gezeichnet                     
       GO TO 300 
      else if( chtxt.eq.IBSL)then 
!      \\  gefunden Steuerzeichen $ wird gezeichnet                     
       J=23 
       CALL ZEICH (J,KOORD) 
       GO TO 400 
      else if( chtxt.eq.IAFFE)then 
!      \@  gefunden Steuerzeichen $ wird gezeichnet                     
       J=22 
       CALL ZEICH (J,KOORD) 
       GO TO 400 
      end if 
      GO TO 1000 
!                                                                       
!      ES WIRD EINE STEUERUNG DES INDEX ERWARTET                        
!      ZULAESSIGE ZEICHEN SIND :                                        
!          $                                                            
!          $^         OBERER INDEX     INDEX = 2                        
!          $_         UNTERER INDEX    INDEX = 3                        
!          $P,p       POSITION X1,Y1 MERKEN                             
!          $B,b       ZURUECK ZUR GEMERKTEN POSITION                    
!          $F,f       VORWAERTS ZUR BISHER WEITESTEN POSITION           
!          $H         *1.2   Buchstabengroesse                          
!          $h         /1.2   Buchstabengroesse                          
!       $U   (14+...)  :  > shift oberer Index                          
!       $u   (14-...)  :  < shift oberer Index                          
!       $D   (-7-...)  :  > shift unterer Index                         
!       $d   (-7+...)  :  < shift unterer Index                         
!          $m         m     multiple Zeichnung  (bold)                  
                                                                        
                                                                        
                                                                        
  600  ch1=chtxt 
       JNDEX = 0 
       i=ichar(ch1)-i0 
       if(i.gt.0.and.i.lt.10) ch1='m' 
!      NORMALBUCHSTABE GEWUENSCHT                                       
      if(ch1.eq.'^')then 
!      OBERER INDEX GEWUENSCHT                                          
       INDEX = 2 
      else if(ch1.eq.'_')then 
!      UNTERER INDEX GEWUENSCHT                                         
       INDEX = 3 
      else if( ch1.eq.'H')then 
!      $H  gefunden Buchstabengroesse *1.2                              
       bsize=bsize*1.2 
       H=H*1.2 
       B=B*1.2 
      else if( ch1.eq.'h')then 
!      $h  gefunden Buchstabengroesse /1.2                              
       bsize=bsize/1.2 
       H=H/1.2 
       B=B/1.2 
      else if( ch1.eq.'U')then 
!      $h  gefunden Buchstabengroesse /1.2                              
       usize=usize+3 
      else if( ch1.eq.'u')then 
!      $h  gefunden Buchstabengroesse /1.2                              
       usize=usize-3 
      else if( ch1.eq.'D')then 
!      $h  gefunden Buchstabengroesse /1.2                              
       dsize=dsize+3 
      else if( ch1.eq.'d')then 
!      $h  gefunden Buchstabengroesse /1.2                              
       dsize=dsize-3 
      else if( ch1.eq.'m')then 
!      $m  gefunden Buchstabengroesse                                   
       nmult=i 
      else if(ch1.eq.'p'.or.ch1.eq.'P')then 
!      MERKEN DER AKTUELLEN X1,Y1 AUF XB,YB                             
       MARK = 1 
       XB = X1 
       YB = Y1 
       ZB = Z1 
      else if(ch1.eq.'b'.or.ch1.eq.'B')then 
!      RUECKSPRUNG AUF (XB,YB),                                         
!      MERKEN DER AKTUELLEN X1,Y1 AUF XF,YF                             
       IF ( MARK.EQ.0 ) GO TO 1000 
!      RUECKSPRUNGSTELLE BEKANNT                                        
       XF = X1 
       YF = Y1 
       ZF = Z1 
       X1 = XB 
       Y1 = YB 
       Z1 = ZB 
      else if(ch1.eq.'f'.or.ch1.eq.'F')then 
!      SPRUNG AUF (XF,YF), FALLS DIESER WEITER RECHTS STEHT             
!      ALS DAS AKTUELLE (X1,Y1)                                         
       MARK = 0 
       IF ( (X1-XF)*COSA.lt.0) X1 = XF 
       IF ( (Y1-YF)*SINA.lt.0) Y1 = YF 
       IF ( (Z1-ZF)*SINA.lt.0) Z1 = ZF 
      else if(ch1.eq.' ')then 
       H=H/bsize 
       B=B/bsize 
       nmult=1 
       INDEX=1 
      else if(ch1.eq.IBSL)then 
       IC=IC+1 
       ch1=ITEXT(IC) 
       i=1 
       do while(ch1.ne.' '.and.ch1.ne.'$'.and.ch1.ne.'@'                &
     &           .and.ch1.ne.IBSL.and.IC.le.NTEXT)                      
        fsym(i:i)=ch1 
!        write(6,'(i4,2a)')IC,'   fsym=',fsym(:i)                       
        i=i+1 
        IC=IC+1 
        if(IC.gt.NTEXT)then 
         ch1='$' 
        else 
         ch1=ITEXT(IC) 
        end if 
       end do 
       IC=IC-1 
       i=i-1 
!        write(6,'(2i4,2a)')NTEXT,IC,'  # fsym=',fsym(:i)               
       J=1 
       do while(fsym(:i).ne.sonderz(J)(:i).and.J.le.42) 
        J=J+1 
       end do 
       if(J.gt.0.and.J.le.43)then 
        CALL ZEICH (J,KOORD) 
        GO TO 400 
       end if 
      end if 
      GO TO 1000 
                                                                        
!      ES WIRD EINE UMSTEUERUNG GROSS-/KLEINBUCHSTABE ERWARTET          
!      ZULAESSIGE ZEICHEN SIND :                                        
!           @                                                           
!           @U,u       Grossbuchstaben               I6BIT = 1          
!           @L,l       KLEINBUCHSTABEN MIT 6-BIT     I6BIT = 2          
!           @C,c       Buchstaben gross(shift)/klein I6BIT = 0          
!           @n         0<=n<=9     Farbe der Feder                      
                                                                        
  700 continue 
      J6BIT = 0 
      I6BIT = 0 
      i=ichar(chtxt)-i0 
      if(i.ge.0.and.i.le.9)then 
       k=ichar(ITEXT(IC+1))-i0 
       if(k.ge.0.and.k.le.9)then 
!       second number                                                   
        i=10*i+k 
        IC=IC+1 
        if(ITEXT(IC+1).eq.' ')IC=IC+1 
       end if 
      else 
       i=-1 
      end if 
      if( chtxt.eq.'u'.or.chtxt.eq.'U')then 
!      7-BIT-ASCII (UMSCHALTUNG MIT 'SHIFT') GEWUENSCHT                 
       I6BIT = 1 
      else if( chtxt.eq.'l'.or.chtxt.eq.'L')then 
!      KLEINBUCHSTABEN BEI 6-BIT-ASCII GEWUENSCHT                       
       I6BIT = 2 
      else if( chtxt.eq.'c'.or.chtxt.eq.'C')then 
!      gross(shift)/klein GEWUENSCHT                                    
       I6BIT = 0 
      else if(i.ge.0)then 
!      federwahl                                                        
       ICOLOR=i 
      else 
       ICOLOR=1 
       goto 50 
      end if 
      GO TO 1000 
                                                                        
!      BLANK, GEFUNDEN                                                  
  800 IB = 20 
      goto 803 
  801 IB=8 
      goto 803 
  802 IB=-4 
                                                                        
  803 IF ( ITYPE.NE.5 ) GO TO 900 
!      ZEICHEN: BLANK ALS "0" INTERPRETIEREN                            
      J = 0 
      GO TO 360 
!      BACKSLASH  "\"  GEFUNDEN                                         
  810 JTYPE = 1 
      GO TO 1000 
!     Dollar   "$"  GEFUNDEN                                            
  820 JNDEX = 1 
      GO TO 1000 
!     KLAMMERAFFE  "@"  GEFUNDEN                                        
  830 J6BIT = 1 
      GO TO 1000 
                                                                        
  840 IF (JUMLAUT .NE. 1) THEN 
       KC=IC 
       IF (KC .LE. NTEXT .AND. ITYPE .LE. 3) THEN 
        IIC=ITEXT(KC) 
        IF (IIC .EQ. ICHAR1(1) .OR. IIC .EQ. ICHAR1(15) .OR.            &
     &      IIC .EQ. ICHAR1(21) ) THEN                                  
         JUMLAUT=1 
         JUMSIZ=1 
        ELSE IF(  IIC .EQ. IUMLAUT .OR.                                 &
     &            IIC .EQ. ICHAR2(1) .OR. IIC .EQ. ICHAR2(15) .OR.      &
     &            IIC .EQ. ICHAR2(21) ) THEN                            
         JUMLAUT=1 
         JUMSIZ=0 
        else 
         jumlaut=0 
        END IF 
       END IF 
       GO TO 1000 
              ! doppeltes "                                             
      ELSE 
       JUMLAUT=0 
       GO TO 100 
      END IF 
!                                                                       
!      BUCHSTABE IST FERTIG, X1,Y1 WERDEN UM DIE BUCHSTABENBREITE ERHOEH
!      DIESE IST   =IB        ,  FALLS  INDEX = 1        (NORMALBUCHSTAB
!                  =0.6*IB    ,  FALLS  INDEX = 2, 3     (OBERER, UNTERE
  900 CONTINUE 
       IF ( INDEX.GT.1 ) GO TO 910 
!      INDEX = 1                                                        
      X1 = X1 + IB*B*COSA 
      Y1 = Y1 + IB*B*SINA 
      if(Z1.lt.H*21) Z1=H*21 
!      BUCHSTABE FERTIG                                                 
      GO TO 1000 
!      INDEX = 2, 3                                                     
  910 CONTINUE 
      X1 = X1 + 0.6*IB*B*COSA 
      Y1 = Y1 + 0.6*IB*B*SINA 
      if(Z1.lt.H*21) Z1=H*21 
!      BUCHSTABE FERTIG                                                 
 1000 CONTINUE 
      end do 
      X2 = X1 
      Y2 = Y1 
      Z2 = Z1 
!      ITEXT  IST ABGEARBEITET                                          
!      DIE LAGE DER RECHTEN UNTEREN ECKE DER TEXTZEICHNUNG              
!      WIRD AN DAS RUFENDE PROGRAMM ZURUECKUEBERGEBEN                   
!                                                                       
!     wahl der startfeder                                               
      if(ISTEU.gt.-1) then 
       j=1 
       do while(ltext(j).ne.0.and.j.lt.32) 
        j=j+1 
       end do 
       ltext(j)=jcw 
       if(OP(0).eq.0)ltext(j)=-jcw 
      if(jcw.gt.max16_128) return 
       ifeder(jcw+1)=npenup 
!       write(6,'(a,2i5,3x,9f7.2)')' j,jcw,OP=',j,jcw,OP                
      end if 
!      write(6,'(a,4f10.2)')' X2,Y2,Z2=',X2,Y2,Z2                       
      RETURN 
      END                                           
!-----------------------------------------------------------------------
!***********************************************************************
!                                                                       
!     BENSON-LIBRARY                                                    
!                                                                       
!***********************************************************************
      SUBROUTINE TRAA(X,Y,J,jcw) 
      use glbconst, only: maxn,MDBPLFT
      implicit none
      integer    J,jcw,IX,IY 
      real       X,Y,XP,YP,XV,YV 
      COMMON /BENXY/ IX,IY,XP,YP,XV,YV 

      real,parameter   :: rad=0.0174533 
      integer,parameter:: idumplot=2*MDBPLFT-176*maxn-8*39,max16=maxn*16,  &
                          max112=7*max16
      character    chardum*4 
      integer      ifeder,int3d,npnt3d,ltext 
      real         plotdum,xyzdz,vtxt,vtxtp 
      common/plot/plotdum(max112),xyzdz(8),vtxt(2,max16),vtxtp(8,32),&
     &            int3d(max16),npnt3d(16),ifeder(max16),ltext(32),   &
     &            chardum(idumplot)                                     
      jcw=jcw+1 
      vtxt(1,jcw)=X 
      vtxt(2,jcw)=Y 
      ifeder(jcw)=J 
      RETURN 
      END                                           
                                                                        
      SUBROUTINE  BECENA(X,Y,J,ICA,HX,HY,COSA,SINA,jcw) 
      implicit none
! X Y COORDONNEES DU CENTRE DU SYMBOLE DEFINI DANS UN CARRE             
!         4 * 4                                                         
!     J   MEME DEFINITION QUE DANS TRAA                                 
!     ICA RANG DU CARACTERE DANS LA TABLE                               
!    HX,HY  DIMENSIONS DU CARACTERE EN CENTIMETRES                      
      integer  J,ICA,jcw,ICOLOR,ID,IFIN,IND,JP,KX,KY,npenup
      real     X,Y,HX,HY,COSA,SINA,DX,DY,XA,YA,TX,TY                                                                    

real,parameter,dimension(1:5):: AT=(/0.,0.25,0.50,0.75,1.0/)
 
integer,parameter,dimension(1:32):: &
         IOC=(/11,15,7,3,1,5,9,13,17,22,66,71,27,28,34,35,42,43,48,49,  &
               54,55,60,61,76,81,86,92,98,104,110,111/)
integer,parameter,dimension(1:121):: &                  
        IDC=(/124,122,142,-122,142,122,120,-122,102,122,124,-122,120,  &
              122,102,-122,124,120,2,142,-122,104,140,0,144,-122,124,  &
              24,102,120,142,124,-22,124,24,104,100,140,144,124,-22,   &
              124,24,100,140,124,-22,120,20,104,144,120,-22,102,2,140, &
              144,102,-22,142,42,104,100,142,-22,4,122,120,44,-122,0,  &
              122,124,40,-122,104,144,100,140,-122,104,100,144,140,    &
              -122,112,124,132,122,120,-122,123,102,121,122,142,-122,  &
              112,120,132,122,124,-122,123,142,121,122,102,-122,124,   &
              24,114,103,101,110,130,141,143,134,124,-22/)              
      ICOLOR=J 
      npenup=-1 
      CALL TRAA(X,Y,npenup,jcw) 
      IF(ICA.le.0.or.ICA-32.gt.0)goto 10 
      IFIN=1 
!      CALL POSA(XA,YA)                                                 
      XA=X 
      YA=Y 
!      write(6,'(a,8f10.3,4x,3i5)')'X,Y,XA,YA=',X,Y,XA,YA,COSA,SINA,HX,H
      XA=XA-(HX*COSA-HY*SINA)*0.5 
      YA=YA-(HX*SINA+HY*COSA)*0.5 
      IND=IOC(ICA) 
    3 ID=IDC(IND) 
      IF(ID.ge.0)goto 5 
      IFIN=2 
      ID=-ID 
    5 JP=ID/100 
      KX=(ID-JP*100)/10 
      KY=ID-JP*100-KX*10+1 
      KX=KX+1 
      TX=HX*AT(KX) 
      TY=HY*AT(KY) 
      DX=XA+TX*COSA-TY*SINA 
      DY=YA+TX*SINA+TY*COSA 
!      write(6,'(a,2f10.3,4x,3i5)')'DX,DY,JP,jcw=',DX,DY,JP,KX,KY       
      if(JP.eq.0)then 
       CALL TRAA(DX,DY,npenup,jcw) 
      else 
       CALL TRAA(DX,DY,ICOLOR,jcw) 
      end if 
      GO TO (6,10),IFIN 
    6 IND=IND+1 
      GO TO 3 
   10 RETURN 
      END                                           
                                                                        
      SUBROUTINE BCERCA(X,Y,J,R,ANG,DANG,jcw)
      implicit none
      integer  J,jcw,ICOLOR,I,JJ
      real     X,Y,R,ANG,DANG,A,EPS,RAD,XP,YP,ALF,XX,YY,DELTA,PHI
      ICOLOR=J 
      J=0 
!      J=-1             !pen down                                       
!      write(6,'(a,i4)')' BCERCA J=',ICOLOR                             
      A=0.5 
      EPS=0.02 
      RAD=0.01745329 
      I=J-2 
      IF(I.ge.0)goto 2 
      JJ=J 
      XP=X 
      YP=Y 
      GO TO 3 
    2 JJ=I 
!      CALL POSA(XP,YP)                                                 
      XP=X 
      YP=Y 
      XP=XP+X 
      YP=YP+Y 
    3 IF(R.gt.0) goto 5 
      CALL TRAA(XP,YP,JJ,jcw) 
      GO TO 100 
    5 ALF=ANG*RAD 
      XX=XP + R*COS(ALF) 
      YY=YP + R*SIN(ALF) 
      CALL TRAA(XX,YY,JJ,jcw) 
      PHI=SQRT(EPS/(A+R)) 
      IF(DANG.eq.0)goto 100 
      IF(DANG.lt.0)PHI=-PHI 
      DELTA=RAD*DANG 
      JJ=DELTA/PHI 
      DELTA=ALF+DELTA 
      IF(JJ.le.0) goto 11 
      DO I=1,JJ 
       ALF=ALF+PHI 
       XX=XP + R*COS(ALF) 
       YY=YP + R*SIN(ALF) 
       CALL TRAA(XX,YY,ICOLOR,jcw) 
      end do 
   11 XX=XP + R*COS(DELTA) 
      YY=YP + R*SIN(DELTA) 
      CALL TRAA(XX,YY,ICOLOR,jcw) 
  100 RETURN 
      END                                           
                                                                        
                                                                        
                                                                        
                                                                        
!#######################################################################
!     vector tables                                                     
!#######################################################################
      SUBROUTINE  ZEICH (J,KOORD) 
!-----------------------------------------------------------------------
!  Symbol 1     :  M.Alflen, irgendwann 1990 oder frueher               
!  Symbol 2..14 :  A.Vef, 08.08.1994                                    
!      ZEICHEN UND SYMBOLE                                              
!      J = 1,..,32                                                      
!  Zeichentabelle:                                                      
!     1 : Integral                                                      
!     2 : Angstroem                                                     
!     3 : Underscore                                                    
!     4 : Caret (^)                                                     
!     5 : Einfacher Pfeil rechts                                        
!     6 : Einfacher Pfeil links                                         
!     7 : Einfacher Pfeil beide                                         
!     8 : Doppelter Pfeil rechts                                        
!     9 : Doppelter Pfeil links                                         
!    10 : Doppelter Pfeil beide                                         
!    11 : Senkrechter Strich, so hoch wie [ und ]                       
!    12 : Pfeil nach oben                                               
!    13 : Pfeil nach unten                                              
!    14 : Pfeil nach oben und unten                                     
!    15 : Punkt in halber Buchstabenhoehe, wie \cdot in TeX             
!    16 : parallel                                                      
!    17 : ungleich                                                      
!    18 : Tilde (proportional)                                          
!    19 : senkrecht                                                     
!    20 : Doppeltilde (ungefaehr gleich)                                
!    21 : h-quer                                                        
!    22 : at sign (see                                                  
!         http://www.webopedia.com/DidYouKnow/Internet/2002/HistoryofAtS
!    23 : Backslash                                                     
!    24 : #                                                             
!    25 : §                                                            
!    26 : infinty                                                       
!    27 : integral                                                      
!    28 : closed integral                                               
!    29 : sqrt                                                          
!    30 : overline for sqrt                                             
!    31 : division sign                                                 
!    32 :                                                               
!    33 :                                                               
!http://www.webopedia.com/DidYouKnow/Internet/2002/HistoryofAtSign.asp  

      integer KOORD(75) 
!                                                                       
      SAVE 
!                                                                       
integer,parameter,dimension(1:44):: &
   ISTART=(/1,  55,  84,  88,  93, 101, 109, 121, 132, 143,            &
       158, 165, 173, 181, 193, 200, 207, 217, 242, 249,               &
       298, 336, 395, 399, 424, 467, 510, 541, 586, 596, 600,          &
       604, 617, 656, 687, 712, 737, 768, 783, 824, 835, 846,          &
       856, 866/)                                                       
integer,parameter,dimension(1:865):: K=&
! Symbol 01 : Integral                                                          
(/ 16, -396, -496, -596, -398, -296, -496, -497, -397, -396, -296, -297, & 
 -398, -498, -597, -596, -495, -294,  107, 2009, 2410, 2611, 2712, 2713, & 
 2614, 2514, 2413, 2412, 2512, 2513, 2613, 2612, 2713, 2514, 2412, 2612, & 
 2513,   50, -495, -194,  307, 1809, 2310, 2611,   50, 1709, 1409,  207, & 
 1709,  407, 1909,  707,  407, 5050, & 
!Symbol 02 : Angstroem: das A                                                   
   20, 2110,    3,   50, 2110,   17,   50, 1810,   16,   50,  605,  614, & 
   50,    1,    7,   50,   13,   19,   50, & 
!            ... und der Kringel drauf                                          
 2109, 2111, 2212, 2412, 2511, 2509, 2408, 2208, 2109, 5050, & 
!    3 : Underscore                                                             
   20,    1,   19, 5050, & 
!    4 : Caret                                                                  
   14, 1002, 1707, 1012, 5050, & 
!    5 : Einfacher Pfeil rechts                                                 
   27, 1003, 1025,   50, 1419, 1025,  619, 5050, & 
!    6 : Einfacher Pfeil links                                                  
   27, 1025, 1003,   50, 1409, 1003,  609, 5050, & 
!    7 : Einfacher Pfeil beide                                                  
   27, 1025, 1003,   50, 1409, 1003,  609,   50, 1419, 1025,  619, 5050, & 
!    8 : Doppelter Pfeil rechts                                                 
   27, 1104, 1124,   50,  904,  924,   50, 1420, 1025,  620, 5050, & 
!    9 : Doppelter Pfeil links                                                  
   27, 1104, 1124,   50,  904,  924,   50, 1408, 1003,  608, 5050, & 
!   10 : Doppelter Pfeil beide                                                  
   27, 1104, 1124,   50,  904,  924,   50, 1408, 1003,  608,   50, 1420, & 
 1025,  620, 5050, & 
!   11 : Senkrechter Strich, so hoch wie [ und ]                                
    5, 2503, -297,   50, 2504, -296, 5050, & 
!   12 : Pfeil nach oben                                                        
   13,  107, 1907,   50, 1303, 1907, 1311, 5050, & 
!   13 : Pfeil nach unten                                                       
   13,  107, 1907,   50,  703,  107,  711, 5050, & 
!   14 : Pfeil nach oben und unten                                              
   13,  107, 1907,   50, 1303, 1907, 1311,   50,  703,  107,  711, 5050, & 
!   15 : Punkt in halber Buchstabenhoehe, wie \cdot in TeX                      
    7, 1003, 1104, 1005,  904, 1003, 5050, & 
!   16 : parallel                                                               
   11,  104, 1904,   50,  107, 1907, 5050, & 
!   17 : ungleich                                                               
   26, 1204, 1222,   50,  604,  622,   50, 1816,   10, 5050, & 
!   18 : Tilde (proportional)                                                   
   27,  603,  803, 1104, 1206, 1208, 1111,  715,  617,  620,  722,  923, & 
   50,  803, 1004, 1106, 1108, 1011,  615,  517,  520,  622,  923, 1123, & 
 5050, & 
!   19 : senkrecht                                                              
   11,  100,  110,   50,  105, 1905, 5050, & 
!   20 : Doppeltilde (ungefaehr gleich)                                         
   27,  903, 1003, 1304, 1406, 1408, 1311,  915,  817,  820,  922, 1123, & 
   50, 1003, 1204, 1306, 1308, 1211,  815,  717,  720,  822, 1123, 1223, & 
   50,  503,  603,  904, 1006, 1008,  911,  515,  417,  420,  522,  723, & 
   50,  603,  804,  906,  908,  811,  415,  317,  320,  422,  723,  823, & 
 5050, & 
!   21 : h-quer (kursives h)                                                    
   21, 2108,    2,   50, 2109,    3,   50,  705, 1107, 1309, 1411, 1413, & 
 1315, 1216, 1016,  414,  114,   15,   50, 1413, 1215, 1015,  413,  113, & 
   14,   17,  219,  420,   50, 2105, 2109,   50, 1500, 1817,   50, 1600, & 
 1917, 5050, & 
!   22 : @ at sign                                                              
   21, 1314, 1412, 1410, 1308, 1207, 1006,  806,  607,  509,  511,  613, & 
  814,   50, 1410, 1208, 1007,  707,  509,   50, 1414,  814,  614,  516, & 
  617,  718, 1019, 1419, 1717, 1813, 1810, 1706,   50,  502,  104,   10, & 
   50, 1414, 1315,  815,  615,  516,   50, 1019, 1419, 1717, 1816, 1913, & 
 1910, 1807, 1605, 1303,  902,  502,    5,    9,  113,   10, 5050, & 
!   23 : Backslash                                                              
   24, -580, 2402, 5050, & 
!   24 : #                                                                      
   17,  403, 1905,   50,  407, 1909,   50,  900,  911,   50, 1401, 1412, & 
   50,  404, 1906,   50,  408, 1910,   50, 1001, 1012,   50, 1502, 1513, & 
 5050, & 
!   25 : §                                                                     
   10, 2007, 2006, 1906, 1907, 2007, 2106, 2104, 2003, 1603, 1404, 1207, & 
 1108,   50, 1603, 1504, 1307, 1108,  908,  706,   50, 1404, 1202, 1002, & 
  803,  606,  507,   50, 1002,  903,  706,  507,  107,    6,    4,  103, & 
  203,  204,  104,  103,  202,  202, 5050, & 
!   26 : infinity                                                               
   24,  812, 1208, 1306, 1305, 1203, 1002,  602,  403,  305,  306,  408, & 
  812, 1207, 1206, 1104,  903,  703,  504,  406,  407,  812,  416,  318, & 
  319,  421,  622, 1022, 1221, 1319, 1318, 1216,  812,  417,  418,  520, & 
  721,  921, 1120, 1218, 1217,  812, 5050, & 
!   27 : integral another                                                       
   20, 2418, 2417, 2317, 2318, 2418, 2517, 2515, 2313, 1911, 1610,  609, & 
  208, -194,   50,  309,  -93, -295, -297, -198,  -98,  -97, -197, -198, & 
   50, 2414, 2012, 1611,  610,  309, 5050, & 
!   28 :  closed integral                                                       
   20, 2418, 2417, 2317, 2318, 2418, 2517, 2515, 2313, 1911, 1610,  609, & 
  208, -194,   50,  309,  -93, -295, -297, -198,  -98,  -97, -197, -198, & 
   50, 2414, 2012, 1611,  610,  309,   50, 1509, 1407, 1206, 1006,  807, & 
  709,  711,  813, 1014, 1214, 1413, 1511, 1509, 5050, & 
!   29 : sqrt                                                                   
   22,  902,  905, -289,   50,  904, -389, 2520, 2522, 5050, & 
!   30 : overline for sqrt                                                      
   24, 2500, 2524, 5050, & 
!   31 : geteilt                                                                
   16,  800,  816, 5050, & 
!   32 : nabla                                                                  
   22, 2102,   11,   50, 2103,  211,   50, 2120,   11,   50, 2102, 2120, & 
 5050, & 
!   33 :  partial                                                               
   16, 1010,  713,  813, 1010, 1108, 1106, 1004,  803,  302,  103,    5, & 
    7,  110,  413,  714, 1014, 1414, 1713, 1911, 1908, 1806, 1605, 1606, & 
 1806,   50, 1106,  804,  503,  103,   50,    7,  210,  412,  813, 1113, & 
 1413, 1812, 5050, & 
!   34 :  Durchschnitt                                                          
   19,    2,    3, 1003, 1404, 1605, 1706, 1808, 1811, 1713, 1614, 1415, & 
 1016,   16,   50,    2, 1002, 1403, 1604, 1705, 1806, 1908, 1911, 1813, & 
 1714, 1615, 1416, 1017,   17,   16, 5050, & 
!   35 : includes right                                                         
   17, 1702, 1602, 1610, 1512, 1413, 1114,  914,  613,  512,  410,  402, & 
   50, 1702, 1710, 1612, 1414, 1215,  815,  614,  412,  310,  302,  402, & 
 5050, & 
!   36 : includes left                                                          
   17, 1715, 1615, 1607, 1505, 1404, 1103,  903,  604,  505,  407,  415, & 
   50, 1715, 1707, 1605, 1403, 1202,  802,  603,  405,  307,  315,  415, & 
 5050, & 
!   37 : vereinigung                                                            
   19, 1902, 1903,  903,  504,  305,  206,  108,  111,  213,  314,  515, & 
  916, 1916,   50, 1902,  902,  503,  304,  205,  106,    8,   11,  113, & 
  214,  315,  516,  917, 1917, 1916, 5050, & 
!   38 : tilde                                                                  
   16, 1702, 1902, 2103, 2105, 1811, 1813,   50, 1902, 2003, 2005, 1711, & 
 1713, 2114, 5050, & 
!   39 : half infinity                                                          
   23,  812, 1208, 1306, 1305, 1203, 1002,  602,  403,  305,  306,  408, & 
  812, 1207, 1206, 1104,  903,  703,  504,  406,  407,  812,  416,  318, & 
  320,  421,   50, 1320, 1318, 1216,  812,  516,  418,  421,   50, 1320, & 
 1221, 1218, 1116,  812, 5050, & 
!   40 : groesse gleich                                                         
   14, 1602, 1212,  802,   50,  702,  712,   50,  302,  312, 5050, & 
!   41 : kleiner gleich                                                         
   14, 1612, 1202,  812,   50,  702,  712,   50,  302,  312, 5050, & 
!   42 : +-                                                                     
   14, 1307,  307,   50,  802,  812,   50,  302,  312, 5050, & 
!  43 : -+                                                                      
   14, 1307,  307,   50, 1302, 1312,   50,  802,  812, 5050/)

      if(J+1.gt.44)then 
        J=-J 
        goto 20 
      end if 
      J1 = ISTART(J+1) 
      J  = ISTART(J) 
      I = 0 
   10 I = I + 1 
      JJ = J + I - 1 
      IF ( JJ.GE.J1 ) GO TO 20 
      KOORD(I) = K(JJ) 
      GO TO 10 
   20 RETURN 
      END                                           
                                                                        
      SUBROUTINE  KROMAN (J,KOORD) 
!-----------------------------------------------------------------------
!      KLEINE ROMAN                                                     
!      abcdefghijklmnopqrstuvwxyz                                       
      integer KOORD(75) 
!                                                                       
      SAVE 
!                                                                       
integer,parameter,dimension(1:27):: &
     ISTART=(/  1, 41, 75,104,141,173,196,257,286,305,331,359,372,  &
              417,446,483,520,554,578,611,628,657,673,698,720,743,  &
              760/)            

integer,parameter,dimension(1:759):: K=&
!   1 character= a                                                              
(/ 20, 1205, 1105, 1104, 1204, 1305, 1407, 1411, 1313, 1214, 1015,  315, & 
  116,   17,   50, 1214,  314,  115,   17,   18,   50, 1014,  913,  807, & 
  704,  503,  303,  104,    7,   10,  112,  314,   50,  807,  705,  504, & 
  304,  105,    7, 5050, & 
!   2 character= b                                                              
   21, 2105,    5,   50, 2106,    6,   50, 1106, 1308, 1410, 1412, 1315, & 
 1117,  818,  618,  317,  115,   12,   10,  108,  306,   50, 1412, 1314, & 
 1116,  817,  617,  316,  114,   12,   50, 2102, 2106, 5050, & 
!   3 character= c                                                              
   19, 1115, 1014,  915, 1016, 1116, 1314, 1412, 1409, 1306, 1104,  803, & 
  603,  304,  106,    9,   11,  114,  316,   50, 1409, 1307, 1105,  804, & 
  604,  305,  107,    9, 5050, & 
!   4 character= d                                                              
   21, 2115,   15,   50, 2116,   16,   50, 1115, 1313, 1411, 1409, 1306, & 
 1104,  803,  603,  304,  106,    9,   11,  113,  315,   50, 1409, 1307, & 
 1105,  804,  604,  305,  107,    9,   50, 2112, 2116,   50,   15,   19, & 
 5050, & 
!   5 character= e                                                              
   19,  804,  816, 1016, 1215, 1314, 1412, 1409, 1306, 1104,  803,  603, & 
  304,  106,    9,   11,  114,  316,   50,  815, 1115, 1314,   50, 1409, & 
 1307, 1105,  804,  604,  305,  107,    9, 5050, & 
!   6 character= f                                                              
   13, 2010, 1909, 1810, 1911, 2011, 2110, 2108, 2006, 1805,    5,   50, & 
 2108, 2007, 1806,    6,   50, 1402, 1410,   50,    2,    9, 5050, & 
!   7 character= g                                                              
   19, 1408, 1306, 1205, 1004,  804,  605,  506,  408,  410,  512,  613, & 
  814, 1014, 1213, 1312, 1410, 1408,   50, 1306, 1105,  705,  506,   50, & 
  512,  713, 1113, 1312,   50, 1213, 1314, 1416, 1316, 1314,   50,  605, & 
  504,  303,  203,    4,  -93,  -88, -185, -284,   50,  203,  104,    7, & 
   12,  -85, -284, -384, -585, -688, -694, -597, -398, -298,  -97,    6, & 
 5050, & 
!   8 character= h                                                              
   22, 2105,    5,   50, 2106,    6,   50, 1106, 1308, 1411, 1413, 1316, & 
 1117,   17,   50, 1413, 1315, 1116,   16,   50, 2102, 2106,   50,    2, & 
    9,   50,   13,   20, 5050, & 
!   9 character= i                                                              
   11, 2105, 2004, 1905, 2006, 2105,   50, 1405,    5,   50, 1406,    6, & 
   50, 1402, 1406,   50,    2,    9, 5050, & 
!  10 character= j                                                              
   15, 2106, 2005, 1906, 2007, 2106,   50, 1407, -393, -594, -696, -698, & 
 -599, -499, -398, -497, -598,   50, 1406, -394, -595, -696,   50, 1403, & 
 1407, 5050, & 
!  11 character= k                                                              
   21, 2105,    5,   50, 2106,    6,   50, 1416,  406,   50,  811,   17, & 
   50,  810,   16,   50, 2102, 2106,   50, 1413, 1419,   50,    2,    9, & 
   50,   13,   19, 5050, & 
!  12 character= l                                                              
   11, 2105,    5,   50, 2106,    6,   50, 2102, 2106,   50,    2,    9, & 
 5050, & 
!  13 character= m                                                              
   33, 1405,    5,   50, 1406,    6,   50, 1106, 1308, 1411, 1413, 1316, & 
 1117,   17,   50, 1413, 1315, 1116,   16,   50, 1117, 1319, 1422, 1424, & 
 1327, 1128,   28,   50, 1424, 1326, 1127,   27,   50, 1402, 1406,   50, & 
    2,    9,   50,   13,   20,   50,   24,   31, 5050, & 
!  14 character= n                                                              
   22, 1405,    5,   50, 1406,    6,   50, 1106, 1308, 1411, 1413, 1316, & 
 1117,   17,   50, 1413, 1315, 1116,   16,   50, 1402, 1406,   50,    2, & 
    9,   50,   13,   20, 5050, & 
!  15 character= o                                                              
   20, 1409, 1306, 1104,  803,  603,  304,  106,    9,   11,  114,  316, & 
  617,  817, 1116, 1314, 1411, 1409,   50, 1409, 1307, 1105,  804,  604, & 
  305,  107,    9,   50,   11,  113,  315,  616,  816, 1115, 1313, 1411, & 
 5050, & 
!  16 character= p                                                              
   21, 1405, -695,   50, 1406, -694,   50, 1106, 1308, 1410, 1412, 1315, & 
 1117,  818,  618,  317,  115,   12,   10,  108,  306,   50, 1412, 1314, & 
 1116,  817,  617,  316,  114,   12,   50, 1402, 1406,   50, -698, -691, & 
 5050, & 
!  17 character= q                                                              
   20, 1415, -685,   50, 1416, -684,   50, 1115, 1313, 1411, 1409, 1306, & 
 1104,  803,  603,  304,  106,    9,   11,  113,  315,   50, 1409, 1307, & 
 1105,  804,  604,  305,  107,    9,   50, -688, -681, 5050, & 
!  18 character= r                                                              
   17, 1405,    5,   50, 1406,    6,   50,  806, 1107, 1309, 1411, 1414, & 
 1315, 1215, 1114, 1213, 1314,   50, 1402, 1406,   50,    2,    9, 5050, & 
!  19 character= s                                                              
   17, 1213, 1414, 1014, 1213, 1312, 1410, 1406, 1304, 1203, 1003,  904, & 
  806,  611,  513,  414,   50, 1103, 1004,  906,  711,  613,  514,  214, & 
  113,   11,    7,  105,  204,  403,    3,  204, 5050, & 
!  20 character= t                                                              
   15, 2105,  405,  106,    8,   10,  112,  313,   50, 2106,  406,  107, & 
    8,   50, 1402, 1410, 5050, & 
!  21 character= u                                                              
   22, 1405,  305,  106,    9,   11,  114,  316,   50, 1406,  306,  107, & 
    9,   50, 1416,   16,   50, 1417,   17,   50, 1402, 1406,   50, 1413, & 
 1417,   50,   16,   20, 5050, & 
!  22 character= v                                                              
   18, 1403,    9,   50, 1404,  209,   50, 1415,    9,   50, 1401, 1407, & 
   50, 1411, 1417, 5050, & 
!  23 character= w                                                              
   24, 1404,    8,   50, 1405,  308,   50, 1412,    8,   50, 1412,   16, & 
   50, 1413,  316,   50, 1420,   16,   50, 1401, 1408,   50, 1417, 1423, & 
 5050, & 
!  24 character= x                                                              
   20, 1404,   15,   50, 1405,   16,   50, 1416,    4,   50, 1402, 1408, & 
   50, 1412, 1418,   50,    2,    8,   50,   12,   18, 5050, & 
!  25 character= y                                                              
   19, 1404,   10,   50, 1405,  210,   50, 1416,   10, -392, -594, -696, & 
 -697, -598, -497, -596,   50, 1402, 1408,   50, 1412, 1418, 5050, & 
!  26 character= z                                                              
   18, 1414,    3,   50, 1415,    4,   50, 1404, 1003, 1403, 1415,   50, & 
    3,   15,  415,   14, 5050/) 

      if(J+1.gt.27)then 
        J=-J 
        goto 20 
      end if 
      J1 = ISTART(J+1) 
      J = ISTART(J) 
      I = 0 
   10 I = I + 1 
      JJ = J + I - 1 
      IF ( JJ.GE.J1 ) GO TO 20 
      KOORD(I) = K(JJ) 
      GO TO 10 
   20 RETURN 
      END                                           
!-----------------------------------------------------------------------
      SUBROUTINE  GROMAN (J,KOORD) 
!-----------------------------------------------------------------------
!      GROSSE ROMAN                                                     
!      ABCDEFGHILJKLMNOPQRSTUVWXYZ                                      
      integer KOORD(75)
!                                                                       
      SAVE 
integer,parameter,dimension(1:27):: &
     ISTART=(/  1, 20, 66, 99,130,153,174,215,243,256,277,305,320,  &
             351,373,418,448,513,559,594,611,635,651,676,698,719,  &
             736/)                                                  
integer,parameter,dimension(1:735):: K=&
!   1 character= A                                                              
(/ 20, 2110,    3,   50, 2110,   17,   50, 1810,   16,   50,  605,  614, & 
   50,    1,    7,   50,   13,   19, 5050, & 
!   2 character= B                                                              
   22, 2105,    5,   50, 2106,    6,   50, 2102, 2114, 2017, 1918, 1719, & 
 1519, 1318, 1217, 1114,   50, 2114, 2016, 1917, 1718, 1518, 1317, 1216, & 
 1114,   50, 1106, 1114, 1017,  918,  719,  419,  218,  117,   14,    2, & 
   50, 1114, 1016,  917,  718,  418,  217,  116,   14, 5050, & 
!   3 character= C                                                              
   21, 1817, 1518, 2118, 1817, 2015, 2112, 2110, 2007, 1805, 1604, 1303, & 
  803,  504,  305,  107,   10,   12,  115,  317,  518,   50, 2110, 2008, & 
 1806, 1605, 1304,  804,  505,  306,  108,   10, 5050, & 
!   4 character= D                                                              
   22, 2105,    5,   50, 2106,    6,   50, 2102, 2112, 2015, 1817, 1618, & 
 1319,  819,  518,  317,  115,   12,    2,   50, 2112, 2014, 1816, 1617, & 
 1318,  818,  517,  316,  114,   12, 5050, & 
!   5 character= E                                                              
   21, 2105,    5,   50, 2106,    6,   50, 1512,  712,   50, 2102, 2118, & 
 1518, 2117,   50, 1106, 1112,   50,    2,   18,  618,   17, 5050, & 
!   6 character= F                                                              
   20, 2105,    5,   50, 2106,    6,   50, 1512,  712,   50, 2102, 2118, & 
 1518, 2117,   50, 1106, 1112,   50,    2,    9, 5050, & 
!   7 character= G                                                              
   23, 1817, 1518, 2118, 1817, 2015, 2112, 2110, 2007, 1805, 1604, 1303, & 
  803,  504,  305,  107,   10,   12,  115,  317,   50, 2110, 2008, 1806, & 
 1605, 1304,  804,  505,  306,  108,   10,   50,  817,   17,   50,  818, & 
   18,   50,  814,  821, 5050, & 
!   8 character= H                                                              
   24, 2105,    5,   50, 2106,    6,   50, 2118,   18,   50, 2119,   19, & 
   50, 2102, 2109,   50, 2115, 2122,   50, 1106, 1118,   50,    2,    9, & 
   50,   15,   22, 5050, & 
!   9 character= I                                                              
   11, 2105,    5,   50, 2106,    6,   50, 2102, 2109,   50,    2,    9, & 
 5050, & 
!  10 character= J                                                              
   15, 2110,  410,  109,    7,    5,  103,  302,  502,  603,  504,  403, & 
   50, 2109,  409,  108,    7,   50, 2106, 2113, 5050, & 
!  11 character= K                                                              
   22, 2105,    5,   50, 2106,    6,   50, 2119,  806,   50, 1211,   19, & 
   50, 1210,   18,   50, 2102, 2109,   50, 2115, 2121,   50,    2,    9, & 
   50,   15,   21, 5050, & 
!  12 character= L                                                              
   18, 2105,    5,   50, 2106,    6,   50, 2102, 2109,   50,    2,   17, & 
  617,   16, 5050, & 
!  13 character= M                                                              
   25, 2105,    5,   50, 2106,  312,   50, 2105,   12,   50, 2119,   12, & 
   50, 2119,   19,   50, 2120,   20,   50, 2102, 2106,   50, 2119, 2123, & 
   50,    2,    8,   50,   16,   23, 5050, & 
!  14 character= N                                                              
   23, 2105,    5,   50, 2106,  218,   50, 1906,   18,   50, 2118,   18, & 
   50, 2102, 2106,   50, 2115, 2121,   50,    2,    8, 5050, & 
!  15 character= O                                                              
   22, 2110, 2007, 1805, 1604, 1203,  903,  504,  305,  107,   10,   12, & 
  115,  317,  518,  919, 1219, 1618, 1817, 2015, 2112, 2110,   50, 2110, & 
 2008, 1806, 1605, 1204,  904,  505,  306,  108,   10,   50,   12,  114, & 
  316,  517,  918, 1218, 1617, 1816, 2014, 2112, 5050, & 
!  16 character= P                                                              
   22, 2105,    5,   50, 2106,    6,   50, 2102, 2114, 2017, 1918, 1719, & 
 1419, 1218, 1117, 1014, 1006,   50, 2114, 2016, 1917, 1718, 1418, 1217, & 
 1116, 1014,   50,    2,    9, 5050, & 
!  17 character= Q                                                              
   22, 2110, 2007, 1805, 1604, 1203,  903,  504,  305,  107,   10,   12, & 
  115,  317,  518,  919, 1219, 1618, 1817, 2015, 2112, 2110,   50, 2110, & 
 2008, 1806, 1605, 1204,  904,  505,  306,  108,   10,   50,   12,  114, & 
  316,  517,  918, 1218, 1617, 1816, 2014, 2112,   50,  207,  307,  508, & 
  610,  611,  513,  314, -385, -484, -482, -281, -181,   50,  314,  -85, & 
 -284, -383, -382, -281, 5050, & 
!  18 character= R                                                              
   22, 2105,    5,   50, 2106,    6,   50, 2102, 2114, 2017, 1918, 1719, & 
 1519, 1318, 1217, 1114, 1106,   50, 2114, 2016, 1917, 1718, 1518, 1317, & 
 1216, 1114,   50,    2,    9,   50, 1111, 1013,  914,  217,  118,  119, & 
  220,   50, 1013,  814,  116,   17,   19,  220,  320, 5050, & 
!  19 character= S                                                              
   20, 1816, 2117, 1517, 1816, 2014, 2111, 2108, 2005, 1803, 1603, 1404, & 
 1305, 1207, 1013,  915,  717,   50, 1603, 1405, 1307, 1113, 1015,  916, & 
  717,  317,  115,   12,    9,  106,  304,  603,    3,  304, 5050, & 
!  20 character= T                                                              
   19, 2109,    9,   50, 2110,   10,   50, 2103, 1502, 2102, 2117, 1517, & 
 2116,   50,    6,   13, 5050, & 
!  21 character= U                                                              
   24, 2105,  605,  306,  108,   11,   13,  116,  318,  619, 2119,   50, & 
 2106,  606,  307,  109,   11,   50, 2102, 2109,   50, 2116, 2122, 5050, & 
!  22 character= V                                                              
   20, 2103,   10,   50, 2104,  310,   50, 2117,   10,   50, 2101, 2107, & 
   50, 2113, 2119, 5050, & 
!  23 character= W                                                              
   24, 2104,    8,   50, 2105,  508,   50, 2112,    8,   50, 2112,   16, & 
   50, 2113,  516,   50, 2120,   16,   50, 2101, 2108,   50, 2117, 2123, & 
 5050, & 
!  24 character= X                                                              
   20, 2103,   16,   50, 2104,   17,   50, 2117,    3,   50, 2101, 2107, & 
   50, 2113, 2119,   50,    1,    7,   50,   13,   19, 5050, & 
!  25 character= Y                                                              
   21, 2103, 1010,   10,   50, 2104, 1011,   11,   50, 2118, 1011,   50, & 
 2101, 2107,   50, 2114, 2120,   50,    7,   14, 5050, & 
!  26 character= Z                                                              
   20, 2116,    3,   50, 2117,    4,   50, 2104, 1503, 2103, 2117,   50, & 
    3,   17,  617,   16, 5050/)


      if(J+1.gt.27)then 
        J=-J 
        goto 20 
      end if 
      J1 = ISTART(J+1) 
      J = ISTART(J) 
      I = 0 
   10 I = I + 1 
      JJ = J + I - 1 
      IF ( JJ.GE.J1 ) GO TO 20 
      KOORD(I) = K(JJ) 
      GO TO 10 
   20 RETURN 
      END                                           
!-----------------------------------------------------------------------
      SUBROUTINE  NROMAN (J,KOORD) 
!-----------------------------------------------------------------------
!      ZIFFERN, SONDERZEICHEN  ROMAN                                    
!      0123456789.,:;!?'"#*/()-+=<>&$[]%_{}|                            
      integer KOORD(75)
!                                                                       
      SAVE 
!                                                                       
integer,parameter,dimension(1:39):: &
    ISTART=(/  1, 42, 54,100,148,162,202,251,283,347,396,403,412,  &
             425,440,456,489,496,509,524,534,538,559,580,584,591,  &
             598,607,616,666,709,720,731,763,767,798,829,854,858/)  

integer,parameter,dimension(1:857):: K=&
!   1 character= 0                                                              
(/ 20, 2109, 2006, 1704, 1203,  903,  404,  106,    9,   11,  114,  416, & 
  917, 1217, 1716, 2014, 2111, 2109,   50, 2109, 2007, 1906, 1705, 1204, & 
  904,  405,  206,  107,    9,   50,   11,  113,  214,  415,  916, 1216, & 
 1715, 1914, 2013, 2111, 5050, & 
!   2 character= 1                                                              
   20, 1706, 1808, 2111,   11,   50, 2010,   10,   50,    6,   15, 5050, & 
!   3 character= 2                                                              
   20, 1704, 1605, 1504, 1603, 1703, 1904, 2005, 2108, 2112, 2015, 1916, & 
 1717, 1517, 1316, 1113,  908,  806,  604,  303,    3,   50, 2112, 2014, & 
 1915, 1716, 1516, 1315, 1112,  908,   50,  203,  304,  306,  111,  114, & 
  216,  317,   50,  306,   11,   15,  116,  317,  517, 5050, & 
!   4 character= 3                                                              
   20, 1704, 1605, 1504, 1603, 1703, 1904, 2005, 2108, 2112, 2015, 1816, & 
 1516, 1315, 1212, 1209,   50, 2112, 2014, 1815, 1515, 1314, 1212,   50, & 
 1212, 1114,  916,  717,  417,  216,  115,   12,    8,  105,  204,  403, & 
  503,  604,  505,  404,   50, 1015,  716,  416,  215,  114,   12, 5050, & 
!   5 character= 4                                                              
   20, 1912,   12,   50, 2113,   13,   50, 2113,  602,  618,   50,    9, & 
   16, 5050, & 
!   6 character= 5                                                              
   20, 2105, 1103,   50, 1103, 1305, 1408, 1411, 1314, 1116,  817,  617, & 
  316,  114,   11,    8,  105,  204,  403,  503,  604,  505,  404,   50, & 
 1411, 1313, 1115,  816,  616,  315,  113,   11,   50, 2105, 2115,   50, & 
 2005, 2010, 2115, 5050, & 
!   7 character= 6                                                              
   20, 1815, 1714, 1615, 1716, 1816, 2015, 2113, 2110, 2007, 1805, 1604, & 
 1203,  603,  304,  106,    9,   11,  114,  316,  617,  717, 1016, 1214, & 
 1311, 1310, 1207, 1005,  704,   50, 2110, 2008, 1806, 1605, 1204,  604, & 
  305,  107,    9,   50,   11,  113,  315,  616,  716, 1015, 1213, 1311, & 
 5050, & 
!   8 character= 7                                                              
   20, 2103, 1503,   50, 1703, 1904, 2106, 2108, 1813, 1815, 1916, 2117, & 
   50, 1904, 2006, 2008, 1813,   50, 2117, 1817, 1516, 1012,  811,  510, & 
   10,   50, 1516, 1011,  810,  509,    9, 5050, & 
!   9 character= 8                                                              
   20, 2108, 2005, 1804, 1504, 1305, 1208, 1212, 1315, 1516, 1816, 2015, & 
 2112, 2108,   50, 2108, 2006, 1805, 1505, 1306, 1208,   50, 1212, 1314, & 
 1515, 1815, 2014, 2112,   50, 1208, 1105, 1004,  803,  403,  204,  105, & 
    8,   12,  115,  216,  417,  817, 1016, 1115, 1212,   50, 1208, 1106, & 
 1005,  804,  404,  205,  106,    8,   50,   12,  114,  215,  416,  816, & 
 1015, 1114, 1212, 5050, & 
!  10 character= 9                                                              
   20, 1416, 1115,  913,  810,  809,  906, 1104, 1403, 1503, 1804, 2006, & 
 2109, 2111, 2014, 1816, 1517,  917,  516,  315,  113,   10,    7,  105, & 
  304,  404,  505,  406,  305,   50,  809,  907, 1105, 1404, 1504, 1805, & 
 2007, 2109,   50, 2111, 2013, 1815, 1516,  916,  515,  314,  112,   10, & 
 5050, & 
!  11 character= .                                                              
   10,  205,  104,    5,  106,  205, 5050, & 
!  12 character= ,                                                              
   10,    5,  104,  205,  106,  -94, -295, -396, 5050, & 
!  13 character= :                                                              
   10, 1405, 1304, 1205, 1306, 1405,   50,  205,  104,    5,  106,  205, & 
 5050, & 
!  14 character= ;                                                              
   10, 1405, 1304, 1205, 1306, 1405,   50,    5,  104,  205,  106,  -94, & 
 -295, -396, 5050, & 
!  15 character= !                                                              
   10, 2105, 1904,  705, 1906, 2105,   50, 1905, 1305,   50,  205,  104, & 
    5,  106,  205, 5050, & 
!  16 character= ?                                                              
   18, 1704, 1605, 1504, 1603, 1703, 1904, 2005, 2107, 2110, 2013, 1914, & 
 1715, 1515, 1314, 1213, 1009,  709,   50, 2110, 2012, 1913, 1714, 1514, & 
 1313, 1111,   50,  209,  108,    9,  110,  209, 5050, & 
!  17 character= <                                                              
    8, 2104, 1403,   50, 2105, 1403, 5050, & 
!  18 character= >                                                              
   16, 2104, 1403,   50, 2105, 1403,   50, 2112, 1411,   50, 2113, 1411, & 
 5050, & 
!  19 character= &                                                              
   14, 2106, 2004, 1803, 1603, 1404, 1306, 1308, 1410, 1611, 1811, 2010, & 
 2108, 2106, 5050, & 
!  20 character= $                                                              
   16, 1608,  408,   50, 1303,  713,   50, 1313,  703, 5050, & 
!  21 character= /                                                              
   22, 2520, -698, 5050, & 
!  22 character= (                                                              
   14, 2511, 2309, 2007, 1605, 1104,  704,  205, -193, -491, -689,   50, & 
 2309, 1907, 1606, 1105,  705,  206,  -93, -491, 5050, & 
!  23 character= )                                                              
   14, 2503, 2305, 2007, 1609, 1110,  710,  209, -193, -495, -697,   50, & 
 2305, 1907, 1608, 1109,  709,  208,  -93, -495, 5050, & 
!  24 character= *                                                              
   26,  904,  922, 5050, & 
!  25 character= -                                                              
   26, 1813,   13,   50,  904,  922, 5050, & 
!  26 character= +                                                              
   26, 1204, 1222,   50,  604,  622, 5050, & 
!  27 character= =                                                              
   26, 1521,  905,  321, 5050,    0,    0,    0,    0, & 
!  28 character= blank                                                               
   26, 1505,  921,  305, 5050,    0,    0,    0,    0, & 
!  29 character= "                                                              
   25, 1321, 1220, 1121, 1222, 1322, 1421, 1420, 1319, 1118,  616,  314, & 
  112,   10,    7,  104,  303,  603,  804, 1210, 1412, 1613, 1813, 2012, & 
 2110, 2008, 1807, 1607, 1308, 1010,  315,  117,   20,   21,  122,  222, & 
   50,    7,  105,  304,  604,  805, 1007,   50, 1607, 1408,  316,  118, & 
   20, 5050, & 
!  30 character= #                                                              
   20, 2508, -392,   50, 2512, -388,   50, 1816, 1715, 1616, 1717, 1817, & 
 2015, 2112, 2108, 2005, 1803, 1603, 1404, 1305, 1207, 1013,  915,  717, & 
   50, 1603, 1405, 1307, 1113, 1015,  916,  717,  317,  115,   12,    8, & 
  105,  303,  403,  504,  405,  304, 5050, & 
!  31 character= [                                                              
   20, 2514, 2506, -394, -386,   50, 2413, 2407, -293, -287, 5050, & 
!  32 character= ]                                                              
   20, 2506, 2514, -386, -394,   50, 2407, 2413, -287, -293, 5050, & 
!  33 character= %                                                              
   22, 2520, -698,   50, 2106, 2004, 1803, 1603, 1404, 1306, 1308, 1410, & 
 1611, 1811, 2010, 2108, 2106,   50,  514,  412,  211,   11, -188, -286, & 
 -284, -182,   19,  219,  418,  516,  514, 5050, & 
!  34 character= _                                                              
   20,    1,   19, 5050, & 
!  35 character= {                                                              
   14, -588, -491, -392,  -93,  507,  806,  905, 1003, 1105, 1206, 1507, & 
 2107, 2408, 2509, 2612, 2510, 2409, 2108, 1508, 1207, 1106, 1003,  906, & 
  807,  508,  -92, -391, -490, -588, 5050, & 
!  36 character= }                                                              
   14, -598, -495, -394,  -93,  507,  808,  909, 1011, 1109, 1208, 1507, & 
 2107, 2406, 2505, 2602, 2504, 2405, 2106, 1506, 1207, 1108, 1011,  908, & 
  807,  506,  -94, -395, -496, -598, 5050, & 
!  37 character= |                                                              
   17,  405, 1907,   50,  409, 1911,   50,  902,  913,   50, 1403, 1414, & 
   50,  406, 1908,   50,  410, 1912,   50, 1003, 1014,   50, 1504, 1515, & 
 5050, & 
!  38 character= |                                                              
    8, -196, 2404, 5050/) 


      if(J+1.gt.39)then 
        J=-J 
        goto 20 
      end if 
      J1 = ISTART(J+1) 
      J = ISTART(J) 
      I = 0 
   10 I = I + 1 
      JJ = J + I - 1 
      IF ( JJ.GE.J1 ) GO TO 20 
      KOORD(I) = K(JJ) 
      GO TO 10 
   20  RETURN 
      END                                           
!-----------------------------------------------------------------------
      SUBROUTINE  KSCRIP (J,KOORD) 
!-----------------------------------------------------------------------
!      KLEINE SCRIPT                                                    
!      abcdefghijklmnopqrstuvwxyz                                       
      integer KOORD(75) 
!                                                                       
      SAVE 
!                                                                       
integer,parameter,dimension(1:27) :: &
ISTART=(/  1, 35, 59, 82,116,140,168,207,238,258,283,315,333,  &
         379,412,442,473,509,534,557,578,606,630,667,710,743,  &
         782/)   
integer,parameter,dimension(1:781) :: K= &
!   1 character= a                                                              
(/ 16,  610,  809,  907,  905,  803,  702,  501,  301,  102,    4,    6, & 
  108,  309,   50,  905,  703,  502,  202,    4,   50,  911,  309,  109, & 
   11,  113,  214,  516,   50,  912,  310,  110,   11, 5050, & 
!   2 character= b                                                              
   14,  500,  802, 1204,   50, 2107,  301,  101,    3,    4,  106,  308, & 
  609,  909,  510,  411,  412,  514,   50, 2108,  302,  102,    3, 5050, & 
!   3 character= c                                                              
   12,  808,  707,  708,  808,  907,  905,  803,  702,  501,  301,  102, & 
    4,    7,  210,  512,   50,  905,  703,  502,  202,    4, 5050, & 
!   4 character= d                                                              
   16,  610,  809,  907,  905,  803,  702,  501,  301,  102,    4,    6, & 
  108,  309,   50,  905,  703,  502,  202,    4,   50, 2115,  309,  109, & 
   11,  113,  214,  516,   50, 2116,  310,  110,   11, 5050, & 
!   5 character= e                                                              
   12,  203,  305,  406,  607,  807,  906,  905,  803,  702,  501,  301, & 
  102,    4,    7,  210,  512,   50,  905,  703,  502,  202,    4, 5050, & 
!   6 character= f                                                              
    9,  903, 1206, 1508, 1809, 2009, 2108, 2006, 1805, -904,-1104,-1203, & 
-1101, -800,  101,    2,    4,  106,  207,  509,   50, 1805, 1304,  903, & 
    0, -502, -904, 5050, & 
!   7 character= g                                                              
   16,  610,  809,  907,  905,  803,  702,  501,  301,  102,    4,    6, & 
  108,  309,   50,  905,  703,  502,  202,    4,   50,  911, -895,   50, & 
  912,    9, -493, -895,-1096,-1198,-1099, -899, -598, -396, -193,   11, & 
  214,  516, 5050, & 
!   8 character= h                                                              
   15,  500,  802, 1204,   50, 2107,    0,   50, 2108,    1,   50,  603, & 
  805,  907,  908,  810,  610,  309,  109,   10,   50,  908,  809,  609, & 
  308,  108,   10,  112,  213,  515, 5050, & 
!   9 character= i                                                              
    8, 1505, 1404, 1305, 1406, 1505,   50,  903,  301,  101,    3,  105, & 
  206,  508,   50,  904,  302,  102,    3, 5050, & 
!  10 character= j                                                              
    8, 1505, 1404, 1305, 1406, 1505,   50,  903, -903,   50,  904,    1, & 
 -501, -903,-1104,-1206,-1107, -907, -606, -404, -201,    3,  206,  508, & 
 5050, & 
!  11 character= k                                                              
   14,  500,  802, 1204,   50, 2107,    0,   50, 2108,    1,   50,  909, & 
  809,  810,  909,  908,  706,  603,   50,  603,  506,  107,    8,   50, & 
  603,  505,  106,    8,    9,  212,  514, 5050, & 
!  12 character= l                                                              
    8,  500,  802, 1204,   50, 2107,  301,  101,    3,  105,  206,  508, & 
   50, 2108,  302,  102,    3, 5050, & 
!  13 character= m                                                              
   25,  500,  802,  904,  806,  606,    4,   50,  904,  805,  605,    3, & 
   50,  606,  808,  910,  911,  813,  613,   11,   50,  911,  812,  612, & 
   10,   50,  613,  815,  917,  918,  820,  620,  319,  119,   20,   50, & 
  918,  819,  619,  318,  118,   20,  122,  223,  525, 5050, & 
!  14 character= n                                                              
   18,  500,  802,  904,  806,  606,    4,   50,  904,  805,  605,    3, & 
   50,  606,  808,  910,  911,  813,  613,  312,  112,   13,   50,  911, & 
  812,  612,  311,  111,   13,  115,  216,  518, 5050, & 
!  15 character= o                                                              
   14,  907,  905,  803,  702,  501,  301,  102,    4,    6,  108,  209, & 
  410,  610,  809,  907,  806,  606,  407,  309,  311,  413,  514,   50, & 
  905,  703,  502,  202,    4, 5050, & 
!  16 character= p                                                              
   15,  500,  802, 1204,   50, 1505,-1204,   50, 1506,-1203,   50,  603, & 
  805,  907,  908,  810,  610,  309,  109,   10,   50,  908,  809,  609, & 
  308,  108,   10,  112,  213,  515, 5050, & 
!  17 character= q                                                              
   16,  610,  809,  907,  905,  803,  702,  501,  301,  102,    4,    6, & 
  108,   50,  905,  703,  502,  202,    4,   50,  911, -895,-1095,-1194, & 
-1092, -791,    9,   11,  214,  516,   50,  912,    9, -493, -895, 5050, & 
!  18 character= r                                                              
   14,  500,  802,  904,  806,  606,    4,   50,  904,  805,  605,    3, & 
   50,  606,  808,  910,  911,  610,   50,  910,  610,  411,  412,  514, & 
 5050, & 
!  19 character= s                                                              
   12,  500,  802, 1003,  803,  606,  407,  207,  106,    4,   50,  803, & 
  605,  406,  206,    4,   50,  100,    2,    7,  210,  512, 5050, & 
!  20 character= t                                                              
    8,  500,  802, 1204,   50, 2107,  301,  101,    3,  105,  206,  508, & 
   50, 2108,  302,  102,    3,   50, 1302, 1308, 5050, & 
!  21 character= u                                                              
   16,  903,  301,  101,    3,    4,  106,  308,  610,   50,  904,  302, & 
  102,    3,   50,  911,  309,  109,   11,  113,  214,  516,   50,  912, & 
  310,  110,   11, 5050, & 
!  22 character= v                                                              
   15,  903,  702,  401,  101,    3,    4,  107,  309,  610,  910,   50, & 
  904,  703,  402,  102,    3,   50,  910,  511,  412,  413,  515, 5050, & 
!  23 character= w                                                              
   21,  904,  702,  401,  101,    3,    4,  106,  308,   50,  905,  703, & 
  402,  102,    3,   50,  910,  308,  108,   10,   11,  113,  315,  616, & 
  916,   50,  911,  309,  109,   10,   50,  916,  517,  418,  419,  521, & 
 5050, & 
!  24 character= x                                                              
   16,  500,  802,  904,  906,  807,  607,  306,  105,    3,    2,  101, & 
  201,  202,  101,   50,  813,  712,  713,  813,  912,  911,  809,  608, & 
  307,  107,    8,   11,  214,  516,   50,  807,  608,   50,  809,  607, & 
   50,  306,  107,   50,  307,  105, 5050, & 
!  25 character= y                                                              
   16,  903,  301,  101,    3,    4,  106,  308,  610,   50,  904,  302, & 
  102,    3,   50,  911, -895,   50,  912,    9, -493, -895,-1096,-1198, & 
-1099, -899, -598, -396, -193,   11,  214,  516, 5050, & 
!  26 character= z                                                              
   13,  500,  802,  904,  906,  808,  508,  307,  104,    2,   50,  906, & 
  807,  507,  306,  104,   50,    2,  -96, -295, -595, -896,-1098,-1200, & 
-1101, -901, -600, -297,  -94,  210,  513,   50,    2,  -97, -296, -596, & 
 -897,-1102, 5050/) 

      if(J+1.gt.27)then 
        J=-J 
        goto 20 
      end if 
      J1 = ISTART(J+1) 
      J = ISTART(J) 
      I = 0 
   10 I = I + 1 
      JJ = J + I - 1 
      IF ( JJ.GE.J1 ) GO TO 20 
      KOORD(I) = K(JJ) 
      GO TO 10 
   20 RETURN 
      END                                           
!-----------------------------------------------------------------------
      SUBROUTINE  GSCRIP (J,KOORD) 
!-----------------------------------------------------------------------
!      GROSSE SCRIPT                                                    
!      ABCDEFGHIJKLMNOPQRSTUVWXYZ                                       
      integer KOORD(75) 
!                                                                       
      SAVE 
!                                                                       
integer,parameter,dimension(1:27):: &
 ISTART=(/  1, 40,111,153,197,247,294,348,404,438,473,533,574,  &
          624,663,698,752,796,862,899,938,978,1015,1057,1110,   &
           1153,1198/)    

integer,parameter,dimension(1:1197):: K=&
!   1 character= A                                                              
(/ 23, 2119, 1917, 1615, 1112,  810,  407,  104,    2,    0,   99,  299, & 
  400,  301,  200,   50, 2119, 1718,  716,   15,   50, 2119,   16,   50, & 
   15,  215,  514,  713,  911, 1009, 1007,  906,  706,  407,  110,   13, & 
   17,  119, 5050, & 
!   2 character= B                                                              
   24, 2015, 1914, 1713, 1211,  609,  408,  106,    4,   50, 1914, 1613, & 
  811,  510,  309,  107,    4,    2,  101,  301,  402,  303,  202,   50, & 
 1509, 1308, 1207, 1205, 1304, 1504, 1705, 1907, 2009, 2112, 2118, 2020, & 
 1821, 1621, 1420, 1318, 1214, 1212,   50, 2118, 2019, 1820, 1620, 1419, & 
 1318,   50, 1214, 1117, 1018,  819,  519,  218,  117,   15,   13,  112, & 
  312,  613,   50, 1214, 1116, 1017,  818,  518,  217,   15, 5050, & 
!   3 character= C                                                              
   21, 1903, 1702, 1502, 1303, 1206, 1209, 1313, 1415, 1617, 1818, 2018, & 
 2117, 2115, 2012, 1709, 1407, 1005,  604,  304,  105,    8,   10,  113, & 
  315,  516,  716,  915,  913,  811,  610,   50, 2115, 2013, 1710, 1408, & 
 1006,  605,  305,  106,    8, 5050, & 
!   4 character= D                                                              
   23, 2015, 1914, 1713, 1211,  609,  408,  106,    4,   50, 1914, 1613, & 
  811,  510,  309,  107,    4,    2,  101,  301,  402,  404,  306,  108, & 
   10,   13,  115,  317,  719, 1220, 1520, 1819, 2017, 2115, 2110, 2007, & 
 1805, 1604, 1404, 1305, 1307, 1408, 1609, 5050, & 
!   5 character= E                                                              
   19, 1814, 1713, 1513, 1414, 1416, 1617, 1817, 2016, 2114, 2111, 2009, & 
 1908, 1707, 1507, 1308, 1210,   50, 2111, 1909, 1708, 1408, 1210,   50, & 
 1210, 1208, 1105,  903,  702,  402,  203,  104,    6,    9,  112,  314, & 
  515,  715,  914,  912,  810,  609,   50, 1208, 1106,  904,  703,  303, & 
  104, 5050, & 
!   6 character= F                                                              
   21, 1916, 1715, 1213,  611,  410,  108,    6,   50, 1510, 1309, 1207, & 
 1205, 1404, 1604, 1805, 2007, 2110, 2120, 2017, 1916, 1615,  813,  512, & 
  311,  109,    6,    4,  102,  201,  301,  402,  303,  202,   50, 2112, & 
 2016, 2017,   50,  808,  909, 1011, 1015, 1117, 1419,  717, 5050, & 
!   7 character= G                                                              
   22, 1803, 1602, 1402, 1203, 1105, 1108, 1211, 1313, 1616, 1917, 2017, & 
 2116, 2115, 2013, 1811, 1610, 1309, 1009,  810,  712,  714,  816, 1018, & 
 1219,   50, 2116, 2014, 1812, 1611, 1310,  910,  712,   50, 1219,  818, & 
  416,  214,  112,    8,    5,  103,  302,  402,  503,  404,  303,   50, & 
  818,  516,  314,  111,    8, 5050, & 
!   8 character= H                                                              
   24, 1506, 1605, 1805, 2006, 2109, 2112, 1009,  407,  206,  105,    3, & 
    1,  100,  300,  401,  302,  201,   50, 2112, 1209,  908,  406,  205, & 
    3,   50,  704,  805,  907, 1216, 1318, 1521, 1723, 1924, 2024, 2123, & 
 2122, 2020, 1718, 1517,  915,  514,  214,   16,   17,  119,  321,   50, & 
 2122, 1920, 1518,  916,  515,  215,   16, 5050, & 
!   9 character= I                                                              
   16, 1914, 1612, 1110,  608,  407,  105,    3,   50, 1516, 1314, 1211, & 
 1208, 1306, 1505, 1705, 1906, 2008, 2112, 2116, 1914, 1713, 1111,  509, & 
  308,  106,    3,    1,  100,  300,  401,  302,  201, 5050, & 
!  10 character= J                                                              
   17, 2116, 1914, 1612, 1110,  207, -195,   50, 1416, 1214, 1111, 1108, & 
 1206, 1405, 1605, 1806, 2008, 2112, 2116, 1814, 1613,  710,  308,  107, & 
 -195, -296, -398, -299,  -99,  102,  304,  406,  509,  613, 5050, & 
!  11 character= K                                                              
   24, 1506, 1605, 1805, 2007, 2110, 2112, 1009,  407,  206,  105,    3, & 
    1,  100,  300,  401,  302,  201,   50, 2112, 1209,  908,  406,  205, & 
    3,   50, 2020, 1617, 1415, 1313, 1210,   50, 2023, 1922, 1823, 1924, & 
 2024, 2123, 2122, 2020, 1517, 1416, 1314, 1210,   50, 1210, 1113,  914, & 
  215,   16,   50, 1210, 1112,  913,  214,   16,   17,  119,  321, 5050, & 
!  12 character= L                                                              
   18, 1804, 1603, 1403, 1204, 1106, 1109, 1212, 1314, 1617, 1918, 2018, & 
 2117, 2116, 2014, 1913, 1611,  607,  406,  104,    2,   50, 1913, 1511, & 
  809,  508,  307,  105,    2,    0,   99,  299,  400,  402,  304,  107, & 
    9,   12,  114,  316, 5050, & 
!  13 character= M                                                              
   28, 2114, 1210,  607,  305,  103,    1,   -1,   98,  298,  399,  300, & 
  199,   50, 2114, 1412, 1011,  510,  110,   12,   50, 2114, 1713, 1212, & 
  511,  111,   12,   50, 2123, 1219,  314,   12,   50, 2123, 1421, 1020, & 
  519,  119,   21,   22,  124,  326,   50, 2123, 1722, 1221,  520,  120, & 
   21, 5050, & 
!  14 character= N                                                              
   23, 2111, 1710, 1108,  606,  405,  103,    1,   -1,   98,  298,  399, & 
  300,  199,   50, 2111, 1611,  512,   13,   50, 2111, 1612,  513,   13, & 
   50, 2025, 1924, 1825, 1926, 2026, 2125, 2123, 2021, 1719, 1518, 1016, & 
  414,   13, 5050, & 
!  15 character= O                                                              
   21, 2111, 2009, 1807, 1505, 1304,  903,  503,  204,  105,    7,    9, & 
  112,  314,  616,  817, 1218, 1618, 1917, 2016, 2015, 1913, 1711, 1309, & 
  808,  508,   50, 2009, 1707, 1305,  904,  504,  205,    7, 5050, & 
!  16 character= P                                                              
   23, 2015, 1914, 1713, 1211,  609,  408,  106,    4,   50, 1914, 1613, & 
  811,  510,  309,  107,    4,    2,  101,  301,  402,  303,  202,   50, & 
 1509, 1308, 1207, 1205, 1304, 1504, 1705, 1907, 2009, 2112, 2116, 2019, & 
 1920, 1721, 1421, 1220, 1119, 1016, 1014, 1112,   50, 2116, 2018, 1919, & 
 1720, 1420, 1219, 1118, 1016, 5050, & 
!  17 character= Q                                                              
   21, 1713, 1513, 1312, 1211, 1109, 1107, 1306, 1506, 1807, 2009, 2112, & 
 2115, 2017, 1818, 1418, 1117,  815,  411,  208,  106,    3,    1,  100, & 
  300,  401,  403,  305,  108,   11,   14,  116,  318,   50, 2115, 2016, & 
 1817, 1417, 1116,  814,  511,  207,    3, 5050, & 
!  18 character= R                                                              
   24, 2015, 1914, 1713, 1211,  609,  408,  106,    4,   50, 1914, 1613, & 
  811,  510,  309,  107,    4,    2,  101,  301,  402,  303,  202,   50, & 
 1509, 1308, 1207, 1205, 1304, 1504, 1705, 1907, 2009, 2112, 2117, 2020, & 
 1821, 1621, 1420, 1319, 1216, 1212,   50, 2117, 2019, 1820, 1620, 1419, & 
 1318, 1216,   50, 1212, 1115,  916,  217,   18,   50, 1212, 1114,  915, & 
  216,   18,   19,  121,  323, 5050, & 
!  19 character= S                                                              
   20, 1806, 1605, 1405, 1206, 1108, 1111, 1214, 1316, 1619, 1920, 2020, & 
 2119, 2118, 2016, 1915, 1714, 1413,  711,  410,  108,    6,   50, 1714, & 
 1313,  612,  311,  109,    6,    3,  101,  300,  400,  501,  402,  301, & 
 5050, & 
!  20 character= T                                                              
   18, 1916, 1715, 1213,  611,  410,  108,    6,   50, 1510, 1309, 1207, & 
 1205, 1404, 1604, 1805, 2007, 2110, 2119, 2017, 1916, 1615,  813,  512, & 
  311,  109,    6,    4,  102,  201,  301,  402,  303,  202,   50, 2112, & 
 2016, 2017, 5050, & 
!  21 character= U                                                              
   22, 1701, 2003, 2105, 2106, 1908, 1608, 1307,  504,  204,    5,   50, & 
 2106, 1907, 1607,  804,  503,  203,    5,    7,  109,  412,  714,  915, & 
   50, 2119,  915,  514,  214,   16,   17,  119,  321,   50, 2120,  916, & 
  515,  215,   16, 5050, & 
!  22 character= V                                                              
   21, 1701, 2003, 2105, 2106, 1908, 1608, 1207,  505,  205,    6,   50, & 
 2106, 1907, 1607,  905,  504,  204,    6,    7,  110,  413,  715, 1117, & 
 1418, 1819, 2019, 2118, 2117, 2016, 1815, 1515, 1316, 1118, 1020, 1022, & 
 5050, & 
!  23 character= W                                                              
   23, 1503, 1502, 1601, 1801, 2002, 2104, 2108, 1907, 1506,  605,    4, & 
   50, 1506,  606,    5,   50, 2116, 1914, 1512,  609,  207,    5,   50, & 
 2116, 1915, 1514,  613,   12,   50, 1514,  614,   13,   50, 2126, 2024, & 
 1822, 1520,  617,  215,   13, 5050, & 
!  24 character= X                                                              
   20, 1608, 1507, 1505, 1604, 1804, 2005, 2107, 2109, 2011, 1812, 1512, & 
 1111,  609,  307,  105,    2,    0,   99,  299,  400,  301,  200,   50, & 
 2109, 2010, 1811, 1511, 1110,  608,  306,  104,    2,   50, 2021, 1920, & 
 1821, 1922, 2022, 2121, 2119, 2017, 1815, 1513, 1111,  610,  310,  111, & 
   12,   13,  115,  317, 5050, & 
!  25 character= Y                                                              
   22, 1703, 2005, 2107, 2108, 2010, 1810, 1208,  908,  709,   50, 2108, & 
 2009, 1809, 1207,  907,  709,  711,  814, 1016, 1318, 1519,   50, 2121, & 
 1519,  716,  314,   50, 2122, 1520, 1018,  616,  314,  112,    9,    5, & 
  103,  302,  402,  503,  404,  303, 5050, & 
!  26 character= Z                                                              
   21, 1919, 1718, 1216,  915,  714,  412,  210,  108,    5,   50, 1512, & 
 1311, 1209, 1207, 1406, 1606, 1807, 2009, 2112, 2122, 2020, 1919, 1618, & 
 1217,  615,  313,  110,    5,    1,  100,  300,  401,  403,  305,  108, & 
   10,   13,  116,  318,   50, 2115, 2019, 2020, 5050/)

      if(J+1.gt.27)then 
        J=-J 
        goto 20 
      end if 
      J1 = ISTART(J+1) 
      J = ISTART(J) 
      I = 0 
   10 I = I + 1 
      JJ = J + I - 1 
      IF ( JJ.GE.J1 ) GO TO 20 
      KOORD(I) = K(JJ) 
      GO TO 10 
   20 RETURN 
      END                                           
!-----------------------------------------------------------------------
      SUBROUTINE  NSCRIP (J,KOORD) 
!-----------------------------------------------------------------------
!      ZIFFERN, SONDERZEICHEN  SCRIPT                                   
!      0123456789 . , : ; ! ? < > & $ / ( ) * - + = ' " # [ ] %_{}      
!                11                20               28 30      34       
      integer KOORD(75) 
!                                                                       
      SAVE 
!                                                                       
integer,parameter,dimension(1:38) :: &
     ISTART=(/  1, 44, 60,103,154,165,205,252,283,347,394,401,410,  &
              422,437,455,490,499,508,564,606,610,631,652,662,666,  &
              673,680,687,700,715,726,737,769,773,804,835,860/)   

integer,parameter,dimension(1:859) :: K=&
!   1 character= 0                                                              
(/ 21, 2112, 2009, 1807, 1505, 1204,  803,  503,  204,  105,    7,    9, & 
  112,  314,  616,  917, 1318, 1618, 1917, 2016, 2114, 2112,   50, 2112, & 
 2010, 1808, 1506, 1205,  804,  504,  205,    7,   50,    9,  111,  313, & 
  615,  916, 1317, 1617, 1916, 2114, 5050, & 
!   2 character= 1                                                              
   21, 1712,    7,   50, 2114,    8,   50, 2114, 1811, 1608, 1506,   50, & 
 1813, 1609, 1506, 5050, & 
!   3 character= 2                                                              
   21, 1707, 1608, 1507, 1606, 1706, 1907, 2008, 2111, 2114, 2017, 1818, & 
 1618, 1417, 1215, 1012,  808,  605,  403,    1,   50, 2114, 2016, 1817, & 
 1617, 1416, 1214,  808,   50,  202,  303,  305,  110,  113,  215,  416, & 
   50,  305,   10,   13,  115,  416, 5050, & 
!   4 character= 3                                                              
   21, 1707, 1608, 1507, 1606, 1706, 1907, 2008, 2111, 2114, 2017, 1818, & 
 1618, 1417, 1214, 1111,   50, 2114, 2016, 1817, 1617, 1416, 1214,   50, & 
 1109, 1111, 1014,  915,  716,  416,  215,  114,   11,    7,  104,  203, & 
  402,  502,  603,  504,  403,   50, 1111, 1013,  914,  715,  415,  214, & 
  113,   11, 5050, & 
!   5 character= 4                                                              
   21, 2016,   10,   50, 2117,   11,   50, 2117,  602,  618, 5050, & 
!   6 character= 5                                                              
   21, 2109, 1104,   50, 2109, 2119,   50, 2009, 2014, 2119,   50, 1104, & 
 1205, 1308, 1311, 1214, 1115,  916,  616,  315,  113,   10,    7,  104, & 
  203,  402,  502,  603,  504,  403,   50, 1311, 1213, 1114,  915,  615, & 
  314,  112,   10, 5050, & 
!   7 character= 6                                                              
   21, 1817, 1716, 1617, 1718, 1818, 2017, 2115, 2112, 2009, 1807, 1505, & 
 1204,  803,  403,  204,  105,    7,   10,  113,  315,  516,  816, 1015, & 
 1114, 1212, 1209, 1107,  905,  704,   50, 2112, 2010, 1808, 1506, 1205, & 
  804,  304,  105,   50,   10,  112,  314,  515,  915, 1114, 5050, & 
!   8 character= 7                                                              
   21, 2106, 1504,   50, 2119, 1818, 1516,  911,  609,  408,    7,   50, & 
 1516,  910,  608,  407,    6,   50, 1805, 2108, 2110, 1815,   50, 1906, & 
 2008, 2010, 1815, 1817, 1918, 2119, 5050, & 
!   9 character= 8                                                              
   21, 2111, 2008, 1907, 1706, 1406, 1207, 1109, 1112, 1216, 1317, 1518, & 
 1818, 2017, 2114, 2111,   50, 2111, 2009, 1908, 1707, 1407, 1208, 1109, & 
   50, 1112, 1215, 1316, 1517, 1817, 2016, 2114,   50, 1109, 1005,  803, & 
  602,  302,  103,    6,   10,  114,  215,  416,  716,  915, 1014, 1112, & 
   50, 1109, 1006,  804,  603,  303,  104,    6,   50,   10,  113,  214, & 
  415,  815, 1014, 5050, & 
!  10 character= 9                                                              
   21, 1417, 1216, 1014,  912,  909, 1007, 1106, 1305, 1605, 1806, 2008, & 
 2111, 2114, 2016, 1917, 1718, 1318,  917,  616,  314,  112,    9,    6, & 
  104,  303,  403,  504,  405,  304,   50, 1007, 1206, 1606, 1807, 2009, & 
 2111,   50, 2016, 1817, 1317,  916,  615,  313,  111,    9, 5050, & 
!  11 character= .                                                              
   11,  203,  102,    3,  104,  203, 5050, & 
!  12 character= ,                                                              
   11,    3,  102,  203,  104,    4, -197, -399, 5050, & 
!  13 character= :                                                              
   11, 1406, 1305, 1206, 1307, 1406,   50,  203,  102,    3,  104, 5050, & 
!  14 character= ;                                                              
   11, 1406, 1305, 1206, 1307, 1406,   50,    3,  102,  203,  104,    4, & 
 -197, -399, 5050, & 
!  15 character= !                                                              
   11, 2108, 2007,  805,   50, 2008,  805,   50, 2108, 2009,  805,   50, & 
  203,  102,    3,  104,  203, 5050, & 
!  16 character= ?                                                              
   21, 1707, 1608, 1507, 1606, 1706, 1907, 2008, 2111, 2115, 2018, 1819, & 
 1619, 1418, 1317, 1111, 1009,  809,  710,  712,   50, 2115, 2017, 1818, & 
 1618, 1417, 1316, 1214,   50,  208,  107,    8,  109,  208, 5050, & 
!  17 character= <                                                              
   26, 1521,  905,  321, 5050,    0,    0,    0,    0, & 
!  18 character= >                                                              
   26, 1505,  921,  305, 5050,    0,    0,    0,    0, & 
!  19 character= &                                                              
   26, 1323, 1222, 1123, 1224, 1324, 1423, 1422, 1320, 1118,  313,  111, & 
    9,    6,  103,  302,  502,  703,  804,  906, 1111, 1213, 1415, 1616, & 
 1816, 2015, 2113, 2011, 1810, 1510,  911,  612,  314,  116,   18,   20, & 
  221,  321,   50,    6,  104,  303,  503,  704,  805, 1111,   50, 1510, & 
 1011,  712,  414,  216,  118,  120,  221, 5050, & 
!  20 character= $                                                              
   21, 2512, -396,   50, 2517, -391,   50, 1718, 1617, 1518, 1619, 1719, & 
 1918, 2017, 2114, 2110, 2007, 1805, 1605, 1406, 1307,  914,  716,   50, & 
 1605, 1407, 1014,  915,  716,  416,  215,  114,   11,    7,  104,  203, & 
  402,  502,  603,  504,  403, 5050, & 
!  21 character= /                                                              
   22, 2524, -702, 5050, & 
!  22 character= (                                                              
   15, 2515, 2211, 1908, 1606, 1204,  703,  303, -196, -495, -694,   50, & 
 2211, 1808, 1406, 1105,  604,  104, -395, -694, 5050, & 
!  23 character= )                                                              
   15, 2509, 2310, 2011, 1512, 1112,  611,  209,  -93, -396, -700,   50, & 
 2509, 2210, 1711, 1211,  710,  409,    7, -396, 5050, & 
!  24 character= *                                                              
   17, 2110,  910,   50, 1805, 1215,   50, 1815, 1205, 5050, & 
!  25 character= -                                                              
   26,  904,  922, 5050, & 
!  26 character= +                                                              
   26, 1813,   13,   50,  904,  922, 5050, & 
!  27 character= =                                                              
   26, 1204, 1222,   50,  604,  622, 5050, & 
!  28 character=                                                                
    9, 2107, 1405,   50, 2108, 1405, 5050, & 
!  29 character= "                                                              
   18, 2107, 1405,   50, 2108, 1405,   50, 2116, 1414,   50, 2117, 1414, & 
 5050, & 
!  30 character= #                                                              
   15, 2108, 2006, 1805, 1605, 1406, 1308, 1310, 1412, 1613, 1813, 2012, & 
 2110, 2108, 5050, & 
!  31 character= [                                                              
   20, 2515, 2507, -394, -386,   50, 2414, 2408, -293, -287, 5050, & 
!  32 character= ]                                                              
   20, 2507, 2515, -386, -394,   50, 2408, 2414, -287, -293, 5050, & 
!  33 character= %                                                              
   22, 2520, -698,   50, 2106, 2004, 1803, 1603, 1404, 1306, 1308, 1410, & 
 1611, 1811, 2010, 2108, 2106,   50,  514,  412,  211,   11, -188, -286, & 
 -284, -182,   19,  219,  418,  516,  514, 5050, & 
!  34 character= _                                                              
   20,    1,   19, 5050, & 
!  35 character= {                                                              
   14, -588, -491, -392,  -93,  507,  806,  905, 1003, 1105, 1206, 1507, & 
 2107, 2408, 2509, 2612, 2510, 2409, 2108, 1508, 1207, 1106, 1003,  906, & 
  807,  508,  -92, -391, -490, -588, 5050, & 
!  36 character= }                                                              
   14, -598, -495, -394,  -93,  507,  808,  909, 1011, 1109, 1208, 1507, & 
 2107, 2406, 2505, 2602, 2504, 2405, 2106, 1506, 1207, 1108, 1011,  908, & 
  807,  506,  -94, -395, -496, -598, 5050, & 
!  37 character= |                                                              
   17,  405, 1907,   50,  409, 1911,   50,  902,  913,   50, 1403, 1414, & 
   50,  406, 1908,   50,  410, 1912,   50, 1003, 1014,   50, 1504, 1515, & 
 5050/)
                                                                        
      if(J+1.gt.38)then 
        J=-J 
        goto 20 
      end if 
      J1 = ISTART(J+1) 
      J = ISTART(J) 
      I = 0 
   10 I = I + 1 
      JJ = J + I - 1 
      IF ( JJ.GE.J1 ) GO TO 20 
      KOORD(I) = K(JJ) 
      GO TO 10 
   20 RETURN 
      END                                           
!-----------------------------------------------------------------------
      SUBROUTINE  KITALI (J,KOORD) 
!-----------------------------------------------------------------------
!      KLEINE ITALICS                                                   
!      abcdefghijklmnopqrstuvwxyz                                       
      integer KOORD(75) 
!                                                                       
      SAVE 
!                                                                       
integer,parameter,dimension(1:27) :: &
     ISTART=(/  1, 41, 78,104,147,174,210,254,286,313,346,381,400,  &
     &        453,491,524,567,601,628,657,676,714,741,783,826,868,  &
     &        900/)     
integer,parameter,dimension(1:899) :: K=&
!   1 character= a                                                              
(/ 21, 1416,  714,  313,  113,   14,   17,  219,  420,   50, 1417,  715, & 
  314,  114,   15,   50,  714, 1014, 1313, 1411, 1409, 1306, 1004,  703, & 
  403,  204,  105,    7,    9,  111,  413,  714,   50, 1409, 1307, 1005, & 
  704,  304,  105, 5050, & 
!   2 character= b                                                              
   19, 2108,  804,  504,  205,  106,   50, 2109,  805,   50,  805, 1106, & 
 1308, 1410, 1412, 1314, 1215, 1016,  716,  415,  113,   10,    8,  106, & 
  405,  805,   50, 1314, 1115,  715,  414,  112,   10,   50, 2105, 2109, & 
 5050, & 
!   3 character= c                                                              
   18, 1114, 1014, 1015, 1115, 1314, 1412, 1409, 1306, 1004,  703,  403, & 
  204,  105,    7,    9,  112,  414,   50, 1409, 1307, 1005,  704,  304, & 
  105, 5050, & 
!   4 character= d                                                              
   21, 2118,  714,  313,  113,   14,   17,  219,  420,   50, 2119,  715, & 
  314,  114,   15,   50,  714, 1014, 1313, 1411, 1409, 1306, 1004,  703, & 
  403,  204,  105,    7,    9,  111,  413,  714,   50, 1409, 1307, 1005, & 
  704,  304,  105,   50, 2115, 2119, 5050, & 
!   5 character= e                                                              
   18,  504,  608,  711,  914, 1115, 1314, 1412, 1409, 1306, 1004,  703, & 
  403,  204,  105,    7,    9,  112,  314,   50, 1409, 1307, 1005,  704, & 
  304,  105, 5050, & 
!   6 character= f                                                              
   15, 2015, 1914, 1815, 1916, 2016, 2115, 2113, 2011, 1910, 1709, 1408, & 
    5, -396, -597,   50, 2113, 1911, 1710, 1309,  407,    6, -295, -496, & 
 -597, -699, -701, -602, -502, -401, -500, -601,   50, 1404, 1414, 5050, & 
!   7 character= g                                                              
   20, 1417,   13, -288, -590, -693, -696, -598, -499, -399, -298, -397, & 
 -498,   50, 1416,   12, -289, -591, -693,   50,  714, 1014, 1313, 1411, & 
 1409, 1306, 1004,  703,  403,  204,  105,    7,    9,  111,  413,  714, & 
   50, 1409, 1307, 1005,  704,  304,  105, 5050, & 
!   8 character= h                                                              
   21, 2108,    2,   50, 2109,    3,   50,  705, 1107, 1309, 1411, 1413, & 
 1315, 1216, 1016,  414,  114,   15,   50, 1413, 1215, 1015,  413,  113, & 
   14,   17,  219,  420,   50, 2105, 2109, 5050, & 
!   9 character= i                                                              
   13, 2109, 2008, 1909, 2010, 2109,   50, 1001, 1202, 1404, 1407, 1308, & 
 1008,  406,  106,    7,   50, 1406, 1307, 1007,  405,  105,    6,    9, & 
  211,  412, 5050, & 
!  10 character= j                                                              
   13, 2110, 2009, 1910, 2011, 2110,   50, 1002, 1203, 1405, 1408, 1309, & 
 1009,    6, -295, -496, -597, -699, -701, -602, -502, -401, -500, -601, & 
   50, 1407, 1308, 1008,    5, -296, -497, -699, 5050, & 
!  11 character= k                                                              
   20, 2108,    2,   50, 2109,    3,   50, 1316, 1215, 1116, 1217, 1317, & 
 1416, 1415, 1313,  909,  807,  805,   50,  807,  709,  111,   12,   50, & 
  807,  708,  110,   11,   13,  115,  417,   50, 2105, 2109, 5050, & 
!  12 character= l                                                              
   12, 2108,  704,  303,  103,    4,    7,  209,  410,   50, 2109,  705, & 
  304,  104,    5,   50, 2105, 2109, 5050, & 
!  13 character= m                                                              
   33, 1001, 1202, 1404, 1407, 1308, 1108,  707,    5,   50, 1406, 1307, & 
 1107,  706,    4,   50,  707, 1109, 1311, 1413, 1415, 1317, 1218, 1018, & 
   15,   50, 1415, 1217, 1017,   14,   50,  717, 1119, 1321, 1423, 1425, & 
 1327, 1228, 1028,  426,  126,   27,   50, 1425, 1227, 1027,  425,  125, & 
   26,   29,  231,  432, 5050, & 
!  14 character= n                                                              
   23, 1001, 1202, 1404, 1407, 1308, 1108,  707,    5,   50, 1406, 1307, & 
 1107,  706,    4,   50,  707, 1109, 1311, 1413, 1415, 1317, 1218, 1018, & 
  416,  116,   17,   50, 1415, 1217, 1017,  415,  115,   16,   19,  221, & 
  422, 5050, & 
!  15 character= o                                                              
   18, 1409, 1306, 1004,  703,  403,  204,  105,    7,    9,  112,  414, & 
  715, 1015, 1214, 1313, 1411, 1409,   50, 1409, 1307, 1005,  704,  304, & 
  105,   50,    9,  111,  413,  714, 1114, 1313, 5050, & 
!  16 character= p                                                              
   21, 1001, 1202, 1404, 1407, 1308, 1108,  707, -697,   50, 1406, 1307, & 
 1107,  706, -698,   50,  707, 1008, 1310, 1412, 1414, 1316, 1217, 1018, & 
  718,  417,  115,   12,   10,  108,  407,  707,   50, 1316, 1117,  717, & 
  416,  114,   12,   50, -701, -694, 5050, & 
!  17 character= q                                                              
   20, 1416, -690,   50, 1417, -689,   50,  714, 1014, 1313, 1411, 1409, & 
 1306, 1004,  703,  403,  204,  105,    7,    9,  111,  413,  714,   50, & 
 1409, 1307, 1005,  704,  304,  105,   50, -693, -686, 5050, & 
!  18 character= r                                                              
   17, 1001, 1202, 1404, 1407, 1308, 1108,  707,    5,   50, 1406, 1307, & 
 1107,  706,    4,   50,  707, 1109, 1311, 1413, 1415, 1316, 1216, 1115, & 
 1214, 1315, 5050, & 
!  19 character= s                                                              
   17, 1214, 1114, 1115, 1215, 1314, 1411, 1408, 1305, 1204, 1004,  905, & 
  512,  413,   50, 1104, 1005,  612,  513,  213,  112,    9,    6,  103, & 
  202,  302,  303,  203, 5050, & 
!  20 character= t                                                              
   14, 2109,  705,  304,  104,    5,    8,  210,  411,   50, 2110,  706, & 
  305,  105,    6,   50, 1403, 1412, 5050, & 
!  21 character= u                                                              
   23, 1001, 1202, 1404, 1407, 1308, 1008,  406,  206,    8,   50, 1406, & 
 1307, 1007,  405,  205,  106,    8,   10,  112,  314,  716,   50, 1418, & 
  716,  315,  115,   16,   19,  221,  422,   50, 1419,  717,  316,  116, & 
   17, 5050, & 
!  22 character= v                                                              
   20, 1001, 1202, 1404, 1407, 1308, 1008,  406,  206,    8,   50, 1406, & 
 1307, 1007,  405,  205,  106,    8,    9,  112,  314,  616, 1017, 1417, & 
 1416, 1217, 5050, & 
!  23 character= w                                                              
   29, 1001, 1202, 1404, 1407, 1308, 1008,  406,  206,    8,   50, 1406, & 
 1307, 1007,  405,  205,  106,    8,   10,  112,  314,  515,   50, 1417, & 
  515,  215,  116,   18,   20,  122,  324,  525,  926, 1426, 1425, 1226, & 
   50, 1418,  516,  216,   18, 5050, & 
!  24 character= x                                                              
   20, 1003, 1305, 1407, 1410, 1211,  911,   50, 1409, 1210,  910,  509, & 
  308,  106,    4,    3,  102,  202,  303,  204,  103,   50,  509,  209, & 
   10,   13,  115,  417,   50, 1317, 1216, 1117, 1218, 1318, 1417, 1416, & 
 1314, 1112,  911,  510,  210,   11, 5050, & 
!  25 character= y                                                              
   21, 1001, 1202, 1404, 1407, 1308, 1008,  406,  206,    8,   50, 1406, & 
 1307, 1007,  405,  205,  106,    8,   10,  112,  314,  716,   50, 1419, & 
   15, -286, -588, -691, -694, -596, -497, -397, -296, -395, -496,   50, & 
 1418,   14, -287, -589, -691, 5050, & 
!  26 character= z                                                              
   20, 1417, 1216, 1014,  406,  204,    3,   50, 1004, 1205, 1407, 1410, & 
 1214,   50, 1205, 1307, 1310, 1214, 1216,   50,  204,  206,  110,  113, & 
  215,   50,  206,   10,   13,  215,  416, 5050/)


      if(J+1.gt.27)then 
        J=-J 
        goto 20 
      end if 
      J1 = ISTART(J+1) 
      J = ISTART(J) 
      I = 0 
   10 I = I + 1 
      JJ = J + I - 1 
      IF ( JJ.GE.J1 ) GO TO 20 
      KOORD(I) = K(JJ) 
      GO TO 10 
   20 RETURN 
      END                                           
!-----------------------------------------------------------------------
      SUBROUTINE  GITALI (J,KOORD) 
!-----------------------------------------------------------------------
!      GROSSE ITALICS                                                   
!      ABCDEFGHIJKLMNOPQRSTUVWXYZ                                       
      integer  KOORD(75) 
!                                                                       
      SAVE 
!                                                                       
integer,parameter,dimension(1:27) :: &
      ISTART=(/  1, 20, 62, 97,128,151,172,215,243,256,278,306,321,  &
               352,374,417,445,507,550,586,603,629,645,670,692,713,  &
               730/)     
integer,parameter,dimension(1:729) :: K=&
!   1 character= A                                                              
(/ 20, 2113,    0,   50, 2113,   14,   50, 1912,   13,   50,  604,  613, & 
   50,   -2,    4,   50,   10,   16, 5050, & 
!   2 character= B                                                              
   24, 2109,    3,   50, 2110,    4,   50, 2106, 2117, 2020, 1821, 1621, & 
 1320, 1219, 1116,   50, 2117, 2019, 1820, 1620, 1319, 1218, 1116,   50, & 
 1107, 1116, 1018,  819,  619,  318,  116,   12,    0,   50, 1116, 1017, & 
  818,  618,  317,  115,   12, 5050, & 
!   3 character= C                                                              
   21, 1918, 1919, 2120, 1519, 1719, 1918, 2017, 2115, 2112, 2009, 1807, & 
 1505, 1204,  803,  503,  204,  105,    8,   11,  113,  315,  516,   50, & 
 2112, 2010, 1808, 1506, 1205,  804,  504,  205,  106,    8, 5050, & 
!   4 character= D                                                              
   23, 2109,    3,   50, 2110,    4,   50, 2106, 2115, 2018, 1919, 1620, & 
 1220,  819,  417,  215,  113,    9,    0,   50, 2115, 2017, 1918, 1619, & 
 1219,  818,  416,  214,  112,    9, 5050, & 
!   5 character= E                                                              
   23, 2109,    3,   50, 2110,    4,   50, 1514,  712,   50, 2106, 2121, & 
 1520, 2120,   50, 1107, 1113,   50,    0,   15,  517,   14, 5050, & 
!   6 character= F                                                              
   22, 2109,    3,   50, 2110,    4,   50, 1514,  712,   50, 2106, 2121, & 
 1520, 2120,   50, 1107, 1113,   50,    0,    7, 5050, & 
!   7 character= G                                                              
   22, 1918, 1919, 2120, 1519, 1719, 1918, 2017, 2115, 2112, 2009, 1807, & 
 1505, 1204,  803,  503,  204,  105,    8,   10,  113,  315,  717,   50, & 
 2112, 2010, 1808, 1506, 1205,  804,  504,  205,  106,    8,   50,   10, & 
  112,  314,  716,   50,  713,  720, 5050, & 
!   8 character= H                                                              
   26, 2109,    3,   50, 2110,    4,   50, 2122,   16,   50, 2123,   17, & 
   50, 2106, 2113,   50, 2119, 2126,   50, 1107, 1119,   50,    0,    7, & 
   50,   13,   20, 5050, & 
!   9 character= I                                                              
   13, 2109,    3,   50, 2110,    4,   50, 2106, 2113,   50,    0,    7, & 
 5050, & 
!  10 character= J                                                              
   18, 2115,  410,  209,  108,    6,    4,  102,  301,  501,  602,  503, & 
  402,   50, 2114,  409,  208,    6,   50, 2111, 2118, 5050, & 
!  11 character= K                                                              
   23, 2109,    3,   50, 2110,    4,   50, 2123,  806,   50, 1213,   17, & 
   50, 1212,   16,   50, 2106, 2113,   50, 2119, 2125,   50,    0,    7, & 
   50,   13,   19, 5050, & 
!  12 character= L                                                              
   20, 2109,    3,   50, 2110,    4,   50, 2106, 2113,   50,    0,   15, & 
  617,   14, 5050, & 
!  13 character= M                                                              
   27, 2109,    3,   50, 2109,   10,   50, 2110,  211,   50, 2123,   10, & 
   50, 2123,   17,   50, 2124,   18,   50, 2106, 2110,   50, 2123, 2127, & 
   50,    0,    6,   50,   14,   21, 5050, & 
!  14 character= N                                                              
   25, 2109,    3,   50, 2109,  316,   50, 1809,   16,   50, 2122,   16, & 
   50, 2106, 2109,   50, 2119, 2125,   50,    0,    6, 5050, & 
!  15 character= O                                                              
   22, 2112, 2009, 1807, 1505, 1204,  803,  503,  204,  105,    7,   10, & 
  113,  315,  617,  918, 1319, 1619, 1918, 2017, 2115, 2112,   50, 2112, & 
 2010, 1808, 1506, 1205,  804,  504,  205,    7,   50,   10,  112,  314, & 
  616,  917, 1318, 1618, 1917, 2115, 5050, & 
!  16 character= P                                                              
   23, 2109,    3,   50, 2110,    4,   50, 2106, 2118, 2021, 1822, 1622, & 
 1321, 1119, 1015, 1007,   50, 2118, 2020, 1821, 1621, 1320, 1118, 1015, & 
   50,    0,    7, 5050, & 
!  17 character= Q                                                              
   22, 2112, 2009, 1807, 1505, 1204,  803,  503,  204,  105,    7,   10, & 
  113,  315,  617,  918, 1319, 1619, 1918, 2017, 2115, 2112,   50, 2112, & 
 2010, 1808, 1506, 1205,  804,  504,  205,    7,   50,   10,  112,  314, & 
  616,  917, 1318, 1618, 1917, 2115,   50,  205,  305,  506,  608,  609, & 
  511,  312, -388, -487, -485, -284, -184,   50,  312, -287, -386, -385, & 
 -284, 5050, & 
!  18 character= R                                                              
   24, 2109,    3,   50, 2110,    4,   50, 2106, 2117, 2020, 1821, 1621, & 
 1320, 1219, 1116, 1107,   50, 2117, 2019, 1820, 1620, 1319, 1218, 1116, & 
   50, 1112, 1014,  915,  116,   17,   19,  220,  320,   50,  915,  217, & 
  118,  119,  220,   50,    0,    7, 5050, & 
!  19 character= S                                                              
   23, 1919, 1920, 2121, 1520, 1720, 1919, 2018, 2115, 2111, 2008, 1806, & 
 1606, 1407, 1308,  915,  717,   50, 1606, 1408, 1015,  916,  717,  417, & 
  216,  115,   12,    8,  105,  204,  403,  603,    2,  203,  204, 5050, & 
!  20 character= T                                                              
   21, 2113,    7,   50, 2114,    8,   50, 2107, 1504, 2106, 2121, 1520, & 
 2120,   50,    4,   11, 5050, & 
!  21 character= U                                                              
   25, 2108, 1005,  604,  304,  105,    8,   12,  115,  317,  618, 2122, & 
   50, 2109, 1006,  605,  305,  106,    8,   50, 2105, 2112,   50, 2119, & 
 2125, 5050, & 
!  22 character= V                                                              
   20, 2106,    7,   50, 2107,  208,   50, 2120,    7,   50, 2104, 2110, & 
   50, 2116, 2122, 5050, & 
!  23 character= W                                                              
   26, 2108,    6,   50, 2109,  207,   50, 2116,    6,   50, 2116,   14, & 
   50, 2117,  215,   50, 2124,   14,   50, 2105, 2112,   50, 2121, 2127, & 
 5050, & 
!  24 character= X                                                              
   22, 2107,   14,   50, 2108,   15,   50, 2121,    1,   50, 2105, 2111, & 
   50, 2117, 2123,   50,   -1,    5,   50,   11,   17, 5050, & 
!  25 character= Y                                                              
   21, 2106, 1110,    7,   50, 2107, 1111,    8,   50, 2121, 1111,   50, & 
 2104, 2110,   50, 2117, 2123,   50,    4,   11, 5050, & 
!  26 character= Z                                                              
   22, 2120,    1,   50, 2121,    2,   50, 2108, 1505, 2107, 2121,   50, & 
    1,   15,  617,   14, 5050/) 


      if(J+1.gt.27)then 
        J=-J 
        goto 20 
      end if 
      J1 = ISTART(J+1) 
      J = ISTART(J) 
      I = 0 
   10 I = I + 1 
      JJ = J + I - 1 
      IF ( JJ.GE.J1 ) GO TO 20 
      KOORD(I) = K(JJ) 
      GO TO 10 
   20 RETURN 
      END                                           
!-----------------------------------------------------------------------
      SUBROUTINE  KGREEK (J,KOORD) 
!-----------------------------------------------------------------------
!      KLEINE GREEK                                                     
!      A,B,G,D,E,Z,C,Q,I,K,L,M,N,X,O,P,R,S,T,U,F,H,Y,W                  
      integer KOORD(75) 
!                                                                       
      SAVE 
!                                                                       

integer,parameter,dimension(1:25) :: &
      ISTART=(/  1, 42,100,129,174,207,239,272,317,333,363,387,      &
               416,441,487,520,543,575,611,628,660,698,722,757,      &
               802/)  
integer,parameter,dimension(1:801) :: K=&
!   1 character= alpha   a                                                      
(/ 23, 1410, 1307, 1105,  904,  603,  303,  104,    7,    9,  111,  414, & 
  716, 1118, 1419,   50, 1410, 1308, 1106,  905,  604,  304,  105,    7, & 
   50, 1410, 1412, 1314, 1115,  317,  118,   19,   50, 1412, 1313, 1114, & 
  316,  117,   19,   20, 5050, & 
!   2 character= beta    b                                                      
   21, 2113, 2010, 1808, 1406, 1105,  704,  103, -698,   50, 2113, 2011, & 
 1809, 1407, 1106,  705,  104, -697,   50, 2113, 2115, 2017, 1918, 1618, & 
 1417, 1316, 1213, 1209,   50, 2115, 1917, 1617, 1416, 1315, 1213,   50, & 
 1209, 1113,  915,  716,  416,  215,  114,   11,    9,  107,  206,  505, & 
   50, 1209, 1112,  914,  715,  415,  214,  113,   11, 5050, & 
!   3 character= gamma   g                                                      
   20, 1101, 1303, 1405, 1407, 1309, 1210,  911,  511,  110, -693,   50, & 
 1202, 1304, 1308, 1210,   50, 1418, 1117,  916,  211, -292, -694,   50, & 
 1417, 1116,  915,  211, 5050, & 
!   4 character= delta   d                                                      
   19, 1313, 1411, 1409, 1306, 1004,  703,  403,  204,  105,    7,    9, & 
  112,  414,  715, 1015, 1214, 1710, 1909, 2109, 2210, 2212, 2114, 1916, & 
   50, 1409, 1307, 1005,  704,  304,  105,   50,    9,  111,  413,  714, & 
 1114, 1313, 1611, 1810, 2010, 2111, 2113, 1916, 5050, & 
!   5 character= epsilon e                                                      
   18, 1115, 1313, 1411, 1407, 1305, 1105,  907,  810,   50, 1407, 1306, & 
 1106,  908,  810,   50,  810,  705,  503,  303,  104,    7,   10,  112, & 
  314,   50,  810,  706,  504,  304,  105,    7, 5050, & 
!   6 character= zeta    z                                                      
   18, 2111, 2009, 1908, 1808, 1709, 1612, 1617, 1717, 1614, 1410, 1207, & 
  904,  603,  403,  204,    7, -190, -389, -589, -690, -692, -593,   50, & 
 1512, 1208,  905,  604,  404,  205,    7, 5050, & 
!   7 character= eta     c                                                      
   22, 1001, 1202, 1404, 1407, 1308, 1108,  707,    5,   50, 1406, 1307, & 
 1107,  706,    4,   50,  707, 1109, 1311, 1413, 1415, 1317, 1218,  918, & 
  417, -686,   50, 1415, 1217,  917,  416, -687, 5050, & 
!   8 character= theta   q                                                      
   23, 1001, 1202, 1404, 1407, 1308, 1108,  607,  307,  108,    9,   50, & 
 1406, 1307, 1107,  606,  306,  107,    9,   11,  113,  315,  617,  918, & 
 1419, 1819, 2018, 2116, 2114, 1912, 1712, 1413, 1115,  917,  720,   50, & 
  113,  415,  616,  917, 1418, 1818, 2017, 2116, 5050, & 
!   9 character= iota    i                                                      
   12, 1406,  704,  303,  103,    4,    7,  209,  410,   50, 1407,  705, & 
  304,  104,    5, 5050, & 
!  10 character= kappa   k                                                      
   20, 1406,    2,   50, 1407,    3,   50, 1416, 1317, 1318, 1417, 1415, & 
 1313,  909,  807,  805,   50,  807,  709,  111,   12,   50,  807,  708, & 
  110,   11,   13,  115,  417, 5050, & 
!  11 character= lambda  l                                                      
   20, 2103, 2105, 2007, 1908, 1709,  315,  116,   17,   50, 2105, 1907, & 
 1708,  314,  115,   17,   18,   50, 1410,    2,   50, 1410,    3, 5050, & 
!  12 character= mue     m                                                      
   23, 1407, -699,   50, 1408, -698,   50, 1107,  506,  206,    8,   10, & 
  112,  314,  616,   50, 1418,  315,  115,   16,   19,  221,  422,   50, & 
 1419,  316,  116,   17, 5050, & 
!  13 character= nue     n                                                      
   20, 1406,    4,   50, 1407,  806,  305,    4,   50, 1417, 1016,  614, & 
   50, 1418, 1117,  916,  614,  412,  209,  107,    4,   50, 1403, 1407, & 
 5050, & 
!  14 character= xi      x                                                      
   17, 2111, 2009, 1908, 1808, 1709, 1612, 1615,   50, 1612, 1508, 1406, & 
 1205, 1005,  807,  710,  713,   50, 1612, 1509, 1407, 1206, 1006,  808, & 
  710,   50,  710,  606,  504,  303,  103,  -95, -290, -389, -589, -691, & 
 -693,   50,  710,  607,  505,  304,  104,  -94, -290, 5050, & 
!  15 character= omikron o                                                      
   18, 1409, 1306, 1004,  703,  403,  204,  105,    7,    9,  112,  414, & 
  715, 1015, 1214, 1313, 1411, 1409,   50, 1409, 1307, 1005,  704,  304, & 
  105,   50,    9,  111,  413,  714, 1114, 1313, 5050, & 
!  16 character= pi      p                                                      
   22, 1309,    5,   50, 1309,    6,   50, 1315,   15,   50, 1315,   16, & 
   50, 1102, 1304, 1407, 1420,   50, 1102, 1204, 1307, 1320, 5050, & 
!  17 character= rho     r                                                      
   19,  504,  205,  106,    8,   10,  113,  415,  716, 1016, 1215, 1314, & 
 1412, 1410, 1307, 1005,  704, -700,   50,   10,  112,  414,  715, 1115, & 
 1314,   50, 1410, 1308, 1006,  705, -699, 5050, & 
!  18 character= sigma   s                                                      
   21, 1419, 1409, 1306, 1004,  703,  403,  204,  105,    7,    9,  112, & 
  414,  715, 1015, 1214, 1313, 1411,   50, 1409, 1307, 1005,  704,  304, & 
  105,   50,    9,  111,  413,  714, 1114, 1313,   50, 1313, 1319, 5050, & 
!  19 character= tau     t                                                      
   20, 1311,    8,   50, 1311,    9,   50, 1102, 1304, 1407, 1418,   50, & 
 1102, 1204, 1307, 1318, 5050, & 
!  20 character= ysilon  u                                                      
   20, 1001, 1202, 1404, 1407, 1308, 1108,  506,  206,    8,   50, 1406, & 
 1307, 1107,  505,  205,  106,    8,    9,  112,  314,  616,  917, 1217, & 
 1416, 1315, 1216,  917,   50,  616, 1217, 5050, & 
!  21 character= phi     f                                                      
   22, 1308, 1206, 1004,  703,  403,  204,  105,    7,   10,  113,  316, & 
  618,  919, 1219, 1417, 1415, 1213,  811,  309, -694,   50,  403,  205, & 
  107,  110,  213,  416,  618,   50, 1219, 1317, 1315, 1113,  811,  209, & 
 -693, 5050, & 
!  22 character= chi     h                                                      
   18, 1402, 1404, 1306, 1107, -388, -587, -686,   50, 1404, 1305, 1106, & 
 -389, -588, -686, -684,   50, 1417, 1216,  914, -196, -498, -699, 5050, & 
!  23 character= psi     y                                                      
   23, 2115, -691,   50, 2116, -692,   50, 1001, 1202, 1404, 1407, 1308, & 
 1108,  607,  307,  109,  112,  214,  517,  819,   50, 1406, 1307, 1107, & 
  606,  306,  107,    9,   12,  114,  316,  618,  819, 1421, 5050, & 
!  24 character= omega   w                                                      
   23, 1004, 1206, 1309, 1408, 1306, 1004,  703,  403,  104,    5,    7, & 
  109,  411,  712,   50,  403,  204,  105,  107,  209,  411,   50,  711, & 
  411,  112,   13,   15,  117,  419,  720, 1020, 1319, 1418, 1317, 1219, & 
 1020,   50,  411,  212,  113,  115,  217,  419, 5050/) 

      if(J+1.gt.25)then 
        J=-J 
        goto 20 
      end if 
      J1 = ISTART(J+1) 
      J = ISTART(J) 
      I = 0 
   10 I = I + 1 
      JJ = J + I - 1 
      IF ( JJ.GE.J1 ) GO TO 20 
      KOORD(I) = K(JJ) 
      GO TO 10 
   20 RETURN 
      END                                           
!-----------------------------------------------------------------------
      SUBROUTINE  GGREEK (J,KOORD) 
!-----------------------------------------------------------------------
!      GROSSE GREEK                                                     
!      A,B,G,D,E,Z,C,Q,I,K,L,M,N,X,O,P,R,S,T,U,F,H,Y,W                  
       integer KOORD(75) 
!                                                                       
      SAVE 
!                                                                       
integer,parameter,dimension(1:25):: &
     ISTART=(/  1, 20, 66, 81, 97,120,137,165,222,235,263,279,      &
              310,332,369,414,436,466,487,504,538,587,609,651,695/)  

integer,parameter,dimension(1:694):: K=&
!   1 character= Alpha   A                                                      
(/ 20, 2110,    3,   50, 2110,   17,   50, 1810,   16,   50,  605,  614, & 
   50,    1,    7,   50,   13,   19, 5050, & 
!   2 character= Beta    B                                                      
   22, 2105,    5,   50, 2106,    6,   50, 2102, 2114, 2017, 1918, 1719, & 
 1519, 1318, 1217, 1114,   50, 2114, 2016, 1917, 1718, 1518, 1317, 1216, & 
 1114,   50, 1106, 1114, 1017,  918,  719,  419,  218,  117,   14,    2, & 
   50, 1114, 1016,  917,  718,  418,  217,  116,   14, 5050, & 
!   3 character= Gamma   G                                                      
   18, 2105,    5,   50, 2106,    6,   50, 2102, 2117, 1517, 2116,   50, & 
    2,    9, 5050, & 
!   4 character= Delta   D                                                      
   20, 2110,    2,   50, 2110,   18,   50, 1810,   17,   50,  103,  117, & 
   50,    2,   18, 5050, & 
!   5 character= Epsilon E                                                      
   21, 2105,    5,   50, 2106,    6,   50, 1512,  712,   50, 2102, 2118, & 
 1518, 2117,   50, 1106, 1112,   50,    2,   18,  618,   17, 5050, & 
!   6 character= Zeta    Z                                                      
   20, 2116,    3,   50, 2117,    4,   50, 2104, 1503, 2103, 2117,   50, & 
    3,   17,  617,   16, 5050, & 
!   7 character= Eta     C                                                      
   24, 2105,    5,   50, 2106,    6,   50, 2118,   18,   50, 2119,   19, & 
   50, 2102, 2109,   50, 2115, 2122,   50, 1106, 1118,   50,    2,    9, & 
   50,   15,   22, 5050, & 
!   8 character= Theta   Q                                                      
   22, 2110, 2007, 1805, 1604, 1203,  903,  504,  305,  107,   10,   12, & 
  115,  317,  518,  919, 1219, 1618, 1817, 2015, 2112, 2110,   50, 2110, & 
 2008, 1806, 1605, 1204,  904,  505,  306,  108,   10,   50,   12,  114, & 
  316,  517,  918, 1218, 1617, 1816, 2014, 2112,   50, 1408,  708,   50, & 
 1414,  714,   50, 1108, 1114,   50, 1008, 1014, 5050, & 
!   9 character= Iota    I                                                      
   11, 2105,    5,   50, 2106,    6,   50, 2102, 2109,   50,    2,    9, & 
 5050, & 
!  10 character= Kappa   K                                                      
   22, 2105,    5,   50, 2106,    6,   50, 2119,  806,   50, 1211,   19, & 
   50, 1210,   18,   50, 2102, 2109,   50, 2115, 2121,   50,    2,    9, & 
   50,   15,   21, 5050, & 
!  11 character= Lambda  L                                                      
   20, 2110,    3,   50, 2110,   17,   50, 1810,   16,   50,    1,    7, & 
   50,   13,   19, 5050, & 
!  12 character= Mue     M                                                      
   25, 2105,    5,   50, 2106,  312,   50, 2105,   12,   50, 2119,   12, & 
   50, 2119,   19,   50, 2120,   20,   50, 2102, 2106,   50, 2119, 2123, & 
   50,    2,    8,   50,   16,   23, 5050, & 
!  13 character= Nue     N                                                      
   23, 2105,    5,   50, 2106,  218,   50, 1906,   18,   50, 2118,   18, & 
   50, 2102, 2106,   50, 2115, 2121,   50,    2,    8, 5050, & 
!  14 character= Xi      X                                                      
   22, 2204, 1703,   50, 2219, 1718,   50, 1308,  807,   50, 1315,  814, & 
   50,  404,  -97,   50,  419,  -82,   50, 2004, 2018,   50, 1904, 1918, & 
   50, 1108, 1114,   50, 1008, 1014,   50,  204,  218,   50,  104,  118, & 
 5050, & 
!  15 character= Omikron O                                                      
   22, 2110, 2007, 1805, 1604, 1203,  903,  504,  305,  107,   10,   12, & 
  115,  317,  518,  919, 1219, 1618, 1817, 2015, 2112, 2110,   50, 2110, & 
 2008, 1806, 1605, 1204,  904,  505,  306,  108,   10,   50,   12,  114, & 
  316,  517,  918, 1218, 1617, 1816, 2014, 2112, 5050, & 
!  16 character= Pi      P                                                      
   24, 2105,    5,   50, 2106,    6,   50, 2118,   18,   50, 2119,   19, & 
   50, 2102, 2122,   50,    2,    9,   50,   15,   22, 5050, & 
!  17 character= Rho     R                                                      
   22, 2105,    5,   50, 2106,    6,   50, 2102, 2114, 2017, 1918, 1719, & 
 1419, 1218, 1117, 1014, 1006,   50, 2114, 2016, 1917, 1718, 1418, 1217, & 
 1116, 1014,   50,    2,    9, 5050, & 
!  18 character= Sigma   S                                                      
   21, 2103, 1110,    2,   50, 2102, 1109,   50, 2102, 2117, 1518, 2116, & 
   50,  103,  116,   50,    2,   17,  618,   16, 5050, & 
!  19 character= Tau     T                                                      
   19, 2109,    9,   50, 2110,   10,   50, 2103, 1502, 2102, 2117, 1517, & 
 2116,   50,    6,   13, 5050, & 
!  20 character= Ysilon  U                                                      
   19, 1602, 1802, 2003, 2104, 2106, 2007, 1808, 1409,    9,   50, 1802, & 
 2004, 2006, 1808,   50, 1617, 1817, 2016, 2115, 2113, 2012, 1811, 1410, & 
   10,   50, 1817, 2015, 2013, 1811,   50,    6,   13, 5050, & 
!  21 character= Phi     F                                                      
   21, 2110,   10,   50, 2111,   11,   50, 1608, 1505, 1404, 1203,  903, & 
  704,  605,  508,  513,  616,  717,  918, 1218, 1417, 1516, 1613, 1608, & 
   50, 1608, 1506, 1405, 1204,  904,  705,  606,  508,   50,  513,  615, & 
  716,  917, 1217, 1416, 1515, 1613,   50, 2107, 2114,   50,    7,   14, & 
 5050, & 
!  22 character= Chi     H                                                      
   20, 2103,   16,   50, 2104,   17,   50, 2117,    3,   50, 2101, 2107, & 
   50, 2113, 2119,   50,    1,    7,   50,   13,   19, 5050, & 
!  23 character= Psi     Y                                                      
   23, 2111,   11,   50, 2112,   12,   50, 1402, 1503, 1405, 1006,  807, & 
  708,  610,   50, 1503, 1404, 1005,  806,  707,  610,  613,  716,  817, & 
 1018, 1419, 1520,   50,  613,  715,  816, 1017, 1418, 1520, 1421,   50, & 
 2108, 2115,   50,    8,   15, 5050, & 
!  24 character= Omega   W                                                      
   22,  303,    4,    8,  406,  804, 1103, 1503, 1804, 2006, 2109, 2113, & 
 2016, 1818, 1519, 1119,  818,  416,   14,   18,  319,   50,  406,  705, & 
 1104, 1504, 1805, 2007, 2109,   50, 2113, 2015, 1817, 1518, 1118,  717, & 
  416,   50,  104,  107,   50,  115,  118, 5050/) 


      if(J+1.gt.25)then 
        J=-J 
        goto 20 
      end if 
      J1 = ISTART(J+1) 
      J = ISTART(J) 
      I = 0 
   10 I = I + 1 
      JJ = J + I - 1 
      IF ( JJ.GE.J1 ) GO TO 20 
      KOORD(I) = K(JJ) 
      GO TO 10 
   20 RETURN 
      END                                           
