      subroutine get_theory(isubthe,info) 
      use glbconst, only: enwr,nwr
      use compar, only: maxthlv
      implicit none
      integer       isubthe,info,ntheo,kssthe,ksscp,kssm 
      common/msgtss/iss,kssthe(0:maxthlv),ksscp(0:2*maxthlv),           &
                     kssm(maxthlv)                                      
      character(len=80):: nath  
      logical b_do 
      integer i0,i1,i10,ic,icase,ig,iget,ip,iput,iss,k,isubthe_n,   &
         nth   !,i,j
!     i=kssthe(0)                                                      
!     write(6,'(a,2i4)')'---------------get_theory-isubthe,kssthe(0)=',isubthe,i      
!      write(6,'(a,11i4)')' kssthe(0..)=',(kssthe(j),j=0,i)            
!     write(6,'(a,11i4)')'  ksscp(1..)=',(ksscp(j),j=1,2*i)            
!     write(6,'(a,11i7)')'   kssm(1..)=',(kssm(j),j=1,i)               
!      write(6,'(a,i7)')'get_theory iss=',iss                          
!      write(6,'(a,i7)')'xxxxxxxxxxxxxxxget_theory isubthe=',isubthe                  
!      kss=iss 
      isubthe_n=isubthe+1 
      ntheo=kssthe(2*isubthe_n-1)
      k=2*isubthe_n-1 
      do while(ntheo.eq.0.and.k.lt.kssthe(0)) 
       k=k+2 
       ntheo=kssthe(k) 
      end do 
      isubthe_n=(k+1)/2 
                                                                        
      if(ntheo.eq.0) then 
       isubthe=0  ! 24.10.07 theory not implemented
!       write(nwr,'(a)')' theory not found/implemented kssthe(1..)='    
!       write(nwr,'(20i4)')(kssthe(i),i=1,kssthe(0))                    
       return 
!      else                                                             
!       write(6,'(a)')' theory found/implemented kssthe(1..)='        
!       write(6,'(20i4)')(kssthe(i),i=1,kssthe(0))                    
      end if 
      icase=kssthe(2*isubthe_n) 
      iput=kssm(isubthe_n) 
      iget=kssm(isubthe_n+1) 
                                                                        
      b_do=enwr(3)(1:1).eq.'y' 
      if(b_do) then 
       i10=ntheo/10 
       i1=ntheo-i10*10 
       i0=ichar('0') 
       write(nwr,'(a22,i1,a,i1,2(a,i7),a1)')                            &
     &  'call theory'//char(i10+i0)//char(i1+i0)//                      &
     &  '(counter=',isubthe_n,', case=',icase,                          &
     &  ', iput=',iput,', iget=',iget,')'                               
      end if 
      if(b_do)then 
       nth=ntheo 
       ic=icase 
       ip=iput 
       ig=iget 
      end if 
                                                                        
      call mapcp(isubthe_n,.true.)
      call distribth(isubthe_n,ntheo,icase,iput,iget,nath,info) 
      if(info.gt.0)return 
      if(isubthe.gt.0) call mapcp(isubthe,.false.) 
      if(b_do)then 
       i10=nth/10 
       i1=nth-i10*10 
       i0=ichar('0') 
       write(nwr,'(a,a)')                                               &
       'exit theory'//char(i10+i0)//char(i1+i0)//'=',nath(:64)         
      end if 
                                                                        
      isubthe=isubthe_n 
!     isubthe<0                           ! 24.10.07 theory not changed 
!     write(6,'(a,i7)')' return get_theory isubthe=',isubthe            
      return 
      END                                           
                                                                        
      function whichtheory(ks,name)
      use comdas, only: ktheo
      implicit none 
      integer, intent(in):: ks
      character(len=80),intent(in):: name
      character(len=132) :: name_theo,property
      logical whichtheory
      integer ln,nthar,nth,lth,klev
      ln=80
      ln=LEN_TRIM(name)
      nthar=abs(ktheo(ks,0,0)) 
      nth=ktheo(ks,0,1) 
      lth=ktheo(ks,0,2) 
      call getname(0,nth,lth,property,name_theo) 
      whichtheory=index(name_theo,name(1:ln)).gt.0
      if(whichtheory)return 
      if(nthar.gt.3) then 
       do klev=3,nthar,2 
        nth=ktheo(ks,0,klev) 
        lth=ktheo(ks,0,klev+1) 
        call getname(1,nth,lth,property,name_theo) 
        whichtheory=whichtheory.or.index(name_theo,name(1:ln)).gt.0 
       end do 
      end if 
      return
      end


      subroutine getname(nfrth,nth,lth,property,name_theory) 
      use comstr, only: ntheory,nameth
      implicit none

      integer   nfrth,nth,lth,kth,lstruct1,lstruct2
      character(len=132):: property,name_theory
      character(len=4)  :: cmch 

      kth=nth 
      cmch='name' 
      if(nfrth.eq.0) then 
       call getfrstring(kth,lth,lstruct1,lstruct2,                      &
                                             cmch,property)            
       name_theory=ntheory(lth) 
      else 
       call  getthstring(kth,lth,cmch,property) 
!       write(6,'(a)')(nameth(i)(:80),i=1,10)           
        name_theory=nameth(lth) 
      end if 
      return 
      END                                           
                                                                         
      subroutine getnamev(nfrth,nth,lth,property,name_theory) 
      use comstr, only: namepg,ntheory,nameth
      use comthe, only: theoryname
      implicit none
      integer   nfrth,nth,lth,kth,lstruct1,lstruct2,iframe,nframe,nj,   &
                n,info,l,lt,kt,i,icase,iget,iput,ipos,isubthe_n,ls,  &
                n1,ntheo
      character(len=132):: property,name_theory,ch132,cp132
      character(len=4)  :: cmch,cich
      character(len=80) :: nath
                                             
!      write(6,'(a,5i4)')' getnamev nth,lth=',nth,lth
      kth=nth 
      cmch='name' 

      if(nfrth.eq.0) then 
       call getfrstring(kth,lth,lstruct1,lstruct2,cmch,property)

       ch132=ADJUSTL(ntheory(1)) 
       ls=LEN_TRIM(ch132) 
!      write(6,'(a,a)')'nfrth.eq.0  ',ch132(:ls)                       
       iframe=0 
       nframe=0 
       nj=1 
       cich='thna' 
       do while(iframe.lt.nj.and.nframe.eq.0) 
        iframe=iframe+1 
        n=iframe 
        info=0 
        call distribthfr(n,cich,n1,info) 
        nj=n 
        l=index(theoryname,'v=') 
        if(l.gt.0)then 
         lt=l-2 
        else 
         lt=72 
        end if 
        do while(theoryname(lt:lt).eq.' ') 
         lt=lt-1 
        end do 
        if(theoryname(1:lt).eq.ch132(1:ls)) then 
         nframe=iframe 
        end if 
       end do 
       name_theory=theoryname 
      else 
       kt=kth 
       lt=lth
       namepg(lt)='nocall' 
       call  getthstring(kt ,lt,'name',property)
       if(index(namepg(lth),'nocall').gt.0) then    ! 23.02.2020
        name_theory=nameth(lth)
       else
        cp132=namepg(lth)
        call nextchar(cp132,0,ipos,ch132,ls)
        cp132=ADJUSTL(nameth(lth)) 

        isubthe_n=-16 
        ntheo=0 
        nj=1 
        i=0 
        do while(ntheo.lt.nj) 
          ntheo=ntheo+1 
          n=ntheo 
          call distribth(isubthe_n,n,icase,iput,iget,nath,info) 
          nj=n 
          l=index(theoryname,'v=') 
          if(l.gt.0)then 
           lt=l-2 
          else 
           lt=72 
          end if 
          do while(theoryname(lt:lt).eq.' ') 
           lt=lt-1 
          end do 
          if(theoryname(1:lt).eq.ch132(1:ls)) then 
           name_theory=TRIM(cp132)//theoryname(lt+1:) 
           nj=0 
          end if 
         end do 
       end if 
      end if
      return 
      END                                           
                                                                        
                                                                          
      subroutine getthnumber(nfrth,nth,lth,property,name_theory,info) 
      use glbconst, only: maxnth,infotext
      use comstr, only: nameth
      implicit none
      integer, intent(in):: nfrth
      character(len=132), intent(in):: property,name_theory
      integer, intent(out):: nth,lth,info

      integer  kth,le,lp,lq,lstruct1,lstruct2,mth 
                                                                        
      character(len=132):: chin
      character(len=4)  :: cmch
      character(len=8)  :: ch8 
                                                                        
      lq=LEN_TRIM(name_theory) 
      lp=LEN_TRIM(property) 

      cmch='name' 
      lstruct1=0; lstruct2=0
      chin=' ' 
      nth=0 
      kth=1 
      lth=1 
      le=lp 
      if(nfrth.eq.0) then 
       do while(property(:lp).ne.chin(:le).and.nth.lt.kth)  !8.2.06  
        nth=nth+1 
        kth=nth 
        call getfrstring(kth,lth,lstruct1,lstruct2,cmch,chin) 
        le=LEN_TRIM(chin) 
!        write(6,'(i4,2x,2i4,1x,2a,5x,a)')  &                            
!                 nth,kth,lth,'getthinf th: ',property(:lp),chin(:le)          
       end do 
       if(property(:lp).ne.chin(:le)) then 
        info=lth 
        infotext(1)='effi/getthnumber/structure/reading' 
        infotext(2)='error translating parameter file' 
        infotext(3)='frame theory name: "'//property(:lp)//             &
     &                        '" read from file .par not found'         
         call itoc8(ch8,kth) 
        infotext(4)='comparison with'//ch8(:3)//                        &
     &  ' names attached to the'//ch8(:3)//' frstr_xx subroutines'      
        infotext(5)=' ' 
        return 
       end if 
       mth=1 
       kth=nth 
       call getfrstring(kth,mth,lstruct1,lstruct2,cmch,chin) 
      else 
       do while(property(:lp).ne.chin(:le).and.nth.lt.kth)  !8.2.06 
        nth=nth+1 
        kth=nth 
        call getthstring(kth,lth,cmch,chin) 
        le=LEN_TRIM(chin) 
!        write(6,'(i4,2x,4i4,1x,2a,2a)') &                               
!        nth,kth,lth,lp,le,'#getthinf:',property(:lp),' chin:',chin(:le) 
       end do 
       if(property(:lp).ne.chin(:le)) then 
        info=lth 
        infotext(1)='effi/getthnumber/structure/reading' 
        infotext(2)='error translating parameter file' 
        infotext(3)='theory name: "'//                                  &
            property(:lp)//'" read from file .par not found'           
         call itoc8(ch8,kth) 
        infotext(4)='comparison with'//ch8(:3)//                        &
       ' names attached to the'//ch8(:3)//' thstr_xx subroutines'      
        infotext(5)=' ' 
        return 
       end if 
       lth=1 
       le=LEN_TRIM(nameth(lth)) 
!       write(6,'(2i4,1x,2a,5x,a)')  &                             
!        lth,kth,'getthinf th2: ',name_theory(:lq),nameth(lth)(:le)
       do while((lq.ne.le.or.name_theory(:lq).ne.nameth(lth)(:le))      &
                                                 .and.le.gt.0)         
        lth=lth+1 
        if(lth.le.maxnth) then 
         le=LEN_TRIM(nameth(lth)) 
        else 
         le=0 
        end if 
!       write(6,'(2i4,1x,2a,5x,a)')  &                             
!         lth,kth,'getthinf th2: ',name_theory(:lq),nameth(lth)(:le) 
        if(le.eq.0.or.le.gt.131) then 
         info=lth 
         infotext(1)='effi/getthnumber/structure/reading' 
         infotext(2)='error translating parameter file' 
         infotext(3)='theory name: "'//name_theory(:lq)//'" not found' 
         infotext(4)='within the group of theories with first member:' 
         infotext(5)=nameth(1) 
         infotext(6)=' ' 
         return 
        end if 
       end do 
      end if 
!       write(6,'(i3,1x,a,2(3x,i3,1x,a))')nfrth,'getthinf=', &           
!     &              nth,property(:lp),lth,name_theory(:lq)             
      return 
      END                                           
                                                                        
      subroutine addtr(ith,icase,nametr,iout,ibvtrf)  ! not used 
      use glbconst, only: maxtrf,maxprd
      use comfrm, only: ncor
      implicit none 
                                                                        
      integer ith,icase,iout,ibvtrf,inf_tr
      real    array_tr 
      common/comtr/array_tr(maxtrf),inf_tr(maxprd) 
                                                                        
      integer ip,in,ii,jj,j,i,k,irow,ib_array,ie_array,                 &
              jsum,ntr,iactive,iva,member                               
      character(len=16) :: nametr
      character(len=8)  :: ch8
                                                                        
                                                                        
                                                                        
!     which transformation matrix                                       
      ip=0 
                                 ! total number of matrices @v          
      in=inf_tr(1) 
!     inf_tr(2)                  !                                      
!     inf_tr(3)                  ! mvpt(kss)+1                          
!     inf_tr(4)                  !                                      
!      write(6,'(a,10i4)')' getthinf inf_tr=',(inf_tr(k),k=1,8)         
                                                                        
                               ! 4+3                                    
      ii=7 
      ntr=inf_tr(ii) 
      do while(ncor(ntr)(1:9).ne.nametr(1:9).and.ip.lt.in) 
       ip=ip+1 
       ii=ii+38 
       ntr=inf_tr(ii) 
      end do 
                                                                        
!      write(6,'(a,a,i4)')' getthinf ncor(ntr),ntr=',ncor(ntr),ntr      
      i=index(ncor(ntr),'@v') 
      ch8=ncor(ntr)(i+2:i+3) 
      call c8toi(ch8,iva) 
      inf_tr(ii-2)=ith        ! 1 theory number                          
      inf_tr(ii-1)=icase      ! 2 theory number, case                    
!     ntr=inf_tr(ii+3)                                                   
                              ! 3 number of the transformation matrix    
      irow=inf_tr(ii+1)       ! 4 rows of the transformation matrix      
!     mtr=inf_tr(ii+5)                                                   
                              ! 5 matrix on which parameters array_tr are
      ie_array=inf_tr(ii+3)   ! 6 pointer on array_tr                    
      ib_array=inf_tr(ii+4)   ! 7 pointer on array_tr                    
      ii=ii+5                 ! 8 10 12 ... pointer on vartrf to evaluate
                              ! 9 11 13 ... first: storage required for m
                              ! 9 11 13 ... second (if known): pointer on                                            
!-----------------member number--------------------                     
       jj=irow/iva*2 
       k=0 
       do while(inf_tr(3).ne.inf_tr(ii+k).and.k.lt.jj) 
        k=k+2 
       end do 
                                              ! 0..member/2             
       member=k 
                                              ! storage not yet known   
       if(ie_array.eq.0) inf_tr(ii+1+k)=iout 
                                                                        
!       write(6,'(a,20i3)')'getthinf (iout) inf_tr=',(inf_tr(k),k=1,20) 
                                                                        
!----------------- all transfer data calculated--------------           
!     all irow/iva sections of the reserved part on array_tr must be    
!     occupied (= different from 0)                                     
      iactive=1 
      do k=1,jj,2 
       if(inf_tr(ii+k).eq.0) iactive=0 
      end do 
                                                                        
      if(iactive.eq.1) then      ! storage  known       
 !-------------------pointer on array_tr --------------------------      
       if(ie_array.eq.0) then 
        do k=1,in 
         j=4+38*(k-1) 
         if(inf_tr(j+6).gt.ie_array) ie_array=inf_tr(j+6) 
        end do 
        inf_tr(ii-1)=ie_array        ! new begin pointer                  
        jsum=0                                                            
        do k=1,jj,2                  ! pointers are calculated            
         jsum=jsum+inf_tr(ii+k)                                           
         inf_tr(ii+k)=ie_array+jsum                                       
        end do                                                            
        inf_tr(ii-2)=ie_array+jsum   ! new last pointer                   
       end if                                                             
       ibvtrf=inf_tr(ii-1+member)    ! pointer inside parameter block (beg
      else 
       ibvtrf=-1 
      end if 
      if(inf_tr(ii-2).eq.0) ibvtrf=-1 
!      write(6,'(a,20i3)')' getthinf inf_tr=',ii,(inf_tr(k),k=1,20)     
      return 
      END                                           
                                                                        
      subroutine infstrth(ico,property,nametheory,itrdata) 
      use glbconst, only: maxtrf,maxprd,maxnth
      use compar, only: maxtheo
      use comstr, only: ntheory,nameth
      implicit none
      integer   ico,itrdata,inf_tr
      character(len=132):: property,nametheory
      character(len=4),dimension(1:maxnth)  :: chfrinf
      character(len=8),dimension(1:maxtheo*maxnth):: chthinf
 
      real         array_tr
      common/comtr/array_tr(maxtrf),inf_tr(maxprd) 
      character(len=4):: cmch
      character(len=2):: ch2
      character(len=1):: ch1 
      integer   i0,j,nfr,kfr,l_k,i,i1,i10,jk,ii,ik,in,ip,icase,k,kth,    &
                ithstr,jth,l1,l2,member,nth                                                                        
      i0=ichar('0') 
                                                                        
      j=1 
      nfr=0 
      kfr=1 
      do while(nfr.lt.kfr) 
       l_k=0 
       nfr=nfr+1 
       kfr=nfr 
       call getfrstring(kfr,l_k,l1,l2,cmch,property) 
       do i=1,l_k 
        i10=nfr/10 
        i1=nfr-10*i10+i0 
        ch1=ntheory(l_k+1) 
        chfrinf(j)=char(i10+i0)//char(i1)//char(i+i0)//ch1 
        j=j+1 
       end do 
      end do 
!      write(6,'(a10)') (chfrinf(k),k=1,j)                              
                                                                        
      j=0 
      cmch='name' 
      nth=0 
      kth=1 
      do while(nth.lt.kth) 
       nth=nth+1 
       property='x' 
       i10=nth/10 
       i1=nth-10*i10+i0 
       l_k=1 
       jk=0 
       do while(l_k.lt.maxnth.and.property.ne.' ') 
        property=' ' 
        kth=nth 
        call getthstring(kth,l_k,cmch,property) 
!        write(6,'(2a)')'property=',property(:60)                       
        i=index(property,'th=') 
        if(i.gt.0) then 
         ik=index(property(i:),',') 
         if(ik.eq.5) then 
          ch2='0'//property(i+3:i+3) 
          ch1=property(i+5:i+5) 
         else 
          ch2=property(i+3:i+4) 
          ch1=property(i+6:i+6) 
         end if 
         j=j+1 
         jk=jk+1 
         chthinf(j)=char(i10+i0)//char(i1)//char(l_k+i0)//ch2//ch1 
        end if 
!        write(6,'(1x,4i4,2x,a)') i,j,jk,l_k,nameth(l_k)(:60)           
        l_k=l_k+1 
       end do 
!       write(6,'(a1,4i4,2x,a)')'#', i,j,jk,l_k,nameth(l_k-1)(:60)      
       ch1=nameth(l_k-1) 
       if(ch1.eq.'@') then 
        do i=j-jk+1,j 
         chthinf(i)(7:8)=ch1//' ' 
        end do 
       end if 
      end do 
!      write(6,'(a10)') (chfrinf(k),k=1,j)                              
      jth=j 
                                                                        
                            ! total number of matrices @v               
      in=inf_tr(1) 
!    inf_tr(ii-2)=ith       ! 1 theory number                           
!    inf_tr(ii-1)=icase     ! 2 theory number, case                     
!    ntr=inf_tr(ii+3)       ! 3 number of the transformation matrix     
!    irow=inf_tr(ii+1)      ! 4 rows of the transformation matrix       
!    mtr=inf_tr(ii+5)       ! 5 matrix on which parameters array_tr are 
!    ie_array=inf_tr(ii+2)  ! 6 pointer on array_tr                     
!    ib_array=inf_tr(ii+3)  ! 7 pointer on array_tr                     
!    ii=ii+5                ! 8 10 12 ... pointer on vartrf to evaluate 
                            ! 9 11 13 ... first: storage required for me
                            !             1 2 3 ...                     
                            ! 9 11 13 ... second (if known): pointer on 
                                                                        
!     1  0 66  0 11  1  5  4  0  4  0 17  2 66  4  0  0  0  0  0        
!              4     6     8    10    12    14                          
!      write(6,'(a,10i4)')' inf_tr=', (inf_tr(i),i=1,10)                
      ip=0 
                             ! 4+3                                      
      ii=7 
      do while(inf_tr(ii).ne.ico.and.ip.lt.in) 
       ip=ip+1 
       ii=ii+38*(ip-1) 
      end do 
      ico=ii+2 
      ii=ii+5 
      member=0 
      do while(inf_tr(ii+member).ne.0) 
       member=member+2 
      end do 
      member=member-2 
      itrdata=inf_tr(ii-2)-inf_tr(ii-1) 
!      write(6,'(a)')'getthinf member,inf_tr='                          
!      write(6,'(a,10i4)')'member,ii,inf_tr(ii-2),inf_tr(ii-1)',        
!     &                    member,ii,inf_tr(ii-2),inf_tr(ii-1)          
!      write(6,'(20i3)')(inf_tr(k),k=1,20)                              
      ithstr=inf_tr(ii-7)  ! 1 theory number   
      icase=inf_tr(ii-6)    ! 2 theory number, case  
!      write(6,'(a,2i4)')' getthinf ithstr,icase=',ithstr,icase         
                                                                        
      if(ithstr.lt.0) then 
       ithstr=abs(ithstr) 
       j=1 
       ch2=chfrinf(j) 
       do while(ch2.ne.' ') 
        k=10*(ichar(ch2(1:1))-i0)+ichar(ch2(2:2))-i0 
        ch1=chfrinf(j)(3:3) 
        l_k=ichar(ch1)-i0 
        if(k.eq.ithstr.and.l_k.eq.icase) goto 210 
        j=j+1 
        ch2=chfrinf(j) 
       end do 
  210  continue 
                                                                        
       call getfrstring(ithstr,l_k,l1,l2,'name',property) 
       nametheory=ntheory(l_k) 
                                                                        
      else 
                                                                        
       do j=1,jth 
        if(chthinf(j)(7:7).eq.'@') then 
         ch2=chthinf(j)(4:5) 
         k=10*(ichar(ch2(1:1))-i0)+ichar(ch2(2:2))-i0 
!         write(6,'(a,i2,2a)')' getthinf chthinf(',j,')=',chthinf(j)    
         ch1=chthinf(j)(6:6) 
         l_k=ichar(ch1)-i0 
         if(k.eq.ithstr.and.l_k.eq.icase) then 
          ch2=chthinf(j)(1:2) 
          ithstr=10*(ichar(ch2(1:1))-i0)+ichar(ch2(2:2))-i0 
          ch1=chthinf(j)(3:3) 
          l_k=ichar(ch1)-i0 
          goto 220 
         end if 
        end if 
       end do 
  220  continue 
       kth=ithstr 
       call getthstring(kth,l_k,'name',property) 
       nametheory=ntheory(l_k) 
      end if 
                                                                        
!      write(6,'(2a,/a)')' getthinf property,nametheory=',              
!     &            property(:60),nametheory(:80)                        
      return 
      END                                           
                                                                        
                                                                        
     subroutine frametheory(ks,cmch,n1,info) 
     use glbconst, only: maxfr1,maxfr2,maxsub,maxthlv,maxnth,maxthss,   &
                         marray_sp,infotext,icstrf,enwr,nwr,b_re
     use comthe, only: iarray_sp,ifrcase,ifrsto,nstorFR,theoryname,     &
                       thfrcase,maxthfrcase,vartrf,ovartrf
     use comths, only: nstorSP
     use comdat, only: ichan,ichanks,nuofdata,nuofdatas,b_data,b_datset,&
                       b_theory,b_theoset,file_data,name_data,b_procstore,&
                       cdatas,vdatas,n_cdatas,n_vdatas,nchandata,        &
                       nchannelsp,name_theory,ks_set
     use comdas, only: datfilesp,namedata,nametheory,ktheo,              &
                       icdata,i_cdata,n_cdata,ncdata,cdata,              &
                       vdata,ivdata,i_vdata,n_vdata,nvdata,bprocstore_rd
     use comeff, only: displaymode,ndispmode,n_subspect,icolorsub,       &
                       pointerstr,pointerks,mcadds,mvadds,               &
                       contrf,ocontrf,chiss,nu_sdevice
     use complt, only: ndisplay_mode,display_mode,icolor_sub,n_subset
     use comstr, only: nameth,ntheory,nu_device
     implicit none 
     integer,          intent(in):: ks,n1
     character(len=4), intent(inout):: cmch
     integer,          intent(out)::info 

     integer idum,iss 
     common/msgtss/iss,idum(2+4*maxthlv) 
                                                                       
     integer     mstruct1,istruct1,istruct2,                           &
                 l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,iadd
     character(len=64) :: frthname
     character(len=4)  :: c1_prp,c2_prp,c3_prp,chLOC
     common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     &
                   l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),    &
                   l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),    &
                   c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),    &
                   frthname(2),iadd(8)              
     integer,parameter:: numstruct=46+4*(maxfr1+maxfr2)+3*maxthss 
     common/strLOC/chLOC(32)  
     integer  ifr_sc,mvpt,mcpt,jvp,ityp,mipt1,mipt2,mipt3,             &
              ksthe,kscp,ksm,iks,numis                         
     integer,parameter:: numsmpt=12+15*maxthss+maxfr2+maxfr1 
     common/smpt/ifr_sc,mvpt(0:maxthss),mcpt(0:maxthss),               &
               jvp(0:maxthss),ityp(0:maxthss),                         &
               mipt1(0:maxfr1),mipt2(0:maxfr2),mipt3(0:maxthss),       &
               ksthe(maxthss*3),kscp(maxthss*3),ksm(0:maxthss*2),      &
               iks(-1:maxthss),numis(0:maxthss)                           

     character(len=8)  :: ch8
     character(len=14) :: ch14
     character(len=4)  :: cich
     character(len=42) :: chg42,chp42,chgp42
     character(len=10) :: ch10
     character(len=132):: property
     character(len=80) :: name
     character(len=60),dimension(1:maxnth) :: names                   
     integer,dimension(1:maxnth) :: inam
                                                                       
     character(len=12),dimension(0:maxthss) :: c_prop
     character(len=24) :: ch24
     character(len=4),dimension(1:2*maxthss):: ksch
     integer,dimension(0:maxthss)     :: i_adds,i_addss,num1,num2,num3
     integer,dimension(0:maxthss,0:8) :: irequ
     logical   b_const,enwr3,enwr4,b_ft 
     integer   lstruct1,lstruct2,lstruct3,                             &
               iframestr,ifrsubcase,isubthe,idistr,ithsto,             &
               iframe,i,icase,iget,iput,ipoi,ipointer,ith,i0,          &
               j,jth,jth1,jks,jc,jp,jm,jthsum,k,                       &
               l,ls,lst1,lst2,lst3,lt,ltt,l_jth,l_nfrtheo,mss,         &
               n,nj,nframe,ntheo                                  
     real cmapsub 
     common/acmaps/cmapsub(icstrf) 
!     cmch,n1 are preserved                                             
      iadd=0                 ! 17.08.2013
      if(ktheo(ks,0,0).le.0)return 
      ks_set=ks
      iframestr =ktheo(ks,0,1) 
      nchannelsp=nchandata(ks)
      cich='name' 
      l_nfrtheo=1
      call getfrstring(iframestr,l_nfrtheo,lstruct1,lstruct2,cich,property)  
                                                                        
       frthname(1)=property 
       property=ADJUSTL(ntheory(1)) 
       ls=LEN_TRIM(property) 
!       write(6,'(2a)')' getthinf:',frthname(1)(1:60)                   
!       write(6,'(2a)')' getthinf:',property(:ls)                       
       
       iframe=0 
       nframe=0 
       nj=1 
       cich='thna' 
       do while(iframe.lt.nj.and.nframe.eq.0) 
        iframe=iframe+1 
        n=iframe 
        call distribthfr(n,cich,iss,info) 
        if(info.gt.0) return 
        nj=n 
        l=index(theoryname,'v=') 
        if(l.gt.0)then 
         lt=l-2 
        else 
         lt=72 
        end if 
        do while(theoryname(lt:lt).eq.' ') 
         lt=lt-1 
        end do 
!        write(6,'(i4,2a)')iframe,' getthinf:',theoryname               
        if(theoryname(1:lt).eq.property(1:ls)) then 
         nframe=iframe 
        end if 
       end do 
       iframe=nframe
       if(iframe.eq.0) then 
        info=1 
        call itoc8(ch8,iframestr) 
        infotext(1)='effi/structure/frameth/notfound' 
        infotext(2)='*** error in set up of theory names' 
        infotext(3)='frame theory'//ch8(:3)//':'//property(:ls) 
        infotext(4)='does not match the theoryname in any fr_***.f' 
        infotext(5)=' ' 
        return 
       end if 
                                                                        
       ifrcase=0 
       l_jth=16 
       do k=1,maxnth 
        inam(k)=0 
       end do 
       k=0 
       ls=0
       do i=3,ktheo(ks,0,0),2 
        jth=ktheo(ks,0,i) 
        jth1=ktheo(ks,0,i+1) 
        cich='name' 
        call getthstring(jth,l_jth,cich,property) 
        name=nameth(jth1) 
!       write(6,'(i2,a,i1,2a)')ktheo(ks,0,i),' nameth(',jth1,')=',nameth(jth1)
        lt=72 
        do while(name(lt:lt).eq.' ') 
         lt=lt-1 
        end do 
        k=k+1 
        names(k)=name 
        inam(k)=lt 
        j=1 
        do while(j.le.maxthfrcase) 
         if(thfrcase(j).ne.' ')then 
!          write(6,'(a)')thfrcase(j)                                    
          l=index(thfrcase(j),'v=') 
          if(l.gt.0) then 
           ltt=l-2 
          else 
           ltt=72 
          end if 
          do while(thfrcase(j)(ltt:ltt).eq.' ') 
           ltt=ltt-1 
          end do 
          l=index(thfrcase(j)(ltt:ltt),')') 
          if(thfrcase(j)(ltt:ltt).eq.')') then 
           ltt=ltt-1 
           do while(thfrcase(j)(ltt:ltt).ne.'(') 
            ltt=ltt-1 
           end do 
          end if 
                                                                        
          if(name(:lt).eq.thfrcase(j)(:ltt-1))then 
           l=index(thfrcase(j)(ltt:),')') 
           ch8=thfrcase(j)(ltt+1:ltt+l-2) 
           ls=ls+1 
           frthname(2)=name(:lt) 
!           write(6,'(a,a)')'ch8=',ch8                                  
           call c8toi(ch8,ifrcase) 
           if(ifrcase.le.0) ifrcase=-1 
!          write(6,'(a,i4)')'ifrcase=',ifrcase                          
           j=maxthfrcase 
          end if 
         end if 
         j=j+1 
        end do 
       end do 
                                                                        
       if(ifrcase.eq.0) then 
        info=1 
        infotext(1)='effi/structure/frameth/notfound' 
        infotext(2)='*** error in set up of theory names' 
        infotext(3)='none of the theory names ('//names(1)(:inam(1)) 
        if(inam(2).gt.0) then 
         infotext(4)=', '//names(2)(:inam(2))//', '//names(3)(:inam(3))//', ...'
         infotext(5)='match any of the thfrcase(i) in fr_*()' 
         infotext(6)=' ' 
        else 
         infotext(4)='match any of the thfrcase(i) in fr_*()' 
         infotext(5)=' ' 
        end if 
        return 
       else if(ifrcase.eq.-1) then 
        info=2 
        infotext(1)='effi/structure/frameth/notfound' 
        infotext(2)='*** error in set up of theory names' 
        infotext(3)='missing number at the end of thfrcase(i) in fr_*()' 
        infotext(4)='written in brackets: name theory(nn)' 
        infotext(5)=' ' 
        return 
       else if(ls.gt.1) then 
        info=3 
        infotext(1)='effi/structure/frameth/notfound' 
        infotext(2)='*** error in set up of theory names' 
        infotext(3)='more than one match between theory names ('//names(1)(:inam(1))
        if(inam(2).gt.0) then 
         infotext(4)= ', '//names(2)(:inam(2))//', '//names(3)(:inam(3))//', ...'
         infotext(5)='and the names of thfrcase(i) in fr_*()' 
         infotext(6)=' ' 
        else 
         infotext(4)='and the names of thfrcase(i) in fr_*()' 
         infotext(5)=' ' 
        end if 
        return 
       end if 
!            i_cdata(maxs,0:maxcvsp),i_vdata(maxs,0:maxcvsp),           
       icdata(0)=i_cdata(ks,0) 
       do k=1,icdata(0) 
        icdata(k)=mcadds(ks,0)+i_cdata(ks,k) 
        ncdata(k)=n_cdata(ks,k) 
        ch24=ncdata(k) 
        i=index(ch24,'_')+1 
        do while(ch24(i:i).eq.'_') 
         i=i+1 
        end do 
        n_cdatas(k)=ch24(i:) 
        n_cdatas(k)(19:)=n_cdata(ks,k)(33:) 
        cdatas(k)=cdata(ks,k) 
       end do 
       n_cdatas(k)=' ' 
       ivdata(0)=i_vdata(ks,0) 
       do k=1,ivdata(0) 
        ivdata(k)=mvadds(ks,0)+i_vdata(ks,k) 
        nvdata(k)=n_vdata(ks,k) 
        ch24=nvdata(k) 
        i=index(ch24,'_')+1 
        do while(ch24(i:i).eq.'_') 
         i=i+1 
        end do 
        n_vdatas(k)=ch24(i:) 
        n_vdatas(k)(19:)=n_vdata(ks,k)(33:) 
        vdatas(k)=vdata(ks,k) 
       end do 
       n_vdatas(k)=' ' 
!       write(6,'(a,10i4)')'getthinf ktheo(ks,0,0..)=',&                 
!      (ktheo(ks,0,i),i=0,ktheo(ks,0,0))                               
                                                                        
      call zerotrfarr       ! call zerotrf

 
      nuofdatas=nuofdata(ks) 
      do k=0,ichan(0,ks)
       ichanks(k)=ichan(k,ks) 
      end do 

      do k=0,maxthss 
       mvpt(k)=mvadds(ks,k) 
       mcpt(k)=mcadds(ks,k) 
       i_adds(k)=0 
       i_addss(k)=0 
      end do 
                                                                        
      do k=1,maxfr1 
       nu_device(k)=nu_sdevice(ks,k) 
      end do 
!      write(6,'(i3,a,16i4)')ks,' nu_device()=',(nu_device(k),k=1,maxfr1)
                                                                        
      if(cmch.eq.'dstr') then 
!      inserted 16.02.08 for reading the data sructure (scale from      
!      the dataheader/ otherwise 1)                                     
       call mapfr0 
       call distribthfr(iframe,cmch,iss,info) 
       return 
      end if 
                                                                        
      b_const=.false.
       
       call  mapspfr(ks) 

       mss=pointerks(ks)-pointerks(ks-1)-1 
       do k=1,i_cdata(ks,0) 
        b_const=(contrf(mcadds(ks,0)+i_cdata(ks,k)).ne.                 &
               ocontrf(mcadds(ks,0)+i_cdata(ks,k)))                    
        if(b_const) goto 10 
       end do 
       do k=1,i_vdata(ks,0) 
        b_const=(vartrf(mvadds(ks,0)+i_vdata(ks,k)).ne.                 &
               ovartrf(mvadds(ks,0)+i_vdata(ks,k)))                    
        if(b_const) goto 10 
       end do 
!       do k=0,mss                                                      
!         write(6,'(a,2i4)')'mcpt(k)+1,mcpt(k+1)=',mcpt(k)+1,mcpt(k+1)  
!       end do                                                          
       do k=mcpt(0)+1,mcpt(mss+1) 
        b_const=(contrf(k).ne.ocontrf(k)) 
!         write(6,'(a,i3,2x,2f10.3)')'contrf(k).ne.ocontrf(k)=',   &       
!                              k,contrf(k),ocontrf(k)                  
        if(b_const) goto 10 
       end do 
!      end if                                                           
                                                                        
   10 continue 
!     only filename for current directory                               
                        ! >=24 for file_data                            
      j=108 
      k=0 
      do while(k.eq.0.and.j.gt.0) 
       if(datfilesp(ks)(j:j).eq.'/') k=j 
       j=j-1 
      end do 
      file_data=datfilesp(ks)(k+1:) 
      name_data= namedata(ks) 

      name_theory=nametheory(ks) 
      b_theory=b_theoset(ks) 
      b_data  =b_datset(ks)
      do k=1,16 
       display_mode(k)=displaymode(ks,k) 
      end do 
      ndisplay_mode=ndispmode(ks) 
      n_subset=n_subspect(ks) 
                                                                        
!      write(6,'(a)')'   getthinf nintstore(ks,1)'                      
      call nintstore(ks,1) 
      do k=1,maxsub 
       icolor_sub(k)=icolorsub(k,ks) 
      end do 

       i0=ichar('0') 
       ipointer=pointerks(ks-1) 
       do iss=0,mss 
        ipoi=ipointer+iss+1 
        ch14=pointerstr(ipoi)(1:14) 
        lstruct1=10*(ichar(ch14(1:1))-i0)+ichar(ch14(2:2))-i0 
        lstruct2=10*(ichar(ch14(3:3))-i0)+ichar(ch14(4:4))-i0 
        lstruct3=10*(ichar(ch14(5:5))-i0)+ichar(ch14(6:6))-i0 
        chiss(iss)=                                                     &
        char(lstruct1+i0)//char(lstruct2+i0)//char(lstruct3+i0)         
       end do 
      if(b_procstore.or.b_re)b_const=.true.

!     write(6,*)'(b_const.or.(.not.b_theoset(ks)=',ks,b_const,b_theoset(ks)
!############------------------------------------------###########      
      if(b_const.or.(.not.b_theoset(ks))) then 
       call contrue 
       b_re=.false.
       do i=1,2 
        k=64 
        do while(frthname(i)(k:k).eq.' ') 
         k=k-1 
        end do 
        do j=1,k 
         if(frthname(i)(j:j).eq.' ')frthname(i)(j:j)='_' 
        end do 
       end do 
                                                                        
!       write(6,'(a,i2,a2,2L5)')'getthinf b_const,b_theoset(',ks,')=',  
!     &                                  b_const,b_theoset(ks)          
       do k=1,i_cdata(ks,0) 
        ocontrf(mcadds(ks,0)+i_cdata(ks,k))=                            &
     &          contrf(mcadds(ks,0)+i_cdata(ks,k))                      
       end do 
       do k=1,i_vdata(ks,0) 
        ovartrf(mvadds(ks,0)+i_vdata(ks,k))=                            &
     &          vartrf(mvadds(ks,0)+i_vdata(ks,k))                      
       end do 
                                                                        
       do i=0,maxthss 
        ityp(i)=0 
       end do 
       iput=0 
       iget=0 
       mstruct1=0 
       lst1=0 
       lst2=0 
       lst3=0 
       ipointer=pointerks(ks-1) 
       iks(-1)=0 
                                                                        
       do iss=0,mss 
        ipoi=ipointer+iss+1 
        ch14=pointerstr(ipoi)(1:14) 
!        write(6,'(2a)')' getthinf: ',ch14                              
        lstruct1=10*(ichar(ch14(1:1))-i0)+ichar(ch14(2:2))-i0 
        lstruct2=10*(ichar(ch14(3:3))-i0)+ichar(ch14(4:4))-i0 
        lstruct3=10*(ichar(ch14(5:5))-i0)+ichar(ch14(6:6))-i0 
        if(lstruct1.gt.lst1) lst1=lstruct1 
        if(lstruct1.gt.mstruct1) mstruct1=lstruct1 
        if(lstruct2.ge.lst2) lst2=lstruct2 
        istruct1(lstruct1)=lst2 
        if(lstruct3.ge.lst3) lst3=lstruct3 
        if(lstruct2.gt.0) istruct2(lstruct2)=lst3 
!        write(6,'(a,a14,a,3i4)')'frametheory ch14=',ch14,  &            
!            'lstruct1,lstruct2,lstruct3=',lstruct1,lstruct2,lstruct3  
                                                                        
        jvp(iss)=10*(ichar(ch14(7:7))-i0)+ichar(ch14(8:8))-i0 
        ityp(iss)=ichar(ch14(10:10))-i0 
                                                                        
        ith=10*(ichar(ch14(11:11))-i0)                                  &
               +ichar(ch14(12:12))-i0                                   
                                                                        
        jks=iks(iss-1) 
        iks(iss)=iks(iss-1)+ith 
        jc=0 
        jp=0 
        do k=1,ith/2 
         i=12+(k-1)*14 
         ch14=pointerstr(ipoi)(i+1:i+14) 
!         write(6,'(2a)')' getthinf: ',ch14                             
         ksch(jks+k)=ch14(1:4) 
         ntheo=10*(ichar(ch14(5:5))-i0)+ichar(ch14(6:6))-i0 
         ksthe(jks+2*k-1)=ntheo 
         icase=10*(ichar(ch14(7:7))-i0)+ichar(ch14(8:8))-i0 
         ksthe(jks+2*k)=icase 
         if(ch14(1:4).eq.'fram'.and.iss.lt.0) then 
          kscp(jks+2*k-1)=0 
          kscp(jks+2*k)=0 
         else 
          jc=jc+10*(ichar(ch14(9:9))-i0)+ichar(ch14(10:10))-i0 
          kscp(jks+2*k-1)=jc 
          jp=jp+10*(ichar(ch14(11:11))-i0)+ichar(ch14(12:12))-i0 
          kscp(jks+2*k)=jp 
!         write(6,'(i3,a,2i4)')iss,'=iss  getthinf jc,jp=',jc,jp        
         end if 
        end do 
        if(ksch(jks+1).eq.'fram') then 
         i=ith/2-1 
        else 
         i=ith/2 
        end if 
        c_prop(iss)=ksch(jks+1)//                                       &
                   pointerstr(ipoi)(1:6)//' '//char(i+i0)              
!        write(6,'(a,i4)')'5ktheo(1:2,0,0:3) ks=',ks                    
        if(lstruct2+lstruct3.eq.0)then 
         c1_prp(lstruct1)= c_prop(iss) 
        else if(lstruct3.eq.0) then 
         c2_prp(lstruct2)= c_prop(iss) 
        else 
         c3_prp(lstruct3)= c_prop(iss) 
        end if 
       end do 

!       write(6,'(a)') 'getthinf content of pointerstr(0-mss)'          
!        write(6,'(a,10i4)')'jvp   =',(jvp(i),i=0,mss)                  
!        write(6,'(a,10i4)')'708ityp  =',(ityp(i),i=0,mss)              
!       write(6,'(a,10i4)')'iks  =',(iks(i),i=-1,mss)                   
!       do iss=0,mss                                                    
!        jks=iks(iss-1)                                                 
!        ith=iks(iss)-iks(iss-1)                                        
!        write(6,'(a,10i4)')'ksthe=',(ksthe(jks+i),i=1,ith)             
!        write(6,'(a,10i4)')'kscp =',(kscp(jks+i),i=1,ith)              
!       end do                                                          
                                                                        
       num1(0)=0 
       num2(0)=0 
       numis(0)=0 
!       c_prop(0)=ksch(1)                                               
       iss=1 
       do lstruct1=1,mstruct1 
        num1(iss)=lstruct1 
        num2(iss)=0 
        numis(iss)=0 
        mipt1(lstruct1)=mvpt(jvp(iss))+1 
!        c_prop(iss)=ksch(iks(iss-1)+1)                                 
        iss=iss+1 
        do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1) 
        num1(iss)=0 
        num2(iss)=lstruct2 
        numis(iss)=0 
         mipt2(lstruct2)=mvpt(jvp(iss))+1 
!         c_prop(iss)=ksch(iks(iss-1)+1)                                
         iss=iss+1 
         do lstruct3=istruct2(lstruct2-1)+1,istruct2(lstruct2) 
          num1(iss)=0 
          num2(iss)=0 
          numis(iss)=lstruct3 
          mipt3(lstruct3)=mvpt(jvp(iss))+1 
!          c_prop(iss)=ksch(iks(iss-1)+1)                               
          iss=iss+1 
         end do 
        end do 
       end do 
       do k=0,mss 
        num3(k)=numis(k) 
       end do 
       mipt1(0)=mstruct1 
       mipt2(0)=istruct1(mstruct1) 
       mipt3(0)=istruct2(istruct1(mstruct1)) 
!       write(6,'(a,10i4)')'frametheory iss,mss=',iss,mss               
!       write(6,'(a,12i6)')'mipt1=',(mipt1(i),i=1,mipt1(0))             
!       write(6,'(a,12i6)')'mipt2=',(mipt2(i),i=1,mipt2(0))             
!       write(6,'(a,12i6)')'mipt3=',(mipt3(i),i=1,mipt3(0))             
!       write(6,'(a,12i8)')'numstruct+numsmpt=',numstruct,numsmpt
       
       jm=(numstruct+32+numsmpt)/2  ! jm=2206 on arry_fr reserved
       info=0 
       ksm(1)=jm 
       nstorFR=jm 
!----------------                                                       
       enwr3=enwr(3)(3:3).eq.'y' 
       enwr4=enwr(7)(4:4).eq.'y' 
       if(enwr3) then 
        write(nwr,'(a)')'           propl1l2l3th' 
        do k=0,mss 
        write(nwr,'(a,i2,a2,a12)')'c_prop(',k,')=',c_prop(k) 
        end do 
       end if 
       ifrsubcase=0 

       do iss=0,mss 
        ipoi=ipointer+iss+1 
        ch14=pointerstr(ipoi)(1:14) 
!        write(6,'(a,2(i3,2x),/,a)')' getthinf iss,ipoi,pointstr=',     
!     &   iss,ipoi,pointerstr(ipoi)(:80)                                
        lstruct1=10*(ichar(ch14(1:1))-i0)+ichar(ch14(2:2))-i0 
        lstruct2=10*(ichar(ch14(3:3))-i0)+ichar(ch14(4:4))-i0 
        lstruct3=10*(ichar(ch14(5:5))-i0)+ichar(ch14(6:6))-i0 
        ith =10*(ichar(ch14(11:11))-i0)+ichar(ch14(12:12))-i0 
                                                                        
!        if(iss.eq.0) then                                              
!         do k=4,ith,2                                                  
!          i=12+(k-2)*7                                       5.5.05    
!          ch14=pointerstr(ipoi)(i+1:i+14)                              
!          if(ch14(5:6).eq.'00')ifrsubcase=ktheo(ks,0,k)                
!         end do                                                        
!        end if                                                         

        jks=iks(iss-1) 
!        call mapfr(0)                                                  
!        write(6,'(a,i2,a1)')'getthinf call mapfr(',iss,')'             
        call mapfr(iss) 
        call mapini(iss) 
                                                                        
        cich='arri' 
        if(iss.eq.0)cich='arr0' 
        call distribthfr(iframe,cich,iss,info) 
        if(info.gt.0) return
        
        iframe=nframe 
        i_adds(iss)=jm 
                                                                        
        jm=jm+ifrsto 
        if(iss.eq.0) l1_get(0)=jm 
        if(enwr4) write(nwr,'(a,a4,a,2i3,6i12)')'frametheory (',cich,     &
        ') iss,ith,i_adds(iss),ifrsto,sum=',iss,ith,i_adds(iss),ifrsto,jm
        isubthe=1 
        isubthe=0 
!        if(ityp(iss).eq.3)isubthe=0                                    
!        if(iss.gt.0) call mapfr(iss-1)                                 
!        if(iss.gt.0) call mapini(iss-1)                                
        jthsum=0 
        irequ(iss,1)=0 
        do k=1,ith/2 
         ksm(jks/2+k+1)=jm 
                                                                        
         isubthe=isubthe+1 
         i=12+(k-1)*14 
         ch14=pointerstr(ipoi)(i+1:i+14) 
         ntheo=ksthe(jks+2*k-1) 
         icase=ksthe(jks+2*k) 
         jc=kscp(jks+2*k-1) 
                                                                        
         if(ch14(5:6).ne.'00') then 
          call mapcp(isubthe,.true.) 
          if(lstruct1.eq.0)then 
           idistr=-1 
          else 
           idistr=-nu_device(lstruct1) 
          end if 
!         the possibility to adjust the required storage to the lstruct1
!         level (i.e. Mossbauer source,absorber,detector : -1,-2,-3     
          call distribth(idistr,ntheo,icase,iput,iget,name,info) 
          if(info.gt.0)return 
          ithsto=cmapsub(1) 
          irequ(iss,k)=ithsto 
          jm=jm+ithsto 
          jthsum=jthsum+ithsto 
          if(enwr4)write(nwr,'(3(a,i2),a,15x,6i12)')                   &
         '    theory',ksthe(jks+2*k-1),                                &
         ' case=',icase,' constants=',jc,'      ithsto,sum=',ithsto,jm 
         end if 
        end do
        irequ(iss,0)=ifrsto 
        if(iss.eq.0)then 
         l1_put(0)=l1_get(0)-ifrsto 
        end if 
!        jm=jm+ifrsto                                                   
        if(num1(iss).gt.0)then 
          l1_get(num1(iss))=ksm((iks(iss-1)+4)/2) 
          l1_put(num1(iss))=l1_get(num1(iss))-ifrsto 
        end if 
        if(num2(iss).gt.0)then 
          l2_get(num2(iss))=ksm((iks(iss-1)+4)/2) 
          l2_put(num2(iss))=l2_get(num2(iss))-ifrsto 
        end if 
        if(numis(iss).gt.0)then 
         i_addss(numis(iss))=ksm((iks(iss-1)+4)/2) 
         l3_get(num3(iss))=i_addss(numis(iss)) 
!         l3_put(num3(iss))=l3_get(num3(iss))+jthsum                    
         l3_put(num3(iss))=l3_get(num3(iss))-ifrsto 
        end if 
       end do  !  do iss=0,mss 
!       ifr_sc=ifrsubcase                                    5.5.05     

       cich='arre' 
       call distribthfr(iframe,cich,iss,info) 

       if(info.gt.0) return 
       iframe=nframe 
!       i_adds(iss)=jm                                                  
       l1_put(mstruct1+1)=jm 
       l1_get(mstruct1+1)=jm 
       jm=jm+ifrsto 
       irequ(iss,0)=ifrsto 
       i_adds(iss)=jm 
       nstorSP=jm 
       if(nstorSP.gt.marray_sp) then 
        info=marray_sp 
        call itoc8(ch8,nstorSP) 
        infotext(1)='effi/array_fr/size' 
        infotext(2)='*** error arrays of the theory larger than' 
        infotext(3)='required size of the theory'//ch8 
        return 
       end if 
       if(enwr4)write(nwr,'(a,a4,a,i3,6x,4i6)')'frametheory (',cich,    &
     &  ')     iss,i_adds(iss),ifrsto,sum=',                            &
     &  iss,i_adds(iss),ifrsto,jm                                       
                                                                        
!---------------- write enable 4_yxxx                                   
      if(enwr3) then 
        write(nwr,'(/,a,/,2a,/)')                                       &
     &  'theory  entry loop  l1 l2 l3                  storage',        &
     &  '              count         ',                                 &
     &  'loop_add request l1_put l1_get l2_put l2_get l3_put l3_get '   
!        write(6,'(a,10i5)')'irequ=',(irequ(i,0),i=0,5)                 
                                                                        
       do iss=0,mss 
        ipoi=ipointer+iss+1 
        ch14=pointerstr(ipoi)(1:14) 
                                                                        
        ith=10*(ichar(ch14(11:11))-i0)                                  &
     &         +ichar(ch14(12:12))-i0                                   
                                                                        
                                                                        
        do k=1,6 
        if(ch14(k:k).eq.'0')ch14(k:k)=' ' 
        end do 
        ch10=ch14(1:2)//' '//ch14(3:4)//' '//ch14(5:6) 
                                                                        
        jks=iks(iss-1) 
        chg42=' ' 
        chp42=' ' 
        chgp42=' ' 
        if(iss.eq.0) then 
         call itoc8(ch8,l1_get(0)+2) 
         chg42(1:7)=ch8(2:8) 
         call itoc8(ch8,l1_put(0)+2) 
         chp42(8:14)=ch8(2:8) 
         chgp42=chg42(1:8)//ch8(2:8) 
        end if 
                                                                        
        if(num1(iss).gt.0) then 
         ch8=' ' 
         if(irequ(iss,0).gt.0)call itoc8(ch8,l1_put(num1(iss))+2) 
         chg42(1:7)=ch8(2:8) 
         call itoc8(ch8,l1_get(num1(iss))+2) 
         chp42(8:14)=ch8(2:8) 
         chgp42=chg42(1:8)//ch8(2:8) 
        end if 
        if(num2(iss).gt.0) then 
         ch8=' ' 
         if(irequ(iss,0).gt.0)call itoc8(ch8,l2_put(num2(iss))+2) 
         chg42(15:21)=ch8(2:8) 
         call itoc8(ch8,l2_get(num2(iss))+2) 
         chp42(22:28)=ch8(2:8) 
         chgp42(15:)=chg42(15:22)//ch8(2:8) 
        end if 
        if(num3(iss).gt.0) then 
         ch8=' ' 
         if(irequ(iss,0).gt.0)call itoc8(ch8,l3_put(num3(iss))+2) 
         chg42(29:35)=ch8(2:8) 
         call itoc8(ch8,l3_get(num3(iss))+2) 
         chp42(36:42)=ch8(2:8) 
         chgp42(29:)=chg42(29:36)//ch8(2:8) 
        end if 
        if(iss.eq.0)then 
         ch8=' ' 
         if(irequ(iss,0).gt.0)call itoc8(ch8,l1_put(num1(iss))+2) 
         chg42(1:7)=ch8(2:8) 
         call itoc8(ch8,l1_get(num1(iss))+2) 
         chp42(8:14)=ch8(2:8) 
         chgp42=chg42(1:8)//ch8(2:8) 
        end if 
                                                                        
                                                                        
                                                               !! 240108
        b_ft=ith.gt.2.and.index(pointerstr(ipoi),'t ').gt.0 
        b_ft=.true. 
        if(irequ(iss,0).gt.0.and.b_ft.and.iss.eq.0) then 
         ch10=' 0        ' 
         write(nwr,'(a,i3,3x,a8,i8,i8,2x,a42)')                         &
     &   'fr_theory arr0',iss,ch10,i_adds(iss)+2,irequ(iss,0),chgp42    
        else 
                                                                        
         if(b_ft) then 
          write(nwr,'(a,i3,3x,a8,i8,i8,2x,a42)')                        &
     &    'fr_theory arri',iss,ch10,i_adds(iss)+2,                      &
     &    irequ(iss,0),chgp42                                           
         else 
          if(irequ(iss,0).gt.0) then 
           write(nwr,'(a,i3,3x,a8,i8,i8,2x,a42)')                       &
     &    'fr_theory arri',iss,ch10,i_adds(iss)+2,                      &
     &     irequ(iss,0),chp42                                           
          else 
           write(nwr,'(a,i3,3x,a8,i8,i8,2x,a42)')                       &
     &     'fr_theory arri',iss,ch10,i_adds(iss)+2,                     &
     &     irequ(iss,0)                                                 
          end if 
         end if 
        end if 
        isubthe=0 
        if(ityp(iss).eq.3)isubthe=-1 
                                                                        
        do k=1,ith/2 
         isubthe=isubthe+1 
         i=12+(k-1)*14 
         ch14=pointerstr(ipoi)(i+1:i+14) 
         if(ch14(13:13).eq.'t') then 
!         if the subroutines only distribute then ch14(13:13)='f'       
          ntheo=ksthe(jks+2*k-1) 
          icase=ksthe(jks+2*k) 
          write(nwr,'(a,i2,a,i1,22x,i8,24x,i8)')                        &
     &   'theory',ntheo,' case',icase,irequ(iss,k)                      
!                               ,ksm((jks+k)/2+2)                       
         end if 
        end do 
       end do  ! iss 
                                                                        
       if(mstruct1.gt.8)then 
        k=(mstruct1+1)/10 
        i=10*k-(mstruct1+1) 
        ch10=char(k+i0)//char(i+i0) 
       else 
        ch10=' '//char(mstruct1+1+i0) 
       end if 
       chp42=' ' 
       ch8=' ' 
       if(irequ(iss,0).gt.0)call itoc8(ch8,l1_put(mstruct1+1)+2) 
        chp42(1:7)=ch8(2:8) 
        write(nwr,'(a,i3,3x,a8,i8,i8,2x,a42)')                       &
         'fr_theory arre',iss,ch10,i_adds(iss)+2,irequ(iss,0),chp42
       end if 
!-------------------------------------                                  
       if(enwr4) then 
        write(nwr,'(a,15i4)')'numis(iss=1,...mss)=',(numis(i),i=1,mss) 
        write(nwr,'(a)')'((iks(i-1)+4)/2,ksm((iks(i-1)+4)/2)=' 
        write(nwr,'(12(i3,i6))')((iks(i-1)+4)/2,ksm((iks(i-1)+4)/2),i=1,mss)
        j=maxthss 
        do while(j.gt.0.and.ksm(j).eq.0) 
          j=j-1 
        end do 
        write(nwr,'(a)')'(ksm(i)=' 
        write(nwr,'(12i6)')(ksm(i),i=1,j) 
       end if 
                                                                        
!      control write                                                    
      if(enwr4)then 
       write(nwr,'(a)') 'pointer structure' 
       iss=0 
       write(nwr,'(a,2i2,5x,9i6)')'lstruct1 iss, kscp,ksm=',            &
            0,iss,(kscp(i),i=iks(iss-1)+1,iks(iss)),-1,                 &
            ((i+3)/2,ksm((i+3)/2),i=iks(iss-1)+1,iks(iss),2)           
       write(nwr,'(a,a8,a,i6)')'c_prop=',c_prop(iss),' i_adds=',i_adds(iss) 
       do lstruct1=1,mstruct1 
        write(nwr,'(a,2i2,5x,12i6)')'lstruct1 iss, kscp,ksm=',          &
         lstruct1,iss,(kscp(i),i=iks(iss-1)+1,iks(iss)),-1,             &
            ((i+3)/2,ksm((i+3)/2),i=iks(iss-1)+1,iks(iss),2)           
        write(nwr,'(a,a8,a,i6)')'c_prop=',c_prop(iss),' i_adds=',i_adds(iss)
         iss=iss+1 
        do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1) 
         write(nwr,'(a,2i2,5x,12i6)')'lstruct2 iss, kscp,ksm=',         &
         lstruct2,iss,(kscp(i),i=iks(iss-1)+1,iks(iss)),-1,             &
          ((i+3)/2,ksm((i+3)/2),i=iks(iss-1)+1,iks(iss),2)           
         write(nwr,'(a,a8,a,i6)')'c_prop=',c_prop(iss),' i_adds=',i_adds(iss)
         iss=iss+1 
         do lstruct3=istruct2(lstruct2-1)+1,istruct2(lstruct2) 
          write(nwr,'(a,2i2,5x,12i6)')'lstruct3 iss, kscp,ksm=',        &
          lstruct3,iss,(kscp(i),i=iks(iss-1)+1,iks(iss)),-1,            &
            ((i+3)/2,ksm((i+3)/2),i=iks(iss-1)+1,iks(iss),2)           
          write(nwr,'(a,a8,a,i6)')'c_prop=',c_prop(iss),' i_adds=',i_adds(iss)
          iss=iss+1 
         end do 
        end do 
       end do 
!      store on array_fr                                                
       write(nwr,'(a,10i4)')'frametheory mvpt=' 
       write(nwr,'(10i7)')(mvpt(i),i=0,mss+1) 
       write(nwr,'(a,10i4)')'frametheory mcpt=' 
       write(nwr,'(10i7)')(mcpt(i),i=0,mss+1) 
      end if 

       if(bprocstore_rd(ks))then
        do iss=0,mss 
         do k=mcpt(iss)+1,mcpt(iss+1) 
          ocontrf(k)=9999.99 
         end do 
        end do 
        do iss=0,mss 
         do k=mvpt(iss)+1,mvpt(iss+1) 
          ovartrf(k)=9999.99 
         end do 
        end do 
       end if

       b_const=.true. 
       nstorFR=i_adds(0)
       call arrayman(ks,iadd(2),b_const,info)
       
       call trf_structks(1) 

!      change to absolute addresses of li_get,put                       
       l1_put(mstruct1+1)=iarray_sp+l1_put(mstruct1+1) 
       l1_get(mstruct1+1)=l1_put(mstruct1+1) 
        l1_get(0)=iarray_sp+l1_get(0) 
        l1_put(0)=iarray_sp+l1_put(0) 
       do lstruct1=1,mstruct1 
        l1_get(lstruct1)=iarray_sp+l1_get(lstruct1) 
        l1_put(lstruct1)=iarray_sp+l1_put(lstruct1) 
        do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1) 
         l2_get(lstruct2)=iarray_sp+l2_get(lstruct2) 
         l2_put(lstruct2)=iarray_sp+l2_put(lstruct2) 
         do lstruct3=istruct2(lstruct2-1)+1,istruct2(lstruct2) 
          l3_get(lstruct3)=iarray_sp+l3_get(lstruct3) 
          l3_put(lstruct3)=iarray_sp+l3_put(lstruct3) 
         end do 
        end do 
       end do 

       do i=1,8 
        iadd(i)=iarray_sp+nstorFR+iadd(i) 
       end do 
!      write(6,'(a,12i6)')'a ityp=',(ityp(i),i=1,10)                    
!      write(6,'(a,12i6)')'jvp=',(jvp(i),i=1,10)                        
!       do k=mcpt(0)+1,mcpt(1)                                          
!         write(6,'(a,2f15.4)') 'contrf(k).ne.ocontrf(k)=',             
!     &                contrf(k),ocontrf(k)                             
!       end do                                                          
!       write(6,'(a)')'getthinf885  call mapcopa(0)'                                               
       call mapglobal 
       call distribthfr(iframe,cmch,n1,info) 
       if(info.gt.0) return 
       iframe=nframe 
       b_theoset(ks)=b_theory 
!       write(6,'(a)')'   getthinf nintstore(ks,0)'                     
       call nintstore(ks,0) 
!       do k=1,maxsub                                                   
!        if(abs(n_int(k,0)).gt.0) then                                  
!         do i=0,maxl                                                   
!          nintks(k,i,ks)=n_int(k,i)                                    
!         end do                                                        
!        end if                                                         
!       end do                                                          
                                                                        
       do k=1,16 
        displaymode(ks,k)=display_mode(k) 
       end do 
       ndispmode(ks)=ndisplay_mode 
       n_subspect(ks)=n_subset 
                                                                        
       nuofdata(ks)=nuofdatas 
       do k=0,ichanks(0) 
        ichan(k,ks)=ichanks(k) 
       end do 
!       n_subspect(ks)=n_subset                                         
!####################### else if FF                                     
      else 
       bprocstore_rd(ks)=.true.
       do i=0,maxthss 
        ityp(i)=0 
       end do 
       nstorSP=1
       call arrayman(ks,iadd(2),b_const,info) 
       call trf_structks(0) 

       l1_put(mstruct1+1)=iarray_sp+l1_put(mstruct1+1) 
       l1_get(mstruct1+1)=l1_put(mstruct1+1) 
       l1_get(0)=iarray_sp+l1_get(0) 
       l1_put(0)=iarray_sp+l1_put(0) 
       do lstruct1=1,mstruct1 
        l1_get(lstruct1)=iarray_sp+l1_get(lstruct1) 
        l1_put(lstruct1)=iarray_sp+l1_put(lstruct1) 
        do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1) 
         l2_get(lstruct2)=iarray_sp+l2_get(lstruct2) 
         l2_put(lstruct2)=iarray_sp+l2_put(lstruct2) 
         do lstruct3=istruct2(lstruct2-1)+1,istruct2(lstruct2) 
          l3_get(lstruct3)=iarray_sp+l3_get(lstruct3) 
          l3_put(lstruct3)=iarray_sp+l3_put(lstruct3) 
         end do 
        end do 
     end do

     do i=1,8 
        iadd(i)=iarray_sp+nstorFR+iadd(i) 
       end do 
!       ifrsubcase=ifr_sc                                  5.5.05       
                                                                        
!      write(6,'(a)')'getthinf call mapspfr(ks)'                        
!      call  mapspfr(ks)                                                
!       write(6,'(a,a4,i6)')'frametheory_F cmch,nstorFR=',cmch,nstorFR  
!      write(6,'(a,12i6)')'i_addss=',(yi_addss(i),i=1,10)               
!       write(6,'(a,12i6)')'mipt1=',(mipt1(i),i=1,mipt1(0))             
!       write(6,'(a,12i6)')'mipt2=',(mipt2(i),i=1,mipt2(0))             
!       write(6,'(a,12i6)')'mipt3=',(mipt3(i),i=1,mipt3(0))             
!       write(6,'(a,20i4)')'b ityp=',(ityp(i),i=1,10)                   
!      write(6,'(a,12i6)')'jvp=',(jvp(i),i=1,10)                        
!       write(6,'(a)')'getthinf call mapcopa(0)'                        
                                                                        
       call mapglobal 
                                                                        
       call distribthfr(iframe,cmch,n1,info) 
                                                                        
       if(info.gt.0) return 
       iframe=nframe 
       b_theoset(ks)=b_theory 
!       n_subspect(ks)=n_subset                                         
                                                                        
!       do k=1,maxsub                                                   
!        do i=0,maxl                                                    
!         nintks(k,i,ks)=n_int(k,i)                                     
!        end do                                                         
!       end do                                                          
!       write(6,'(a)')'###getthinf nintstore(ks,0)'                     
       call nintstore(ks,0) 
                                                                        
       do k=1,16 
        displaymode(ks,k)=display_mode(k) 
       end do 
       ndispmode(ks)=ndisplay_mode 
       n_subspect(ks)=n_subset 
                                                                        
       nuofdata(ks)=nuofdatas 
       do k=0,ichanks(0) 
        ichan(k,ks)=ichanks(k) 
       end do 
       do k=1,maxfr1 
        nu_sdevice(ks,k)=nu_device(k) 
       end do 
      end if 
                                                                        
      return 
      END                                           
                                                                        
                                                                        
      subroutine trf_structks(ntrf) 
      use glbconst, only: maxfr1,maxfr2,maxthss,marray_sp
      use comthe, only: iarray_sp
      implicit none
      integer     ntrf,nn,k
      
      character(len=4):: c_array 
      common/store/c_array(marray_sp*2) 
                                                                        
!     ntrf=0 read from array_fr                                         
!     ntrf=1 write on array_fr                                          
                                                                        
      character(len=4) :: cdumstr,chLOC 
      integer, parameter:: numstr=46+4*(maxfr1+maxfr2)+3*maxthss
      common/struct/cdumstr(numstr) 
      common/strLOC/chLOC(32)                                                                         
      character(len=4) :: cdumsmpt
      integer,parameter:: numsmpt=12+15*maxthss+maxfr2+maxfr1
      common/smpt/cdumsmpt(numsmpt)

!      write(6,'(a,i3,4i8)') 'getthinf ntrf,iarray_sp,numstr,numsmpt=', &
!            ntrf,iarray_sp,numstr, numsmpt,marray_sp*2
      if(ntrf.eq.1) then 
!     write(6,'(a,4f15.1)') 'getthinf array_fr(1,2) =', &
!              (array_fr(iarray_sp-1)),array_fr(iarray_sp)                      
       nn=iarray_sp*2       
       do k=1,numstr 
          c_array(nn+k)=cdumstr(k)
       end do 
       nn=nn+numstr 
       do k=1,32 
        c_array(nn+k)=chLOC(k)
       end do 
       nn=nn+32 
       do k=1,numsmpt 
        c_array(nn+k)=cdumsmpt(k) 
       end do 
      else 
       nn=iarray_sp*2 
       do k=1,numstr 
        cdumstr(k)=c_array(nn+k) 
       end do 
       nn=nn+numstr
       do k=1,32 
        chLOC(k)=c_array(nn+k)
       end do 
       nn=nn+32 
       do k=1,numsmpt 
          cdumsmpt(k)=c_array(nn+k)
       end do
      end if
      return 
    END subroutine trf_structks
    
     

    subroutine mapsub(l1,l2,l3) 
      use glbconst, only: maxfr1,maxfr2,maxthlv,maxthss,icstrf,ivstrf
      use comeff, only: chiss
      use comthe, only: iarray_sp
      implicit none                                                                        
      integer       l1,l2,l3,kssthe,ksscp,kssm
      common/msgtss/kss,kssthe(0:maxthlv),ksscp(0:2*maxthlv),           &
                    kssm(maxthlv)                                      
                                                                        
      integer  ifrsto_s,mvpt,mcpt,jvp,ityp,mipt1,mipt2,mipt3,           &
               ksthe,kscp,ksm,iks,numis,                                &
               i0,iss,j,k,kss                      
      integer,parameter:: numsmpt=12+15*maxthss+maxfr2+maxfr1 
      common/smpt/ifrsto_s,mvpt(0:maxthss),mcpt(0:maxthss),             &
                  jvp(0:maxthss),ityp(0:maxthss),                       &
                  mipt1(0:maxfr1),mipt2(0:maxfr2),mipt3(0:maxthss),     &
                  ksthe(maxthss*3),kscp(maxthss*3),ksm(0:maxthss*2),    &
                  iks(-1:maxthss),numis(0:maxthss)                           

      real          cmapsub,vmapsub 
      common/acmaps/cmapsub(icstrf) 
      common/avmaps/vmapsub(ivstrf) 
      character(len=3):: ch3 
                                                                        
       do j=1,icstrf 
        cmapsub(j)=0. 
       end do 
       do j=1,ivstrf 
        vmapsub(j)=0. 
       end do 
                                                                        
      i0=ichar('0') 
      ch3=char(l1+i0)//char(l2+i0)//char(l3+i0) 
      iss=0 
      do while(ch3.ne.chiss(iss)(1:3)) 
       iss=iss+1 
      end do 
                                                                        
       kss=iss 
       j=0 
       do k=iks(iss-1)+1,iks(iss) 
        j=j+1 
        kssthe(j)=ksthe(k) 
       end do 
       kssthe(0)=j 
       kssthe(j+1)=0 
       ksscp(j+1)=0 
                                                                        
       j=2 
       do k=iks(iss-1)+1,iks(iss) 
          j=j+1 
         ksscp(j)=kscp(k) 
        end do 
       ksscp(0)=j 
       ksscp(1)=0 
       ksscp(2)=0 
                                                                        
!        write(6,'(a,i2,5x,18i3)')'getthinf mapsub: iss, ksthe(0:)=',   
!     &     iss,(ksthe(i),i=0,18)                                       
!        write(6,'(39x,16i3)')(kssthe(i),i=0,kssthe(0))                 
!        write(6,'(a,i2,5x,28i3)')'getthinf mapsub: iss,  kscp(1:)=', &  
!          iss,(kscp(j),j=1,28)                                        
!         write(6,'(39x,16i3)')(ksscp(j),j=1,ksscp(0))                  
                                                                        
       j=0 
       if(numis(iss).eq.0) then 
        j=1 
        kssm(1)=0 
       end if 
       do k=iks(iss-1)+1,iks(iss),2 
        j=j+1 
        kssm(j)=iarray_sp+ksm((k+3)/2) 
       end do 
                                                                        
!     write(6,'(i4,a,10i4)')iss,'=iss mapsub mvpt=',(mvpt(j),j=0,iss+1)            
!      write(6,'(a,10i4)')'mapsub mcpt=',(mcpt(i),i=0,iss+1)            
      call mapcopa(iss) 
                                                                        
      return 

    END subroutine mapsub
                                                                        
      subroutine mapini(iss) 
      use glbconst, only: maxfr1,maxfr2,maxthlv,maxthss
      use comthe, only: iarray_sp
      implicit none
      integer       iss, kssthe,ksscp,kssm 
      common/msgtss/kss,kssthe(0:maxthlv),ksscp(0:2*maxthlv),           &
                    kssm(maxthlv)                                      
                                                                        
      integer  ifrsto_s,mvpt,mcpt,jvp,ityp,mipt1,mipt2,mipt3,           &
               ksthe,kscp,ksm,iks,numis,kss,j,k
      integer,parameter:: numsmpt=12+15*maxthss+maxfr2+maxfr1 
      common/smpt/ifrsto_s,mvpt(0:maxthss),mcpt(0:maxthss),             &
                  jvp(0:maxthss),ityp(0:maxthss),                       &
                  mipt1(0:maxfr1),mipt2(0:maxfr2),mipt3(0:maxthss),     &
                  ksthe(maxthss*3),kscp(maxthss*3),ksm(0:maxthss*2),    &
                  iks(-1:maxthss),numis(0:maxthss)                           
                                                                        
       kss=iss 
       j=0 
       do k=iks(iss-1)+1,iks(iss) 
        j=j+1 
        kssthe(j)=ksthe(k) 
       end do 
       kssthe(0)=j 
       kssthe(j+1)=0 
       ksscp(j+1)=0 
                                                                        
       j=2 
       do k=iks(iss-1)+1,iks(iss) 
          j=j+1 
         ksscp(j)=kscp(k) 
        end do 
       ksscp(0)=j 
       ksscp(1)=0 
       ksscp(2)=0 
                                                                        
!       write(6,'(a,i2,5x,18i3)')'getthinf mapsub: iss, ksthe(0:)=',    
!     &     iss,(ksthe(i),i=0,18)                                       
!             write(6,'(39x,16i3)')(kssthe(i),i=0,kssthe(0))            
!        write(6,'(a,i2,5x,28i3)')'getthinf mapsub: iss,  kscp(1:)=',   
!     &     iss,(kscp(i),i=0,28)                                        
!         write(6,'(39x,16i3)')(ksscp(i),i=1,ksscp(0))                  
                                                                        
       j=0 
       if(numis(iss).eq.0) then 
        j=1 
        kssm(1)=0 
       end if 
       do k=iks(iss-1)+1,iks(iss),2 
        j=j+1 
        kssm(j)=iarray_sp+ksm((k+3)/2) 
       end do 
                                                                        
!      write(6,'(a,10i4)')'mapsub mvpt=',(mvpt(i),i=0,iss+1)            
!      write(6,'(a,10i4)')'mapsub mcpt=',(mcpt(i),i=0,iss+1)            
!      call mapfr(iss)                                                  
                                                                        
      return 
      END                                           
                                                                        
                                                                        
      subroutine nintstore(ks,lgp)
      use glbconst, only: maxs,maxsub
      use complt, only: n_int
      use comeff, only: nintset 
      implicit none 
      integer   ks,lgp,k,j,jd,iadd,inl,nset 
      integer, dimension(maxsub):: in 
                                                                        
!      add a nint                                                       
       if(lgp.eq.0)then 
!        write(6,'(a,i4)') 'lgp=0 nint=',nintset(0)                     
!        write(6,'(8i3)')n_int                                          
!       the address nintset(ks) tells the number of stored n_int values 
        iadd=nintset(ks) 
        nset=0 
        inl=0 
        do  k=1,maxsub 
         if(n_int(k,0).gt.0) then 
          inl=inl+1 
          nset=nset+abs(n_int(k,0))+1 
          in(inl)=k 
         end if 
        end do 
        nset=nset+maxsub-inl+1 
!       nset is the number of n_int values (starts with 0)              
        nintset(iadd)=nset 
!       move ks+1 to maxs blocks by the number nset                     
!        nintset(ks+1) until nintset(0)                                 
        jd=nset -(nintset(ks+1)-nintset(ks)) 
        if(jd.gt.0) then 
         do k=nintset(0),nintset(ks+1),-1 
          nintset(k+jd)=nintset(k) 
         end do 
             ! j.lt.0                                                   
        else 
         do k=nintset(ks+1),nintset(0) 
          nintset(k+jd)=nintset(k) 
         end do 
        end if 
!       change of the addresses                                         
        do k=ks+1,maxs 
         nintset(k)=nintset(k)+jd 
        end do 
!       writing the n_int values on nintset                             
        do  k=1,maxsub 
         nintset(iadd+1)=n_int(k,0) 
         do j=1,abs(n_int(k,0)) 
          nintset(iadd+1+j)=n_int(k,j) 
         end do 
         iadd=iadd+abs(n_int(k,0))+1 
        end do 
        nintset(0)=nintset(0)+jd 
!        write(6,'(a,i3)') 'nintset(0)=',nintset(0)                     
!        write(6,'(20i3)') (nintset(i),i=1,100)                         
       else ! lgp=1   
        n_int=0      ! n_int(maxsub,0:maxthss)=0
        iadd=nintset(ks) 
        do  k=1,maxsub 
         n_int(k,0)=nintset(iadd+1) 
         do j=1,abs(n_int(k,0)) 
          n_int(k,j)=nintset(iadd+j+1) 
         end do 
         iadd=iadd+abs(n_int(k,0))+1 
        end do 
       end if 
       return 
      END                                           
