      subroutine parm(n1,ledit,chisqmin) 
      use glbconst, only: maxp,maxvaco,maxc,maxco,maxpl,    &
                          infotext,nwr,nrd
      use compar, only:   maxsto,maxscr,ncolwin,nwrwin
      use comfrm, only:   kp,np,p,up,op,ddp,nthpl,kcp,kcof,mco,mp,mprdn,&
                          mc,mcs,mr,ncor
      use comeff, only:   led,ncol,ixpixel
      use comscd, only:   npanum,queryar,scratch,fscratch
      implicit none
      integer, intent(inout):: n1,ledit
      real,    intent(in):: chisqmin

      character(len=256):: chflen
      character(len=132):: chin,chcom,ch132,cp132,chtext,ct132,querytype 
      character(len=80) :: chline
      character(len=24) :: chl,chr
      character(len=16) :: cp16
      character(len=8)  :: ch8
      character(len=7)  :: form
      character(len=5)  :: chred,chblue,chgreen 
      character(len=4)  :: chbold,chnorm
      character(len=2)  :: ch2,prompt
      character(len=1)  :: ch0,ch1 

      real,    dimension(32):: out
      character(len=14), dimension(3):: formpr
      character(len=24), dimension(maxp):: nppr
      character(len=20), dimension(3) :: formco
      character(len=5), dimension(maxp):: chcol
      character(len=1), dimension(maxp):: iich

      integer, dimension(maxp) :: kpnum,kednum,iind,ind,iip
      integer, dimension(maxco):: indco
      logical, dimension(maxp) :: b_ed

      real         hu,rn
      integer      i,readaline,i0,i1,i10,i_,ic,                         &
                   ic1,ic2,icol,icoln,ienter,ih,ihasch,ii,iih,iir,ik,   &
                   ikp,il,iline,ilmax,im,in,in1,inenter,info,io,ip,ipl, &
                   ipm,ipos,ir,irl,iu,iumax,iun,j,j0,j1,j2,jco,jjcom,jp,&
                   k,k1,ki,jj,jjco,jpr,l,l10,len,lengthi,lengths,       &
                   lq,mscr1,mscr2,nak,nit,nk,nll,nn,npa,nw
      integer      mch(132),length(0:4),knum(maxp+2*maxc) 
                                                                        
!     call setscrd(1,1)   !!!! scrd 100000.99 +i                        
!     n1 < 0 error return                                               
!     n1 = 2 changing of parameters,constants and their names           
!     n1 = 3 fix                                                        
!     n1 = 4 free                                                       
!     n1 = 5 restore                                                    
      ch0=char(0) 
      ipm=1 
      chbold=char(27)//'[1m' 
      chred=char(27)//'[31m' 
      chblue=char(27)//'[34m' 
      chgreen=char(27)//'[32m' 
      chnorm=char(27)//'[0m' 
      icoln=ncolwin 
!      write(6,'(a,i4)')' param icoln=',ncolwin                         
      i0=ichar('0') 
      chcom='effi/parameter/structure/handling' 
      k1=n1 
       do k=1,maxp+maxc*2 
        knum(k)=npanum(k) 
       end do 
      if(k1.eq.0) return 
      goto (100,100,500,500,600,601),k1 
!     ******************************************************************
                                                                        
!     ******************************************************************
  100 continue 
      mscr1=maxc 
      mscr2=mscr1+maxp 
                                                                        
!     ******************************************************************
!     changing of parameters and their names                            
!     ******************************************************************
      goto(300,400),npanum(1) 
!        npanum(mscr1+1)= 1 - p (parameters)                            
!               mscr2+1)= 2 - c (constants )                            
!        npanum(mscri+2)= number of parameters (constants)              
!      npanum(n>mscri+2)= parameter- (constant-) number                 
  300 continue 
!      write(6,'(a,i4)') ' npanum(mscr1+2)=',npanum(mscr1+2)            
!      write(6,'(20i4)') (npanum(2+mscr1+i),i=1,npanum(mscr1+2))        
      if(npanum(mscr1+2).le.0) then 
       call help(chcom) 
       return 
      end if 
      npa=0 
      lengths=0 
      do k=0,4 
       call fvadjust(k,length(k)) 
       lengths=lengths+length(k) 
      end do 
!      write(6,'(a,5i5)') ' parm length=',(length(i),i=0,4)             
      if(length(0).gt.24)length(0)=24 
      i10=length(0)/10 
      i1=length(0)-i10*10+i0 
      ch2=char(i10+i0)//char(i1) 
                                                                        
      formpr(1)='2a1,i1,3x,a'//ch2//',' 
      formpr(2)='2a1,i2,2x,a'//ch2//',' 
      formpr(3)='2a1,i3,1x,a'//ch2//',' 
                                                                        
       nit=nwr 
       if(ledit.gt.10) then 
        open(unit=9                                                     &
                 ,file='editor.pa'                                      &
                 ,status='unknown'                                      &
                 ,access='sequential'                                   &
                 ,form='formatted'                                      &
                 ,err=10)                                               
        nit=9 
       end if 
       goto 20 
   10  continue 
        write(nwr,'(a)')'**fatal error** editor file could not be opend' 
        ledit=0 
   20   continue 
                                                                        
!      do k=1,mp                                                        
!        write(6,'(i3,2x,a)')k,np(k)                                    
!      end do                                                           
                                                                        
                                                                        
      iumax=0 
      jpr=npanum(mscr1+2) 
      do j=1,jpr 
       ch1=' ' 
                                                                        
       ii=npanum(j+mscr1+2) 
       if(ii.gt.mp) then 
        write(nwr,'(2(a,i3))')' parameter number ',ii,                  &
                 ' is larger than the total number of parameter',mp     
        write(nwr,'(a)')' check command buffer pa b1' 
        npanum(mscr1+2)=j-1 
        goto 20 
       end if 
       if(ddp(ii).eq.0.0)then 
        k=index(np(ii),'*') 
        kp(ii)=3 
        if(k.gt.0) then 
         kp(ii)=2 
         ch1='x' 
        else 
         kp(ii)=3 
         ch1='%' 
        end if 
       else 
        if(kp(ii).eq.3) kp(ii)=1 
       end if 
       if(kp(ii).eq.0) ch1='*' 
       if(kp(ii).eq.2) ch1='x' 
       kpnum(ii)=kp(ii) 
       k=ii/100 
       ip=3 
       if(k.eq.0) then 
        ip=2 
        k=ii/10 
       end if 
       if(k.eq.0) ip=1 
       chflen='('//formpr(ip)//np(ii)(25:60)
       iu=index(np(ii),'_') 
       if(iu.eq.0) then 
        write(nwr,'(3a)')' name:',np(ii)(:23), ' is not seperated by _' 
        write(nwr,'(a)')' ed mode requires seperation by an underscore' 
        ledit=0 
        nit=nwr 
        close(unit=9) 
       else 
        do while(np(ii)(iu:iu).eq.'_') 
         iu=iu+1 
        end do 
        if(iu.gt.iumax)iumax=iu 
       end if 
!       write(6,'(a)')chflen                                            
                                                                        
       if(kp(ii).eq.2) then 
         write(nit,chflen) ch1,'p',ii,np(ii),p(ii) 
        else 
         write(nit,chflen)                                              &
                       ch1,'p',ii,np(ii),p(ii),up(ii),op(ii),ddp(ii)    
        end if 
      end do 
                                                                        
      iu=iumax 
      ilmax=0 
!--------------------------------------------                           
      if(ledit.gt.10) then 
       close(unit=nit) 
       if(ledit.gt.20.and.ledit.lt.30) then 
        l=16+lengths 
        call itoc8(ch8,l) 
        ch8(4:4)='x' 
        ch132='-geometry '//ch8(:4) 
        if(jpr.gt.65) then 
         call itoc8(ch8,73) 
        else 
         call itoc8(ch8,jpr+9) 
        end if 
        ch132(15:)=ch8(2:3) 
        call itoc8(ch8,ixpixel(1)+10) 
        ch8(1:1)='+' 
        ch132(17:)=ch8(1:4)//'+0 '//ch0 
       else 
        ch132=' '//ch0 
       end if 
       if(jpr.eq.mp) then 
        write(nwr,'(a4,2a,a5)')chbold,'Alteration of the sequence of ', &
       'parameters is supported ',chnorm                                
       else 
        write(nwr,'(a4,2a,a5)')chbold,'Alteration of the sequence of ', &
       'parameters is not supported ({pa a} required)',chnorm           
       end if 
       call openeditor(ledit,ch132) 
                                                                        
         open(unit=nit                                                  &
                 ,file='editor.pa'                                      &
                 ,status='unknown'                                      &
                 ,access='sequential'                                   &
                ,form='formatted')                                     
      do j=1,jpr 
       i=npanum(mscr1+2+j) 
       nppr(i)=np(i) 
      end do 
                                                                        
      do j=1,jpr 
       i=npanum(mscr1+2+j) 
        read(nit,'(a)')ch132 
!        write(6,'(2a)')'ch132=',ch132(1:65)                            
        call nextchar(ch132,0,ipos,cp132,ip) 
        kpnum(j)=1 
        if(cp132(1:1).eq.'*')kpnum(j)=0 
        if(cp132(1:1).eq.'x')kpnum(j)=2 
                                                                        
                                                                        
        call nextchar(cp132,1,ipos,ch132,ih) 
        iun=index(ch132(1:ih),'_')+1 
        if(iun.gt.ilmax)ilmax=iun 
                                                                        
        ip=index(cp132(1:ih),'p')+1 
        ch8=cp132(ip:ip+2) 
        call c8toi(ch8,ic1) 
        kednum(j)=ic1 
        if(ic1.eq.0)then                                               
         print'(a)',' ic1=0  appeared one time and never again'     
         print'(a,2x,a8)',cp132(1:ih),ch8                           
         read(5,'(a)')                                                 
        end if                                                         
        do while(ch132(iun:iun).eq.'_') 
         iun=iun+1 
        end do 
        io=iu+ih-iun+1 
!        write(6,'(i4,2a)')io,'ch132=',ch132(iun:ih)                    
        nppr(ic1)(iun:iu)='____' 
        np(i)(:iu)=nppr(ic1)(:iu) 
        l=ih 
        do while(ch132(l:l).eq.' ') 
         l=l+1 
        end do 
        if(l.gt.24)l=24 
        np(i)(iu:24)=ch132(iun:l) 
!        write(6,'(2a)')'np(i)=',np(i)                                  
        call nextchar(ch132,1,ipos,cp132,ih) 
           chin=cp132 
           call fout_c(chin,ch132,jj) 
!           write(6,'(2a)')cp132(1:40),ch132(1:40)                      
           call trlch(icoln,cp132,nn,out) 
           if(nn.gt.4) nn=4 
           icol=1 
           do while(icol.le.nn) 
            ic1=9*(icol-1)+6 
            ic2=ic1+1 
            in1=23+ic1 
            l=10*(ichar(ch132(ic1:ic1))-i0)+ichar(ch132(ic2:ic2))-i0 
            np(i)(in1-1:in1+3)=ch132(ic1-1:ic1+3) 
!            write(6,'(a,a)')'.1',np(i)                                 
            if(icol.eq.1) p(i)=out(1) 
            if(icol.eq.2) up(i)=out(2) 
            if(icol.eq.3) op(i)=out(3) 
            if(icol.eq.4) ddp(i)=out(4) 
            if(l.ne.length(icol)) then 
              call fvadjust(icol,lengthi) 
              length(icol)=lengthi 
            end if 
            icol=icol+1 
           end do 
!         read(5,'(a)')                                                 
       end do 
       ledit=35 
       close(unit=nit) 
       call systemcmd("rm  editor.pa"//char(0)) 
!       write(6,'(a,i5)')'npanum=',mp                                   
!       write(6,'(20i4)')(npanum(mscr1+2+i),i=1,mp)                     
!       write(6,'(a,i5)')'kednum=',mp                                   
!       write(6,'(20i4)')(kednum(i),i=1,mp)                             
       l=0 
       do i=1,mp 
        b_ed(i)=.true. 
       end do 
                                                                        
      do i=1,mp 
        kp(i)=kpnum(i) 
      end do 
      do i=1,mp 
        if(b_ed(i)) then 
         do j=1,jpr 
           l=l+1 
          if(kednum(j).gt.0) then 
           if(kcp(i).eq.kednum(j))then 
            kcp(i)=npanum(mscr1+2+j) 
            kednum(j)=0 
            b_ed(i)=.false. 
            goto 302 
           end if 
          end if 
         end do 
        end if 
  302   continue 
       end do 
                                                                        
       ilmax=0 
       if(jpr.eq.mp) then 
        do i=1,mp 
         iu=index(np(i),'_') 
         if(iu.gt.ilmax)ilmax=iu 
        end do 
        chl='______________' 
        do i=1,mp 
         iu=index(np(i),'_') 
         j=iu 
         do while(np(i)(iu:iu).eq.'_') 
          iu=iu+1 
         end do 
         chr=np(i)(iu:) 
         np(i)(j:24)=chl 
!        write(6,'(a,5x,a)')ncon(i)(ilmax:24),chr                       
         np(i)(ilmax+2:24)=chr(1:24-iu) 
        end do 
       end if 
!      write(6,'(i3,a,20i3)')l,'kcp   =',(kcp(l),l=1,mp)                
       call coexam(0,info) 
       return 
      end if 
                                                                        
                                                                        
                                                                        
      write(nwr,'(a)') 
!      i=npanum(mscr1+3)-1                                              
      i=1 
      ihasch=0 
      goto 385 
  316 info=0 
      if(ihasch.eq.1) then 
       call calpl('test') 
!       cp132='te #'                                                    
       call subtest(cp132,chisqmin,info) 
       do k=1,maxp+maxc*2 
        npanum(k)=knum(k) 
       end do 
       ihasch=0 
      end if 
                                                                        
      cp132=' ' 
      ct132=' ' 
                                                                        
      prompt='>'//ch0 
      irl=readaline(mch,prompt) 
      if(irl.gt.0) then 
       do j=1,irl 
        cp132(j:j)=char(mch(j)) 
       end do 
       call addhist(cp132(:irl)//ch0) 
      end if 
                                                                        
!      read(nrd,'(a)') cp132                                            
      ct132=cp132 
!      write(6,'(2a)') ' parm cp132=',cp132(:70)                         
      ii=npanum(i+mscr1+2) 
                                                                        
!      call history(cp132)                                              
      if(cp132(1:2).eq.'te') then 
       write(nwr,'(1x,a1,a3)') char(27),'[2A' 
!        cp132=' '                                                      
        ihasch=1 
        goto 316 
      end if 
                                                                        
      if(cp132(1:2).eq.'le') then 
       write(nwr,'(1x,a1,a3)') char(27),'[2A' 
        led=mod(led+1,2) 
        led=0 
!        if(led.eq.0) write(nwr,'(a)') ' command mode'                  
!        if(led.eq.1) write(nwr,'(a)') ' replacement mode'              
        cp132=' ' 
        goto 380 
      end if 
                                                                        
      call nextchar(cp132,0,ipos,ch132,ih) 
      ch1=ch132(1:1) 
      if(ch1.eq.'P')ch1='p' 
      if(ch1.eq.'p') then 
        if(ch132(2:2).eq.' ') then 
         chin=ch132 
         call paident(info,chin) 
       write(nwr,'(1x,a1,a3)') char(27),'[2A' 
       write(nwr,'(2a)')'                                        ',     &
                        '                                        '      
!       write(6,'(a,i4)')  ' 1back from paident -p,P- ',info            
         if(info.eq.1) goto 316 
         if(chin(2:).ne.' ') then 
          cp132='pa  '//chin 
          inenter=2 
          call comln1(cp132,chcom,ienter) 
         end if 
         goto 300 
        end if 
      end if 
      if(ch132(1:1).eq.'b'.and.ch132(2:2).ne.' ') then 
       in=ichar(ch132(2:2))-ichar('0') 
       if((in.gt.0.and.in.lt.10).or.ch132(2:3).eq.'f ') then 
        cp132='pa  ' 
        if(ch132(2:2).eq.'f') cp132='pa '//ch132(1:5) 
        chin=cp132 
        ienter=1 
!       write(6,'(2a)') 'parm bf: vor comln1 chin=',chin(:40)           
        call comln1(chin,chcom,ienter) 
!       write(6,'(2a)') 'parm bf: nach comln1 chin=',chin(:40)          
        if(chin(1:1).eq.'*'.or.chin(1:1).eq.'q') goto 390 
        call nextchar(chin,2,ipos,ch132,ih) 
       end if 
      end if 
                                                                        
      if(ch132(1:1).eq.'c') then 
        chin=ch132 
        call paident(info,chin) 
!       write(6,'(a,i4)')  ' back from paident -c- ',info               
        if(info.eq.1) goto 316 
        if(ch132(2:).ne.' ') then 
         cp132='pa  '//chin 
         ienter=2 
         call comln1(cp132,chcom,ienter) 
        end if 
        goto 400 
      end if 
      if(ch132(1:1).eq.'#') then 
       do k=1,4 
        call fvadjust(k,length(k)) 
       end do 
       goto 300 
      end if 
      if(ch132(1:1).eq.'*'.or.ch132(1:1).eq.'q') goto 390 
      if(ch132(1:2).eq.'he') then 
       cp132=ch132(3:) 
       call trlch(24,cp132,nn,out) 
       jp=out(1) 
!       write(6,'(a,i4,a)')' jp,cp132=',jp,cp132(:24)                   
       if(jp.gt.0.and.jp.le.mp) then 
        call identv(jp) 
        len=8 
        do  k=1,npanum(2) 
         l=10*(ichar(fscratch(k)(2:2))-i0)                              &
              +ichar(fscratch(k)(3:3))-i0                               
         if(l.gt.len) len=l 
        end do 
        l10=len/10 
        ch2=char(l10+i0)//char(len-l10*10+i0) 
        write(nwr,'(a,i3,a,i2,a/)')' parameter ',jp,' is mapped onto',  &
          npanum(2),' variables:'                                       
        write(nwr,'(24x,a24)')np(jp) 
        do k=1,npanum(2) 
         if(fscratch(k)(1:1).eq.'i') then 
          cp16='(a24,f'//ch2//'.0)' 
          else 
          cp16='(a24,'//fscratch(k)(1:1)//ch2//'.'                      &
                                       //fscratch(k)(4:4)//')'          
          end if 
         ipl=npanum(k+2) 
         write(nwr,cp16)nthpl(ipl)(1:24),scratch(k) 
        end do 
        write(nwr,'(a)') 
        querytype='proceed with description of the variable(s)' 
        ch1='y' 
        chcom='effi/variables/description' 
        call yesno(querytype,ch1,chcom,icoln,nrd,nwr) 
        if(ch1.eq.'y') then 
         ch8=nthpl(ipl)(25:32) 
         k=1
         do while(k.le.npanum(2).and.ch1.eq.'y') 
          ipl=npanum(2+k) 
          chcom='theory/'//ch8//'/variable/'                            &
              //nthpl(ipl)(1:24)                                       
!          1abs5___EFG             th140113                                       
!          write(6,'(a,a)')' param nthpl=',nthpl(ipl)                   
!          write(6,'(a,a)')' param nthpl(ipl)(25:32)=',nthpl(ipl)(25:32)
          call help(chcom) 
          querytype=' description of the next variable' 
          ch1='n' 
          chcom='effi/variables/description/repeat'
          k=k+1 
          if(k.le.npanum(2))call yesno(querytype,ch1,chcom,icoln,nrd,nwr) 
         end do 
                                                                        
        end if 
       else 
        write(nwr,'(17(a,/),a)')                                        &
       ' ----------------------------------------------------',         &
       ' use the readline properties: the string containing',           &
       ' the values is buffered (edit the string)           ',          &
       '                                                   ',           &
       '           pi  value : defines the format (also reduced)',      &
       '               value : extended format is accepted',            &
       '           pi  name  : defines new parameter name',             &
       '           #   listing of parameters',                          &
       '           c   switching to constants',                         &
       '           b/f switching to preceding/following lines',         &
       '           *,q back to command level',                          &
       ' old input format----------------------------',                 &
       '                        value, value  ... (1-4)',               &
       '           pi                  values ... (1-4)',               &
       '           ll (lower limit)    values ... (1-3)',               &
       '           ul (upper limit)    values ... (1-2)',               &
       '           dp (stepwidths)     value      (1  )',               &
       ' ----------------------------------------------------'          
       end if 
       goto 316 
      end if 
                                                                        
      jj=0 
      if(led.eq.1.and.ch1.ne.'p') then 
!     1sp___f_factor          1x,f10.4,1x,f07.4,1x,f07.3,1x,e09.3)           
!123456789012345678901234567890123456789012345678901234567890           
        in=ichar(ct132(2:2))-i0 
        if(in.gt.0.and.in.lt.10) then 
         call trlch(ih,ct132,nn,out) 
         ii=out(1) 
         k=0 
         do j=1,npanum(mscr1+2) 
           if(ii.eq.npanum(j+mscr1+2)) k=j 
         end do 
         if(k.gt.0) i=k-ipm 
        end if 
        ii=npanum(i+mscr1+2) 
        ch2=formpr(1)(12:13) 
        nw=(ichar(ch2(1:1))-i0)*10+ichar(ch2(2:2))-i0+1 
        chline='      '//np(ii)(1:nw) 
        form=np(ii)(28:32) 
        rn=p(ii) 
        call trlnu(form,rn,chr,nn,chl,im) 
!       write(6,'(i2,a8,a,a)')nw,form,'a chr(1:nn)=',chr(1:nn)          
!       write(6,'(2a)')' parm chline :',chline(1:60)                    
        iline=6+nw 
        chline=chline(1:iline)//chr(1:nn) 
        iline=iline+nn 
!       write(6,'(2a)')' parm chline=',chline(1:60)                     
        form=np(ii)(37:41) 
        rn=up(ii) 
        call trlnu(form,rn,chr,nn,chl,im) 
        chline=chline(1:iline)//chr(1:nn) 
        iline=iline+nn 
!       write(6,'(i4,2a)')nn,' parm chline :',chline(1:60)              
        form=np(ii)(46:50) 
        rn=op(ii) 
        call trlnu(form,rn,chr,nn,chl,im) 
        chline=chline(1:iline)//chr(1:nn) 
        iline=iline+nn 
!       write(6,'(i4,2a)')nn,' parm chline :',chline(1:60)              
        if(ddp(ii).gt.0.0) then 
         form=np(ii)(55:59) 
         rn=ddp(ii) 
         call trlnu(form,rn,chr,nn,chl,im) 
         chline=chline(1:iline)//chr(1:nn) 
         iline=iline+nn 
        end if 
!        write(6,'(2a)')'parm chline:',chline(7:72)                     
!        write(6,'(2a)')'parm cp132 :',cp132(1:120)                     
!       analyse cp132                                                   
        chtext=chline(nw+1:) 
        call nextchar(chtext,0,ipos,ch132,ih) 
        call nextchar(ch132,0,ipos,chtext,iih) 
        jj=0 
        icol=icoln 
        if(icoln.gt.130)icol=130 
        do k=7,icol 
         if(cp132(k:k).ne.' ') then 
          if(k.gt.nw)then 
           if(cp132(k:k).eq.'x'.or.(chline(k-1:k-1).eq.' '.and.         &
             chline(k+1:k+1).eq.' '))cp132(k:k)=' '                    
!            write(6,'(2a)')'parm  cp132(k-1:k+1):',cp132(k-1:k+1)          
                                                                        
          else 
           if(chline(k-1:k-1).eq.' ') then 
            write(nwr,'(a)') 'blank inside name is not accepted' 
            cp132(k:k)=' ' 
           end if 
          end if 
          chline(k:k)=cp132(k:k) 
          nk=k 
          jj=jj+1 
         end if 
        end do 
!        write(6,'(a,3i4)')' jj,k=',jj,k,nk                             
        cp132(1:)=chline(7:) 
!        write(6,'(2a)')'parm  chline(7:):',chline(7:)                  
!        write(6,'(2a)')'parm cp132(7:nw):',cp132(7:nw)                 
!        write(6,'(2a)')'parm np(ii)(7:nw):',np(ii)(7:nw)               
                                                                        
        if(cp132(7:nw).ne.np(ii)(7:nw)) np(ii)(7:nw)=cp132(7:nw) 
        cp132(1:nw)=' ' 
        if(jj.eq.0) cp132(7:)=' ' 
       end if 
!        write(6,'(2a)')'parm cp132:',cp132(7:72)                       
       call nextchar(cp132,0,ipos,ch132,ih) 
!       write(6,'(2a)')'parm ch132(:ih):',ch132(:ih)                    
                                                                        
!       if(jj.gt.0.and.led.eq.1) then                                   
!        if(ch132(1:ih).ne.chtext(1:iih))ihasch=1                       
!        write(6,'(2a)')'parm chtext(:ihh):',chtext(:ihh)               
!       end if                                                          
                                                                        
                                                                        
      if(ct132(1:1).eq.'b')then 
       ipm=-1 
       ih=0 
      else if(ct132(1:1).eq.'f')then 
       ipm=1 
       ih=0 
      else if(ct132(1:10).eq.' ')then 
!       ih=0                                                            
      end if 
                                                                        
                                                                        
      if(ih.eq.0) then 
       i=i+ipm 
       if(i.eq.0) then 
        write(nwr,'(a)') 
        i=npanum(mscr1+2) 
       else if(i.eq.npanum(mscr1+2)+1) then 
        write(nwr,'(a)') 
        i=1 
       end if 
       ii=npanum(i+mscr1+2) 
       write(nwr,'(1x,a1,a3)') char(27),'[2A' 
       goto 380 
      else 
       write(nwr,'(1x,a1,a3)') char(27),'[2A' 
       write(nwr,'(2a)')'                                        ',     &
                        '                                        '      
       write(nwr,'(2a)')'                                        ',     &
                        '                                        '      
       write(nwr,'(1x,a1,a3)') char(27),'[3A' 
      end if 
                                                                        
      ch1=ch132(1:1) 
      if(ch1.eq.'p'.or.ch1.eq.'P') then 
        if(ch132(2:2).eq.' ') then 
         chin=ch132 
         call paident(info,chin) 
       write(nwr,'(1x,a1,a3)') char(27),'[2A' 
       write(nwr,'(2a)')'                                        ',     &
                        '                                        '      
!       write(6,'(a,i4)')  ' 1back from paident -p,P- ',info            
         if(info.eq.1) goto 316 
         if(chin(2:).ne.' ') then 
          cp132='pa  '//chin 
          inenter=2 
          call comln1(cp132,chcom,ienter) 
         end if 
         goto 300 
        end if 
                                                                        
        in=ichar(ch132(2:2))-i0 
        if(in.gt.0.and.in.lt.10) then 
         call trlch(ih,ch132,nn,out) 
         ii=out(1) 
         if(ii.gt.0.and.ii.le.mp) then 
          call nextchar(ch132,ih,ipos,cp132,ip) 
          ch1=cp132(1:1) 
          if(ch1.eq.' ') goto 378 
          if(kp(ii).eq.2) then 
           write(nwr,'(2a)') 'value is calculated by the product ',     &
                             'of two factors'                           
!           goto 378                                                    
          end if 
          in=ichar(cp132(1:1))-i0 
          if(in.ge.-6.and.in.lt.10) then 
           chin=cp132 
           call fout_c(chin,ch132,j) 
           call trlch(icoln,cp132,nn,out)
 
           if(nn.gt.4) nn=4 
           icol=1 
           do while(icol.le.nn) 
            ic1=9*(icol-1)+6 
            ic2=ic1+1 
            in1=23+ic1 
            l=10*(ichar(ch132(ic1:ic1))-i0)+ichar(ch132(ic2:ic2))-i0 
            np(ii)(in1:in1+3)=ch132(ic1:ic1+3) 
!           write(6,'(a,a)')'.1',np(ii)                                 
            if(icol.eq.1) p(ii)=out(1) 
            if(icol.eq.2) up(ii)=out(2) 
            if(icol.eq.3) op(ii)=out(3) 
            if(icol.eq.4) ddp(ii)=out(4) 
            if(l.ne.length(icol)) then 
              call fvadjust(icol,lengthi) 
              length(icol)=lengthi 
            end if 
            icol=icol+1 
           end do 
           if(kp(ii).eq.2) call calpl('test') 
           goto 360 
          else 
           i_=index(np(ii),'_') 
           do while(np(ii)(i_:i_).eq.'_') 
             i_=i_+1 
           end do 
           np(ii)(i_:24)=cp132(1:ip) 
!          write(6,'(a,a)')'.2',np(ii)                                  
          end if 
          goto 378 
         else 
          write(nwr,'(2(a,i2))') '***error*** ',ii,                     &
                                   ' out of range 1-',mp                
         end if 
         i=1 
         k=npanum(mscr1+2) 
         do while(npanum(i+mscr1+2).ne.ii.and.i.le.k) 
          i=i+1 
         end do 
         i=i+ipm 
         goto 380 
        end if 
                                              ! pi ...                  
      end if 
                                                                        
      in=ichar(ch1)-ichar('0') 
      if(in.ge.-6.and.in.lt.10) then 
       if(kp(ii).eq.2) then 
        write(nwr,'(2a)') 'value is calculated by the product ',        &
                          'of two factors'                              
!        goto 378                                                       
       end if 
!         write(6,'(a,a)')'3a',np(ii)                                   
          chin=ch132 
          call fout_c(chin,cp132,j) 
!           write(6,'(2a)')cp132(1:40),ch132(1:40)                                                                           
          call trlch(icoln,ch132,nn,out) 

          if(nn.eq.0) goto 365 
          if(nn.gt.4) nn=4 
          icol=1 
          do while(icol.le.nn)
           in1=24+9*(icol-1)+4 
           ic1=9*(icol-1)+6 
           ic2=ic1+1 
           l=10*(ichar(cp132(ic1:ic1))-i0)+ichar(cp132(ic2:ic2))-i0 
           nak=ichar(np(ii)(in1+4:in1+4))-ichar(cp132(ic1+3:ic1+3)) 
           if(nak.gt.0) then 
            l=l+nak 
            i10=l/10 
            i1=l-10*i10+i0 
            cp132(ic1:ic2)=char(i10+i0)//char(i1) 
            if(led.eq.0)np(ii)(in1:in1+3)=cp132(ic1-1:ic1+2) 
!            write(6,'(a,a)')'.3',np(ii)
           else 
            if(led.eq.0) np(ii)(in1:in1+4)=cp132(ic1-1:ic1+3) 
!           write(6,'(a,a)')'.4',np(ii)                                 
           end if 
           if(icol.eq.1) p(ii)=out(1) 
           if(icol.eq.2) up(ii)=out(2) 
           if(icol.eq.3) op(ii)=out(3) 
           if(icol.eq.4) ddp(ii)=out(4) 
           if(l.ne.length(icol).and.led.eq.0) then 
            call fvadjust(icol,lengthi) 
            length(icol)=lengthi 
           end if 
           icol=icol+1 
          end do 
          if(kp(ii).eq.2) call calpl('test') 
       goto 360 
      end if 
      ch2=ch132(1:2) 
      if(ch2.eq.'ll') then 
       chin=ch132(3:) 
       call fout_c(chin,cp132,j) 
!       write(6,'(a,a)') ' ll:',cp132(1:60)                             
       call trlch(40,ch132,nn,out) 
          if(nn.gt.3) nn=3 
          icol=2 
          do while(icol.le.nn+1) 
           in1=24+9*(icol-1)+4 
           ic1=9*(icol-2)+6 
           ic2=ic1+1 
           l=10*(ichar(cp132(ic1:ic1))-i0)+ichar(cp132(ic2:ic2))-i0 
           nak=ichar(np(ii)(in1+4:in1+4))-ichar(cp132(ic1+3:ic1+3)) 
           if(nak.gt.0) then 
            l=l+nak 
            i10=l/10 
            i1=l-10*i10+i0 
            cp132(ic1:ic2)=char(i10+i0)//char(i1) 
            np(ii)(in1:in1+3)=cp132(ic1-1:ic1+2) 
!           write(6,'(a,a)')'.5',np(ii)                                 
           else 
            np(ii)(in1:in1+4)=cp132(ic1-1:ic1+3) 
!           write(6,'(a,a)')'.6',np(ii)                                 
           end if 
           if(icol.eq.2) up(ii)=out(1) 
           if(icol.eq.3) op(ii)=out(2) 
           if(icol.eq.4) ddp(ii)=out(3) 
           if(l.ne.length(icol)) then 
             call fvadjust(icol,lengthi) 
             length(icol)=lengthi 
           end if 
           icol=icol+1 
          end do 
       goto 360 
      end if 
      if(ch2.eq.'ul') then 
       chin=ch132(3:) 
       call fout_c(chin,cp132,j) 
!       write(6,'(a,a)') ' ul:',cp132(1:60)                             
       call trlch(40,ch132,nn,out) 
          if(nn.gt.2) nn=2 
          icol=3 
          do while(icol.le.nn+2) 
           in1=24+9*(icol-1)+4 
           ic1=9*(icol-3)+6 
           ic2=ic1+1 
           l=10*(ichar(cp132(ic1:ic1))-i0)+ichar(cp132(ic2:ic2))-i0 
           nak=ichar(np(ii)(in1+4:in1+4))-ichar(cp132(ic1+3:ic1+3)) 
           if(nak.gt.0) then 
            l=l+nak 
            i10=l/10 
            i1=l-10*i10+i0 
            cp132(ic1:ic2)=char(i10+i0)//char(i1) 
            np(ii)(in1:in1+3)=cp132(ic1-1:ic1+2) 
!           write(6,'(a,a)')'.7',np(ii)                                 
           else 
            np(ii)(in1:in1+4)=cp132(ic1-1:ic1+3) 
!           write(6,'(a,a)')'.8',np(ii)                                 
           end if 
           if(icol.eq.3) op(ii)=out(1) 
           if(icol.eq.4) ddp(ii)=out(2) 
           if(l.ne.length(icol)) then 
             call fvadjust(icol,lengthi) 
             length(icol)=lengthi 
           end if 
           icol=icol+1 
          end do 
       goto 360 
      end if 
      if(ch2.eq.'dp') then 
       chin=ch132(3:) 
       call fout_c(chin,cp132,j) 
!       write(6,'(a,a)') ' dp:',cp132(1:60)                             
       call trlch(40,ch132,nn,out) 
          icol=4 
          in1=24+9*(icol-1)+4 
          ic1=6 
          ic2=ic1+1 
          l=10*(ichar(cp132(ic1:ic1))-i0)+ichar(cp132(ic2:ic2))-i0 
           nak=ichar(np(ii)(in1+4:in1+4))-ichar(cp132(ic1+3:ic1+3)) 
           if(nak.gt.0) then 
            l=l+nak 
            i10=l/10 
            i1=l-10*i10+i0 
            cp132(ic1:ic2)=char(i10+i0)//char(i1) 
            np(ii)(in1:in1+3)=cp132(ic1-1:ic1+2) 
!           write(6,'(a,a)')'.8',np(ii)                                 
           else 
            np(ii)(in1:in1+4)=cp132(ic1-1:ic1+3) 
!           write(6,'(a,a)')'.9',np(ii)                                 
           end if 
          ddp(ii)=out(1) 
          if(l.ne.length(icol)) then 
            call fvadjust(icol,lengthi) 
            length(icol)=lengthi 
          end if 
       goto 378 
      end if 
                                                                        
!     character .ne. number, read name                                  
  365 cp16=ch132(1:ih) 
                                                                        
!     identify name                                                     
      do j=1,npanum(mscr1+2) 
        k=npanum(j+mscr1+2) 
      if(index(np(k),cp16(1:ih)).gt.0) then 
       ii=k 
       call nextchar(ch132,ih,ipos,cp132,ip) 
       ch1=cp132(1:1) 
       if(ch1.eq.' ') goto 378 
       if(kp(ii).eq.2) then 
       write(nwr,'(2a)') 'value is calculated by the product of ',      &
        'two factors'                                                   
!       goto 378                                                        
       end if 
       in=ichar(ch1)-i0 
       if(in.ge.0.and.in.lt.10) then 
           chin=cp132 
           call fout_c(chin,ch132,j) 
           call trlch(icoln,cp132,nn,out) 
           if(nn.eq.0) np(k)(9:24)=cp132(1:ip) 
           if(nn.gt.4) nn=4 
           icol=1 
           do while(icol.le.nn) 
            in1=24+9*(icol-1)+4 
            ic1=9*(icol-1)+6 
            ic2=ic1+1 
            l=10*(ichar(ch132(ic1:ic1))-i0)+ichar(ch132(ic2:ic2))-i0 
            nak=ichar(np(ii)(in1+4:in1+4))-ichar(cp132(ic1+3:ic1+3)) 
            if(nak.gt.0) then 
             l=l+nak 
             i10=l/10 
             i1=l-10*i10+i0 
             cp132(ic1:ic2)=char(i10+i0)//char(i1) 
             np(ii)(in1:in1+3)=cp132(ic1-1:ic1+2) 
!            write(6,'(a,a)')'10',np(ii)                                
            else 
             np(ii)(in1:in1+4)=cp132(ic1-1:ic1+3) 
!            write(6,'(a,a)')'11',np(ii)                                
            end if 
            if(icol.eq.1) p(ii)=out(1) 
            if(icol.eq.2) up(ii)=out(2) 
            if(icol.eq.3) op(ii)=out(3) 
            if(icol.eq.4) ddp(ii)=out(4) 
            if(l.ne.length(icol)) then 
             call fvadjust(icol,lengthi) 
             length(icol)=lengthi 
            end if 
            icol=icol+1 
           end do 
           if(kp(ii).eq.2) call calpl('test') 
        goto 360 
       else 
         i_=index(np(k),'_') 
         do while(np(k)(i_:i_).eq.'_') 
           i_=i_+1 
         end do 
         np(k)(i_:24)=cp132(1:ip) 
!        write(6,'(a,a)')'13',np(ii)                                    
       end if 
       goto 378 
      else 
       goto 316 
      end if 
      end do 
                                                                        
!     limits                                                            
                                                                        
  360 continue 
      j=-2 
  361 j=j+3 
       j0=mprdn(j) 
       j1=mprdn(j+1) 
       j2=mprdn(j+2) 
       jj=j0*j1*j2 
      if(jj.gt.0) then 
       p(j0)=p(j1)*p(j2) 
       up(j0)=up(j1)*up(j2) 
       op(j0)=op(j1)*op(j2) 
       goto 361 
      else 
       if(j0.gt.0) then 
        n1=-10 
        infotext(1)='effi/structure/mprdn/vector' 
        infotext(2)(1:17)='** fatal error **' 
        infotext(3)='structure of mprdn vector is wrong' 
        infotext(4)=' ' 
        return 
       end if 
      end if 
                                                                        
!     parameter specified without limits                                
!     both limits = 0                                                   
                                                                        
!     parameter specified with limits                                   
!     plausibility control of limits                                    
      if(up(ii).eq.0.0.and.op(ii).eq.0.0) goto 380 
      if(op(ii)-up(ii).lt.0.0) then 
!     limits must be reserved                                           
       hu=up(ii) 
       up(ii)=op(ii) 
       op(ii)=hu 
       write(nwr,'(2a)')                                                &
       ' **limits**                reversed     ',                      &
      '                                       '                        
      end if 
!     limit exceeded                                                    
      if(p(ii)-up(ii).lt.0.) then 
       up(ii)=0. 
       op(ii)=0. 
       write(nwr,'(2a)')                                                &
       ' **** parameter out of limits : limits set to zero',            &
      '                           '                                    
       goto 380 
      end if 
      if(op(ii)-p(ii).lt.0.0) then 
       up(ii)=0. 
       op(ii)=0. 
       write(nwr,'(2a)')                                                &
       ' **** parameter out of limits : limits set to zero',            &
       '                           '                                    
      end if 
  378 ki=0 
      do k=1,npanum(mscr1+2) 
       if(npanum(k+mscr1+2).eq.ii) ki=k 
      end do 
      if(ki.eq.0) then 
        npanum(npanum(mscr1+2)+mscr1+3)=ii 
        npanum(mscr1+2)=npanum(mscr1+2)+1 
       do k=2,npanum(mscr1+2)+2 
         npanum(k)=npanum(mscr1+k) 
       end do 
       k=npanum(2)
        ih=-1
        call panum(ch132,k,npanum,ih)
        if(ih.ne.-1) then
         print'(2a)','error in the list:',TRIM(ch132)
         return
        end if         
       do k=2,npanum(2)+2 
         npanum(mscr1+k)=npanum(k) 
       end do 
      else 
       i=ki 
      end if 
                                                                        
  380 continue 
      j=-2 
  382 j=j+3 
      j0=mprdn(j) 
      if(j0.gt.0) then 
       j1=mprdn(j+1) 
       j2=mprdn(j+2) 
       p(j0)=p(j1)*p(j2) 
       goto 382 
      end if 
                                                                        
  385 continue 
      if(npanum(mscr1+2).eq.0) goto 316 
      if(i.gt.npanum(mscr1+2)) i=1 
      npa=npanum(i+mscr1+2) 
                                                                        
      ch1=' ' 
      if(ddp(npa).eq.0.0)then 
       k=index(np(npa),'*') 
       kp(npa)=3 
                                                                        
       if(k.gt.0) then 
        kp(npa)=2 
        ch1='x' 
       else 
        kp(npa)=3 
        ch1='%' 
       end if 
      else 
       if(kp(npa).eq.3) kp(npa)=1 
      end if 
      if(kp(npa).eq.0) ch1='*' 
                                                                        
!      if(led.eq.1)then                                                 
        form='i3' 
        rn=npa 
        ch2=formpr(1)(12:13) 
                                                         ! -1  20.09.07 
        nw=(ichar(ch2(1:1))-i0)*10+ichar(ch2(2:2))-i0 
                                                                        
        call trlnu(form,rn,chr,nn,chl,im) 
        chline=ch1//'p'//chl(1:4)//np(npa)(1:nw) 
!        write(6,'(a)')chline                                           
        form=np(npa)(28:32) 
        rn=p(npa) 
        call trlnu(form,rn,chr,nn,chl,im) 
        iline=6+nw 
!        write(6,'(i2,a8,a,a)')nw,form,'l chr(1:nn)=',chr(1:nn)         
        chline=chline(1:iline)//chr(1:nn) 
        iline=iline+nn 
        form=np(npa)(37:41) 
        rn=up(npa) 
        call trlnu(form,rn,chr,nn,chl,im) 
        chline=chline(1:iline)//chr(1:nn) 
        iline=iline+nn 
        form=np(npa)(46:50) 
        rn=op(npa) 
        call trlnu(form,rn,chr,nn,chl,im) 
        chline=chline(1:iline)//chr(1:nn) 
        iline=iline+nn 
        if(abs(ddp(npa)).gt.0.0) then   ! altered to abs 01.04.2015
         form=np(npa)(55:59) 
         rn=ddp(npa) 
         call trlnu(form,rn,chr,nn,chl,im) 
         chline=chline(1:iline)//chr(1:nn) 
        end if 
        call addhist(chline(6+nw:iline+nn)//ch0) 
!        write(6,'(a)')chline(6+nw:iline+nn)                            
!        write(6,'(a)')chline(1:iline+nn)                               
!        icol=icoln-10                                                  
!        if(icol.gt.80)icol=70                                          
!        write(nwr,'(a1,a5,a,a4)')                                      
!            chline(1:1),chblue, chline(2:icol),chnorm                 
!       else                                                            
        k=npa/100 
        ip=3 
        if(k.eq.0) then 
         ip=2 
         k=npa/10 
        end if 
        if(k.eq.0) ip=1 
         chflen='('//formpr(ip)//np(npa)(25:60) 
         if(kp(npa).eq.2) then 
          write(nwr,chflen) ch1,'p',npa,np(npa),p(npa) 
         else 
          write(nwr,chflen)                                             &
                   ch1,'p',npa,np(npa),p(npa),up(npa),op(npa),ddp(npa)  
         end if 
!        end if                                                         
!       end if                                                          
       goto 316 
                                                                        
  390 continue 
      return 
!     ******************************************************************
!     constants                                                         
!     ******************************************************************
  400 continue 
                                                                        
      call chconst(nll,ledit) 
      if(nll.eq.300) goto 300 
                                                                        
      return 
!     ******************************************************************
!     fix,free                                                          
!     ******************************************************************
!     n1 = number of elements nv                                        
!     kp(i)=0 parameter fixed                                           
!                                                                       
                                                                        
  500 continue 
      icoln=ncol(1) 
      ikp=0                ! fix 
      if(k1.eq.4) ikp=1    ! free  
      mscr1=maxc 
      ip=npanum(mscr1+2) 
      do k=1,ip 
        ik=npanum(k+mscr1+2) 
!        if(ik.le.mp)then                                               
         if(kp(ik).ge.0.and.kp(ik).lt.2) kp(ik)=ikp 
!        end if                                                         
      end do 
      ikp=icoln/4 
      call itoc8(ch8,ikp) 
      ch2=ch8(2:) 
!      if(ip.lt.mp)write(nwr,'('//ch2//'i4)') (npanum(k+mscr1+2),k=1,ip)
      do k=1,mco 
        kcof(k)=0 
        do ir=1,mr(k) 
         do ic=1,mc(k) 
          j=kcp(mcs(k)+ic) 
          if(kp(j).eq.1) then 
           kcof(k)=k 
           goto 508 
          end if 
         end do 
        end do 
  508   continue 
      end do 
                                                                        
      return 
!     ******************************************************************
!     show parameter and matrices                                       
!     ******************************************************************
!                                                                       
                                                                        
  600 continue 
      lq=1 
      goto 602 
  601 continue 
      lq=2 
      jjcom=npanum(2) 
      do jj=1,jjcom 
       indco(jj)=npanum(2+jj) 
      end do 
      jjco=0 
  602 continue 
                                                                        
      chtext=ADJUSTL(infotext(8)) 
      il=LEN_TRIM(chtext) 
!      write(6,'(2a)')'param chtext=',chtext(:il)                       
      ch132=chtext(1:il)//': '//queryar(lq)(:78-il) 
      mscr1=maxc 
      mscr2=mscr1+maxp 
      if(npanum(mscr1+2).le.0) then 
       call help(chcom) 
       return 
      end if 
                                                                        
  610 if(lq.eq.2) then 
       jjco=jjco+1 
       jco=indco(jjco) 
       if(jco.lt.10) then 
        ch2=char(i0+jco)//' ' 
        else if(jco.ge.10) then 
        i10=jco/10 
        i1=jco-i10*10+i0 
        ch2=char(i0+i10)//char(i1) 
       end if 
       chin='p m'//ch2 
       call paident(info,chin) 
       if(info.gt.0.or.jco.gt.mco) return 
       if(mc(jco).eq.0) goto 610 
                                                                        
       write(nwrwin,'(/a5,a,a2,a3,a16,a1,i2,a1,i2,a1,a4)')chblue,       &
       'matrix(',ch2,'): ',ncor(jco),'(',mr(jco),',',mc(jco),')',chnorm 
      end if 
                                                                        
                                                                        
      do k=0,4 
       call fvadjust(k,length(k)) 
      end do 
      length(0)=length(0)-1 
      i10=length(0)/10 
      i1=length(0)-i10*10+i0 
      ch2=char(i10+i0)//char(i1) 
!      i1=13+length(0)+length(1)+length(2)+length(3)                    
      i1=13+length(0)+length(1) 
!      write(6,'(a,4i4)')'param ncolwin,i1=',                           
!     &                   ncolwin,i1,length(0),length(1)                
        ipl=(ncolwin+12)/i1 
        ch1=char(ipl+i0) 
        il=npanum(mscr1+2)/ipl 
        if(il.eq.0)then 
         il=1 
         ir=0 
         ipl=npanum(mscr1+2) 
        else 
         ir=npanum(mscr1+2)-ipl*il 
        end if 
        jj=0 
        if(ir.gt.0) then 
         do j=1,il 
          do k=1,ipl 
           jj=jj+1 
           ind(jj)=(k-1)*il+j 
          end do 
         end do 
         do k=1,ir 
          jj=jj+1 
          ind(jj)=jj 
         end do 
        else 
         do j=1,il 
          do k=1,ipl 
           jj=jj+1 
           ind(jj)=(k-1)*il+j 
          end do 
         end do 
        end if 
        jj=npanum(mscr1+2) 
!        write(6,'(16i4)')(npanum(mscr1+2+i),i=1,jj)                    
        do k=1,ir 
         i=k*(il+1)-(k-1) 
         iir=npanum(mscr1+2+i) 
         do j=i,jj-1 
          npanum(mscr1+2+j)=npanum(mscr1+3+j) 
         end do 
         npanum(mscr1+2+jj)=iir 
        end do 
!        write(6,'(a)')' param ind(1..)'                                
!        write(6,'(16i4)')(ind(i),i=1,jj)                               
!        write(6,'(16i4)')(npanum(mscr1+2+i),i=1,jj)                    
                                                                        
      formco(1)='a5,2a1,i1,a4,3x,a'//ch2//',' 
      formco(2)='a5,2a1,i2,a4,2x,a'//ch2//',' 
      formco(3)='a5,2a1,i3,a4,1x,a'//ch2//',' 
                                                                        
      do j=1,npanum(mscr1+2) 
            ch1=' ' 
            ii=npanum(mscr1+2+ind(j)) 
            if(kp(ii).eq.0) ch1='*' 
            if(kp(ii).eq.2) then
              ch1='x'
              ddp(ii)=0.
            end if 
            if(ddp(ii).eq.0.) ch1='x' 
 
       k=ii/100 
       ip=3 
       if(k.eq.0) then 
        ip=2 
        k=ii/10 
       end if 
       if(k.eq.0) ip=1 
       iip(j)=ip 
       iind(j)=ii 
       iich(ii)=ch1 
       chcol(ii)=chred 
       if(ch1.eq.'*')chcol(ii)=chblue 
       if(ch1.eq.'x')chcol(ii)=chgreen 
      end do 
                                                                        
      if(lq.eq.1) write(nwrwin,'(i4,a)') npanum(mscr1+2),' parameter' 
      do j=1,il 
       jj=ipl*(j-1) 
       do k=1,ipl 
        i=(k-1)*32 
!        chflen(i+2:i+51)=formco(iip(jj+k))//np(iind(jj+k))(25:54)      
        chflen(i+2:i+51)=formco(iip(jj+k))//np(iind(jj+k))(25:36) 
!        chflen(i+49:i+49)='4'                                          
        chflen(i+31:i+31)='4' 
       end do 
                                                                        
       i=ipl*32+1 
       chflen(1:1)='(' 
       chflen(i:i)=')' 
!       write(6,'(a)')chflen(:100)                                      
        write(nwrwin,chflen)                                            &
        (chcol(iind(jj+k)),iich(iind(jj+k)),'p',                        &
         iind(jj+k),chnorm,np(iind(jj+k)),                              &
         p(iind(jj+k)),k=1,ipl)                                         
!     &   p(iind(jj+k)),up(iind(jj+k)),op(iind(jj+k)),k=1,ipl)          
      end do 
       chflen=' ' 
      if(ir.gt.0) then 
        jj=ipl*il 
        do k=1,ir 
         i=(k-1)*32 
         chflen(i+2:i+51)=formco(iip(jj+k))//np(iind(jj+k))(25:36) 
         chflen(i+31:i+31)='4' 
        end do 
        i=ipl*32+1 
        chflen(1:1)='(' 
        chflen(i:i)=')' 
         write(nwrwin,chflen)                                    &
        (chcol(iind(jj+k)),iich(iind(jj+k)),'p',                 &
          iind(jj+k),chnorm,np(iind(jj+k)),                      &
        p(iind(jj+k)),k=1,ir)                                          
!     &   p(iind(jj+k)),up(iind(jj+k)),op(iind(jj+k)),k=1,ir)           
      end if 
      if(lq.eq.2.and.jjco.lt.jjcom) goto 610 
                                                                        
      return 
      END                                           
                                                                        
                                                                        
     subroutine subtest(comline,chisqmin,info) 
     use glbconst, only: maxs,nwr,enwr
     use compar, only: nwrwin
     
     use comfrm, only: p,pmin,mp,kp,minsets
     use comdas, only: nametheory
     use comdat, only: b_datset
     use comths, only: nfit,ntest,kf,chitest
     use comeff, only: ndispmode,ncol
     use comscd, only: npanum
     implicit none
                                                                       
     integer iter,info,j1,mf,mfout,ks,npunch,n1,iter_count,ihasch 
     real    pathw,path1,path2,chisqmin,ochisq,chisq,chi_p,t 
                                                                       
     character(len=132):: comline,chstring,ch132,cp132
     character(len=4)  :: cmch
     
     character(len=32) :: intptr
     common/wptr/intptr(maxs) 

     integer kshandle,whandle,hold,idum  
     common/win/kshandle,hold,whandle(maxs),idum(18*maxs+404)
                                                                       
     integer i,k,j,ii,iiq,ncl 
     logical b_dataone,b_const


     ochisq=0.0
     ncl=ncol(1)                                                       
     chstring=' ' 
     ihasch=index(comline,'#') 
     if(ihasch.gt.0)comline(ihasch:ihasch)=' ' 
                                                                        
     i=index(comline,'&&') 
  10 nfit(0)=0 
     if(i.gt.0) then 
      ch132=chstring 
      j1=132 
      do while(comline(j1:j1).eq.' ') 
       j1=j1-1 
      end do 
      chstring=comline(i:j1+1)//ch132 
      comline(i:)=' ' 
     end if 
     call ks_select(comline,info) 
     i=index(comline,'&&') 
     if(i.gt.0)goto 10 

     iiq=index(comline,' q') 
     if(comline(1:1).eq.'*') goto 1 
     if(comline.ne.' ') then 
      ch132=TRIM(comline)//' '//chstring 
      chstring=ch132 
     end if 
!    write(6,'(2a)')'## ',chstring(:70)                                
     ntest(0)=npanum(2) 
     do k=1,ntest(0) 
      ntest(k)=npanum(k+2) 
     end do 
                                                                       
     if(ihasch.gt.0) write(nwr,'(1x,a1,a3)') char(27),'[2A' 
                                                                       
!    write(6,'(a,10i4)') 'ntest(0)=',ntest(0)                         
!    write(6,'(20i4)') (ntest(k),k=1,ntest(0))                        
                                                                       
     mf=0 
     do k=1,mp 
      if(kp(k).eq.1) then 
       mf=mf+1 
       kf(mf)=k 
      end if 
     end do 
                                                                       
     cmch='test' 
     call fit(cmch,mf,mfout,iter_count,pathw,                   &
              chisqmin,ochisq,chisq,chi_p,path1,path2,info) 
     mf=mfout        
     if(info.gt.0) goto 1 

     do k=1,ntest(0) 
      ks=ntest(k) 
      if(.not.b_datset(ks))then 
       j1=1 
       write(nwr,'(a,/,a)')'*no data, simulation of the theory: ',&
                nametheory(ks)(:80)                                    
       call cvdata(ks,b_const,iiq) 
       cmch='test'; call frametheory(ks,cmch,j1,info)
       if(info.gt.0) goto 1 
      end if 
!     write(6,'(a,2i4)')' efficmd test ks,whandle=',ks,whandle(ks)     
      if(whandle(ks).ge.0) then 
       n1=ndispmode(ks) 
       cmch='plot'; call frametheory(ks,cmch,n1,info) 
       if(info.gt.0) goto 1 
                                                                       
!      write(6,'(a,2i4)')' efficmd test ks,whandle=',ks,whandle(ks)    
       kshandle=ks 
       cmch='ple2'; call frametheory(ks,cmch,n1,info) 
      if(info.gt.0) goto 1 
      end if 
     end do 
     
     npunch=npunch+1 
                                                                        
     b_dataone=.false. 
     do i=1,ntest(0) 
      ks=ntest(i) 
      b_dataone=b_dataone.or.b_datset(ks) 
     end do 
     if(b_dataone) then 
      t=1000. 
      if(chi_p.gt.99.9) chi_p=99.9
      if(chisq.lt.t) then 
       ch132='(a,f8.3,2x,f5.1,a,a,ES9.1)' 
      else 
       ch132='(a,e10.3,2x,f5.1,a,a,ES9.1)' 
      end if 
      if(ntest(0).eq.1) then
       if(abs(chitest(0)).gt.0.)then 
        write(nwrwin,ch132) '   chi**2=',chisq,chi_p,'% <sigma',   &
              '    misfit=',chitest(0)                                 
       else
         write(nwrwin,ch132) ' chi**2=',chisq,chi_p,'% <sigma'  
       end if
      else
       if(abs(chitest(0)).gt.0.)then 
        write(nwrwin,ch132) ' <chi**2>=',chisq,chi_p,'% <sigma', &
              '    <misfit>=',chitest(0)                                 
       else
         write(nwrwin,ch132) ' <chi**2>=',chisq,chi_p,'% <sigma'  
       end if
      end if
      if(ntest(0).gt.1)then
       if(ntest(0).lt.10) then 
        if(chisq.lt.t.and.chi_p.lt.t) then 
         ch132='(1x,16(f9.3,a1,i1,a1))' 
         cp132='(a,16(f9.3,a1,i1,a1))' 
         k=ncl/13 
        else 
         ch132='(1x,16(e10.3,a1,i1,a1))' 
         cp132='(a,16(e10.3,a1,i1,a1))' 
         k=ncl/14 
        end if
       else
        if(chisq.lt.t.and.chi_p.lt.t) then 
         ch132='(16(f9.3,a1,i2,a1))' 
         cp132='(a,16(f9.3,a1,i2,a1))' 
         k=ncl/13 
        else 
         ch132='(16(e10.3,a1,i2,a1))' 
         cp132='(a,16(e10.3,a1,i1,a1))' 
         k=ncl/14 
        end if 
       end if
       ii=ntest(0)/k 
       if(ii.eq.0)then
         write(nwrwin,cp132)'pa fixed:',                       &
                  (chitest(i),'(',ntest(i),')',i=1,ntest(0))
       else
        ii=ntest(0)/k
        do j=1,ii
         if(j.eq.1) write(nwrwin,cp132)'pa fixed:',              &
          (chitest(i),'(',ntest(i),')',i=1,k-1)
         if(j.gt.1)write(nwrwin,ch132)                               &
                      (chitest(i),'(',ntest(i),')',i=(j-1)*k,j*k-1)    
        end do 
        if(k*ii-1.lt.ntest(0))write(nwrwin,ch132)                    &
                    (chitest(i),'(',ntest(i),')',i=ii*k,ntest(0))    
       end if
      end if
     end if 

     iter=0 
     if(chisq.lt.ochisq.or.ochisq.eq.0.0) then 
      if(ochisq.lt.1.0e6) then
       ochisq=chisq 
       do ii=1,mp 
        pmin(ii)=p(ii) 
       end do 
      end if
       do ii=0,ntest(0) 
        minsets(ii)=ntest(ii) 
       end do 
     end if 
                                                                       
     comline=chstring 
1     if(enwr(5).eq.'avch')then
      t=0.
      do i=1,ntest(0)
       t=t+abs(chitest(i)-chisq)
      end do
      t=t/ntest(0)
      print '(a,f10.3)',' average deviation from mean of chi**2:',t
     end if

     return 
     END                                           
