     subroutine theostr(ks,cmch,scriptfile,info) 
     use glbconst, only: maxfr1,maxfr2,maxs,maxp,maxc,maxpl,maxthlv,  &
                         maxthss,maxvaco,b_noask,                    &
                         maxco,maxcom,maxscr,maxscrd,infotext,nwr,nrd
     use compar, only: maxdimco,maxsto,icstrf
     use comeff, only: idpmat,dpmat,strco,strth,strtm,idistsites,     &
                       chsite,nu_sdevice,mvadds,mcadds,npl,ncol
     use comfrm, only: ncon,ivadd,ivaddsp,icadd,icaddsp,np,mpl,mcl
     use comdat, only: b_datset
     use comdas, only: ktheo,nametheory,namedata,istrss
     use comstr, only: itheory,ntheory,jtheory,kssthe,nameth_as,nstruct,strcmt, &
                       ndevice,ndev,lp_handbook,nfrtheo,i_theoset,itheoset
     use comsto, only: nstrco,nstrth,nstrtm
     use comscd, only: npanum,helpar,queryar,ext
     implicit none 
      
     integer, intent(inout):: ks
     character(len=4), intent(inout):: cmch
     character(len=132), intent(in):: scriptfile
     integer, intent(out):: info

 

     character(len=132):: chin,querytype,ch132,ct132,cask,namefr, &
                          chcom,strcmtcorr,nhelpentry,script 
     character(len=80) :: chdf
     character(len=64) :: thframename
     character(len=34) :: ynch 
     character(len=32) :: nhandbook  
     character(len=24) :: chl,chr,nheader1,nheader2
     character(len=16) :: ch16,exten
     character(len=8)  :: chext
     character(len=7)  :: form
     character(len=4)  :: ch4
     character(len=3)  :: chprf
     character(len=2)  :: ch2,nstruct0,nstruct1
     character(len=1)  :: ch1,wrb,corrall,corr_old,go,ig,cLP

     character(len=80), dimension(0:3)   :: nameth_level
     character(len=2),  dimension(maxthss):: nloop
     character(len=2),  dimension(maxfr2) :: nstr1
     character(len=2),  dimension(maxthss):: nstr2
     character(len=1),  dimension(27), save:: cig
     
     integer, dimension(0:maxthss):: mfr2
     integer, dimension(0:maxfr2,0:8):: idpmlay
     integer, dimension(0:maxthss)   :: nstrhss
     integer, dimension(8)           :: iquery_o
     integer, dimension(maxs)        :: numv

     logical   b_exist,b_modify,truedist

     integer   i,ii,ia,i0,i1,i10,icall,ientry,il,istr2,istr3,          &
               im,i1ext,i2ext,iset,iv,maskp,                           &
               ithjlist1,ithjlist2,j,jj,ja,jfr,jfrtheo,jlist,jtask,    &
               k,kfr,l,levelth,l_jfrtheo,lk,loop,lup,l_name,           &
               lstruct1,lstruct2,lup_fr2,lup_ss,ms,                    &
               mscr1,mscr2,nistr2,nerr,nn,npll,nstrcoss,isite,         &
               ls1,idistdif,idpm_rem,                                  &
               n_trmatrix,inlaysite,ipart,number_device,icomp,ntrimto0
     integer, save:: ls,mss
     integer       mstruct1,istruct1,istruct2,idumc 
     integer,parameter:: idum=3*(maxfr1+1+maxfr2+maxthss)+32+8 
     common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),idumc(idum)
                                                                       
!     dimension istruct1(0:maxfr1),istruct2(0:maxfr2)                  
!    &          numstr1(maxfr1),numstr2(maxfr2),numss(maxthss)  ! 10.06
                                                                       
     real      dumcsp,alowlimit,uplimit,value,rn 
     integer, parameter:: idumcsp=icstrf-16
     common/acstrf/dumcsp(idumcsp),thframename 
                                                                        
     character(len=24), dimension(:,:,:), allocatable::cdpmat

!     write(6,'(a,i5,a)') 'theostr  ks=',ks,cmch                          
      if(cmch.eq.'name') then 
!      names of the frame theories                                      
       nhelpentry=' ' 
       jfrtheo=ktheo(ks,0,1) 
       l_jfrtheo=ktheo(ks,0,2) 
       call getfrstring(jfrtheo,l_jfrtheo,lstruct1,lstruct2,cmch,nhelpentry)
       nametheory(ks)=ntheory(l_jfrtheo)
! -----------------------------------------------        
       return 
      end if 
!---------------------------------                                      
      i0=ichar('0') 
      iA=ichar('A')-10 
      ja=ichar('a')-36 
      idpm_rem=0 
      b_modify=.false. 
!      write(6,'(a,/,60i4,/)')'theostr ipladd:',(ipladd(j),j=1,60)      
                                                                        
      if(scriptfile.eq.' ') then 
       script='theory.scr' 
       il=1 
      else 
       il=-1 
       script=scriptfile 
      end if 
                                                                        
      if(b_noask) then 
       jtask=5 
       wrb='r' 
       goto 10 
      end if 
                                                                        
      helpar(1)='effi/structure/script/without' 
      helpar(2)='effi/structure/script/write' 
      helpar(3)='effi/structure/script/read' 
      helpar(4)='effi/structure/modify' 
      queryar(1)='without script file' 
      queryar(2)='write a script file' 
      queryar(3)='read a script file' 
      queryar(4)='modify a theory model' 
      lk=4 
      do k=1,lk 
        ext(k)=' ' 
      end do 
      wrb='l' 
      jtask=lk 
      chdf=queryar(1) 
      chdf(80:80)='#' 
      chin='handling sript file' 
      chin(132:132)=wrb 
      if(il.eq.1) then 
        call query(jtask,lk,chin,chdf) 
        if(jtask.eq.0) return 
      else 
       jtask=3 
      end if 
                                                                        
   10 continue 
      if(jtask.gt.1) then 
       if(jtask.eq.2) then 
        write(nwr,'(a)')'script file for the decision tree' 
        wrb='w'
        ls=0
       end if 
       if(jtask.eq.3) then 
        write(nwr,'(a)')'reading the decision tree from file' 
        wrb='r' 
       end if 
       if(jtask.eq.4) then  ! modify 
                                                                        
        if(b_modify) then 
         ls=ks+1 
         if(abs(ktheo(ls,0,0)).eq.0)then 
          b_modify=.false. 
          goto 10 
         end if 
        else 
         ls=1 
         do while(abs(ktheo(ls,0,0)).eq.0.and.ls.lt.maxs) 
          ls=ls+1 
         end do 
        end if 
        if(ls.eq.maxs.and.abs(ktheo(ls,0,0)).eq.0.) then 
         write(nwr,'(a)')' no theory yet defined' 
         return 
        end if 
        ch132='li sets' 
        call list(ch132,0,info) 
        querytype='set to be modified' 
        form='i3' 
        chcom='effi/structure/modify' 
                                                                        
        value=ls 
        call askvalue(querytype,form,value,chcom,npl,nrd,nwr) 
        if(querytype(1:1).eq.'*'.or.querytype(1:1).eq.'q') then
         if(cmch.eq.'mdfy')then
         info=1 
         infotext(1)='effi/modify'
         infotext(2)='regard the following instructions- /return ' 
         infotext(3)=' ' 
         call save_modified
         end if
         return
        end if 
        ks=value 
        if(ks.gt.maxs) ks=ls 
        b_modify=.true. 
        cmch='mdfy' 
        helpar(1)='effi/structure/append/module' 
        helpar(2)='effi/structure/insert/component' 
        helpar(3)='effi/structure/delete' 
        queryar(1)='append a module' 
        queryar(2)='insert a component' 
        queryar(3)='remove component/empty module' 
        lk=3 
        do k=1,lk 
         ext(k)=' ' 
        end do 
        wrb='l' 
        jlist=lk 
        chdf=queryar(1) 
        chdf(80:80)='#' 
        chin='inserting/deleting a module/component' 
        chin(132:132)=wrb 
        call query(jlist,lk,chin,chdf) 

        if(jlist.eq.0)then
         info=1 
         infotext(1)='effi/modify' 
         infotext(2)='regard the following instructions- /return ' 
         infotext(3)=' '
         return 
        end if
        if(jlist.le.2)inlaysite=jlist 
        if(jlist.eq.3) then 
    8    call remove(ks,ls,info) 
         if(ls.gt.0) then 
          i=istrss(ks,ls+1) 
          if(istrss(ks,ls).lt.0.and.i.gt.0) then 
           write(nwr,'(a)')char(27)//                                   &
            '[1m module still contains components'//char(27)//'[0m'      
           goto 8 
          end if 
          call del(ks,ls) 
         else if(ls.eq.0) then 
          goto 10 
         else if(ls.lt.0) then 
          write(nwr,'(a)')'devices cannot be removed (use {rm} a set)' 
         end if 
         goto 8 
        end if 
        goto 15 
       end if 
                                                                        
       chcom='effi/script/file' 
       ch132='script' 
       exten='scr'
       if(il.gt.0)call rdfname(ch132,script,exten,chcom,npl,nwr) 
                  
       if(script.eq.' ') then 
        write(nwr,'(2a)') 'no script file choosen;',                    &
                        'proceeding without a script file'             
        wrb='l' 
       else 
        inquire(file=script,exist=b_exist) 
!        write(6,'(a,l5,2x,a)')' b_exist=', b_exist,script(:40)         
        if(b_exist) then 
         open(unit=10,file=script                                       &
                   ,status='old'                                        &
                   ,access='sequential'                                 &
                     ,form='formatted')                                    
        else if(jtask.eq.2) then 
          open(unit=10,file=script                                      &
                    ,status='new'                                       &
                    ,access='sequential'                                &
                      ,form='formatted')                                    
         else 
          wrb='l' 
          write(nwr,'(a,a)')'no sript file: ',TRIM(script) 
          if(jtask.eq.5) return 
        end if 
       end if 
      end if 
!      write(6,'(a,a1,//)')'theostr wrb=',wrb                           
                                                                        
!------------------------------------------------------------           
   15 info=0 
                                                                        
      dpmat=' ' 
      idpmat=0 
      mfr2=0 
      idpmlay=0 
      do k=1,maxvaco 
        strco(k)=' ' 
        strth(k,1)=' ' 
        strth(k,2)=' ' 
      end do 
      do k=1,maxco 
        strtm(k,1)=' ' 
      end do 
                                                                        
      corrall=' ' 
      go=' ' 
      nameth_as=' ' 
      nstrco(0)=0 
      nstrth(0,1)=0 
      nstrth(0,2)=0 
      nstrtm(0)=0 
       do k=1,16 
       itheory(k,1)=0 
       itheory(k,2)=0 
       end do 
                                                                        
      if(b_modify)then 
          jfrtheo=ktheo(ks,0,1) 
          l_jfrtheo=ktheo(ks,0,2) 
          call getname(0,jfrtheo,l_jfrtheo,nhelpentry,namefr) 
          goto 17 
      end if 
                                                                        
      do k=0,maxthss 
       istrss(ks,k)=0 
       nstrhss(k)=k 
      end do 
                                                                        
                                                                        
      jlist=0 
      jfr=0 
      kfr=1 
      do while(jfr.lt.kfr) 
       nhelpentry=' ' 
       jfr=jfr+1 
       kfr=jfr 
       l_jfrtheo=1 
       cmch='name' 
       call getfrstring(kfr,l_jfrtheo,lstruct1,lstruct2,cmch,nhelpentry)
       i=1
       do while(ntheory(i).ne.' ')
        jlist=jlist+1 
        queryar(jlist)=ntheory(i)
        itheory(jlist,1)=jfr 
        itheory(jlist,2)=i
        i=i+1  
       end do
!       write(6,'(a)') queryar(jlist)(:80)                               
      end do 
                                                                        
      do k=1,jlist 
       i1=itheory(k,1) 
       i10=i1/10 
       i1=i1-10*i10 
       chext(1:4)='fr'//char(i10+i0)//char(i1+i0) 
       i1=itheory(k,2) 
       i10=i1/10 
       i1=i1-10*i10 
       chext(5:8)=char(i10+i0)//char(i1+i0)//'  ' 
       helpar(k)='theory/'//chext//'/'//queryar(k) 
      end do 
!     --------------------------------------------------------'         
                                                                        
      lk=jlist 
      do k=1,lk 
        ext(k)=' ' 
      end do 
      chdf=queryar(1) 
      chdf(80:80)='#' 
      chin='global theories' 
      chin(132:132)=wrb 
      call query(jlist,lk,chin,chdf) 
      if(jlist.eq.0) then 
       close(unit=10) 
       return 
      end if 
!     frametheory number  choosen                                       
                                                                        
      cmch='name' 
      jfrtheo=itheory(jlist,1) 
      l_jfrtheo=itheory(jlist,2)

      kfr=jfrtheo 
      nhelpentry=' ' 
      call getfrstring(kfr,l_jfrtheo,lstruct1,lstruct2,cmch,nhelpentry)
      cig=' '
      do i=1,27
         i_theoset(i)=itheoset(i,l_jfrtheo)
         cig(i)=char(i_theoset(i)+i0)
       if(i_theoset(i).eq.9)cig(i)='i'
      end do
      namefr= ntheory(1)
      do k=1,3
       ndevice(k)=ndev(k) 
      end do
      
   17 ch132=namefr 
                                                                        
      il=ntrimto0(ch132) 
      if(il.lt.npl-16) then 
       write(nwr,'(2a)')'GLOBAL THEORY :',ch132(:il) 
      else 
       write(nwr,'(a,/,a)')'GLOBAL THEORY :',ch132(:il) 
      end if 

      if(b_modify) goto 31                  ! modify    
      npll=80 
      querytype='(n)'//TRIM(nhelpentry)//' for set number' 
      form='i2' 
      chcom='effi/setnumber/select' 
      alowlimit=1 
      uplimit=maxs 
                                                                        
      value=ks 
   30 if(wrb.ne.'r') call askvallim(querytype,form,                     &
                       alowlimit,uplimit,value,chcom,npll,nrd,nwr)     
                                                                        
      if(ktheo(ks,0,0).gt.0) then 
       write(nwr,'(a,i2,2a)') ' ***  set=',ks,                          &
                              ' is occupied:',ch132(1:il)               
       goto 30 
      end if 
      ks=value !     ks choosen                                                        
                                                                        
!      call savearsp(12) 
      call zerosto 
!############-----------------------------------------###############   
   31 nametheory(ks)=namefr 
      nameth_as=namefr 
                                                                        
      if(b_datset(ks)) write(nwr,'(a,/)') namedata(ks) 
      lup_fr2=maxfr2 
      lup_ss=maxthss 
      lstruct1=0 
      lstruct2=0 
      istruct1(0)=0 
      istruct2(0)=0 
      mss=0 
      nerr=1 
      ithjlist1=itheory(jlist,1) 
      ithjlist2=itheory(jlist,2) 
      kssthe(0)=2 
      kssthe(1)=ithjlist1 
      kssthe(2)=ithjlist2 
                                                                        
      strco(1)='#end#    0  ' 
      strco(2)='#beg#' 
      strtm(1,1)='#end#    0  ' 
      strtm(2,1)='#beg#' 
      do k=1,maxvaco 
       strth(k,1)=' ' 
       strth(k,2)=' ' 
      end do 
                                                                        
      ientry=-1 
      call  handbook(wrb,ientry,info) 
!     lp_handbook is put to 0, ientry=0                                 
                                                                        
!     call for handbook on level 0                                      
      cmch='hdbk' 
      nhelpentry=' ' 
      kfr=jfrtheo 
      call getfrstring(kfr,l_jfrtheo,lstruct1,lstruct2,cmch,nhelpentry) 
      ientry=0 
      i=index(nstruct,'handbook') 
      if(i.gt.0) then 
       if(b_modify)then 
        j=index(nstruct,'.hdb') 
        nhandbook=nstruct(i+9:j+3) 
        call gethdb(i,nhandbook) 
        ch4='hdb'//char(i+i0) 
        i=1 
        do while(index(ncon(i),ch4).eq.0.and.i.lt.mcl) 
         i=i+1 
        end do 
        j=index(ncon(i),ch4) 
        if(j.gt.0)lp_handbook=ichar(ncon(i)(j+4:j+4))-i0 
       else 
        call handbook(wrb,ientry,info) 
       end if 
      end if 
      if(info.gt.0) goto 1020 
                                                                        
      if(b_modify) then 
        call theostrins(ks,inlaysite,info) 
        cmch='mdfy' 
        if(info.gt.0) goto 1020 
        goto 10 
      end if 
                                                                        
!-----------------------------------------------------------------------
!     call for frame theories (branch of frame theories)                
!     first branch provides the number l_jfrtheo of the if(l_jfrtheo...)
!     in the subroutines  frstr_...f: example synchrotron               
!                                                                       
!                         Synchrotron source                            
!                               / \                                     
!     Synchrotron transmission       Synchrotron reflection             
!                                           |                           
!                                     time domain reflection spectrum'  
!                                     time integral - rocking curve'    
!                                     prompt - rocking curve'c          
!        if(wrb.eq.'w')write(10,'(a)')'[g]'                             
      if(wrb.eq.'r') then 
       read(10,'(a)')ch4 
       do while(ch4(3:3).eq.']') 
        if(ch4(2:2).eq.'b') then 
         wrb='w' 
         backspace 10 
         write(10,'(a3)')'[g]' 
        end if 
        if(wrb.eq.'r')then 
         read(10,'(a)')ch4 
        else 
         ch4='end' 
        end if 
       end do 
       if(wrb.eq.'r')backspace 10 
      end if 
                                                                         
      chprf=' ' 
      do i=1,8 
       iquery_o(i)=0 
      end do 
      ynch=' ' 
      levelth=2 
      call seltheory(levelth,cmch,nhelpentry,iquery_o,wrb,info) 
      if(levelth.eq.3)l_jfrtheo=kssthe(4)
      
!    write(6,'(i3,a,10i4)')jfrtheo,'   kssthe=',(kssthe(k),k=0,kssthe(0))        
                                                                        
!    entry in subroutines  frstr_...f and reading the part of label 100 
!    which is the global part  (lstruct1=0) of the theory:              
!    common/acstrf and /avstrf                                          
      cmch='empt' 
      kfr=jfrtheo 
      nhelpentry=' ' 
      call getfrstring(kfr,l_jfrtheo,lstruct1,lstruct2,cmch,nhelpentry)
      jtheory=l_jfrtheo
!     call for further branch of frame theories                         
!     example above: in case of Synchrotron reflection                  
!     constants and variables belong to the global part  (lstruct1=0)   
!     Their relative address in the common block is later or changed to 
!     an absolute address (the highest address already used is added)   
!      levelth=2                                                        

      nfrtheo=l_jfrtheo  ! used in str_files.f90
      chcom=strcmt(4)
      call help(chcom)
      
                                                                        
      do i=1,8 
       iquery_o(i)=0 
      end do 
      do while(cmch.ne.'ende')
       call seltheory(levelth,cmch,nhelpentry,iquery_o,wrb,info) 
       if(info.gt.0) goto 1020 
      end do 
                                                                        
!       j=1                                                             
!       do while(strco(j)(:5).ne.'#beg#')                               
!        write(6,'(i3,2x,a)')j,strco(j)(:60)                            
!        j=j+1                                                          
!       end do                                                          
                                                                        
      do k=0,kssthe(0) 
       ktheo(ks,mss,k)=kssthe(k) 
      end do 
!      write(6,'(a,10i4)')'kssthe=',(kssthe(k),k=0,kssthe(0))           
!      j=1                                                              
!      do while(strco(j)(1:5).ne.'#beg#')                               
!       write(6,'(i3,a)')j,strco(j)(:60)                                
!       j=j+1                                                           
!      end do                                                           
!---------------------------------------------------------------------  
                                                                        
      ch132=nameth_as 
      l_name=LEN_TRIM(ch132) 
!      write(6,'(3(a,/))')'2nameth_as,namefr:',nameth_as(:80),namefr(:80
      if(ch132(1:l_name).ne.namefr(1:l_name)) then 
!      then there exist a branch of frame theories;                     
!      nameth_as is the last one. The code starts again with  namefr    
       namefr=nameth_as 
       nameth_as(l_name+1:l_name+2)='_00' 
!------------------------------------------------------------------     
       call analyse_frame(ks,kssthe(0),info) 
       if(info.gt.0) goto 1020 
!------------------------------------------------------------------     
                                                                        
!       write(6,'(2a,/,2a)')'nameth_as=',nameth_as(:80),                
!     &                    '   namefr=',namefr(:80)                     
!      call theories on frame level (0)                                 
!       levelth=2                                                       
                                                                        
      if(wrb.eq.'r') then 
       read(10,'(a)')ch4 
       do while(ch4(3:3).eq.']') 
        if(ch4(2:2).eq.'b') then 
         wrb='w' 
         backspace 10 
         write(10,'(a3)')'[g]' 
        end if 
        if(wrb.eq.'r')then 
         read(10,'(a)')ch4 
        else 
         ch4='end' 
        end if 
       end do 
       if(wrb.eq.'r')backspace 10 
      end if 

       cmch='empt' 
       do i=1,8 
        iquery_o(i)=0 
       end do 
       ynch=' ' 
       do while(cmch.ne.'ende') 
!       write(6,'(3(a,/))')'nameth_as,namefr:',nameth_as(:80),namefr(:80)
        nhelpentry(131:131)=cig(1) ! ##1    
        call seltheory(levelth,cmch,nhelpentry,iquery_o,wrb,info)
        if(info.gt.0) goto 1020 
       end do 
                                                                        
       do k=0,kssthe(0) 
        ktheo(ks,mss,k)=kssthe(k) 
       end do 
                                                                        
                                                                        
       if(wrb.eq.'w')write(10,'(a)')'[g]' 
       if(wrb.eq.'r') then 
        read(10,'(a)')ch4 
        do while(ch4(3:3).eq.']') 
         if(ch4(2:2).eq.'b') then 
          wrb='w' 
          backspace 10 
          write(10,'(a3)')'[g]' 
         end if 
         if(wrb.eq.'r')then 
          read(10,'(a)')ch4 
         else 
          ch4='end' 
         end if 
        end do 
        if(wrb.eq.'r')backspace 10 
       end if 
                                                                        
       lup=maxfr1 
       loop=0
       ig=' '
       call strloop(lup,loop,nloop,nheader1,wrb,corrall,ig,info) 
       if(info.gt.0) goto 1020 

       if(nheader1(1:4).eq.'back')then 
        call startagain 
        ktheo(ks,0,0)=0 
        wrb='r' 
        rewind 10 
        goto 15 
       end if 
       mstruct1=loop 
       nstruct0=nloop(1) 
       chext='________' 
       j=ks/10 
       if(ks.lt.10)then 
        ch2=' '//char(ks+48) 
        chext(1:3)=ch2(2:2)//nstruct0 
       else 
                                                    ! 30.10.07          
        j=ks/10 
        ch2=char(j+48)//char(ks-10*j+48) 
        chext(1:4)=ch2//nstruct0 
       end if 
                                                                        
       if(wrb.eq.'w')write(10,'(a)')'[g]' 
       if(wrb.eq.'r') then 
        read(10,'(a)')ch4 
        do while(ch4(3:3).eq.']') 
         if(ch4(2:2).eq.'b') then 
          wrb='w' 
          backspace 10 
          write(10,'(a3)')'[g]' 
         end if 
         if(wrb.eq.'r')then 
          read(10,'(a)')ch4 
         else 
          ch4='end' 
         end if 
        end do 
        if(wrb.eq.'r')backspace 10 
       end if 

      if(index(ynch,'#').gt.0) nstrhss(mss)=nstrhss(mss-1) 
       go=cig(2);   i_theoset(0)=2   ! ##1a
       call strsto(chext,chprf,ynch,mss,wrb,corrall,go,info) 
       if(info.gt.0) goto 1020
      end if
      mss=mss+1 
!---------------------------------------------------------------------  
      if(wrb.eq.'w')write(10,'(a)')'[g]' 
      if(wrb.eq.'r') then 
       read(10,'(a)',end=111)ch4 
       do while(ch4(3:3).eq.']') 
        if(ch4(2:2).eq.'b') then 
         wrb='w' 
         backspace 10 
         write(10,'(a3)')'[g]' 
        end if 
        if(wrb.eq.'r')then 
         read(10,'(a)')ch4 
        else 
         ch4='end' 
        end if 
       end do 
       if(wrb.eq.'r')backspace 10 
      end if 
      goto 112 
  111 continue 
      info=1 
      infotext(1)='effi/theostr/script/eof' 
      infotext(2)(1:19)='*** fatal error ***' 
      infotext(3)='read command reached end of sript file' 
      infotext(4)=' ' 
      goto 1020 
  112 continue 
!      write(6,'(2a,/,2a)')'nameth_as=',nameth_as(:70),                 
!     &                    '   namefr=',namefr(:70)                     
                                                                        
      do k=1,3 
       nameth_level(k)=TRIM(namefr)//'_'//char(k+i0) 
!      write(6,'(i2,2x,2a)')k,'nameth_as=', nameth_level(k)(:60)        
      end do 
                                                                        
!     frame theory calls theories on frame level lstructi, i=1,2,3      
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~  
      if (.not.allocated(cdpmat))allocate(cdpmat(8,0:3,0:maxfr2))
      cdpmat=' ' 
      ipart=0
! mstruct1-------------------  
      do lstruct1=1,mstruct1
       maskp=( lstruct1-1)*11
       lstruct2=0 
       corrall=' ' 
       write(nwr,'(a)') 
                                                                        
       do k=1,maxvaco 
        strco(k)=' ' 
        strth(k,1)=' ' 
        strth(k,2)=' ' 
       end do 
       do k=1,maxco 
        strtm(k,1)=' ' 
       end do 
       strcmt(4)=' ' 
                                                                        
       strco(1)='#end#    0  ' 
       strco(2)='#beg#' 
       strtm(1,1)='#end#    0 ' 
       strtm(2,1)='#beg#' 
                                                                        
       kssthe(0)=2 
       kssthe(1)=ithjlist1 
       kssthe(2)=ithjlist2 
                                                                        
!      call for handbook at frame level (1)                             
       cmch='hdbk' 
       nhelpentry=' ' 
       kfr=jfrtheo 
       call getfrstring(kfr,l_jfrtheo,lstruct1,lstruct2,cmch,nhelpentry)
       nu_sdevice(ks,lstruct1)=number_device(lstruct1) 
       
       ientry=0 
       i=index(nstruct,'handbook') 
       if(i.gt.0) call handbook(wrb,ientry,info) 
       if(info.gt.0) goto 1020 
                                                                        
       nhelpentry=' ' 
       cmch='empt' 
       kfr=jfrtheo 
       call getfrstring(kfr,l_jfrtheo,lstruct1,lstruct2,cmch,nhelpentry)
!       write(6,'(2a)') 'theostr-365  nhelpentry=',nhelpentry(:50)      
        ct132=strcmt(1)
        call nextchar(ct132,0,i,ch132,l) 
        ct132=ch132(:l) 
        ch1=' ' 
        call chcenter(ct132,ch1,npl) 
                                          ! 200  mstruct1 (lstruct2=0)  
        write(nwr,'(a)') ct132(:npl) 
                                                                        
!      incoherent_part  pj       l         #  1#  is changed to         
!      incoherent_part  p1       l         #  1#                        
!      incoherent_part  p2       l         #  1#    etc                 
                                                                        
       i=index(strcmt(1),'j  ') 
       if(i.gt.0) then 
        if(mstruct1.gt.1) then 
         ipart=ipart+1 
         ct132=strcmt(1) 
         call nextchar(ct132,2,i,ch132,l) 
         strcmt(1)(i+1:i+1)=char(ipart+i0) 
        end if 
       end if
     
       i=i0+nu_sdevice(ks,lstruct1) 
       nameth_as=nameth_level(1)(:l_name+2)//char(i) 

       do i=1,8 
        iquery_o(i)=0 
       end do 
       ynch=' ' 
       levelth=2
       nhelpentry(131:131)=cig(3) ! ##2       
       do while(cmch.ne.'ende') 
       call seltheory(levelth,cmch,nhelpentry,iquery_o,wrb,info) 
        if(info.gt.0) goto 1020 
       end do 
                                                                        
!       write(6,'(a,i3)')'591b strloop lstruct1=',lstruct1              
!       write(6,'(a)')strcmt(2)                                         
!       write(6,'(a)')strcmt(3)                                         
!       write(6,'(a)')strcmt(4)                                         
                                                                        
       do k=0,kssthe(0) 
        ktheo(ks,mss,k)=kssthe(k) 
       end do 
       lup=lup_fr2 
       ig=cig(4); i_theoset(0)=4 ! ##2a 
!       write(6,'(a,10a4)')'loop nloop=',(nloop(i),i=1,loop)
       call strloop(lup,loop,nloop,nheader1,wrb,corrall,ig,info) 
!       write(6,'(a,10a4)')'loop nloop=',(nloop(i),i=1,loop)
                                                                        
       if(nheader1(1:4).eq.'back')then 
        call startagain 
        wrb='r' 
        rewind 10 
        ktheo(ks,0,0)=0 
        goto 15 
       end if                                                                         
                                                                        
!       write(6,'(a,2i4,2a4,a24)') &                                     
!         '794 a theostr lup,loop,nloop(1..2),nheader1=',&              
!                  lup,loop,nloop(1),nloop(2),nheader1                 
                                                                        
       lup_fr2=lup_fr2-loop 
        istruct1(lstruct1)=istruct1(lstruct1-1)+loop 
        nstruct1=nloop(1) 
        if(loop.ge.1) then 
         do k=1,loop 
          nstr1(k)=nloop(loop+k) 
         end do 
        end if 
!        write(6,'(a,10a4)')' theostr1 nloop=',(nloop(k),k=1,loop)      
!        write(6,'(a,i2,2x,a2)')' theostr lstruct1,nstruct1=',lstruct1,nstruct1            
                                                                        
       if(ch2(1:1).eq.' ') then 
        chext=ch2(2:2)//nstruct1//'_____' 
        ii=-1 
       else 
        chext=ch2//nstruct1//'____' 
        ii=0 
       end if 
                                                                        
       if(index(ynch,'#').gt.0) nstrhss(mss)=nstrhss(mss-1) 
      go=cig(5);i_theoset(0)=5  ! ##2b
       call strsto(chext,chprf,ynch,mss,wrb,corrall,go,info) 
         ! ext field module                                              
                                                                        
!       write(6,'(a,2i4)')' theostr lstruct2,mss=',lstruct2,mss         
                                                                        
       istrss(ks,mss)=-lstruct1*10 
!       cstrss(1:2)(ks,mss)=ci2(lstruct1)                               
       mss=mss+1 
                                                                        
        if(strcmt(4).ne.' ')then 
!        write(6,'(a,a)')' theostr strcmt(4)=',strcmt(4)                
                                                                        
         strcmtcorr=strcmt(4) 
         strcmtcorr(132:132)=wrb 
         strcmtcorr(131:131)=cig(6+maskp); i_theoset(0)=6 ! ##2c
         
!         ch1='n'                                                       
!         chcom='effi/distribution/component'                           
!         call yesno(strcmtcorr,ch1,chcom,npl,nrd,nwr)                  
!          corrall=' '                                                  
!         if(ch1.eq.'y') corrall='#'                                    
        else 
         strcmtcorr=' ' 
        end if 
!       write(6,'(a2,a,5i4)')corrall,'=corrall 1 lstruct1=',lstruct1, &  
!                             istruct1(lstruct1-1),istruct1(lstruct1),lstruct2 
       if(lstruct2.eq.-1) goto 301
        
       istr2=0 
       if(wrb.eq.'w')write(10,'(a)')'[g]' 
       if(wrb.eq.'r') then 
        read(10,'(a)')ch4 
        do while(ch4(3:3).eq.']') 
         if(ch4(2:2).eq.'b') then 
          wrb='w' 
          backspace 10 
          write(10,'(a3)')'[g]' 
         end if 
         if(wrb.eq.'r')then 
          read(10,'(a)')ch4 
         else 
          ch4='end' 
         end if 
        end do 
        if(wrb.eq.'r')backspace 10 
       end if 
       n_trmatrix=0  ! no number for new matrix  
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

       do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1) ! lstruct2-
        ynch=' ' 
        corrall=' ' 
        corr_old=' ' 
        do i=0,8 
         idpmat(i)=0 
        end do 
        chsite=' ' 
                                                                        
        istr2=istr2+1 
        levelth=1 
        do k=1,maxvaco 
         strco(k)=' ' 
         strth(k,1)=' ' 
         strth(k,2)=' ' 
        end do 
        do k=1,maxco 
         strtm(k,1)=' ' 
        end do 
        go=' ' 
        strco(1)='#end#    0  ' 
        strco(2)='#beg#' 
        strtm(1,1)='#end#    0 ' 
        strtm(2,1)='#beg#' 

        kssthe(0)=2 
        kssthe(1)=ithjlist1 
        kssthe(2)=ithjlist2 
        kfr=jfrtheo 
!        write(6,'(2a)') 'theostr-487  nhelpentry=',nhelpentry(:50)     
!       call for handbook at frame level (2)                            
        cmch='hdbk' 
        nhelpentry=' ' 
        kfr=jfrtheo 
        call getfrstring(kfr,l_jfrtheo,lstruct1,lstruct2,cmch,nhelpentry)
        ientry=0 
        i=index(nstruct,'handbook') 
        if(i.gt.0)call handbook(wrb,ientry,info) 
        if(info.gt.0) goto 1020 
                                                                        
        nhelpentry=' ' 
        cmch='empt' 
        kfr=jfrtheo 
        call getfrstring(kfr,l_jfrtheo,lstruct1,lstruct2,cmch,nhelpentry)
        if(lstruct2.eq.-1) goto 301
        ! the theory does not have entries for lstruct2 => lstruct2 is set
        ! to -1 in frstr_theory in block
        ! 110     continue    ! modules of first device

        i=i0+nu_sdevice(ks,lstruct1) 
        nameth_as=nameth_level(2)(:l_name+2)//char(i) 

        nistr2=istruct1(lstruct1)-istruct1(lstruct1-1) 
        ct132=nheader1 
        call nextchar(ct132,0,i,ch132,l) 
        if(l.gt.23)l=23 
!        write(6,'(i4,2a)')l,'=l ch132=',ch132(:70)                     
        if(nistr2.gt.1) then 
         form='i2' 
         rn=istr2 
         call trlnu(form,rn,chr,nn,chl,im) 
         ch132='properties of module '//chl(:im) 
         cask='two letters name for module '//chl(:im) 
        else 
         cask='two letters name for'//nheader1(1:l+1) 
         ch132=nheader1(1:l+1) 
        end if 
!-----------------      shifted 3.1.2005                                
!        levelth=2                                                      
!        cmch='empt'                                                    
!        do while(cmch.ne.'ende')                                       
!         call seltheory(levelth,cmch,nhelpentry,iquery_o,wrb,info)     
!         if(info.gt.0) goto 1020                                       
!        end do                                                         
!        do k=0,kssthe(0)                                               
!         ktheo(ks,mss,k)=kssthe(k)                                     
!        end do                                                         
!-----------------                                                      
                                                                        
        if(nistr2.gt.1) then                    ! module name only if >1 
         chcom='effi/name/substructure/module' 
         ch132=nstr1(istr2)
         cask(132:132)=wrb 
         call askstring(cask,ch132,chcom,npl,nwr) 
         nstr1(istr2)=ch132 
!        write(6,'(a,i4,a4)')' nistr2,nstr1(istr2)=',nistr2,nstr1(istr2)

         chext(5+ii:6+ii)=nstr1(istr2) 
         ch1=char(i0+istr2) 
         if(istr2.gt.9)ch1=char(iA+istr2) 
         if(istr2.gt.35)ch1=char(ja+istr2) 
         if(ch1.eq.nstr1(istr2)(2:2).or.nistr2.eq.1)then 
          chext(7+ii:8+ii)='__' 
         else 
          chext(7+ii:8+ii)=ch1//'_' 
         end if 
         i1ext=7+ii 
         i2ext=8+ii 
        else 
         i1ext=5+ii 
         i2ext=6+ii 
        end if 
                                                                        
!       write(6,'(a,i3)')'743 lstruct2=',lstruct2                       
!       write(6,'(a)')strcmt(2)                                         
!       write(6,'(a)')strcmt(3)                                         
!       write(6,'(a)')strcmt(4)                                         
!        call strsto(chext,mss,wrb,corrall,go,info)     ! shifted  27.12
                                                                        
!       write(6,'(2a)') 'theostr-564 :','before call seltheory'         
!       shifted from above 3.1.2005                                     
        do i=1,8 
         iquery_o(i)=0 
        end do 
        ynch=' ' 
        levelth=2 
        cmch='empt' 
         nhelpentry(131:131)=cig(7+maskp)  ! ##3         
        do while(cmch.ne.'ende') 
         call seltheory(levelth,cmch,nhelpentry,iquery_o,wrb,info) 
         if(info.gt.0) goto 1020 
        end do 
                                                                        
!        write(6,'(a,i2,a,11i4)')' kssthe(',mss,',0..)=',               
!     &                       (kssthe(j),j=0,kssthe(0))                 
                                                                        
        do k=0,kssthe(0) 
         ktheo(ks,mss,k)=kssthe(k) 
        end do 
                                                                        
        corrall=' '     !  16 Dez 09 (new module-new decission) 
        if(index(ynch,'#').gt.0) nstrhss(mss)=nstrhss(mss-1)  ! 2005   
         if(go.ne.'g')go=cig(8+maskp);  i_theoset(0)=8  ! ##3a
        call strsto(chext,chprf,ynch,mss,wrb,corrall,go,info)   ! shifted
                                                                        
!        write(6,'(a,a)')'ynch=',ynch                                   
!        write(6,'(a,11i4)') 'nstrhss(1:)=',(nstrhss(i),i=1,10)         
                                                                        
        if(lstruct2.le.9) then 
         istrss(ks,mss)=-lstruct1*10-lstruct2 
        else 
         istrss(ks,mss)=-lstruct1*100-lstruct2 
!         write(6,'(a,3i5)')' istrss(ks,mss)=',istrss(ks,mss),          
!     &                       lstruct1,lstruct2                         
        end if 
!         cstrss(3:4)(ks,mss)=ci2(lstruct2)                             
        
                                                                        
        loop=istruct2(lstruct2-1) 
        lup=lup_ss 
        if(strcmtcorr.ne.cig(6+maskp))then
         ch1='n' 
         chcom='effi/distribution/component' 
         ch132=strcmtcorr 
         ch132(132:132)=wrb 
         call yesno(ch132,ch1,chcom,npl,nrd,nwr) 
         corrall=' ' 
         if(ch1.eq.'y') then 
          corrall='#' 
          corr_old='#' 
          idpmat(0)=1 
          idpm_rem=1 
         end if 
        end if
        ig=cig(10+maskp)  ! ##10
        !        if(lup.gt.maxss) lup=maxss                                     
        call strloop(lup,loop,nloop,nheader2,wrb,corrall,ig,info) 
        if(nheader2(1:4).eq.'back')then 
         call startagain 
         wrb='r' 
         rewind 10 
         ktheo(ks,0,0)=0 
         goto 15 
        end if 
                                                                        
!       write(6,'(a,2i4,2a4,a24)')                                      
!     &    'theostr_a lup,loop,nloop(1..2),nheader2=',                  
!     &             lup,loop,nloop(1),nloop(2),nheader2                 
                                                                        
                                                                        
!       originally here 27.12.04                                        
        mss=mss+1 
        istr3=0 
                                                                        
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       ls1=0                             ! 20.08.07 
       do i=1,8 
        iquery_o(i)=0 
       end do 
       ynch=' ' 
       istruct2(lstruct2)=istruct2(lstruct2-1)+loop 
       if(loop.gt.0) then 
        lup_ss=lup_ss-loop 
        ls=istruct2(lstruct2-1) 
        ls1=ls+1 
        do k=loop,1,-1 
         nstr2(k)=nloop(k) 
         idistsites(k+ls)=idistsites(k)+ls1 
!         write(6,'(a,i2,2x,a2)') 'theostr k,1_nloop(k)=',k,nloop(k)    
!         write(6,'(a,i2,a2,3(2x,i2))')'k,ls,idistsites(',k+ls,')=', &   
!                         k,ls,idistsites(k+ls)                   
        end do 
       else 
        nstr2(1)='__' 
       end if 
       cLP=nloop(1) 
       isite=0
       icomp=0 
  300  ls=ls+1 
         corrall=corr_old 
         if(ls.gt.istruct2(lstruct2)) goto 310 
         i=i0+nu_sdevice(ks,lstruct1) 
         nameth_as=nameth_level(3)(:l_name+2)//char(i) 
                                                                        
         istr3=istr3+1 
         chext(i1ext:i2ext)=nstr2(istr3) 
                                                                        
!         write(6,'(i2,a,i2,a,3(2x,a))')ls,' nloop(',istr3,             
!     &  '),chext,nstr2(istr3)=',                                       
!     &                    nloop(istr3),chext,nstr2(istr3)              
                                                                        
!         write(6,'(a,i3)')'837 lstruct3=',ls                           
!         write(6,'(a)')strcmt(2)                                       
!         write(6,'(a)')strcmt(3)                                       
!         write(6,'(a)')strcmt(4)                                       

         ch132=ADJUSTL(nheader2) 
         nstruct=TRIM(ch132)//': extension of parameters:'//chext(:i2ext)
         do k=1,maxvaco 
          strco(k)=' ' 
          strth(k,1)=' ' 
          strth(k,2)=' ' 
         end do 
         do k=1,maxco 
          strtm(k,1)=' ' 
         end do 
         strco(1)='#end#    0  ' 
         strco(2)='#beg#' 
         strtm(1,1)='#end#    0 ' 
         strtm(2,1)='#beg#' 
                                                                        
!         write(6,'(2a)') 'thstruct bf-seltheory nhelpentry=',nhelpentry
         do k=0,maxthlv 
          kssthe(k)=0 
         end do 
         nstrcoss=0 
                                          ! fr_not_fr                   
         levelth=1 
         cmch='empt' 
                                                                        
         if(corrall.eq.'#') then 
          idistdif=idistsites(ls)-idistsites(ls-1) 
!          write(6,'(a,i2,a2,2(2x,i2),2(a,i2),i3)')'ls,idistsites(',ls,')=', &
!         ls,idistsites(ls),' idistdif=',idistdif,' ls1=',ls1,istruct2(lstruct2)
!block not used------------------
      i=1; truedist=.true.
      do while(idistsites(i).ne.0)
       k=1
       do while(idistsites(i+k).eq.idistsites(i))
!       write(6,'(a,5i3)')'i,k=',i,k,idistsites(i),idistsites(i+k)
        k=k+1
       end do
!       write(6,'(a,3i3)')'i,k=',i,k
       if(i.eq.ls.and.k.eq.1) truedist=.false.
       i=i+k
      end do
!------------------------------
          go='n' 
          if(idistdif.gt.0.and.truedist)icomp=icomp+1
          isite=isite+1 
          ch1=' ' 
          if(truedist)then  
           ct132='component number '//char(isite+i0)//' distribution '//char(icomp+i0) 
          else
           ct132='component number '//char(isite+i0)//' no distribution'
          end if
          call chcenter(ct132,ch1,npl) 
          if(wrb.eq.'w')write(10,'(a)')'[g]' 
          if(wrb.eq.'r') then 
           read(10,'(a)')ch4 
           do while(ch4(3:3).eq.']') 
            if(ch4(2:2).eq.'b') then 
             wrb='w' 
             backspace 10 
             write(10,'(a3)')'[g]' 
            end if 
            if(wrb.eq.'r')then 
             read(10,'(a)')ch4 
            else 
             ch4='end' 
            end if 
           end do 
           if(wrb.eq.'r')backspace 10 
          end if 
          write(nwr,'(a)') ct132(:npl) 
                                                                        
          if(idistdif.gt.0) then 
            if(idpm_rem.eq.0)idpmat(0)=idpmat(0)+1 
            idpm_rem=0 
          end if 
          if(ls.eq.idistsites(ls).or.idistdif.gt.1)then 
           do i=1,8 
            iquery_o(i)=0 
           end do 
           ynch=' ' 
          end if 

          if(ls.gt.ls1.and.ls.lt.idistsites(ls).and.idistdif.lt.1)go='g' 
!          write(6,'(a,i2,2a2,2x,a2)')'  theostr cLP,nloop(',istr3,')=',
!     &               cLP,nloop(istr3)                                  
          if(cLP.ne.nloop(istr3)(1:1))then 
           go=' ' 
           cLP=nloop(istr3) 
           chsite=CLP 
!           write(6,'(a,i2,2a2)')'  theostr nloop(',istr3,')=',cLP       
          end if 
                                                                        
          nhelpentry(131:131)=cig(11+maskp) ! ##11         
          do while(cmch.ne.'ende') 
             nhelpentry(132:132)=go; 
           call seltheory(levelth,cmch,nhelpentry,iquery_o,wrb,info) 
           if(info.gt.0) goto 1020 
          end do 
                                                                        
          if(index(ynch,'#').gt.0.and.ls.lt.idistsites(ls))             &
                                 nstrhss(mss)=nstrhss(mss-1)
                            
          go=' '                                                 ! 2005 
          if(ls.gt.ls1.and.ls.lt.idistsites(ls).and.idistdif.lt.1)go='g' 
                                                                        
         else 
          nhelpentry(132:132)=' ' 
          nhelpentry(131:131)=cig(12+maskp) ! ##12
          do while(cmch.ne.'ende') 
             if(cig(12+maskp).eq.'/')nhelpentry(131:131)='1'
             call seltheory(levelth,cmch,nhelpentry,iquery_o,wrb,info)
           if(info.gt.0) goto 1020 
          end do 
                                                                        
          k=0 
          i=2 
          do while(k.eq.0.and.i.lt.maxco) 
           k=index(strtm(i,1),'end')+index(strtm(i,1),'beg') 
           i=i+1 
          end do 
                                                                        
          if(i.gt.3) then 
           k=istruct2(lstruct2)-istruct2(lstruct2-1) 
           if(k.gt.1) then 
            if(wrb.eq.'r') then 
             read(10,'(a)')querytype 
             i=index(querytype,'[')      ! ok no [ in the string   
             ch1=querytype(i+1:i+1) 
!             write(6,'(a,a1)')'theostr ch1=',ch1                       
            else 
             ch1='n' 
             querytype='new transformation matrix for each component' 
             querytype(132:132)=wrb 
             chcom='effi/trans_matrix/component' 
             call yesno(querytype,ch1,chcom,npl,nrd,nwr) 
            end if 
            if(ch1.eq.'y') then 
             form='i1' 
             chcom='effi/transmatrix/extension/number' 
             ch132='name of transformation matrices end with number' 
             if(n_trmatrix.gt.0)then 
              n_trmatrix=istr3 
              value=istr3 
             else 
              value=1 
             end if 
             alowlimit=1 
             uplimit=9 
             ch132(132:132)=wrb 
             call askvallim(ch132,form,                                 &
                       alowlimit,uplimit,value,chcom,ncol,nrd,nwr)     
             n_trmatrix=value 
             ch1=char(n_trmatrix+i0) 
             
             do k=2,i-2 
              nn=2 
              do while(strtm(k,1)(nn:nn).ne.' '.and.nn.lt.18) 
               nn=nn+1 
              end do 
              if(index(strtm(k,1),'end')+index(strtm(k,1),'beg').eq.0) & 
              strtm(k,1)(nn:nn)=ch1
             end do 
            end if 
           end if 
          end if 
         end if 
                                                                        
         nstrco(mss)=nstrcoss 
!         write(6,'(2a)') 'thstruct af-seltheory nhelpentry=',nhelpentry
!         write(6,'(a,i2,a,11i4)')' kssthe(',mss,',0..)=',              
!     &                      (kssthe(j),j=0,kssthe(0))                  
!         chext(3:3)=char(lstruct2+i0+2)                                
         chprf(2:2)=char(lstruct2+i0) 
         if(ks.gt.1)chprf(3:3)=char(ks+i0)
         ynch(34:34)='n'; if(truedist)ynch(34:34)='y'
         if(go.ne.'g')go=cig(13+maskp); i_theoset(0)=13    !  ##6a
         call strsto(chext,chprf,ynch,mss,wrb,corrall,go,info) 
                                                                        
         do k=0,kssthe(0) 
           ktheo(ks,mss,k)=kssthe(k) 
         end do 
         istrss(ks,mss)=ls 
                                                                        
!         cstrss(5:6)(ks,mss)=ci2(ls)                                   
                                                                        
         mss=mss+1 
        if(ls.lt.istruct2(lstruct2)) goto 300 
  310   continue 
!        write(6,'(i3,a,10i3)')mss,'=mss idpmat(0..)=',(idpmat(i),i=0,8)
         mfr2(mss-1)=lstruct2 
         do i=0,8 
          idpmlay(lstruct2,i)=idpmat(i) 
         end do 
         do i=1,8 
          do j=0,3 
           cdpmat(i,j,lstruct2)=dpmat(i,j) 
          end do 
         end do 
!         write(6,'(i4,a,a)')mss,'=mss ### dpmat=',dpmat(1,1)           
!         write(6,'(i2,2x,a,9a10)')lstruct2,                            
!     &         '     ###cdpmat=',(cdpmat(1,1,i),i=1,4)                 
!         write(6,'(a,3i4)')' mss,mfr2(mss),idpmat(0)=',                
!     &                     mss,mfr2(mss),idpmat(0)                     
       end do 
 301   continue
     end do

      mss=mss-1 
      do i=0,mss 
        do k=0,8 
         idpmat(k)=idpmlay(mfr2(i),k) 
        end do 
        do k=1,8 
         do j=0,3 
          dpmat(k,j)=cdpmat(k,j,mfr2(i)) 
         end do 
        end do 
        call strrec(i) 
!          read(5,'(a)')                                                
          nerr=i 
          call constins(nerr,nstrhss,ks,i) 
          if(nerr.gt.0) goto 1010 
!         write(6,'(a,3i5)')'theostr_c mss,i,nerr=',mss,i,nerr          
          nerr=10+i 
          call paramins(nerr,nstrhss,ks,i) 
          if(nerr.gt.0) goto 1010 
      end do 
!      write(6,'(a,10i4)') ' istrss(ks,1..)=',(istrss(ks,i),i=1,mss)    
!     write(6,'(a,10i4)') ' ktheo(ks,1..,0)=',(ktheo(ks,i,0),i=1,mss)   
!        do i=1,mss                                                     
!        write(6,'(a,i2,a,11i4)')' ktheo(',i,',0..)=',                  
!     &                       (ktheo(ks,i,j),j=0,ktheo(ks,i,0))         
!        end do                                                         
      call istvadd(2,ks) 
                                                                        
      do iset=1,maxs 
       numv(iset)=mvadds(iset,maxthss)-mvadds(iset,0) 
      end do 
                                                                        
      ms=maxs 
      do while(numv(ms).eq.1) 
       ms=ms-1 
      end do 
!     write(6,'(a,i4,4x,32i4)')'theostr ms,numv(1..)=',ms,(numv(i),i=1,maxs)
      
                                                                        
                                                                        
      do i=1,mpl 
       ivadd(i)=0 
      end do 
      j=0 
      do iset=1,ms 
       do i=1,numv(iset) 
        iv=ivaddsp(iset,i) 
        if(iv.gt.0) then 
         j=j+1 
         ivadd(j)=iv+mvadds(iset,0) 
        end if 
       end do 
      end do 
      mpl=j 
!      write(6,'(a,i4)') ' theostr ivadd,kpl j=',j                      
!      write(6,'(20i4)') (ivadd(i),i=1,j)                               
!      write(6,'(20i4)') (kpl(i),i=1,j)                                 
                                                                        
      do iset=1,ms 
       numv(iset)=mcadds(iset,maxthss)-mcadds(iset,0) 
      end do 
!      write(6,'(a,i4,4x,18i4)')'theostr ms,numv(1..)=',                
!     &                           ms,(numv(i),i=1,maxs)                 
      do i=1,mcl 
        icadd(i)=0 
      end do 
      j=0 
      do iset=1,ms 
        do i=1,numv(iset) 
         iv=icaddsp(iset,i) 
         if(iv.gt.0) then 
          j=j+1 
          icadd(j)=iv+mcadds(iset,0) 
         end if 
        end do 
      end do 
      mcl=j 
                                                                        
      mscr1=maxc 
      mscr2=mscr1+maxp 
      icall=0 
!      call structure_ks(ks,                                            
!     &           mstruct1,numstr1,mstruct2,numstr2,mstruct3,numss) ! 10
      npanum(mscr1+2)=0 
      call pameter(ks,-1,0,icall) 
      j=0 
!      write(6,'(a,i3)') 'theostr ks=',ks                               
!      write(6,'(a,20i3)')                                              
!     &   'npanum=',(npanum(i+mscr1+2),i=1,npanum(mscr1+2))             
      jj=0 
      do i=1,npanum(mscr1+2) 
       ii=npanum(i+mscr1+2) 
!       if(np(ii)(7:8).eq.'__') j=j+1                                   
       if(np(ii)(6:8).eq.'___')j=j+1 
       if(j.gt.0.and.jj.eq.0) jj=i 
!       write(6,'(a24,i6)')np(ii),j                                     
      end do 
!      write(6,'(a,20i3)')'j,jj,npanum(mscr1+2)=',j,jj,npanum(mscr1+2)  
                                                                        
      if(j.eq.npanum(mscr1+2)-jj+1) then 
       do i=jj,npanum(mscr1+2) 
        ii=npanum(i+mscr1+2) 
        do j=7,22 
         np(ii)(j:j)=np(ii)(j+2:j+2) 
        end do 
        np(ii)(22:24)=' ' 
!       write(6,'(a,a24,i6)')'##theostr np=',np(ii),ii                  
       end do 
      end if 
                                                                        
                                                                        
      npanum(mscr2+2)=0 
      icall=0 
      call constants(-1,-1,icall) 
      j=0 
!      write(6,'(a)')' theostr call constants(-1,-1,icall) npanum='     
!      write(6,'(25i3)')(npanum(i+mscr2+2),i=1,npanum(mscr2+2))         
                                                                        
      do i=1,npanum(mscr2+2) 
       ii=npanum(i+mscr2+2) 
       if(ncon(ii)(7:8).eq.'__') then 
         ch16=ncon(ii)(9:24) 
         ncon(ii)(7:22)=ch16 
         ncon(ii)(23:24)=' ' 
       end if 
       if(ncon(ii)(7:9).eq.'___') then 
         ch16=ncon(ii)(10:24) 
         ncon(ii)(7:21)=ch16 
         ncon(ii)(22:24)=' ' 
       end if 
      end do 
                                                                        
                                                                        
      goto 1020  
 1010 continue 
      info=nerr 
      goto 1030
                                                                        
 1020 continue 
!      call save(6,1)                                                   
!      call savearsp(21) 
      call zerotrf 
      if(info.gt.0) goto 1030 
      info=0 
                                                                        
      do i=1,mss 
        do k=0,8 
         idpmat(k)=idpmlay(mfr2(i),k) 
!        write(6,'(i2,a,8i4)')k,' idpmlay(mfr2(i),k)=',mfr2(i),idpmat(k)
        end do 
        do k=1,8 
         do j=0,3 
          dpmat(k,j)=cdpmat(k,j,mfr2(i)) 
         end do 
        end do 
!       write(6,'(a,3i4,2x,a)')'++ mss,mfr2(mss),idpmat(0)=',   &        
!                          i,mfr2(i),idpmat(0),dpmat(1,1)              
       if(idpmat(0).gt.0) call dpmatrix(wrb,info)
       if(info.gt.0) return
      end do 
1030  continue
      if (allocated(cdpmat))deallocate(cdpmat)
      close(unit=10) 
      return 
      END                                           
!    *****************************************************************  
                                                                       
      subroutine setscrd(j,k) 
      use glbconst, only: maxcom,maxscr,ii_scrd,ir_scrd,maxscrd
      implicit none
      integer    j,k,i
      integer,parameter:: idum=ii_scrd+ir_scrd, mc_scrd=maxscrd-idum 
      character(len=4):: cdum 
      real      rdum
      common/scrd/rdum(idum),cdum(mc_scrd)  

      if(j.eq.0) then 
       do i=1,idum 
        rdum(i)=100000.99+float(i) 
       end do 
      else 
       do i=maxscr+1,idum 
        rdum(i)=100000.99+float(i) 
       end do 
      end if 
      if(k.eq.0) then 
       do i=1,mc_scrd 
        cdum(i)='abcd' 
       end do 
      end if 
      if(k.eq.1) then 
       do i=maxcom*70+1,mc_scrd 
        cdum(i)='efgh' 
       end do 
      end if 
      return 
      END                                           
                                                                        
      subroutine analyse_frame(ks,i0,info) 
      use glbconst, only: infotext
      use comdas, only: ktheo
      use comstr, only: ntheory,nameth
      use comthe, only: ifrcase,theoryname,thfrcase,maxthfrcase
      implicit none 
      integer   ks,i0,info
      character(len=132):: nhelpentry
      character(len=80) :: name
      character(len=4)  :: cich
      character(len=8)  :: ch8
      integer iframe,nframe,iframestr,lstruct1,lstruct2,l_nfrtheo,     &
              j,l,ls,lt,ltt,l_jth,jth,jth1,n,n1,nj,ntrimto0
      
                                                                        
      iframestr =ktheo(ks,0,1) 
      cich='name' 
      call getfrstring(iframestr,l_nfrtheo,lstruct1,lstruct2,cich,nhelpentry)
       nhelpentry=ntheory(1) 
       ls=ntrimto0(nhelpentry) 
       iframe=0 
       nframe=0 
       nj=1 
       cich='thna' 
       do while(iframe.lt.nj.and.nframe.eq.0) 
        iframe=iframe+1 
        n=iframe 
        call distribthfr(n,cich,n1,info) 
        nj=n 
        l=index(theoryname,'v=') 
        if(l.gt.0)then 
         lt=l-2 
        else 
         lt=72 
        end if 
        do while(theoryname(lt:lt).eq.' ') 
         lt=lt-1 
        end do 
!        write(6,'(i4,2a)')iframe,' getthinf:',theoryname(1:lt)         
        if(theoryname(1:lt).eq.nhelpentry(1:ls)) then 
!         write(6,'(a)')(thfrcase(j),j=1,4)                             
         nframe=iframe 
        end if 
       end do 
       iframe=nframe 
       if(iframe.eq.0) then 
        info=1 
        call itoc8(ch8,iframestr) 
        infotext(1)='effi/structure/frameth/notfound' 
        infotext(2)='*** error in set up of theory names' 
        infotext(3)='frame theory'//ch8(:3)//':'//nhelpentry(:ls) 
        infotext(4)='does not match the theoryname in any fr_***.f' 
        infotext(5)=' ' 
        return 
       end if 
                                                                        
       ifrcase=0 
       l_jth=16 
       ls=0 
        jth=ktheo(ks,0,i0-1) 
        jth1=ktheo(ks,0,i0) 
        cich='name' 
        call getthstring(jth,l_jth,cich,nhelpentry) 
        name=nameth(jth1) 
!        write(6,'(i2,a,i1,2a)')                                        
!     &        ktheo(ks,0,i0-1),' nameth(',jth1,')=',nameth(jth1)       
        lt=72 
        do while(name(lt:lt).eq.' ') 
         lt=lt-1 
        end do 
                                                                        
        j=1 
        do while(j.le.maxthfrcase) 
!        write(6,'(i4,a)')lt,thfrcase(j)                                
         if(thfrcase(j).ne.' ')then 
                                                                        
          l=index(thfrcase(j),'v=') 
          if(l.gt.0)then 
           ltt=l-2 
          else 
           ltt=72 
          end if 
          do while(thfrcase(j)(ltt:ltt).eq.' ') 
           ltt=ltt-1 
          end do 
          l=index(thfrcase(j)(ltt:ltt),')') 
          if(l.gt.0) then 
           do while(thfrcase(j)(ltt:ltt).ne.'(') 
            ltt=ltt-1 
           end do 
          end if 
!          write(6,'(2i4,2(2x,a))')lt,ltt,name(:lt),thfrcase(j)
          
          if(name(:lt).eq.thfrcase(j)(:ltt-1))then 
           l=index(thfrcase(j)(ltt:),')') 
!          write(6,'(2i4,a)')ltt,l,thfrcase(j)                          
           ch8=thfrcase(j)(ltt+1:ltt+l-2) 
           ls=ls+1 
!          write(6,'(a,a)')'ch8=',ch8                                   
           call c8toi(ch8,ifrcase) 
           if(ifrcase.le.0) ifrcase=-1 
!          write(6,'(a,i4)')'ifrcase=',ifrcase,maxthfrcase           
           j=maxthfrcase 
          end if 
         end if 
         j=j+1 
         if(j.eq.maxthfrcase+1) goto 10 
        end do 
   10   continue 
                                                                        
      if(ifrcase.eq.0) then 
        info=1 
        infotext(1)='effi/structure/frameth/notfound' 
        infotext(2)='*** error in set up of theory names' 
        infotext(3)='the theory name: '//name(:lt) 
        infotext(4)='does not match any of the thfrcase(i) in fr_***.f' 
        infotext(5)=' ' 
       else if(ifrcase.eq.-1) then 
        info=2 
        infotext(1)='effi/structure/frameth/notfound' 
        infotext(2)='*** error in set up of theory names' 
        infotext(3)='missing number at the end of thfrcase(i) in fr_***.f'
        infotext(4)='written in brackets: name theory(nn)' 
        infotext(5)=' ' 
       else if(ls.gt.1) then 
        info=3 
        infotext(1)='effi/structure/frameth/notfound' 
        infotext(2)='*** error in set up of theory names' 
        infotext(3)='more than one match between theory name: '//name(:lt)
        infotext(4)='and the names of thfrcase(i) in fr_***.f' 
        infotext(5)=' ' 
       end if 
                                                                        
       return 
      END                                           
                                                                        
                                                                        
       subroutine startagain 
       use glbconst, only: nrd,nwr
       implicit none 
       character*132 querytype,chcom,ch*80,ch3*3, ch1*1 
       integer ncol 
                                                                        
    1  ch3=' ' 
       do while(ch3.ne.'[g]') 
        backspace 10 
        read(10,'(a)')ch 
        write(nwr,'(a)')'<'//ch(:78) 
        if(index(ch,'global').gt.1) goto 2 
        ch3=ch 
        backspace 10 
       end do 
       write(10,'(a3)')'[b]' 
       querytype=' go on further backwards' 
       ch1='n' 
       chcom='effi/scr/back' 
       ncol=80 
       call yesno(querytype,ch1,chcom,ncol,nrd,nwr) 
       if(ch1.eq.'y') goto 1 
       write(10,'(a)')'file ends' 
       goto 3 
    2  continue 
       do while(ch3.ne.'[b]') 
        read(10,'(a)')ch 
        write(nwr,'(a)')':'//ch(:78) 
         ch3=ch 
       end do 
       write(10,'(a)')'file ends' 
    3   continue 
       return 
      END                                           

      subroutine save_modified
      use glbconst, only: sessfile
      use comeff, only: npl
      implicit none 
      character(len=132), dimension(:), allocatable :: line
      character(len=4) :: lin
      integer nfile,npls,k,j

      npls=npl
      npl=80
      nfile=1
     
      open(unit=nfile,file='modified.par'     &
                ,status='unknown'                 &
                ,access='sequential'              &
                ,form='formatted')

      call save(nfile,1,'nnnn',.false.) 
      close(unit=nfile)

      open(unit=nfile,file=sessfile             &
                ,status='unknown'                 &
                ,access='sequential'              &
                ,form='formatted')

      do k=1,100
       read(nfile,'(a)',end=10)lin
      end do
 10   continue
      REWIND(unit=nfile)
      allocate(line(k))

      do j=1,k-1
       read(nfile,'(a)')line(j)
      end do

      REWIND(unit=nfile)
      write(nfile,'(a)')'rs modified.par ks=1'
      line(1)='#'//line(1)
      do j=1,k-1
       write(nfile,'(a)')line(j)
      end do
      close(unit=nfile)
      deallocate(line)
      close(unit=nfile)
      npl=npls
      return
      END

