  program ratiocounts
    character(len=132):: ch(19)
    integer n_ch,i,iout
    real h1,h2,f,ratio,out(32),ar(20),al(20)
    
   
    
 ch(1)='  0.8169   0.6748 '    
 ch(2)='  0.8744   0.6430 '
 ch(3)='  0.8872   0.6370 '    
 ch(4)='  0.8575   0.6518 '
 ch(5)='  0.7961   0.6905 '    
 ch(6)='  0.7353   0.7286 '    
 ch(7)='  0.7101   0.7137 '
 ch(8)='  0.7174   0.6612 '     
 ch(9)='  0.7560   0.5820 '
 ch(10)=' 0.8074   0.5026 '
 ch(11)=' 0.8504   0.4533 '
 ch(12)=' 0.8614   0.4388 ' 
 ch(13)=' 0.8352   0.4633 ' 
 ch(14)=' 0.7933   0.5202 ' 
 ch(15)=' 0.7461   0.5980 '
 ch(16)=' 0.7152   0.6765 '
 ch(17)=' 0.7155   0.7209 '
 ch(18)=' 0.7622   0.7024 '
 ch(19)=' 0.3904   1.1531 '

 n_ch=80
 hf=0.097*3.14159/2.0*(1.-0.083)
 do i=1,18
    call  trlch(n_ch,ch(i),iout,out)
  h1= 0.5+out(2)
  h2= out(1)*h1
  al(i)=out(1)*out(2)*hf
  ar(i)=0.5*out(1)*hf
  print'(a,f12.4,a2,2f8.4,a1,3f12.4)',' intensity:', h2,'*(',out(2)/h1,0.5/h1,')', &
       al(i),ar(i), 0.5/out(2)
end do
 hf=0.097*3.14159/2.0*(1.-0.067)
 i=19
    call  trlch(n_ch,ch(i),iout,out)
  h1= 0.5+out(2)
  h2= out(1)*h1
  al(i)=out(1)*out(2)*hf
  ar(i)=0.5*out(1)*hf
  print'(a,f12.4,a2,2f8.4,a1,3f12.4)',' intensity:', h2,'*(',out(2)/h1,0.5/h1,')', &
       !        out(1)*out(2),0.5*out(1), 0.5/out(2)
       al(i),ar(i), 0.5/out(2)

  ! 2A/(1-bg)/(pi*G_Q*f_Q)
  hf=2./(3.14159*0.102*0.75)/(1.-0.083)
  do i=1,18
    print'(i3,a,2f12.4)',i,' DFA:',al(i)*hf,ar(i)*hf
 end do
  hf=2./(3.14159*0.102*0.75)/(1.-0.067)
  i=19
  print'(i3,a,2f12.4)',i,' DFA:',al(i)*hf,ar(i)*hf
  
  stop
end program ratiocounts



      subroutine trlch(n_ch,chin,iout,out) 
      implicit none
      character chin*132,ch*132 
      real      out(32),pt 
      integer nch,n_ch, &
              i,ic,i0,nsig,k,k1,k2,nex,nnum,iout 
!     program translates numbers (all possible fortran formates,        
!     separated by at least one blank or other character) given as ch*13
!     to iout real numbers (max.32) stored in the vector out.           
!     nch characters of ch(1:nch) are analysed.                         
      nch=n_ch 
      if(nch.gt.132) nch=132 
      ch=chin 
      i0=ichar('0') 
      nsig=1 
      pt=1. 
      k1=0 
      k2=0 
      nex=0 
      nnum=0 
      iout=0 
      do k=1,32 
       out(k)=0. 
      end do 
                                                                        
      k=0 
   10 k=k+1 
      i=ichar(ch(k:k))-i0 
      if(i.ge.0.and.i.lt.10) then 
       nnum=1 
       if (pt.eq.1.) then 
        out(iout+1)=out(iout+1)*10.+float(i) 
       else 
        out(iout+1)=out(iout+1)+float(i)*pt 
        pt=pt/10. 
       end if 
       if(k.eq.nch) goto 50 
       goto 100 
      end if 
                                                                        
      if(ch(k:k).eq.'e'.or.ch(k:k).eq.'E') then 
       if(nex.eq.1) goto 50 
       do i=k-1,1,-1 
        if(ch(i:i).eq.'.') then 
         nex=-1 
         goto 50 
        end if 
        ic=ichar(ch(i:i))-i0 
        if(ic.lt.0.or.ic.gt.9) goto 100 
       end do 
      end if 
                                                                        
      if(pt.lt.1.)then 
       k=k-1 
       goto 50 
      end if 
                                                                        
      if (ch(k:k).eq.'.') then 
        pt =0.1 
        goto 100 
      end if 
      if(ch(k:k).eq.'-') then 
        if(nsig.eq.1) k1=k 
        if(nsig.eq.-1) k2=k 
        nsig=-1 
      end if 
      if(nnum.eq.1) goto 50 
      if(nex.eq.1.and.ch(k:k).eq.' ') nex=0 
      goto 100 
                                                                        
   50 if(k1.lt.k) then 
       out(iout+1)=nsig*out(iout+1) 
       if(k2.lt.k1) then 
        nsig=1 
       else 
        k1=k2 
       end if 
      end if 
      nnum=0 
      pt=1. 
      if (nex.le.0) goto 60 
      out(iout)=out(iout)*10.**out(iout+1) 
      nex=0 
      out(iout+1)=0. 
      iout=iout-1 
   60 if (iout.eq.32) goto 110 
      iout=iout+1 
      k1=0 
      k2=0 
      if(nex.eq.-1) nex=1 
                                                                        
  100 if(k.lt.nch) goto 10 
  110 return 
      END                                           
                                                                        
